/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){
var e,t=["require","exports","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/network","vs/nls!vs/server/remoteExtensionHostAgent","vs/nls","vs/base/common/types","vs/platform/log/common/log","vs/base/common/strings","vs/base/node/pfs","vs/base/common/errors","vs/base/common/arrays","vs/base/common/async","vs/base/common/objects","vs/base/common/buffer","fs","vs/base/common/uuid","vs/base/common/resources","vs/base/common/map","vs/platform/product/common/product","os","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/extpath","vs/platform/extensionManagement/common/extensionManagement","vs/platform/registry/common/platform","child_process","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetry","vs/server/remoteUriTransformer","vs/base/common/glob","vs/base/parts/ipc/node/ipc.net","vs/platform/extensions/common/extensions","vs/platform/product/common/productService","vs/platform/configuration/common/configurationRegistry","vs/base/common/process","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/labels","util","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/base/common/semver/semver","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/uriIpc","crypto","vs/editor/common/core/range","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/configuration/common/configurationService","url","vs/platform/extensionManagement/common/extensionGalleryService","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/remoteExtensionManagement","vs/base/common/functional","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/node/decoder","vs/base/node/id","net","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/localizations/common/localizations","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogService","vs/platform/environment/node/environmentService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/commonProperties","vs/platform/workspaces/common/workspaces","vs/server/remoteLanguagePacks","vs/server/extensionHostConnection","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/contrib/terminal/common/terminal","vs/workbench/contrib/terminal/node/terminal","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/editor/common/editorService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/base/common/assert","vs/base/common/decorators","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/processes","vs/base/common/hash","vs/base/common/console","vs/base/common/filters","vs/base/common/codicon","vs/base/common/mime","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/paths","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/code/node/shellEnv","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/code/node/cliProcessMain","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/nls!vs/workbench/contrib/terminal/node/terminalProcess","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/downloadIpc","vs/platform/environment/node/argv","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/log/common/logIpc","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/storage/common/storage","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/node/errorTelemetry","vs/platform/telemetry/node/telemetry","vs/platform/workspace/common/workspace","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalDataBuffering","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/contrib/terminal/node/terminalProcess","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/api/common/extHostTypeConverters","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionsScanner","vs/code/node/cliProcessMain","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","string_decoder","path","vs/base/common/performance","minimist","applicationinsights","cookie","vs/base/common/marked/marked","yauzl","yazl","zlib","vs/server/remoteExtensionHostAgent"],n=function(e){
for(var n=[],r=0,i=e.length;r<i;r++)n[r]=t[e[r]];return n};function r(e){e.MonacoPerformanceMarks=e.MonacoPerformanceMarks||[];const t=2,n="function"==typeof console.timeStamp?console.timeStamp.bind(console):()=>{};return{mark:function(t){e.MonacoPerformanceMarks.push(t,Date.now()),n(t)},getEntries:function(){const n=[],r=e.MonacoPerformanceMarks;for(let e=0;e<r.length;e+=t)n.push({name:r[e],startTime:r[e+1]});return n},getDuration:function(n,r){const i=e.MonacoPerformanceMarks;let s=r,o=0;for(let e=i.length-t;e>=0;e-=t)if(i[e]===s){if(s!==r)return i[o+1]-i[e+1];o=e,s=n}return 0},importEntries:function(t){e.MonacoPerformanceMarks.splice(0,0,...t)},exportEntries:function(){return e.MonacoPerformanceMarks.slice(0)}}}function i(e,t,n,r){function i(e){return new Promise(t=>n.exists(e,t))}function s(e){return(r=e,new Promise((e,t)=>n.lstat(r,(n,r)=>n?t(n):e(r)))).then(r=>r.isDirectory()&&!r.isSymbolicLink()?function(e){return new Promise((t,r)=>n.readdir(e,(e,n)=>e?r(e):t(n)))
}(e).then(n=>Promise.all(n.map(n=>s(t.join(e,n))))).then(()=>(function(e){return new Promise((t,r)=>n.rmdir(e,e=>e?r(e):t(void 0)))})(e)):function(e){return new Promise((t,r)=>n.unlink(e,e=>e?r(e):t(void 0)))}(e),e=>{if("ENOENT"!==e.code)throw e});var r}function o(e){return new Promise((function(t,r){n.readFile(e,"utf8",(function(e,n){e?r(e):t(n)}))}))}function a(e,t){return new Promise((function(r,i){n.writeFile(e,t,"utf8",(function(e){e?i(e):r()}))}))}return{getNLSConfiguration:function(c,l,u,h){if("pseudo"===h)return Promise.resolve({locale:h,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:h,availableLanguages:{}});if(h&&("en"===h||"en-us"===h))return Promise.resolve({locale:h,availableLanguages:{}});const d=h;r.mark("nlsGeneration:start");const f=function(e){return r.mark("nlsGeneration:end"),Promise.resolve({locale:e,availableLanguages:{}})};try{if(!c)return f(d);const p=function(n){const r=t.join(n,"languagepacks.json");try{return e(r)}catch(e){}}(l)
;if(!p)return f(d);if(!(h=function(e,t){try{for(;t;){if(e[t])return t;{const e=t.lastIndexOf("-");if(!(e>0))return;t=t.substring(0,e)}}}catch(e){console.error("Resolving language pack configuration failed.",e)}}(p,h)))return f(d);const m=p[h];let g;return m&&"string"==typeof m.hash&&m.translations&&"string"==typeof(g=m.translations.vscode)?i(g).then(e=>{if(!e)return f(d);const p=m.hash+"."+h,v=t.join(l,"clp",p),y=t.join(v,c),b=t.join(v,"tcf.json"),w=t.join(v,"corrupted.info"),_={locale:d,availableLanguages:{"*":h},_languagePackId:p,_translationsConfigFile:b,_cacheRoot:v,_resolvedLanguagePackCoreLocation:y,_corruptedFile:w};return i(w).then(e=>{let c;return(c=e?s(v):Promise.resolve(void 0)).then(()=>i(y).then(e=>e?(function(e){return new Promise((t,r)=>{const i=new Date;n.utimes(e,i,i,e=>e?r(e):t())})}(y).catch(()=>{}),r.mark("nlsGeneration:end"),_):function(e){return new Promise((t,r)=>n.mkdir(e,{recursive:!0},n=>n&&"EEXIST"!==n.code?r(n):t(e)))}(y).then(()=>Promise.all([o(u),o(g)])).then(e=>{
const n=JSON.parse(e[0]),r=JSON.parse(e[1]).contents,i=Object.keys(n.bundles),s=[];for(const e of i){const i=n.bundles[e],o=Object.create(null);for(const e of i){const t=n.keys[e],i=n.messages[e],s=r[e];let a;if(s){a=[];for(let e=0;e<t.length;e++){const n=t[e];let r=s["string"==typeof n?n:n.key];void 0===r&&(r=i[e]),a.push(r)}}else a=i;o[e]=a}s.push(a(t.join(y,e.replace(/\//g,"!")+".nls.json"),JSON.stringify(o)))}return s.push(a(b,JSON.stringify(m.translations))),Promise.all(s)}).then(()=>(r.mark("nlsGeneration:end"),_)).catch(e=>(console.error("Generating translation files failed.",e),f(h)))))})}):f(d)}catch(e){return console.error("Generating translation files failed.",e),f(h)}}}}if(define(t[107],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0,t.ok=function(e,t){if(!e)throw new Error(t?`Assertion failed (${t})`:"Assertion Failed")}})),define(t[108],n([0,1]),(function(e,t){"use strict";function n(e){return(t,n,r)=>{let i=null,s=null
;if("function"==typeof r.value?(i="value",s=r.value):"function"==typeof r.get&&(i="get",s=r.get),!s)throw new Error("not supported");r[i]=e(s,n)}}Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0,t.createDecorator=n;let r=0;function i(){const e=`$memoize${r++}`;let t=void 0;const n=function(n,r,i){let s=null,o=null;if("function"==typeof i.value?(s="value",0!==(o=i.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof i.get&&(s="get",o=i.get),!o)throw new Error("not supported");const a=`${e}:${r}`;i[s]=function(...e){return t=this,this.hasOwnProperty(a)||Object.defineProperty(this,a,{configurable:!0,enumerable:!1,writable:!0,value:o.apply(this,e)}),this[a]}};return n.clear=()=>{void 0!==t&&Object.getOwnPropertyNames(t).forEach(n=>{0===n.indexOf(e)&&delete t[n]})},n}t.createMemoizer=i,t.memoize=function(e,t,n){return i()(e,t,n)},t.debounce=function(e,t,r){return n((n,i)=>{
const s=`$debounce$${i}`,o=`$debounce$result$${i}`;return function(...i){this[o]||(this[o]=r?r():void 0),clearTimeout(this[s]),t&&(this[o]=t(this[o],...i),i=[this[o]]),this[s]=setTimeout(()=>{n.apply(this,i),this[o]=r?r():void 0},e)}})},t.throttle=function(e,t,r){return n((n,i)=>{const s=`$throttle$timer$${i}`,o=`$throttle$result$${i}`,a=`$throttle$lastRun$${i}`,c=`$throttle$pending$${i}`;return function(...i){if(this[o]||(this[o]=r?r():void 0),null!==this[a]&&void 0!==this[a]||(this[a]=-Number.MAX_VALUE),t&&(this[o]=t(this[o],...i)),this[c])return;const l=this[a]+e;l<=Date.now()?(this[a]=Date.now(),n.apply(this,[this[o]]),this[o]=r?r():void 0):(this[c]=!0,this[s]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),n.apply(this,[this[o]]),this[o]=r?r():void 0},l-Date.now()))}})}})),define(t[15],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class n{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=n,t.errorHandler=new n,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},
t.onUnexpectedError=function(e){i(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){i(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:n}=e;return{$isError:!0,name:t,message:n,stack:e.stacktrace||e.stack}}return e};const r="Canceled";function i(e){return e instanceof Error&&e.name===r&&e.message===r}t.isPromiseCanceledError=i,t.canceled=function(){const e=new Error(r);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){
return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};class s extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}}t.NotImplementedError=s;class o extends Error{constructor(e){super("NotSupported"),e&&(this.message=e)}}t.NotSupportedError=o})),define(t[16],n([0,1,15]),(function(e,t,n){"use strict";function r(e,t){let n=0,r=e.length;if(0===r)return 0;for(;n<r;){const i=Math.floor((n+r)/2);t(e[i])?r=i:n=i+1}return n}function i(e,t){return function e(t,n,r,i,s){if(i<=r)return;const o=r+(i-r)/2|0;e(t,n,r,o,s);e(t,n,o+1,i,s);if(n(t[o],t[o+1])<=0)return;!function(e,t,n,r,i,s){let o=n,a=r+1;for(let t=n;t<=i;t++)s[t]=e[t];for(let c=n;c<=i;c++)o>r?e[c]=s[a++]:a>i?e[c]=s[o++]:t(s[a],s[o])<0?e[c]=s[a++]:e[c]=s[o++]}(t,n,r,o,i,s)}(e,t,0,e.length-1,[]),e}function s(e,t,n){const r=[];function i(e,t,n){if(0===t&&0===n.length)return;const i=r[r.length-1];i&&i.start+i.deleteCount===e?(i.deleteCount+=t,i.toInsert.push(...n)):r.push({start:e,deleteCount:t,toInsert:n})}let s=0,o=0
;for(;;){if(s===e.length){i(s,0,t.slice(o));break}if(o===t.length){i(s,e.length-s,[]);break}const r=e[s],a=t[o],c=n(r,a);0===c?(s+=1,o+=1):c<0?(i(s,1,[]),s+=1):c>0&&(i(s,0,[a]),o+=1)}return r}function o(e,t,n,i,s){for(const o=n.length;i<s;i++){const s=e[i];if(t(s,n[o-1])<0){n.pop();const e=r(n,e=>t(s,e)<0);n.splice(e,0,s)}}}function a(e,t){const n=e.indexOf(t);if(n>-1)return e.splice(n,1),t}Object.defineProperty(t,"__esModule",{value:!0}),t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0,t.tail=function(e,t=0){return e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call")
;return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,n=((e,t)=>e===t)){if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(let r=0,i=e.length;r<i;r++)if(!n(e[r],t[r]))return!1;return!0},t.binarySearch=function(e,t,n){let r=0,i=e.length-1;for(;r<=i;){const s=(r+i)/2|0,o=n(e[s],t);if(o<0)r=s+1;else{if(!(o>0))return s;i=s-1}}return-(r+1)},t.findFirstInSorted=r,t.quickSelect=function e(t,n,r){if((t|=0)>=n.length)throw new TypeError("invalid index");let i=n[Math.floor(n.length*Math.random())],s=[],o=[],a=[];for(let e of n){const t=r(e,i);t<0?s.push(e):t>0?o.push(e):a.push(e)}return t<s.length?e(t,s,r):t<s.length+a.length?a[0]:e(t-(s.length+a.length),o,r)},t.mergeSort=i,t.groupBy=function(e,t){const n=[];let r=void 0;for(const s of i(e.slice(0),t))r&&0===t(r[0],s)?r.push(s):(r=[s],n.push(r));return n},t.sortedDiff=s,t.delta=function(e,t,n){const r=s(e,t,n),i=[],o=[];for(const t of r)i.push(...e.slice(t.start,t.start+t.deleteCount)),o.push(...t.toInsert);return{removed:i,added:o}
},t.top=function(e,t,n){if(0===n)return[];const r=e.slice(0,n).sort(t);return o(e,t,r,n,e.length),r},t.topAsync=function(e,t,r,i,s){return 0===r?Promise.resolve([]):new Promise((a,c)=>{(async()=>{const a=e.length,c=e.slice(0,r).sort(t);for(let l=r,u=Math.min(r+i,a);l<a;l=u,u=Math.min(u+i,a)){if(l>r&&await new Promise(e=>setTimeout(e)),s&&s.isCancellationRequested)throw n.canceled();o(e,t,c,l,u)}return c})().then(a,c)})},t.coalesce=function(e){return e.filter(e=>!!e)},t.coalesceInPlace=function(e){let t=0;for(let n=0;n<e.length;n++)e[n]&&(e[t]=e[n],t+=1);e.length=t},t.move=function(e,t,n){e.splice(n,0,e.splice(t,1)[0])},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter((t,n)=>e.indexOf(t)===n);const n=Object.create(null);return e.filter(e=>{const r=t(e);return!n[r]&&(n[r]=!0,!0)})},t.distinctES6=function(e){const t=new Set;return e.filter(e=>!t.has(e)&&(t.add(e),!0))},
t.uniqueFilter=function(e){const t=Object.create(null);return n=>{const r=e(n);return!t[r]&&(t[r]=!0,!0)}},t.lastIndex=function(e,t){for(let n=e.length-1;n>=0;n--){if(t(e[n]))return n}return-1},t.firstOrDefault=function(e,t){return e.length>0?e[0]:t},t.commonPrefixLength=function(e,t,n=((e,t)=>e===t)){let r=0;for(let i=0,s=Math.min(e.length,t.length);i<s&&n(e[i],t[i]);i++)r++;return r},t.flatten=function(e){return[].concat(...e)},t.range=function(e,t){let n="number"==typeof t?e:0;"number"==typeof t?n=e:(n=0,t=e);const r=[];if(n<=t)for(let e=n;e<t;e++)r.push(e);else for(let e=n;e>t;e--)r.push(e);return r},t.index=function(e,t,n){return e.reduce((e,r)=>(e[t(r)]=n?n(r):r,e),Object.create(null))},t.insert=function(e,t){return e.push(t),()=>a(e,t)},t.remove=a,t.arrayInsert=function(e,t,n){const r=e.slice(0,t),i=e.slice(t);return r.concat(n,i)},t.shuffle=function(e,t){let n;if("number"==typeof t){let e=t;n=()=>{const t=179426549*Math.sin(e++);return t-Math.floor(t)}}else n=Math.random
;for(let t=e.length-1;t>0;t-=1){const r=Math.floor(n()*(t+1)),i=e[t];e[t]=e[r],e[r]=i}},t.pushToStart=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.unshift(t))},t.pushToEnd=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.push(t))},t.mapArrayOrNot=function(e,t){return Array.isArray(e)?e.map(t):t(e)},t.asArray=function(e){return Array.isArray(e)?e:[e]},t.getRandomElement=function(e){return e[Math.floor(Math.random()*e.length)]}})),define(t[72],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0,t.once=function(e){const t=this;let n,r=!1;return function(){return r?n:(r=!0,n=e.apply(t,arguments))}}})),define(t[57],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0,function(e){e.is=function(e){return e&&"object"==typeof e&&"function"==typeof e[Symbol.iterator]};const t=Object.freeze([]);e.empty=function(){return t},e.single=function*(e){yield e},e.from=function(e){return e||t},
e.first=function(e){return e[Symbol.iterator]().next().value},e.some=function(e,t){for(const n of e)if(t(n))return!0;return!1},e.filter=function*(e,t){for(const n of e)t(n)&&(yield n)},e.map=function*(e,t){for(const n of e)yield t(n)},e.concat=function*(...e){for(const t of e)for(const e of t)yield e},e.consume=function(t,n=Number.POSITIVE_INFINITY){const r=[];if(0===n)return[r,t];const i=t[Symbol.iterator]();for(let t=0;t<n;t++){const t=i.next();if(t.done)return[r,e.empty()];r.push(t.value)}return[r,{[Symbol.iterator]:()=>i}]}}(t.Iterable||(t.Iterable={}))})),define(t[35],n([0,1]),(function(e,t){"use strict";var n,r;function i(e,t=!1){let n=0,r=e.length,i="",c=0,l=16,u=0;function h(t){let r=0,i=0;for(;r<t;){const t=e.charCodeAt(n);if(t>=48&&t<=57)i=16*i+t-48;else if(t>=65&&t<=70)i=16*i+t-65+10;else{if(!(t>=97&&t<=102))break;i=16*i+t-97+10}n++,r++}return r<t&&(i=-1),i}function d(){if(i="",u=0,c=n,n>=r)return c=r,l=17;let t=e.charCodeAt(n);if(s(t)){do{n++,i+=String.fromCharCode(t),t=e.charCodeAt(n)}while(s(t))
;return l=15}if(o(t))return n++,i+=String.fromCharCode(t),13===t&&10===e.charCodeAt(n)&&(n++,i+="\n"),l=14;switch(t){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,i=function(){let t="",i=n;for(;;){if(n>=r){t+=e.substring(i,n),u=2;break}const s=e.charCodeAt(n);if(34===s){t+=e.substring(i,n),n++;break}if(92!==s){if(s>=0&&s<=31){if(o(s)){t+=e.substring(i,n),u=2;break}u=6}n++}else{if(t+=e.substring(i,n),++n>=r){u=2;break}switch(e.charCodeAt(n++)){case 34:t+='"';break;case 92:t+="\\";break;case 47:t+="/";break;case 98:t+="\b";break;case 102:t+="\f";break;case 110:t+="\n";break;case 114:t+="\r";break;case 116:t+="\t";break;case 117:const e=h(4);e>=0?t+=String.fromCharCode(e):u=4;break;default:u=5}i=n}}return t}(),l=10;case 47:const s=n-1;if(47===e.charCodeAt(n+1)){for(n+=2;n<r&&!o(e.charCodeAt(n));)n++;return i=e.substring(s,n),l=12}if(42===e.charCodeAt(n+1)){n+=2;const t=r-1;let o=!1;for(;n<t;){
if(42===e.charCodeAt(n)&&47===e.charCodeAt(n+1)){n+=2,o=!0;break}n++}return o||(n++,u=1),i=e.substring(s,n),l=13}return i+=String.fromCharCode(t),n++,l=16;case 45:if(i+=String.fromCharCode(t),++n===r||!a(e.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=function(){const t=n;if(48===e.charCodeAt(n))n++;else for(n++;n<e.length&&a(e.charCodeAt(n));)n++;if(n<e.length&&46===e.charCodeAt(n)){if(!(++n<e.length&&a(e.charCodeAt(n))))return u=3,e.substring(t,n);for(n++;n<e.length&&a(e.charCodeAt(n));)n++}let r=n;if(n<e.length&&(69===e.charCodeAt(n)||101===e.charCodeAt(n)))if((++n<e.length&&43===e.charCodeAt(n)||45===e.charCodeAt(n))&&n++,n<e.length&&a(e.charCodeAt(n))){for(n++;n<e.length&&a(e.charCodeAt(n));)n++;r=n}else u=3;return e.substring(t,r)}(),l=11;default:for(;n<r&&f(t);)n++,t=e.charCodeAt(n);if(c!==n){switch(i=e.substring(c,n)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return i+=String.fromCharCode(t),
n++,l=16}}function f(e){if(s(e)||o(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}return{setPosition:function(e){n=e,i="",c=0,l=16,u=0},getPosition:()=>n,scan:t?function(){let e;do{e=d()}while(e>=12&&e<=15);return e}:d,getToken:()=>l,getTokenValue:()=>i,getTokenOffset:()=>c,getTokenLength:()=>n-c,getTokenError:()=>u}}function s(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&e<=8203||8239===e||8287===e||12288===e||65279===e}function o(e){return 10===e||13===e||8232===e||8233===e}function a(e){return e>=48&&e<=57}function c(e,t,n=!1){return t>=e.offset&&t<e.offset+e.length||n&&t===e.offset+e.length}function l(e,t,r=n.DEFAULT){const s=i(e,!1);function o(e){return e?()=>e(s.getTokenOffset(),s.getTokenLength()):()=>!0}function a(e){return e?t=>e(t,s.getTokenOffset(),s.getTokenLength()):()=>!0}
const c=o(t.onObjectBegin),l=a(t.onObjectProperty),u=o(t.onObjectEnd),h=o(t.onArrayBegin),d=o(t.onArrayEnd),f=a(t.onLiteralValue),p=a(t.onSeparator),m=o(t.onComment),g=a(t.onError),v=r&&r.disallowComments,y=r&&r.allowTrailingComma;function b(){for(;;){const e=s.scan();switch(s.getTokenError()){case 4:w(14);break;case 5:w(15);break;case 3:w(13);break;case 1:v||w(11);break;case 2:w(12);break;case 6:w(16)}switch(e){case 12:case 13:v?w(10):m();break;case 16:w(1);break;case 15:case 14:break;default:return e}}}function w(e,t=[],n=[]){if(g(e),t.length+n.length>0){let e=s.getToken();for(;17!==e;){if(-1!==t.indexOf(e)){b();break}if(-1!==n.indexOf(e))break;e=b()}}}function _(e){const t=s.getTokenValue();return e?f(t):l(t),b(),!0}function E(){switch(s.getToken()){case 3:return function(){h(),b();let e=!1;for(;4!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||w(4,[],[]),p(","),b(),4===s.getToken()&&y)break}else e&&w(6,[],[]);E()||w(4,[],[4,5]),e=!0}return d(),4!==s.getToken()?w(8,[4],[]):b(),!0}();case 1:
return function(){c(),b();let e=!1;for(;2!==s.getToken()&&17!==s.getToken();){if(5===s.getToken()){if(e||w(4,[],[]),p(","),b(),2===s.getToken()&&y)break}else e&&w(6,[],[]);(10!==s.getToken()?(w(3,[],[2,5]),0):(_(!1),6===s.getToken()?(p(":"),b(),E()||w(4,[],[2,5])):w(5,[],[2,5]),1))||w(4,[],[2,5]),e=!0}return u(),2!==s.getToken()?w(7,[2],[]):b(),!0}();case 10:return _(!0);default:return function(){switch(s.getToken()){case 11:let e=0;try{"number"!=typeof(e=JSON.parse(s.getTokenValue()))&&(w(2),e=0)}catch(e){w(2)}f(e);break;case 7:f(null);break;case 8:f(!0);break;case 9:f(!1);break;default:return!1}return b(),!0}()}}return b(),17===s.getToken()?!!r.allowEmptyContent||(w(4,[],[]),!1):E()?(17!==s.getToken()&&w(9,[],[]),!0):(w(4,[],[]),!1)}function u(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":return e?Array.isArray(e)?"array":"object":"null";default:return"null"}}Object.defineProperty(t,"__esModule",{value:!0}),
t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"}(t.ScanError||(t.ScanError={})),function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",
e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"}(t.SyntaxKind||(t.SyntaxKind={})),function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"
}(t.ParseErrorCode||(t.ParseErrorCode={})),function(e){e.DEFAULT={allowTrailingComma:!0}}(n=t.ParseOptions||(t.ParseOptions={})),t.createScanner=i,function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",
e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",
e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(r||(r={})),t.getLocation=function(e,t){const n=[],r=new Object;let i=void 0;const s={value:{},offset:0,length:0,
type:"object",parent:void 0};let o=!1;function a(e,t,n,r){s.value=e,s.offset=t,s.length=n,s.type=r,s.colonOffset=void 0,i=s}try{l(e,{onObjectBegin:(e,s)=>{if(t<=e)throw r;i=void 0,o=t>e,n.push("")},onObjectProperty:(e,i,s)=>{if(t<i)throw r;if(a(e,i,s,"property"),n[n.length-1]=e,t<=i+s)throw r},onObjectEnd:(e,s)=>{if(t<=e)throw r;i=void 0,n.pop()},onArrayBegin:(e,s)=>{if(t<=e)throw r;i=void 0,n.push(0)},onArrayEnd:(e,s)=>{if(t<=e)throw r;i=void 0,n.pop()},onLiteralValue:(e,n,i)=>{if(t<n)throw r;if(a(e,n,i,u(e)),t<=n+i)throw r},onSeparator:(e,s,a)=>{if(t<=s)throw r;if(":"===e&&i&&"property"===i.type)i.colonOffset=s,o=!1,i=void 0;else if(","===e){const e=n[n.length-1];"number"==typeof e?n[n.length-1]=e+1:(o=!0,n[n.length-1]=""),i=void 0}}})}catch(e){if(e!==r)throw e}return{path:n,previousNode:i,isAtPropertyKey:o,matches:e=>{let t=0;for(let r=0;t<e.length&&r<n.length;r++)if(e[t]===n[r]||"*"===e[t])t++;else if("**"!==e[t])return!1;return t===e.length}}},t.parse=function(e,t=[],r=n.DEFAULT){let i=null,s=[]
;const o=[];function a(e){Array.isArray(s)?s.push(e):null!==i&&(s[i]=e)}return l(e,{onObjectBegin:()=>{const e={};a(e),o.push(s),s=e,i=null},onObjectProperty:e=>{i=e},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const e=[];a(e),o.push(s),s=e,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:a,onError:(e,n,r)=>{t.push({error:e,offset:n,length:r})}},r),s[0]},t.parseTree=function(e,t=[],r=n.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(e){"property"===i.type&&(i.length=e-i.offset,i=i.parent)}function o(e){return i.children.push(e),e}l(e,{onObjectBegin:e=>{i=o({type:"object",offset:e,length:-1,parent:i,children:[]})},onObjectProperty:(e,t,n)=>{(i=o({type:"property",offset:t,length:-1,parent:i,children:[]})).children.push({type:"string",value:e,offset:t,length:n,parent:i})},onObjectEnd:(e,t)=>{i.length=e+t-i.offset,i=i.parent,s(e+t)},onArrayBegin:(e,t)=>{i=o({type:"array",offset:e,length:-1,parent:i,children:[]})},onArrayEnd:(e,t)=>{i.length=e+t-i.offset,i=i.parent,s(e+t)
},onLiteralValue:(e,t,n)=>{o({type:u(e),offset:t,length:n,parent:i,value:e}),s(t+n)},onSeparator:(e,t,n)=>{"property"===i.type&&(":"===e?i.colonOffset=t:","===e&&s(t))},onError:(e,n,r)=>{t.push({error:e,offset:n,length:r})}},r);const a=i.children[0];return a&&delete a.parent,a},t.findNodeAtLocation=function(e,t){if(!e)return;let n=e;for(let e of t)if("string"==typeof e){if("object"!==n.type||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===e){n=r.children[1],t=!0;break}if(!t)return}else{const t=e;if("array"!==n.type||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n},t.getNodePath=function e(t){if(!t.parent||!t.parent.children)return[];const n=e(t.parent);if("property"===t.parent.type){const e=t.parent.children[0].value;n.push(e)}else if("array"===t.parent.type){const e=t.parent.children.indexOf(t);-1!==e&&n.push(e)}return n},t.getNodeValue=function e(t){switch(t.type){case"array":
return t.children.map(e);case"object":const n=Object.create(null);for(let r of t.children){const t=r.children[1];t&&(n[r.children[0].value]=e(t))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}},t.contains=c,t.findNodeAtOffset=function e(t,n,r=!1){if(c(t,n,r)){const i=t.children;if(Array.isArray(i))for(let t=0;t<i.length&&i[t].offset<=n;t++){const s=e(i[t],n,r);if(s)return s}return t}},t.visit=l,t.stripComments=function(e,t){let n,r,s=i(e),o=[],a=0;do{switch(r=s.getPosition(),n=s.scan()){case 12:case 13:case 17:a!==r&&o.push(e.substring(a,r)),void 0!==t&&o.push(s.getTokenValue().replace(/[^\r\n]/g,t)),a=s.getPosition()}}while(17!==n);return o.join("")},t.getNodeType=u})),define(t[109],n([0,1,35]),(function(e,t,n){"use strict";function r(e,t){let n="";for(let r=0;r<t;r++)n+=e;return n}function i(e,t){for(let e=0;e<t.length;e++){const n=t.charAt(e);if("\r"===n)return e+1<t.length&&"\n"===t.charAt(e+1)?"\r\n":"\r";if("\n"===n)return"\n"}return e&&e.eol||"\n"}
function s(e,t){return-1!=="\r\n".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0}),t.isEOL=t.getEOL=t.format=void 0,t.format=function(e,t,o){let a,c,l,u,h;if(t){for(u=t.offset,h=u+t.length,l=u;l>0&&!s(e,l-1);)l--;let n=h;for(;n<e.length&&!s(e,n);)n++;c=e.substring(l,n),a=function(e,t){let n=0,r=0;const i=t.tabSize||4;for(;n<e.length;){const t=e.charAt(n);if(" "===t)r++;else{if("\t"!==t)break;r+=i}n++}return Math.floor(r/i)}(c,o)}else c=e,a=0,l=0,u=0,h=e.length;const d=i(o,e);let f,p=!1,m=0;f=o.insertSpaces?r(" ",o.tabSize||4):"\t";const g=n.createScanner(c,!1);let v=!1;function y(){return d+r(f,a+m)}function b(){let e=g.scan();for(p=!1;15===e||14===e;)p=p||14===e,e=g.scan();return v=16===e||0!==g.getTokenError(),e}const w=[];function _(t,n,r){!v&&n<h&&r>u&&e.substring(n,r)!==t&&w.push({offset:n,length:r-n,content:t})}let E=b();if(17!==E){const e=g.getTokenOffset()+l;_(r(f,a),l,e)}for(;17!==E;){let e=g.getTokenOffset()+g.getTokenLength()+l,t=b(),n="";for(;!p&&(12===t||13===t);){
_(" ",e,g.getTokenOffset()+l),e=g.getTokenOffset()+g.getTokenLength()+l,n=12===t?y():"",t=b()}if(2===t)1!==E&&(m--,n=y());else if(4===t)3!==E&&(m--,n=y());else{switch(E){case 3:case 1:m++,n=y();break;case 5:case 12:n=y();break;case 13:n=p?y():" ";break;case 6:n=" ";break;case 10:if(6===t){n="";break}case 7:case 8:case 9:case 11:case 2:case 4:12===t||13===t?n=" ":5!==t&&17!==t&&(v=!0);break;case 16:v=!0}!p||12!==t&&13!==t||(n=y())}_(n,e,g.getTokenOffset()+l),E=t}return w},t.getEOL=i,t.isEOL=s})),define(t[110],n([0,1,35,109,16]),(function(e,t,n,r,i){"use strict";function s(e,t,r,i,s){const a=t.slice(),c=n.parseTree(e,[]);let l=void 0,u=void 0;for(;a.length>0&&(u=a.pop(),void 0===(l=n.findNodeAtLocation(c,a))&&void 0!==r);)r="string"==typeof u?{[u]:r}:[r];if(l){if("object"===l.type&&"string"==typeof u&&Array.isArray(l.children)){const t=n.findNodeAtLocation(l,[u]);if(void 0!==t){if(void 0===r){if(!t.parent)throw new Error("Malformed AST");const n=l.children.indexOf(t.parent)
;let r,s=t.parent.offset+t.parent.length;if(n>0){const e=l.children[n-1];r=e.offset+e.length}else if(r=l.offset+1,l.children.length>1){s=l.children[1].offset}return o(e,{offset:r,length:s-r,content:""},i)}return o(e,{offset:t.offset,length:t.length,content:JSON.stringify(r)},i)}{if(void 0===r)return[];const t=`${JSON.stringify(u)}: ${JSON.stringify(r)}`,n=s?s(l.children.map(e=>e.children[0].value)):l.children.length;let a;if(n>0){const e=l.children[n-1];a={offset:e.offset+e.length,length:0,content:","+t}}else a=0===l.children.length?{offset:l.offset+1,length:0,content:t}:{offset:l.offset+1,length:0,content:t+","};return o(e,a,i)}}if("array"===l.type&&"number"==typeof u&&Array.isArray(l.children)){if(void 0!==r){const t=`${JSON.stringify(r)}`;let n;if(0===l.children.length||0===u)n={offset:l.offset+1,length:0,content:0===l.children.length?t:t+","};else{const e=-1===u||u>l.children.length?l.children.length:u,r=l.children[e-1];n={offset:r.offset+r.length,length:0,content:","+t}}return o(e,n,i)}{
const t=u,n=l.children[t];let r;if(1===l.children.length)r={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===t){const e=l.children[t-1],n=e.offset+e.length;r={offset:n,length:l.offset+l.length-2-n,content:""}}else r={offset:n.offset,length:l.children[t+1].offset-n.offset,content:""};return o(e,r,i)}}throw new Error(`Can not add ${"number"!=typeof u?"index":"property"} to parent of type ${l.type}`)}if(void 0===r)throw new Error("Can not delete in empty document");return o(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(r)},i)}function o(e,t,n){let i=a(e,t),s=t.offset,o=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;s>0&&!r.isEOL(i,s-1);)s--;for(;o<i.length&&!r.isEOL(i,o);)o++}const c=r.format(i,{offset:s,length:o-s},n);for(let e=c.length-1;e>=0;e--){const t=c[e];i=a(i,t),s=Math.min(s,t.offset),o=Math.max(o,t.offset+t.length),o+=t.content.length-t.length}return[{offset:s,length:e.length-(i.length-o)-s,content:i.substring(s,o)}]}
function a(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}Object.defineProperty(t,"__esModule",{value:!0}),t.applyEdits=t.applyEdit=t.withFormatting=t.setProperty=t.removeProperty=void 0,t.removeProperty=function(e,t,n){return s(e,t,void 0,n)},t.setProperty=s,t.withFormatting=o,t.applyEdit=a,t.applyEdits=function(e,t){let n=i.mergeSort(t,(e,t)=>{const n=e.offset-t.offset;return 0===n?e.length-t.length:n}),r=e.length;for(let t=n.length-1;t>=0;t--){let i=n[t];if(!(i.offset+i.length<=r))throw new Error("Overlapping edit");e=a(e,i),r=i.offset}return e}})),define(t[3],n([0,1,72,57]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=void 0;const i=!1,s="__is_disposable_tracked__";function o(e){if(i&&e&&e!==h.None)try{e[s]=!0}catch(e){}}function a(e){if(!i)return e
;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[s]||console.log(t)},3e3),e}class c extends Error{constructor(e){super(`Encounter errors while disposing of store. Errors: [${e.join(", ")}]`),this.errors=e}}function l(e){if(r.Iterable.is(e)){let t=[];for(const n of e)if(n){o(n);try{n.dispose()}catch(e){t.push(e)}}if(1===t.length)throw t[0];if(t.length>1)throw new c(t);return Array.isArray(e)?[]:e}if(e)return o(e),e.dispose(),e}t.MultiDisposeError=c,t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=l,t.combinedDisposable=function(...e){return e.forEach(o),a({dispose:()=>l(e)})},t.toDisposable=function(e){const t=a({dispose:()=>{o(t),e()}});return t};class u{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(o(this),this._isDisposed=!0,this.clear())}clear(){try{l(this._toDispose.values())}finally{this._toDispose.clear()}}add(e){if(!e)return e
;if(e===this)throw new Error("Cannot register a disposable on itself!");return o(e),this._isDisposed?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(e),e}}t.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this._store=new u,a(this)}dispose(){o(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}t.Disposable=h,h.None=Object.freeze({dispose(){}});t.MutableDisposable=class{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&o(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,o(this),this._value&&this._value.dispose(),this._value=void 0}};t.ReferenceCollection=class{constructor(){this.references=new Map}
acquire(e,...t){let r=this.references.get(e);r||(r={counter:0,object:this.createReferencedObject(e,...t)},this.references.set(e,r));const{object:i}=r,s=n.once(()=>{0==--r.counter&&(this.destroyReferencedObject(e,r.object),this.references.delete(e))});return r.counter++,{object:i,dispose:s}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}})),define(t[111],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class n{constructor(e){this.element=e,this.next=n.Undefined,this.prev=n.Undefined}}n.Undefined=new n(void 0);t.LinkedList=class{constructor(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===n.Undefined}clear(){this._first=n.Undefined,this._last=n.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const r=new n(e);if(this._first===n.Undefined)this._first=r,this._last=r;else if(t){const e=this._last
;this._last=r,r.prev=e,e.next=r}else{const e=this._first;this._first=r,r.next=e,e.prev=r}this._size+=1;let i=!1;return()=>{i||(i=!0,this._remove(r))}}shift(){if(this._first!==n.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==n.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==n.Undefined&&e.next!==n.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===n.Undefined&&e.next===n.Undefined?(this._first=n.Undefined,this._last=n.Undefined):e.next===n.Undefined?(this._last=this._last.prev,this._last.next=n.Undefined):e.prev===n.Undefined&&(this._first=this._first.next,this._first.prev=n.Undefined);this._size-=1}*[Symbol.iterator](){let e=this._first;for(;e!==n.Undefined;)yield e.element,e=e.next}toArray(){const e=[];for(let t=this._first;t!==n.Undefined;t=t.next)e.push(t.element);return e}}})),define(t[6],n([0,1,15,72,3,111]),(function(e,t,n,r,i,s){"use strict";var o;Object.defineProperty(t,"__esModule",{
value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.AsyncEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0,function(e){function t(e){return(t,n=null,r)=>{let i,s=!1;return i=e(e=>{if(!s)return i?i.dispose():s=!0,t.call(n,e)},null,r),s&&i.dispose(),i}}function n(e,t){return a((n,r=null,i)=>e(e=>n.call(r,t(e)),null,i))}function r(e,t){return a((n,r=null,i)=>e(e=>{t(e),n.call(r,e)},null,i))}function s(e,t){return a((n,r=null,i)=>e(e=>t(e)&&n.call(r,e),null,i))}function o(e,t,r){let i=r;return n(e,e=>i=t(i,e))}function a(e){let t;const n=new l({onFirstListenerAdd(){t=e(n.fire,n)},onLastListenerRemove(){t.dispose()}});return n.event}function c(e,t,n=100,r=!1,i){let s,o=void 0,a=void 0,c=0;const u=new l({leakWarningThreshold:i,onFirstListenerAdd(){s=e(e=>{c++,o=t(o,e),r&&!a&&(u.fire(o),o=void 0),clearTimeout(a),a=setTimeout(()=>{const e=o;o=void 0,a=void 0,(!r||c>1)&&u.fire(e),c=0},n)})},onLastListenerRemove(){s.dispose()}});return u.event}function u(e){let t,n=!0
;return s(e,e=>{const r=n||e!==t;return n=!1,t=e,r})}e.None=()=>i.Disposable.None,e.once=t,e.map=n,e.forEach=r,e.filter=s,e.signal=function(e){return e},e.any=function(...e){return(t,n=null,r)=>i.combinedDisposable(...e.map(e=>e(e=>t.call(n,e),null,r)))},e.reduce=o,e.snapshot=a,e.debounce=c,e.stopwatch=function(e){const r=(new Date).getTime();return n(t(e),e=>(new Date).getTime()-r)},e.latch=u,e.buffer=function(e,t=!1,n=[]){let r=n.slice(),i=e(e=>{r?r.push(e):o.fire(e)});const s=()=>{r&&r.forEach(e=>o.fire(e)),r=null},o=new l({onFirstListenerAdd(){i||(i=e(e=>o.fire(e)))},onFirstListenerDidAdd(){r&&(t?setTimeout(s):s())},onLastListenerRemove(){i&&i.dispose(),i=null}});return o.event};class h{constructor(e){this.event=e}map(e){return new h(n(this.event,e))}forEach(e){return new h(r(this.event,e))}filter(e){return new h(s(this.event,e))}reduce(e,t){return new h(o(this.event,e,t))}latch(){return new h(u(this.event))}debounce(e,t=100,n=!1,r){return new h(c(this.event,e,t,n,r))}on(e,t,n){return this.event(e,t,n)}
once(e,n,r){return t(this.event)(e,n,r)}}e.chain=function(e){return new h(e)},e.fromNodeEventEmitter=function(e,t,n=(e=>e)){const r=(...e)=>i.fire(n(...e)),i=new l({onFirstListenerAdd:()=>e.on(t,r),onLastListenerRemove:()=>e.removeListener(t,r)});return i.event},e.fromDOMEventEmitter=function(e,t,n=(e=>e)){const r=(...e)=>i.fire(n(...e)),i=new l({onFirstListenerAdd:()=>e.addEventListener(t,r),onLastListenerRemove:()=>e.removeEventListener(t,r)});return i.event},e.fromPromise=function(e){const t=new l;let n=!1;return e.then(void 0,()=>null).then(()=>{n?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),n=!0,t.event},e.toPromise=function(e){return new Promise(n=>t(e)(n))}}(o=t.Event||(t.Event={}));let a=-1;t.setGlobalLeakWarningThreshold=function(e){const t=a;return a=e,{dispose(){a=t}}};class c{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=a
;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const n=(new Error).stack.split("\n").slice(3).join("\n"),r=this._stacks.get(n)||0;if(this._stacks.set(n,r+1),this._warnCountdown-=1,this._warnCountdown<=0){let n;this._warnCountdown=.5*t;let r=0;for(const[e,t]of this._stacks)(!n||r<t)&&(n=e,r=t);console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${r}):`),console.warn(n)}return()=>{const e=this._stacks.get(n)||0;this._stacks.set(n,e-1)}}}class l{constructor(e){this._disposed=!1,this._options=e,this._leakageMon=a>0?new c(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=(e,t,n)=>{this._listeners||(this._listeners=new s.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const o=this._listeners.push(t?[e,t]:e);let a,c
;return r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,e,t),this._leakageMon&&(a=this._leakageMon.check(this._listeners.size)),c={dispose:()=>{if(a&&a(),c.dispose=l._noop,!this._disposed&&(o(),this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},n instanceof i.DisposableStore?n.add(c):Array.isArray(n)&&n.push(c),c}),this._event}fire(e){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new s.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,e]);for(;this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){n.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),
this._disposed=!0}}t.Emitter=l,l._noop=function(){};t.PauseableEmitter=class extends l{constructor(e){super(e),this._isPaused=0,this._eventQueue=new s.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray();this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}};t.AsyncEmitter=class extends l{async fireAsync(e,t,r){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new s.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,e]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[e,t]=this._asyncDeliveryQueue.shift(),i=[],s=Object.assign(Object.assign({},t),{waitUntil:t=>{if(Object.isFrozen(i))throw new Error("waitUntil can NOT be called asynchronous")
;r&&(t=r(t,"function"==typeof e?e:e[0])),i.push(t)}});try{"function"==typeof e?e.call(void 0,s):e[0].call(e[1],s)}catch(e){n.onUnexpectedError(e);continue}Object.freeze(i),await Promise.all(i).catch(e=>n.onUnexpectedError(e))}}}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t);return i.toDisposable(r.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{
constructor(){this.buffers=[]}wrapEvent(e){return(t,n,r)=>e(e=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>t.call(n,e)):t.call(n,e)},void 0,r)}bufferEvents(e){const t=[];this.buffers.push(t);const n=e();return this.buffers.pop(),t.forEach(e=>e()),n}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=o.None,this.inputEventListener=i.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}})),define(t[28],n([0,1,6]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0
;const r=Object.freeze((function(e,t){const n=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(n)}}}));var i;!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||(t instanceof s||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})}(i=t.CancellationToken||(t.CancellationToken={}));class s{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?r:(this._emitter||(this._emitter=new n.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){
this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new s),this._token}cancel(){this._token?this._token instanceof s&&this._token.cancel():this._token=i.Cancelled}dispose(e=!1){e&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof s&&this._token.dispose():this._token=i.None}}})),define(t[17],n([0,1,28,15,6,3]),(function(e,t,n,r,i,s){"use strict";function o(e){return e&&"function"==typeof e.then}function a(e){const t=new n.CancellationTokenSource,i=e(t.token),s=new Promise((e,n)=>{t.token.onCancellationRequested(()=>{n(r.canceled())}),Promise.resolve(i).then(n=>{t.dispose(),e(n)},e=>{t.dispose(),n(e)})});return new class{cancel(){t.cancel()}then(e,t){return s.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return s.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),
t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.RunOnceWorker=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.first=t.sequence=t.ignoreErrors=t.disposableTimeout=t.timeout=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0,t.isThenable=o,t.createCancelablePromise=a,t.raceCancellation=function(e,t,n){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(n)))])},t.raceCancellablePromises=async function(e){let t=-1;const n=e.map((e,n)=>e.then(e=>(t=n,e))),r=await Promise.race(n);return e.forEach((e,n)=>{n!==t&&e.cancel()}),r},t.raceTimeout=function(e,t,n){let r=void 0;const i=setTimeout(()=>{null==r||r(void 0),null==n||n()},t);return Promise.race([e.finally(()=>clearTimeout(i)),new Promise(e=>r=e)])},t.asPromise=function(e){return new Promise((t,n)=>{const r=e();o(r)?r.then(t,n):t(r)})}
;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=c;t.Sequencer=class{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}};t.SequencerByKey=class{constructor(){this.promiseMap=new Map}queue(e,t){var n;const r=(null!==(n=this.promiseMap.get(e))&&void 0!==n?n:Promise.resolve()).catch(()=>{}).then(t).finally(()=>{this.promiseMap.get(e)===r&&this.promiseMap.delete(e)});return this.promiseMap.set(e,r),r}};class l{
constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const e=this.task;return this.task=null,e()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(r.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=l;t.ThrottledDelayer=class{constructor(e){this.delayer=new l(e),this.throttler=new c}trigger(e,t){return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){
return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function u(e,t){return t?new Promise((n,i)=>{const s=setTimeout(n,e);t.onCancellationRequested(()=>{clearTimeout(s),i(r.canceled())})}):a(t=>u(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}},t.timeout=u,t.disposableTimeout=function(e,t=0){const n=setTimeout(e,t);return s.toDisposable(()=>clearTimeout(n))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let n=0;const r=e.length;return Promise.resolve(null).then((function i(s){null!=s&&t.push(s);const o=n<r?e[n++]():null;return o?o.then(i):Promise.resolve(t)}))},t.first=function(e,t=(e=>!!e),n=null){let r=0;const i=e.length,s=()=>{if(r>=i)return Promise.resolve(n);const o=e[r++];return Promise.resolve(o()).then(e=>t(e)?Promise.resolve(e):s())}
;return s()};class h{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new i.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,n)=>{this.outstandingPromises.push({factory:e,c:t,e:n}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=h;class d extends h{constructor(){super(1)}}t.Queue=d;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new d;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),
this.queues.set(t,e)}return this.queues.get(t)}dispose(){this.queues.forEach(e=>e.dispose()),this.queues.clear()}};t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class f{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),
this.timeoutToken=setTimeout(this.timeoutHandler,e)}get delay(){return this.timeout}set delay(e){this.timeout=e}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=f;t.RunOnceWorker=class extends f{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=t=>{const n=setTimeout(()=>t(e));let r=!1;return{dispose(){r||(r=!0,clearTimeout(n))}}}}else t.runWhenIdle=(e,t)=>{const n=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let r=!1;return{dispose(){r||(r=!0,cancelIdleCallback(n))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()
}catch(e){this._error=e}finally{this._didRun=!0}},this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,n){let r;for(let i=0;i<n;i++)try{return await e()}catch(e){r=e,await u(t)}throw r};t.TaskSequentializer=class{hasPending(e){return!!this._pending&&("number"==typeof e?this._pending.taskId===e:!!this._pending)}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var e;null===(e=this._pending)||void 0===e||e.cancel()}setPending(e,t,n){return this._pending={taskId:e,cancel:()=>null==n?void 0:n(),promise:t},t.then(()=>this.donePending(e),()=>this.donePending(e)),t}donePending(e){this._pending&&e===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const e=this._next;this._next=void 0,e.run().then(e.promiseResolve,e.promiseReject)}}setNext(e){
if(this._next)this._next.run=e;else{let t,n;const r=new Promise((e,r)=>{t=e,n=r});this._next={run:e,promise:r,promiseResolve:t,promiseReject:n}}return this._next.promise}};t.IntervalCounter=class{constructor(e){this.interval=e,this.lastIncrementTime=0,this.value=0}increment(){const e=Date.now();return e-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=e,this.value=0),this.value++,this.value}}})),
/**
 * marked - a markdown parser
 * Copyright (c) 2011-2020, Christopher Jeffrey. (MIT Licensed)
 * https://github.com/markedjs/marked
 */
function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define("vs/base/common/marked/marked",t):(e=e||self).marked=t()}(this,(function(){"use strict";function e(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,r.key,r)}}function t(e,t){(null==t||t>e.length)&&(t=e.length);for(var n=0,r=new Array(t);n<t;n++)r[n]=e[n];return r}function n(e,n){var r;if("undefined"==typeof Symbol||null==e[Symbol.iterator]){if(Array.isArray(e)||(r=function(e,n){if(e){if("string"==typeof e)return t(e,n);var r=Object.prototype.toString.call(e).slice(8,-1);return"Object"===r&&e.constructor&&(r=e.constructor.name),"Map"===r||"Set"===r?Array.from(e):"Arguments"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?t(e,n):void 0}}(e))||n&&e&&"number"==typeof e.length){r&&(e=r);var i=0;return function(){return i>=e.length?{done:!0}:{done:!1,value:e[i++]}}}
throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}return(r=e[Symbol.iterator]()).next.bind(r)}var r=function(e,t){return e(t={exports:{}},t.exports),t.exports}((function(e){function t(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}e.exports={defaults:{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1},getDefaults:t,changeDefaults:function(t){e.exports.defaults=t}}})),i=(r.defaults,r.getDefaults,r.changeDefaults,/[&<>"']/),s=/[&<>"']/g,o=/[<>"']|&(?!#?\w+;)/,a=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",
'"':"&quot;","'":"&#39;"},l=function(e){return c[e]};var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/gi;function h(e){return e.replace(u,(function(e,t){return"colon"===(t=t.toLowerCase())?":":"#"===t.charAt(0)?"x"===t.charAt(1)?String.fromCharCode(parseInt(t.substring(2),16)):String.fromCharCode(+t.substring(1)):""}))}var d=/(^|[^\[])\^/g;var f=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;var m={},g=/^[^:]+:\/*[^/]*$/,v=/^([^:]+:)[\s\S]*$/,y=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(e,t){m[" "+e]||(g.test(e)?m[" "+e]=e+"/":m[" "+e]=w(e,"/",!0));var n=-1===(e=m[" "+e]).indexOf(":");return"//"===t.substring(0,2)?n?t:e.replace(v,"$1")+t:"/"===t.charAt(0)?n?t:e.replace(y,"$1")+t:e+t}function w(e,t,n){var r=e.length;if(0===r)return"";for(var i=0;i<r;){var s=e.charAt(r-i-1);if(s!==t||n){if(s===t||!n)break;i++}else i++}return e.substr(0,r-i)}var _=function(e,t){if(t){if(i.test(e))return e.replace(s,l)}else if(o.test(e))return e.replace(a,l);return e},E=h,S=function(e,t){e=e.source||e,t=t||"";var n={
replace:function(t,r){return r=(r=r.source||r).replace(d,"$1"),e=e.replace(t,r),n},getRegex:function(){return new RegExp(e,t)}};return n},C=function(e,t,n){if(e){var r;try{r=decodeURIComponent(h(n)).replace(f,"").toLowerCase()}catch(e){return null}if(0===r.indexOf("javascript:")||0===r.indexOf("vbscript:")||0===r.indexOf("data:"))return null}t&&!p.test(n)&&(n=b(t,n));try{n=encodeURI(n).replace(/%25/g,"%")}catch(e){return null}return n},x={exec:function(){}},I=function(e){for(var t,n,r=1;r<arguments.length;r++)for(n in t=arguments[r])Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n]);return e},k=function(e,t){var n=e.replace(/\|/g,(function(e,t,n){for(var r=!1,i=t;--i>=0&&"\\"===n[i];)r=!r;return r?"|":" |"})).split(/ \|/),r=0;if(n.length>t)n.splice(t);else for(;n.length<t;)n.push("");for(;r<n.length;r++)n[r]=n[r].trim().replace(/\\\|/g,"|");return n},T=w,P=function(e,t){if(-1===e.indexOf(t[1]))return-1
;for(var n=e.length,r=0,i=0;i<n;i++)if("\\"===e[i])i++;else if(e[i]===t[0])r++;else if(e[i]===t[1]&&--r<0)return i;return-1},R=function(e){e&&e.sanitize&&e.silent},O=r.defaults,L=T,D=k,A=_,N=P;function M(e,t,n){var r=t.href,i=t.title?A(t.title):null,s=e[1].replace(/\\([\[\]])/g,"$1");return"!"!==e[0].charAt(0)?{type:"link",raw:n,href:r,title:i,text:s}:{type:"image",raw:n,href:r,title:i,text:A(s)}}var F=function(){function e(e){this.options=e||O}var t=e.prototype;return t.space=function(e){var t=this.rules.block.newline.exec(e);if(t)return t[0].length>1?{type:"space",raw:t[0]}:{raw:"\n"}},t.code=function(e,t){var n=this.rules.block.code.exec(e);if(n){var r=t[t.length-1];if(r&&"paragraph"===r.type)return{raw:n[0],text:n[0].trimRight()};var i=n[0].replace(/^ {4}/gm,"");return{type:"code",raw:n[0],codeBlockStyle:"indented",text:this.options.pedantic?i:L(i,"\n")}}},t.fences=function(e){var t=this.rules.block.fences.exec(e);if(t){var n=t[0],r=function(e,t){var n=e.match(/^(\s+)(?:```)/);if(null===n)return t
;var r=n[1];return t.split("\n").map((function(e){var t=e.match(/^\s+/);return null===t?e:t[0].length>=r.length?e.slice(r.length):e})).join("\n")}(n,t[3]||"");return{type:"code",raw:n,lang:t[2]?t[2].trim():t[2],text:r}}},t.heading=function(e){var t=this.rules.block.heading.exec(e);if(t)return{type:"heading",raw:t[0],depth:t[1].length,text:t[2]}},t.nptable=function(e){var t=this.rules.block.nptable.exec(e);if(t){var n={type:"table",header:D(t[1].replace(/^ *| *\| *$/g,"")),align:t[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:t[3]?t[3].replace(/\n$/,"").split("\n"):[],raw:t[0]};if(n.header.length===n.align.length){var r,i=n.align.length;for(r=0;r<i;r++)/^ *-+: *$/.test(n.align[r])?n.align[r]="right":/^ *:-+: *$/.test(n.align[r])?n.align[r]="center":/^ *:-+ *$/.test(n.align[r])?n.align[r]="left":n.align[r]=null;for(i=n.cells.length,r=0;r<i;r++)n.cells[r]=D(n.cells[r],n.header.length);return n}}},t.hr=function(e){var t=this.rules.block.hr.exec(e);if(t)return{type:"hr",raw:t[0]}},t.blockquote=function(e){
var t=this.rules.block.blockquote.exec(e);if(t){var n=t[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:t[0],text:n}}},t.list=function(e){var t=this.rules.block.list.exec(e);if(t){for(var n,r,i,s,o,a,c,l=t[0],u=t[2],h=u.length>1,d=")"===u[u.length-1],f={type:"list",raw:l,ordered:h,start:h?+u.slice(0,-1):"",loose:!1,items:[]},p=t[0].match(this.rules.block.item),m=!1,g=p.length,v=0;v<g;v++)l=n=p[v],r=n.length,~(n=n.replace(/^ *([*+-]|\d+[.)]) */,"")).indexOf("\n ")&&(r-=n.length,n=this.options.pedantic?n.replace(/^ {1,4}/gm,""):n.replace(new RegExp("^ {1,"+r+"}","gm"),"")),v!==g-1&&(i=this.rules.block.bullet.exec(p[v+1])[0],(h?1===i.length||!d&&")"===i[i.length-1]:i.length>1||this.options.smartLists&&i!==u)&&(s=p.slice(v+1).join("\n"),f.raw=f.raw.substring(0,f.raw.length-s.length),v=g-1)),o=m||/\n\n(?!\s*$)/.test(n),v!==g-1&&(m="\n"===n.charAt(n.length-1),o||(o=m)),o&&(f.loose=!0),c=void 0,(a=/^\[[ xX]\] /.test(n))&&(c=" "!==n[1],n=n.replace(/^\[[ xX]\] +/,"")),f.items.push({type:"list_item",raw:l,
task:a,checked:c,loose:o,text:n});return f}},t.html=function(e){var t=this.rules.block.html.exec(e);if(t)return{type:this.options.sanitize?"paragraph":"html",raw:t[0],pre:!this.options.sanitizer&&("pre"===t[1]||"script"===t[1]||"style"===t[1]),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(t[0]):A(t[0]):t[0]}},t.def=function(e){var t=this.rules.block.def.exec(e);if(t)return t[3]&&(t[3]=t[3].substring(1,t[3].length-1)),{tag:t[1].toLowerCase().replace(/\s+/g," "),raw:t[0],href:t[2],title:t[3]}},t.table=function(e){var t=this.rules.block.table.exec(e);if(t){var n={type:"table",header:D(t[1].replace(/^ *| *\| *$/g,"")),align:t[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:t[3]?t[3].replace(/\n$/,"").split("\n"):[]};if(n.header.length===n.align.length){n.raw=t[0];var r,i=n.align.length;for(r=0;r<i;r++)/^ *-+: *$/.test(n.align[r])?n.align[r]="right":/^ *:-+: *$/.test(n.align[r])?n.align[r]="center":/^ *:-+ *$/.test(n.align[r])?n.align[r]="left":n.align[r]=null;for(i=n.cells.length,
r=0;r<i;r++)n.cells[r]=D(n.cells[r].replace(/^ *\| *| *\| *$/g,""),n.header.length);return n}}},t.lheading=function(e){var t=this.rules.block.lheading.exec(e);if(t)return{type:"heading",raw:t[0],depth:"="===t[2].charAt(0)?1:2,text:t[1]}},t.paragraph=function(e){var t=this.rules.block.paragraph.exec(e);if(t)return{type:"paragraph",raw:t[0],text:"\n"===t[1].charAt(t[1].length-1)?t[1].slice(0,-1):t[1]}},t.text=function(e,t){var n=this.rules.block.text.exec(e);if(n){var r=t[t.length-1];return r&&"text"===r.type?{raw:n[0],text:n[0]}:{type:"text",raw:n[0],text:n[0]}}},t.escape=function(e){var t=this.rules.inline.escape.exec(e);if(t)return{type:"escape",raw:t[0],text:A(t[1])}},t.tag=function(e,t,n){var r=this.rules.inline.tag.exec(e);if(r)return!t&&/^<a /i.test(r[0])?t=!0:t&&/^<\/a>/i.test(r[0])&&(t=!1),!n&&/^<(pre|code|kbd|script)(\s|>)/i.test(r[0])?n=!0:n&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(r[0])&&(n=!1),{type:this.options.sanitize?"text":"html",raw:r[0],inLink:t,inRawBlock:n,
text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(r[0]):A(r[0]):r[0]}},t.link=function(e){var t=this.rules.inline.link.exec(e);if(t){var n=N(t[2],"()");if(n>-1){var r=(0===t[0].indexOf("!")?5:4)+t[1].length+n;t[2]=t[2].substring(0,n),t[0]=t[0].substring(0,r).trim(),t[3]=""}var i=t[2],s="";if(this.options.pedantic){var o=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(i);o?(i=o[1],s=o[3]):s=""}else s=t[3]?t[3].slice(1,-1):"";return M(t,{href:(i=i.trim().replace(/^<([\s\S]*)>$/,"$1"))?i.replace(this.rules.inline._escapes,"$1"):i,title:s?s.replace(this.rules.inline._escapes,"$1"):s},t[0])}},t.reflink=function(e,t){var n;if((n=this.rules.inline.reflink.exec(e))||(n=this.rules.inline.nolink.exec(e))){var r=(n[2]||n[1]).replace(/\s+/g," ");if(!(r=t[r.toLowerCase()])||!r.href){var i=n[0].charAt(0);return{type:"text",raw:i,text:i}}return M(n,r,n[0])}},t.strong=function(e,t,n){void 0===n&&(n="");var r=this.rules.inline.strong.start.exec(e)
;if(r&&(!r[1]||r[1]&&(""===n||this.rules.inline.punctuation.exec(n)))){t=t.slice(-1*e.length);var i,s="**"===r[0]?this.rules.inline.strong.endAst:this.rules.inline.strong.endUnd;for(s.lastIndex=0;null!=(r=s.exec(t));)if(i=this.rules.inline.strong.middle.exec(t.slice(0,r.index+3)))return{type:"strong",raw:e.slice(0,i[0].length),text:e.slice(2,i[0].length-2)}}},t.em=function(e,t,n){void 0===n&&(n="");var r=this.rules.inline.em.start.exec(e);if(r&&(!r[1]||r[1]&&(""===n||this.rules.inline.punctuation.exec(n)))){t=t.slice(-1*e.length);var i,s="*"===r[0]?this.rules.inline.em.endAst:this.rules.inline.em.endUnd;for(s.lastIndex=0;null!=(r=s.exec(t));)if(i=this.rules.inline.em.middle.exec(t.slice(0,r.index+2)))return{type:"em",raw:e.slice(0,i[0].length),text:e.slice(1,i[0].length-1)}}},t.codespan=function(e){var t=this.rules.inline.code.exec(e);if(t){var n=t[2].replace(/\n/g," "),r=/[^ ]/.test(n),i=n.startsWith(" ")&&n.endsWith(" ");return r&&i&&(n=n.substring(1,n.length-1)),n=A(n,!0),{type:"codespan",raw:t[0],text:n}}
},t.br=function(e){var t=this.rules.inline.br.exec(e);if(t)return{type:"br",raw:t[0]}},t.del=function(e){var t=this.rules.inline.del.exec(e);if(t)return{type:"del",raw:t[0],text:t[1]}},t.autolink=function(e,t){var n,r,i=this.rules.inline.autolink.exec(e);if(i)return r="@"===i[2]?"mailto:"+(n=A(this.options.mangle?t(i[1]):i[1])):n=A(i[1]),{type:"link",raw:i[0],text:n,href:r,tokens:[{type:"text",raw:n,text:n}]}},t.url=function(e,t){var n;if(n=this.rules.inline.url.exec(e)){var r,i;if("@"===n[2])i="mailto:"+(r=A(this.options.mangle?t(n[0]):n[0]));else{var s;do{s=n[0],n[0]=this.rules.inline._backpedal.exec(n[0])[0]}while(s!==n[0]);r=A(n[0]),i="www."===n[1]?"http://"+r:r}return{type:"link",raw:n[0],text:r,href:i,tokens:[{type:"text",raw:r,text:r}]}}},t.inlineText=function(e,t,n){var r,i=this.rules.inline.text.exec(e);if(i)return r=t?this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):A(i[0]):i[0]:A(this.options.smartypants?n(i[0]):i[0]),{type:"text",raw:i[0],text:r}},e}(),U=x,j=S,z=I,$={
newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6}) +([^\n]*?)(?: +#+)? *(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:U,table:U,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,
_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html)[^\n]+)*)/,text:/^[^\n]+/,_label:/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,_title:/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/};$.def=j($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.item=/^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/,$.item=j($.item,"gm").replace(/bull/g,$.bullet).getRegex(),$.list=j($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,
$.html=j($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=j($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.blockquote=j($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=z({},$),$.gfm=z({},$.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n *([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n *\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),
$.gfm.nptable=j($.gfm.nptable).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.gfm.table=j($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",$._tag).getRegex(),$.pedantic=z({},$.normal,{
html:j("^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:\"[^\"]*\"|'[^']*'|\\s[^'\"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))").replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,fences:U,paragraph:j($.normal._paragraph).replace("hr",$.hr).replace("heading"," *#{1,6} *[^\n]").replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:U,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",
link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",strong:{start:/^(?:(\*\*(?=[*punctuation]))|\*\*)(?![\s])|__/,middle:/^\*\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*\*$|^__(?![\s])((?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?)__$/,endAst:/[^punctuation\s]\*\*(?!\*)|[punctuation]\*\*(?!\*)(?:(?=[punctuation\s]|$))/,endUnd:/[^\s]__(?!_)(?:(?=[punctuation\s])|$)/},em:{start:/^(?:(\*(?=[punctuation]))|\*)(?![*\s])|_/,middle:/^\*(?:(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)|\*(?:(?!overlapSkip)(?:[^*]|\\\*)|overlapSkip)*?\*)+?\*$|^_(?![_\s])(?:(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)|_(?:(?!overlapSkip)(?:[^_]|\\_)|overlapSkip)*?_)+?_$/,endAst:/[^punctuation\s]\*(?!\*)|[punctuation]\*(?!\*)(?:(?=[punctuation\s]|$))/,
endUnd:/[^\s]_(?!_)(?:(?=[punctuation\s])|$)/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:U,text:/^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*]|\b_|$)|[^ ](?= {2,}\n))|(?= {2,}\n))/,punctuation:/^([\s*punctuation])/,_punctuation:"!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~"};B.punctuation=j(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B._blockSkip="\\[[^\\]]*?\\]\\([^\\)]*?\\)|`[^`]*?`|<[^>]*?>",B._overlapSkip="__[^_]*?__|\\*\\*\\[^\\*\\]*?\\*\\*",B._comment=j($._comment).replace("(?:--\x3e|$)","--\x3e").getRegex(),B.em.start=j(B.em.start).replace(/punctuation/g,B._punctuation).getRegex(),B.em.middle=j(B.em.middle).replace(/punctuation/g,B._punctuation).replace(/overlapSkip/g,B._overlapSkip).getRegex(),B.em.endAst=j(B.em.endAst,"g").replace(/punctuation/g,B._punctuation).getRegex(),B.em.endUnd=j(B.em.endUnd,"g").replace(/punctuation/g,B._punctuation).getRegex(),B.strong.start=j(B.strong.start).replace(/punctuation/g,B._punctuation).getRegex(),
B.strong.middle=j(B.strong.middle).replace(/punctuation/g,B._punctuation).replace(/blockSkip/g,B._blockSkip).getRegex(),B.strong.endAst=j(B.strong.endAst,"g").replace(/punctuation/g,B._punctuation).getRegex(),B.strong.endUnd=j(B.strong.endUnd,"g").replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=j(B._blockSkip,"g").getRegex(),B.overlapSkip=j(B._overlapSkip,"g").getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=j(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=j(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*/,
B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=j(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=j(B.reflink).replace("label",B._label).getRegex(),B.reflinkSearch=j(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=z({},B),B.pedantic=z({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:j(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:j(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=z({},B.normal,{escape:j(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,
url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^~+(?=\S)([\s\S]*?\S)~+/,text:/^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*~]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?= {2,}\n|[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),B.gfm.url=j(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=z({},B.gfm,{br:j(B.br).replace("{2,}","*").getRegex(),text:j(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var W={block:$,inline:B},V=r.defaults,H=W.block,K=W.inline;function q(e){return e.replace(/---/g,"—").replace(/--/g,"–").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1‘").replace(/'/g,"’").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1“").replace(/"/g,"”").replace(/\.{3}/g,"…")}function G(e){var t,n,r="",i=e.length;for(t=0;t<i;t++)n=e.charCodeAt(t),Math.random()>.5&&(n="x"+n.toString(16)),r+="&#"+n+";"
;return r}var X=function(){function t(e){this.tokens=[],this.tokens.links=Object.create(null),this.options=e||V,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var t={block:H.normal,inline:K.normal};this.options.pedantic?(t.block=H.pedantic,t.inline=K.pedantic):this.options.gfm&&(t.block=H.gfm,this.options.breaks?t.inline=K.breaks:t.inline=K.gfm),this.tokenizer.rules=t}t.lex=function(e,n){return new t(n).lex(e)};var n,r,i,s=t.prototype;return s.lex=function(e){return e=e.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    "),this.blockTokens(e,this.tokens,!0),this.inline(this.tokens),this.tokens},s.blockTokens=function(e,t,n){var r,i,s,o;for(void 0===t&&(t=[]),void 0===n&&(n=!0),e=e.replace(/^ +$/gm,"");e;)if(r=this.tokenizer.space(e))e=e.substring(r.raw.length),r.type&&t.push(r);else if(r=this.tokenizer.code(e,t))e=e.substring(r.raw.length),r.type?t.push(r):((o=t[t.length-1]).raw+="\n"+r.raw,
o.text+="\n"+r.text);else if(r=this.tokenizer.fences(e))e=e.substring(r.raw.length),t.push(r);else if(r=this.tokenizer.heading(e))e=e.substring(r.raw.length),t.push(r);else if(r=this.tokenizer.nptable(e))e=e.substring(r.raw.length),t.push(r);else if(r=this.tokenizer.hr(e))e=e.substring(r.raw.length),t.push(r);else if(r=this.tokenizer.blockquote(e))e=e.substring(r.raw.length),r.tokens=this.blockTokens(r.text,[],n),t.push(r);else if(r=this.tokenizer.list(e)){for(e=e.substring(r.raw.length),s=r.items.length,i=0;i<s;i++)r.items[i].tokens=this.blockTokens(r.items[i].text,[],!1);t.push(r)}else if(r=this.tokenizer.html(e))e=e.substring(r.raw.length),t.push(r);else if(n&&(r=this.tokenizer.def(e)))e=e.substring(r.raw.length),this.tokens.links[r.tag]||(this.tokens.links[r.tag]={href:r.href,title:r.title});else if(r=this.tokenizer.table(e))e=e.substring(r.raw.length),t.push(r);else if(r=this.tokenizer.lheading(e))e=e.substring(r.raw.length),
t.push(r);else if(n&&(r=this.tokenizer.paragraph(e)))e=e.substring(r.raw.length),t.push(r);else if(r=this.tokenizer.text(e,t))e=e.substring(r.raw.length),r.type?t.push(r):((o=t[t.length-1]).raw+="\n"+r.raw,o.text+="\n"+r.text);else if(e){var a="Infinite loop on byte: "+e.charCodeAt(0);if(this.options.silent){console.error(a);break}throw new Error(a)}return t},s.inline=function(e){var t,n,r,i,s,o,a=e.length;for(t=0;t<a;t++)switch((o=e[t]).type){case"paragraph":case"text":case"heading":o.tokens=[],this.inlineTokens(o.text,o.tokens);break;case"table":for(o.tokens={header:[],cells:[]},i=o.header.length,n=0;n<i;n++)o.tokens.header[n]=[],this.inlineTokens(o.header[n],o.tokens.header[n]);for(i=o.cells.length,n=0;n<i;n++)for(s=o.cells[n],o.tokens.cells[n]=[],r=0;r<s.length;r++)o.tokens.cells[n][r]=[],this.inlineTokens(s[r],o.tokens.cells[n][r]);break;case"blockquote":this.inline(o.tokens);break;case"list":for(i=o.items.length,n=0;n<i;n++)this.inline(o.items[n].tokens)}return e},s.inlineTokens=function(e,t,n,r,i){
var s;void 0===t&&(t=[]),void 0===n&&(n=!1),void 0===r&&(r=!1),void 0===i&&(i="");var o,a=e;if(this.tokens.links){var c=Object.keys(this.tokens.links);if(c.length>0)for(;null!=(o=this.tokenizer.rules.inline.reflinkSearch.exec(a));)c.includes(o[0].slice(o[0].lastIndexOf("[")+1,-1))&&(a=a.slice(0,o.index)+"["+"a".repeat(o[0].length-2)+"]"+a.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;null!=(o=this.tokenizer.rules.inline.blockSkip.exec(a));)a=a.slice(0,o.index)+"["+"a".repeat(o[0].length-2)+"]"+a.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;e;)if(s=this.tokenizer.escape(e))e=e.substring(s.raw.length),t.push(s);else if(s=this.tokenizer.tag(e,n,r))e=e.substring(s.raw.length),n=s.inLink,r=s.inRawBlock,t.push(s);else if(s=this.tokenizer.link(e))e=e.substring(s.raw.length),"link"===s.type&&(s.tokens=this.inlineTokens(s.text,[],!0,r)),t.push(s);else if(s=this.tokenizer.reflink(e,this.tokens.links))e=e.substring(s.raw.length),
"link"===s.type&&(s.tokens=this.inlineTokens(s.text,[],!0,r)),t.push(s);else if(s=this.tokenizer.strong(e,a,i))e=e.substring(s.raw.length),s.tokens=this.inlineTokens(s.text,[],n,r),t.push(s);else if(s=this.tokenizer.em(e,a,i))e=e.substring(s.raw.length),s.tokens=this.inlineTokens(s.text,[],n,r),t.push(s);else if(s=this.tokenizer.codespan(e))e=e.substring(s.raw.length),t.push(s);else if(s=this.tokenizer.br(e))e=e.substring(s.raw.length),t.push(s);else if(s=this.tokenizer.del(e))e=e.substring(s.raw.length),s.tokens=this.inlineTokens(s.text,[],n,r),t.push(s);else if(s=this.tokenizer.autolink(e,G))e=e.substring(s.raw.length),t.push(s);else if(n||!(s=this.tokenizer.url(e,G))){if(s=this.tokenizer.inlineText(e,r,q))e=e.substring(s.raw.length),i=s.raw.slice(-1),t.push(s);else if(e){var l="Infinite loop on byte: "+e.charCodeAt(0);if(this.options.silent){console.error(l);break}throw new Error(l)}}else e=e.substring(s.raw.length),t.push(s);return t},n=t,i=[{key:"rules",get:function(){return{block:H,inline:K}}}],
(r=null)&&e(n.prototype,r),i&&e(n,i),t}(),Y=r.defaults,Q=C,J=_,Z=function(){function e(e){this.options=e||Y}var t=e.prototype;return t.code=function(e,t,n){var r=(t||"").match(/\S*/)[0];if(this.options.highlight){var i=this.options.highlight(e,r);null!=i&&i!==e&&(n=!0,e=i)}return r?'<pre><code class="'+this.options.langPrefix+J(r,!0)+'">'+(n?e:J(e,!0))+"</code></pre>\n":"<pre><code>"+(n?e:J(e,!0))+"</code></pre>\n"},t.blockquote=function(e){return"<blockquote>\n"+e+"</blockquote>\n"},t.html=function(e){return e},t.heading=function(e,t,n,r){return this.options.headerIds?"<h"+t+' id="'+this.options.headerPrefix+r.slug(n)+'">'+e+"</h"+t+">\n":"<h"+t+">"+e+"</h"+t+">\n"},t.hr=function(){return this.options.xhtml?"<hr/>\n":"<hr>\n"},t.list=function(e,t,n){var r=t?"ol":"ul";return"<"+r+(t&&1!==n?' start="'+n+'"':"")+">\n"+e+"</"+r+">\n"},t.listitem=function(e){return"<li>"+e+"</li>\n"},t.checkbox=function(e){return"<input "+(e?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},
t.paragraph=function(e){return"<p>"+e+"</p>\n"},t.table=function(e,t){return t&&(t="<tbody>"+t+"</tbody>"),"<table>\n<thead>\n"+e+"</thead>\n"+t+"</table>\n"},t.tablerow=function(e){return"<tr>\n"+e+"</tr>\n"},t.tablecell=function(e,t){var n=t.header?"th":"td";return(t.align?"<"+n+' align="'+t.align+'">':"<"+n+">")+e+"</"+n+">\n"},t.strong=function(e){return"<strong>"+e+"</strong>"},t.em=function(e){return"<em>"+e+"</em>"},t.codespan=function(e){return"<code>"+e+"</code>"},t.br=function(){return this.options.xhtml?"<br/>":"<br>"},t.del=function(e){return"<del>"+e+"</del>"},t.link=function(e,t,n){if(null===(e=Q(this.options.sanitize,this.options.baseUrl,e)))return n;var r='<a href="'+J(e)+'"';return t&&(r+=' title="'+t+'"'),r+=">"+n+"</a>"},t.image=function(e,t,n){if(null===(e=Q(this.options.sanitize,this.options.baseUrl,e)))return n;var r='<img src="'+e+'" alt="'+n+'"';return t&&(r+=' title="'+t+'"'),r+=this.options.xhtml?"/>":">"},t.text=function(e){return e},e}(),ee=function(){function e(){}
var t=e.prototype;return t.strong=function(e){return e},t.em=function(e){return e},t.codespan=function(e){return e},t.del=function(e){return e},t.html=function(e){return e},t.text=function(e){return e},t.link=function(e,t,n){return""+n},t.image=function(e,t,n){return""+n},t.br=function(){return""},e}(),te=function(){function e(){this.seen={}}var t=e.prototype;return t.serialize=function(e){return e.toLowerCase().trim().replace(/<[!\/a-z].*?>/gi,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},t.getNextSafeSlug=function(e,t){var n=e,r=0;if(this.seen.hasOwnProperty(n)){r=this.seen[e];do{n=e+"-"+ ++r}while(this.seen.hasOwnProperty(n))}return t||(this.seen[e]=r,this.seen[n]=0),n},t.slug=function(e,t){void 0===t&&(t={});var n=this.serialize(e);return this.getNextSafeSlug(n,t.dryrun)},e}(),ne=r.defaults,re=E,ie=function(){function e(e){this.options=e||ne,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,
this.renderer.options=this.options,this.textRenderer=new ee,this.slugger=new te}e.parse=function(t,n){return new e(n).parse(t)};var t=e.prototype;return t.parse=function(e,t){void 0===t&&(t=!0);var n,r,i,s,o,a,c,l,u,h,d,f,p,m,g,v,y,b,w="",_=e.length;for(n=0;n<_;n++)switch((h=e[n]).type){case"space":continue;case"hr":w+=this.renderer.hr();continue;case"heading":w+=this.renderer.heading(this.parseInline(h.tokens),h.depth,re(this.parseInline(h.tokens,this.textRenderer)),this.slugger);continue;case"code":w+=this.renderer.code(h.text,h.lang,h.escaped);continue;case"table":for(l="",c="",s=h.header.length,r=0;r<s;r++)c+=this.renderer.tablecell(this.parseInline(h.tokens.header[r]),{header:!0,align:h.align[r]});for(l+=this.renderer.tablerow(c),u="",s=h.cells.length,r=0;r<s;r++){for(c="",o=(a=h.tokens.cells[r]).length,i=0;i<o;i++)c+=this.renderer.tablecell(this.parseInline(a[i]),{header:!1,align:h.align[i]});u+=this.renderer.tablerow(c)}w+=this.renderer.table(l,u);continue;case"blockquote":u=this.parse(h.tokens),
w+=this.renderer.blockquote(u);continue;case"list":for(d=h.ordered,f=h.start,p=h.loose,s=h.items.length,u="",r=0;r<s;r++)v=(g=h.items[r]).checked,y=g.task,m="",g.task&&(b=this.renderer.checkbox(v),p?g.tokens.length>0&&"text"===g.tokens[0].type?(g.tokens[0].text=b+" "+g.tokens[0].text,g.tokens[0].tokens&&g.tokens[0].tokens.length>0&&"text"===g.tokens[0].tokens[0].type&&(g.tokens[0].tokens[0].text=b+" "+g.tokens[0].tokens[0].text)):g.tokens.unshift({type:"text",text:b}):m+=b),m+=this.parse(g.tokens,p),u+=this.renderer.listitem(m,y,v);w+=this.renderer.list(u,d,f);continue;case"html":w+=this.renderer.html(h.text);continue;case"paragraph":w+=this.renderer.paragraph(this.parseInline(h.tokens));continue;case"text":for(u=h.tokens?this.parseInline(h.tokens):h.text;n+1<_&&"text"===e[n+1].type;)u+="\n"+((h=e[++n]).tokens?this.parseInline(h.tokens):h.text);w+=t?this.renderer.paragraph(u):u;continue;default:var E='Token with "'+h.type+'" type was not found.';if(this.options.silent)return void console.error(E)
;throw new Error(E)}return w},t.parseInline=function(e,t){t=t||this.renderer;var n,r,i="",s=e.length;for(n=0;n<s;n++)switch((r=e[n]).type){case"escape":i+=t.text(r.text);break;case"html":i+=t.html(r.text);break;case"link":i+=t.link(r.href,r.title,this.parseInline(r.tokens,t));break;case"image":i+=t.image(r.href,r.title,r.text);break;case"strong":i+=t.strong(this.parseInline(r.tokens,t));break;case"em":i+=t.em(this.parseInline(r.tokens,t));break;case"codespan":i+=t.codespan(r.text);break;case"br":i+=t.br();break;case"del":i+=t.del(this.parseInline(r.tokens,t));break;case"text":i+=t.text(r.text);break;default:var o='Token with "'+r.type+'" type was not found.';if(this.options.silent)return void console.error(o);throw new Error(o)}return i},e}(),se=I,oe=R,ae=_,ce=r.getDefaults,le=r.changeDefaults,ue=r.defaults;function he(e,t,n){if(null==e)throw new Error("marked(): input parameter is undefined or null")
;if("string"!=typeof e)throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(e)+", string expected");if("function"==typeof t&&(n=t,t=null),t=se({},he.defaults,t||{}),oe(t),n){var r,i=t.highlight;try{r=X.lex(e,t)}catch(e){return n(e)}var s=function(e){var s;if(!e)try{s=ie.parse(r,t)}catch(t){e=t}return t.highlight=i,e?n(e):n(null,s)};if(!i||i.length<3)return s();if(delete t.highlight,!r.length)return s();var o=0;return he.walkTokens(r,(function(e){"code"===e.type&&(o++,setTimeout((function(){i(e.text,e.lang,(function(t,n){if(t)return s(t);null!=n&&n!==e.text&&(e.text=n,e.escaped=!0),0===--o&&s()}))}),0))})),void(0===o&&s())}try{var a=X.lex(e,t);return t.walkTokens&&he.walkTokens(a,t.walkTokens),ie.parse(a,t)}catch(e){if(e.message+="\nPlease report this to https://github.com/markedjs/marked.",t.silent)return"<p>An error occurred:</p><pre>"+ae(e.message+"",!0)+"</pre>";throw e}}return he.options=he.setOptions=function(e){return se(he.defaults,e),le(he.defaults),he},
he.getDefaults=ce,he.defaults=ue,he.use=function(e){var t=se({},e);if(e.renderer&&function(){var n=he.defaults.renderer||new Z,r=function(t){var r=n[t];n[t]=function(){for(var i=arguments.length,s=new Array(i),o=0;o<i;o++)s[o]=arguments[o];var a=e.renderer[t].apply(n,s);return!1===a&&(a=r.apply(n,s)),a}};for(var i in e.renderer)r(i);t.renderer=n}(),e.tokenizer&&function(){var n=he.defaults.tokenizer||new F,r=function(t){var r=n[t];n[t]=function(){for(var i=arguments.length,s=new Array(i),o=0;o<i;o++)s[o]=arguments[o];var a=e.tokenizer[t].apply(n,s);return!1===a&&(a=r.apply(n,s)),a}};for(var i in e.tokenizer)r(i);t.tokenizer=n}(),e.walkTokens){var n=he.defaults.walkTokens;t.walkTokens=function(t){e.walkTokens(t),n&&n(t)}}he.setOptions(t)},he.walkTokens=function(e,t){for(var r,i=n(e);!(r=i()).done;){var s=r.value;switch(t(s),s.type){case"table":for(var o,a=n(s.tokens.header);!(o=a()).done;){var c=o.value;he.walkTokens(c,t)}for(var l,u=n(s.tokens.cells);!(l=u()).done;)for(var h,d=n(l.value);!(h=d()).done;){
var f=h.value;he.walkTokens(f,t)}break;case"list":he.walkTokens(s.items,t);break;default:s.tokens&&he.walkTokens(s.tokens,t)}}},he.Parser=ie,he.parser=ie.parse,he.Renderer=Z,he.TextRenderer=ee,he.Lexer=X,he.lexer=X.lex,he.Tokenizer=F,he.Slugger=te,he.parse=he,he})),define(t[112],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovingAverage=t.Counter=t.rot=t.clamp=void 0,t.clamp=function(e,t,n){return Math.min(Math.max(e,t),n)},t.rot=function(e,t){return(t+e%t)%t};t.Counter=class{constructor(){this._next=0}getNext(){return this._next++}};t.MovingAverage=class{constructor(){this._n=1,this._val=0}update(e){return this._val=this._val+(e-this._val)/this._n,this._n+=1,this}get value(){return this._val}}})),e="object"==typeof global?global:"object"==typeof self?self:{},"function"==typeof define?define("vs/base/common/performance",[],(function(){return r(e)})):"object"==typeof module&&"object"==typeof module.exports?module.exports=r(e):e.perf=r(e),
define(t[5],n([0,1]),(function(e,t){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.isRootUser=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=void 0;let r=!1,i=!1,s=!1,o=!1,a=!1,c=!1,l=void 0,u="en",h=void 0,d=void 0;const f="object"==typeof self?self:"object"==typeof global?global:{};let p=void 0;"undefined"!=typeof process?p=process:void 0!==f.vscode&&(p=f.vscode.process);const m="string"==typeof(null===(n=null==p?void 0:p.versions)||void 0===n?void 0:n.electron)&&"renderer"===p.type;if("object"!=typeof navigator||m)if("object"==typeof p){r="win32"===p.platform,i="darwin"===p.platform,s="linux"===p.platform,l="en",u="en";const e=p.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),n=t.availableLanguages["*"];l=t.locale,u=n||"en",h=t._translationsConfigFile}catch(e){}o=!0
}else console.error("Unable to resolve platform.");else d=navigator.userAgent,r=d.indexOf("Windows")>=0,i=d.indexOf("Macintosh")>=0,c=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,s=d.indexOf("Linux")>=0,a=!0,u=l=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let g=0;i?g=1:r?g=3:s&&(g=2),t.isWindows=r,t.isMacintosh=i,t.isLinux=s,t.isNative=o,t.isWeb=a,t.isIOS=c,t.platform=g,t.userAgent=d,t.isRootUser=function(){return!!p&&!r&&0===p.getuid()},t.language=u,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}
}(t.Language||(t.Language={})),t.locale=l,t.translationsConfigFile=h,t.globals=f,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if("function"==typeof t.globals.postMessage&&!t.globals.importScripts){let e=[];t.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeSetImmediateId)for(let n=0,r=e.length;n<r;n++){const r=e[n];if(r.id===t.data.vscodeSetImmediateId)return e.splice(n,1),void r.callback()}});let n=0;return r=>{const i=++n;e.push({id:i,callback:r}),t.globals.postMessage({vscodeSetImmediateId:i},"*")}}if(p)return p.nextTick.bind(p);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=i||c?2:r?1:3;let v=!0,y=!1;t.isLittleEndian=function(){if(!y){y=!0;const e=new Uint8Array(2);e[0]=1,e[1]=2;const t=new Uint16Array(e.buffer);v=513===t[0]}return v}})),define(t[44],n([0,1,5]),(function(e,t,n){"use strict";let r
;Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0,r="undefined"!=typeof process?process:void 0!==n.globals.vscode?n.globals.vscode.process:{get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},nextTick:e=>n.setImmediate(e),get env(){return Object.create(null)},cwd:()=>"/",getuid:()=>-1},t.cwd=r.cwd,t.env=r.env,t.platform=r.platform,t.nextTick=r.nextTick})),define(t[2],n([0,1,44]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const r=65,i=97,s=90,o=122,a=46,c=47,l=92;class u extends Error{constructor(e,t,n){let r;"string"==typeof t&&0===t.indexOf("not ")?(r="must not be",t=t.replace(/^not /,"")):r="must be";const i=-1!==e.indexOf(".")?"property":"argument";let s=`The "${e}" ${i} ${r} of type ${t}`;super(s+=`. Received type ${typeof n}`),
this.code="ERR_INVALID_ARG_TYPE"}}function h(e,t){if("string"!=typeof e)throw new u(t,"string",e)}function d(e){return e===c||e===l}function f(e){return e===c}function p(e){return e>=r&&e<=s||e>=i&&e<=o}function m(e,t,n,r){let i="",s=0,o=-1,l=0,u=0;for(let h=0;h<=e.length;++h){if(h<e.length)u=e.charCodeAt(h);else{if(r(u))break;u=c}if(r(u)){if(o===h-1||1===l);else if(2===l){if(i.length<2||2!==s||i.charCodeAt(i.length-1)!==a||i.charCodeAt(i.length-2)!==a){if(i.length>2){const e=i.lastIndexOf(n);-1===e?(i="",s=0):s=(i=i.slice(0,e)).length-1-i.lastIndexOf(n),o=h,l=0;continue}if(0!==i.length){i="",s=0,o=h,l=0;continue}}t&&(i+=i.length>0?`${n}..`:"..",s=2)}else i.length>0?i+=`${n}${e.slice(o+1,h)}`:i=e.slice(o+1,h),s=h-o-1;o=h,l=0}else u===a&&-1!==l?++l:l=-1}return i}function g(e,t){if(null===t||"object"!=typeof t)throw new u("pathObject","Object",t);const n=t.dir||t.root,r=t.base||`${t.name||""}${t.ext||""}`;return n?n===t.root?`${n}${r}`:`${n}${e}${r}`:r}t.win32={resolve(...e){let t="",r="",i=!1
;for(let s=e.length-1;s>=-1;s--){let o;if(s>=0){if(h(o=e[s],"path"),0===o.length)continue}else 0===t.length?o=n.cwd():(void 0===(o=n.env[`=${t}`]||n.cwd())||o.slice(0,2).toLowerCase()!==t.toLowerCase()&&o.charCodeAt(2)===l)&&(o=`${t}\\`);const a=o.length;let c=0,u="",f=!1;const m=o.charCodeAt(0);if(1===a)d(m)&&(c=1,f=!0);else if(d(m))if(f=!0,d(o.charCodeAt(1))){let e=2,t=e;for(;e<a&&!d(o.charCodeAt(e));)e++;if(e<a&&e!==t){const n=o.slice(t,e);for(t=e;e<a&&d(o.charCodeAt(e));)e++;if(e<a&&e!==t){for(t=e;e<a&&!d(o.charCodeAt(e));)e++;e!==a&&e===t||(u=`\\\\${n}\\${o.slice(t,e)}`,c=e)}}}else c=1;else p(m)&&58===o.charCodeAt(1)&&(u=o.slice(0,2),c=2,a>2&&d(o.charCodeAt(2))&&(f=!0,c=3));if(u.length>0)if(t.length>0){if(u.toLowerCase()!==t.toLowerCase())continue}else t=u;if(i){if(t.length>0)break}else if(r=`${o.slice(c)}\\${r}`,i=f,f&&t.length>0)break}return r=m(r,!i,"\\",d),i?`${t}\\${r}`:`${t}${r}`||"."},normalize(e){h(e,"path");const t=e.length;if(0===t)return".";let n,r=0,i=!1;const s=e.charCodeAt(0)
;if(1===t)return f(s)?"\\":e;if(d(s))if(i=!0,d(e.charCodeAt(1))){let i=2,s=i;for(;i<t&&!d(e.charCodeAt(i));)i++;if(i<t&&i!==s){const o=e.slice(s,i);for(s=i;i<t&&d(e.charCodeAt(i));)i++;if(i<t&&i!==s){for(s=i;i<t&&!d(e.charCodeAt(i));)i++;if(i===t)return`\\\\${o}\\${e.slice(s)}\\`;i!==s&&(n=`\\\\${o}\\${e.slice(s,i)}`,r=i)}}}else r=1;else p(s)&&58===e.charCodeAt(1)&&(n=e.slice(0,2),r=2,t>2&&d(e.charCodeAt(2))&&(i=!0,r=3));let o=r<t?m(e.slice(r),!i,"\\",d):"";return 0!==o.length||i||(o="."),o.length>0&&d(e.charCodeAt(t-1))&&(o+="\\"),void 0===n?i?`\\${o}`:o:i?`${n}\\${o}`:`${n}${o}`},isAbsolute(e){h(e,"path");const t=e.length;if(0===t)return!1;const n=e.charCodeAt(0);return d(n)||t>2&&p(n)&&58===e.charCodeAt(1)&&d(e.charCodeAt(2))},join(...e){if(0===e.length)return".";let n,r;for(let t=0;t<e.length;++t){const i=e[t];h(i,"path"),i.length>0&&(void 0===n?n=r=i:n+=`\\${i}`)}if(void 0===n)return".";let i=!0,s=0;if("string"==typeof r&&d(r.charCodeAt(0))){++s;const e=r.length;e>1&&d(r.charCodeAt(1))&&(++s,
e>2&&(d(r.charCodeAt(2))?++s:i=!1))}if(i){for(;s<n.length&&d(n.charCodeAt(s));)s++;s>=2&&(n=`\\${n.slice(s)}`)}return t.win32.normalize(n)},relative(e,n){if(h(e,"from"),h(n,"to"),e===n)return"";const r=t.win32.resolve(e),i=t.win32.resolve(n);if(r===i)return"";if((e=r.toLowerCase())===(n=i.toLowerCase()))return"";let s=0;for(;s<e.length&&e.charCodeAt(s)===l;)s++;let o=e.length;for(;o-1>s&&e.charCodeAt(o-1)===l;)o--;const a=o-s;let c=0;for(;c<n.length&&n.charCodeAt(c)===l;)c++;let u=n.length;for(;u-1>c&&n.charCodeAt(u-1)===l;)u--;const d=u-c,f=a<d?a:d;let p=-1,m=0;for(;m<f;m++){const t=e.charCodeAt(s+m);if(t!==n.charCodeAt(c+m))break;t===l&&(p=m)}if(m!==f){if(-1===p)return i}else{if(d>f){if(n.charCodeAt(c+m)===l)return i.slice(c+m+1);if(2===m)return i.slice(c+m)}a>f&&(e.charCodeAt(s+m)===l?p=m:2===m&&(p=3)),-1===p&&(p=0)}let g="";for(m=s+p+1;m<=o;++m)m!==o&&e.charCodeAt(m)!==l||(g+=0===g.length?"..":"\\..");return c+=p,g.length>0?`${g}${i.slice(c,u)}`:(i.charCodeAt(c)===l&&++c,i.slice(c,u))},
toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const n=t.win32.resolve(e);if(n.length<=2)return e;if(n.charCodeAt(0)===l){if(n.charCodeAt(1)===l){const e=n.charCodeAt(2);if(63!==e&&e!==a)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(p(n.charCodeAt(0))&&58===n.charCodeAt(1)&&n.charCodeAt(2)===l)return`\\\\?\\${n}`;return e},dirname(e){h(e,"path");const t=e.length;if(0===t)return".";let n=-1,r=0;const i=e.charCodeAt(0);if(1===t)return d(i)?e:".";if(d(i)){if(n=r=1,d(e.charCodeAt(1))){let i=2,s=i;for(;i<t&&!d(e.charCodeAt(i));)i++;if(i<t&&i!==s){for(s=i;i<t&&d(e.charCodeAt(i));)i++;if(i<t&&i!==s){for(s=i;i<t&&!d(e.charCodeAt(i));)i++;if(i===t)return e;i!==s&&(n=r=i+1)}}}}else p(i)&&58===e.charCodeAt(1)&&(r=n=t>2&&d(e.charCodeAt(2))?3:2);let s=-1,o=!0;for(let n=t-1;n>=r;--n)if(d(e.charCodeAt(n))){if(!o){s=n;break}}else o=!1;if(-1===s){if(-1===n)return".";s=n}return e.slice(0,s)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let n,r=0,i=-1,s=!0
;if(e.length>=2&&p(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(r=2),void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(n=e.length-1;n>=r;--n){const c=e.charCodeAt(n);if(d(c)){if(!s){r=n+1;break}}else-1===a&&(s=!1,a=n+1),o>=0&&(c===t.charCodeAt(o)?-1==--o&&(i=n):(o=-1,i=a))}return r===i?i=a:-1===i&&(i=e.length),e.slice(r,i)}for(n=e.length-1;n>=r;--n)if(d(e.charCodeAt(n))){if(!s){r=n+1;break}}else-1===i&&(s=!1,i=n+1);return-1===i?"":e.slice(r,i)},extname(e){h(e,"path");let t=0,n=-1,r=0,i=-1,s=!0,o=0;e.length>=2&&58===e.charCodeAt(1)&&p(e.charCodeAt(0))&&(t=r=2);for(let c=e.length-1;c>=t;--c){const t=e.charCodeAt(c);if(d(t)){if(!s){r=c+1;break}}else-1===i&&(s=!1,i=c+1),t===a?-1===n?n=c:1!==o&&(o=1):-1!==n&&(o=-1)}return-1===n||-1===i||0===o||1===o&&n===i-1&&n===r+1?"":e.slice(n,i)},format:g.bind(null,"\\"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.length;let r=0,i=e.charCodeAt(0);if(1===n)return d(i)?(t.root=t.dir=e,
t):(t.base=t.name=e,t);if(d(i)){if(r=1,d(e.charCodeAt(1))){let t=2,i=t;for(;t<n&&!d(e.charCodeAt(t));)t++;if(t<n&&t!==i){for(i=t;t<n&&d(e.charCodeAt(t));)t++;if(t<n&&t!==i){for(i=t;t<n&&!d(e.charCodeAt(t));)t++;t===n?r=t:t!==i&&(r=t+1)}}}}else if(p(i)&&58===e.charCodeAt(1)){if(n<=2)return t.root=t.dir=e,t;if(r=2,d(e.charCodeAt(2))){if(3===n)return t.root=t.dir=e,t;r=3}}r>0&&(t.root=e.slice(0,r));let s=-1,o=r,c=-1,l=!0,u=e.length-1,f=0;for(;u>=r;--u)if(d(i=e.charCodeAt(u))){if(!l){o=u+1;break}}else-1===c&&(l=!1,c=u+1),i===a?-1===s?s=u:1!==f&&(f=1):-1!==s&&(f=-1);return-1!==c&&(-1===s||0===f||1===f&&s===c-1&&s===o+1?t.base=t.name=e.slice(o,c):(t.name=e.slice(o,s),t.base=e.slice(o,c),t.ext=e.slice(s,c))),t.dir=o>0&&o!==r?e.slice(0,o-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){let t="",r=!1;for(let i=e.length-1;i>=-1&&!r;i--){const s=i>=0?e[i]:n.cwd();h(s,"path"),0!==s.length&&(t=`${s}/${t}`,r=s.charCodeAt(0)===c)}return t=m(t,!r,"/",f),r?`/${t}`:t.length>0?t:"."},
normalize(e){if(h(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c,n=e.charCodeAt(e.length-1)===c;return 0===(e=m(e,!t,"/",f)).length?t?"/":n?"./":".":(n&&(e+="/"),t?`/${e}`:e)},isAbsolute:e=>(h(e,"path"),e.length>0&&e.charCodeAt(0)===c),join(...e){if(0===e.length)return".";let n;for(let t=0;t<e.length;++t){const r=e[t];h(r,"path"),r.length>0&&(void 0===n?n=r:n+=`/${r}`)}return void 0===n?".":t.posix.normalize(n)},relative(e,n){if(h(e,"from"),h(n,"to"),e===n)return"";if((e=t.posix.resolve(e))===(n=t.posix.resolve(n)))return"";const r=e.length,i=r-1,s=n.length-1,o=i<s?i:s;let a=-1,l=0;for(;l<o;l++){const t=e.charCodeAt(1+l);if(t!==n.charCodeAt(1+l))break;t===c&&(a=l)}if(l===o)if(s>o){if(n.charCodeAt(1+l)===c)return n.slice(1+l+1);if(0===l)return n.slice(1+l)}else i>o&&(e.charCodeAt(1+l)===c?a=l:0===l&&(a=0));let u="";for(l=1+a+1;l<=r;++l)l!==r&&e.charCodeAt(l)!==c||(u+=0===u.length?"..":"/..");return`${u}${n.slice(1+a)}`},toNamespacedPath:e=>e,dirname(e){if(h(e,"path"),0===e.length)return"."
;const t=e.charCodeAt(0)===c;let n=-1,r=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===c){if(!r){n=t;break}}else r=!1;return-1===n?t?"/":".":t&&1===n?"//":e.slice(0,n)},basename(e,t){void 0!==t&&h(t,"ext"),h(e,"path");let n,r=0,i=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let o=t.length-1,a=-1;for(n=e.length-1;n>=0;--n){const l=e.charCodeAt(n);if(l===c){if(!s){r=n+1;break}}else-1===a&&(s=!1,a=n+1),o>=0&&(l===t.charCodeAt(o)?-1==--o&&(i=n):(o=-1,i=a))}return r===i?i=a:-1===i&&(i=e.length),e.slice(r,i)}for(n=e.length-1;n>=0;--n)if(e.charCodeAt(n)===c){if(!s){r=n+1;break}}else-1===i&&(s=!1,i=n+1);return-1===i?"":e.slice(r,i)},extname(e){h(e,"path");let t=-1,n=0,r=-1,i=!0,s=0;for(let o=e.length-1;o>=0;--o){const l=e.charCodeAt(o);if(l!==c)-1===r&&(i=!1,r=o+1),l===a?-1===t?t=o:1!==s&&(s=1):-1!==t&&(s=-1);else if(!i){n=o+1;break}}return-1===t||-1===r||0===s||1===s&&t===r-1&&t===n+1?"":e.slice(t,r)},format:g.bind(null,"/"),parse(e){h(e,"path");const t={root:"",dir:"",base:"",
ext:"",name:""};if(0===e.length)return t;const n=e.charCodeAt(0)===c;let r;n?(t.root="/",r=1):r=0;let i=-1,s=0,o=-1,l=!0,u=e.length-1,d=0;for(;u>=r;--u){const t=e.charCodeAt(u);if(t!==c)-1===o&&(l=!1,o=u+1),t===a?-1===i?i=u:1!==d&&(d=1):-1!==i&&(d=-1);else if(!l){s=u+1;break}}if(-1!==o){const r=0===s&&n?1:s;-1===i||0===d||1===d&&i===o-1&&i===s+1?t.base=t.name=e.slice(r,o):(t.name=e.slice(r,i),t.base=e.slice(r,o),t.ext=e.slice(i,o))}return s>0?t.dir=e.slice(0,s-1):n&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===n.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===n.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===n.platform?t.win32.join:t.posix.join,t.resolve="win32"===n.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===n.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===n.platform?t.win32.dirname:t.posix.dirname,
t.basename="win32"===n.platform?t.win32.basename:t.posix.basename,t.extname="win32"===n.platform?t.win32.extname:t.posix.extname,t.format="win32"===n.platform?t.win32.format:t.posix.format,t.parse="win32"===n.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===n.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===n.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===n.platform?t.win32.delimiter:t.posix.delimiter})),define(t[113],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0,function(e){e[e.stdout=0]="stdout",e[e.stderr=1]="stderr"}(t.Source||(t.Source={})),function(e){e[e.Success=0]="Success",e[e.Unknown=1]="Unknown",e[e.AccessDenied=2]="AccessDenied",e[e.ProcessNotFound=3]="ProcessNotFound"}(t.TerminateResponseCode||(t.TerminateResponseCode={})),t.sanitizeProcessEnvironment=function(e,...t){const n=t.reduce((e,t)=>(e[t]=!0,
e),{}),r=[/^ELECTRON_.+$/,/^GOOGLE_API_KEY$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(e).filter(e=>!n[e]).forEach(t=>{for(let n=0;n<r.length;n++)if(-1!==t.search(r[n])){delete e[t];break}})}})),function(e,t){if("object"==typeof exports&&"object"==typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define("vs/base/common/semver/semver",[],t);else{var n=t();for(var r in n)("object"==typeof exports?exports:e)[r]=n[r]}}("undefined"!=typeof self?self:this,(function(){return function(e){var t={};function n(r){if(t[r])return t[r].exports;var i=t[r]={i:r,l:!1,exports:{}};return e[r].call(i.exports,i,i.exports,n),i.l=!0,i.exports}return n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e
;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var i in e)n.d(r,i,function(t){return e[t]}.bind(null,i));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=0)}([function(e,t,n){(function(n){var r;t=e.exports=G,r="object"==typeof n&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var e=Array.prototype.slice.call(arguments,0);e.unshift("SEMVER"),console.log.apply(console,e)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var i=256,s=Number.MAX_SAFE_INTEGER||9007199254740991,o=t.re=[],a=t.src=[],c=0,l=c++;a[l]="0|[1-9]\\d*";var u=c++;a[u]="[0-9]+";var h=c++;a[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=c++;a[d]="("+a[l]+")\\.("+a[l]+")\\.("+a[l]+")";var f=c++;a[f]="("+a[u]+")\\.("+a[u]+")\\.("+a[u]+")";var p=c++
;a[p]="(?:"+a[l]+"|"+a[h]+")";var m=c++;a[m]="(?:"+a[u]+"|"+a[h]+")";var g=c++;a[g]="(?:-("+a[p]+"(?:\\."+a[p]+")*))";var v=c++;a[v]="(?:-?("+a[m]+"(?:\\."+a[m]+")*))";var y=c++;a[y]="[0-9A-Za-z-]+";var b=c++;a[b]="(?:\\+("+a[y]+"(?:\\."+a[y]+")*))";var w=c++,_="v?"+a[d]+a[g]+"?"+a[b]+"?";a[w]="^"+_+"$";var E="[v=\\s]*"+a[f]+a[v]+"?"+a[b]+"?",S=c++;a[S]="^"+E+"$";var C=c++;a[C]="((?:<|>)?=?)";var x=c++;a[x]=a[u]+"|x|X|\\*";var I=c++;a[I]=a[l]+"|x|X|\\*";var k=c++;a[k]="[v=\\s]*("+a[I]+")(?:\\.("+a[I]+")(?:\\.("+a[I]+")(?:"+a[g]+")?"+a[b]+"?)?)?";var T=c++;a[T]="[v=\\s]*("+a[x]+")(?:\\.("+a[x]+")(?:\\.("+a[x]+")(?:"+a[v]+")?"+a[b]+"?)?)?";var P=c++;a[P]="^"+a[C]+"\\s*"+a[k]+"$";var R=c++;a[R]="^"+a[C]+"\\s*"+a[T]+"$";var O=c++;a[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=c++;a[L]="(?:~>?)";var D=c++;a[D]="(\\s*)"+a[L]+"\\s+",o[D]=new RegExp(a[D],"g");var A=c++;a[A]="^"+a[L]+a[k]+"$";var N=c++;a[N]="^"+a[L]+a[T]+"$";var M=c++;a[M]="(?:\\^)";var F=c++
;a[F]="(\\s*)"+a[M]+"\\s+",o[F]=new RegExp(a[F],"g");var U=c++;a[U]="^"+a[M]+a[k]+"$";var j=c++;a[j]="^"+a[M]+a[T]+"$";var z=c++;a[z]="^"+a[C]+"\\s*("+E+")$|^$";var $=c++;a[$]="^"+a[C]+"\\s*("+_+")$|^$";var B=c++;a[B]="(\\s*)"+a[C]+"\\s*("+E+"|"+a[k]+")",o[B]=new RegExp(a[B],"g");var W=c++;a[W]="^\\s*("+a[k]+")\\s+-\\s+("+a[k]+")\\s*$";var V=c++;a[V]="^\\s*("+a[T]+")\\s+-\\s+("+a[T]+")\\s*$";var H=c++;a[H]="(<|>)?=?\\s*\\*";for(var K=0;K<35;K++)r(K,a[K]),o[K]||(o[K]=new RegExp(a[K]));function q(e,t){if(e instanceof G)return e;if("string"!=typeof e)return null;if(e.length>i)return null;if(!(t?o[S]:o[w]).test(e))return null;try{return new G(e,t)}catch(e){return null}}function G(e,t){if(e instanceof G){if(e.loose===t)return e;e=e.version}else if("string"!=typeof e)throw new TypeError("Invalid Version: "+e);if(e.length>i)throw new TypeError("version is longer than "+i+" characters");if(!(this instanceof G))return new G(e,t);r("SemVer",e,t),this.loose=t;var n=e.trim().match(t?o[S]:o[w])
;if(!n)throw new TypeError("Invalid Version: "+e);if(this.raw=e,this.major=+n[1],this.minor=+n[2],this.patch=+n[3],this.major>s||this.major<0)throw new TypeError("Invalid major version");if(this.minor>s||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>s||this.patch<0)throw new TypeError("Invalid patch version");n[4]?this.prerelease=n[4].split(".").map((function(e){if(/^[0-9]+$/.test(e)){var t=+e;if(t>=0&&t<s)return t}return e})):this.prerelease=[],this.build=n[5]?n[5].split("."):[],this.format()}t.parse=q,t.valid=function(e,t){var n=q(e,t);return n?n.version:null},t.clean=function(e,t){var n=q(e.trim().replace(/^[=v]+/,""),t);return n?n.version:null},t.SemVer=G,G.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},G.prototype.toString=function(){return this.version},G.prototype.compare=function(e){return r("SemVer.compare",this.version,this.loose,e),
e instanceof G||(e=new G(e,this.loose)),this.compareMain(e)||this.comparePre(e)},G.prototype.compareMain=function(e){return e instanceof G||(e=new G(e,this.loose)),Y(this.major,e.major)||Y(this.minor,e.minor)||Y(this.patch,e.patch)},G.prototype.comparePre=function(e){if(e instanceof G||(e=new G(e,this.loose)),this.prerelease.length&&!e.prerelease.length)return-1;if(!this.prerelease.length&&e.prerelease.length)return 1;if(!this.prerelease.length&&!e.prerelease.length)return 0;var t=0;do{var n=this.prerelease[t],i=e.prerelease[t];if(r("prerelease compare",t,n,i),void 0===n&&void 0===i)return 0;if(void 0===i)return 1;if(void 0===n)return-1;if(n!==i)return Y(n,i)}while(++t)},G.prototype.inc=function(e,t){switch(e){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",t);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",t);break;case"prepatch":this.prerelease.length=0,this.inc("patch",t),this.inc("pre",t);break;case"prerelease":
0===this.prerelease.length&&this.inc("patch",t),this.inc("pre",t);break;case"major":0===this.minor&&0===this.patch&&0!==this.prerelease.length||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":0===this.patch&&0!==this.prerelease.length||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":0===this.prerelease.length&&this.patch++,this.prerelease=[];break;case"pre":if(0===this.prerelease.length)this.prerelease=[0];else{for(var n=this.prerelease.length;--n>=0;)"number"==typeof this.prerelease[n]&&(this.prerelease[n]++,n=-2);-1===n&&this.prerelease.push(0)}t&&(this.prerelease[0]===t?isNaN(this.prerelease[1])&&(this.prerelease=[t,0]):this.prerelease=[t,0]);break;default:throw new Error("invalid increment argument: "+e)}return this.format(),this.raw=this.version,this},t.inc=function(e,t,n,r){"string"==typeof n&&(r=n,n=void 0);try{return new G(e,n).inc(t,r).version}catch(e){return null}},t.diff=function(e,t){if(ee(e,t))return null;var n=q(e),r=q(t)
;if(n.prerelease.length||r.prerelease.length){for(var i in n)if(("major"===i||"minor"===i||"patch"===i)&&n[i]!==r[i])return"pre"+i;return"prerelease"}for(var i in n)if(("major"===i||"minor"===i||"patch"===i)&&n[i]!==r[i])return i},t.compareIdentifiers=Y;var X=/^[0-9]+$/;function Y(e,t){var n=X.test(e),r=X.test(t);return n&&r&&(e=+e,t=+t),n&&!r?-1:r&&!n?1:e<t?-1:e>t?1:0}function Q(e,t,n){return new G(e,n).compare(new G(t,n))}function J(e,t,n){return Q(e,t,n)>0}function Z(e,t,n){return Q(e,t,n)<0}function ee(e,t,n){return 0===Q(e,t,n)}function te(e,t,n){return 0!==Q(e,t,n)}function ne(e,t,n){return Q(e,t,n)>=0}function re(e,t,n){return Q(e,t,n)<=0}function ie(e,t,n,r){var i;switch(t){case"===":"object"==typeof e&&(e=e.version),"object"==typeof n&&(n=n.version),i=e===n;break;case"!==":"object"==typeof e&&(e=e.version),"object"==typeof n&&(n=n.version),i=e!==n;break;case"":case"=":case"==":i=ee(e,n,r);break;case"!=":i=te(e,n,r);break;case">":i=J(e,n,r);break;case">=":i=ne(e,n,r);break;case"<":i=Z(e,n,r);break
;case"<=":i=re(e,n,r);break;default:throw new TypeError("Invalid operator: "+t)}return i}function se(e,t){if(e instanceof se){if(e.loose===t)return e;e=e.value}if(!(this instanceof se))return new se(e,t);r("comparator",e,t),this.loose=t,this.parse(e),this.semver===oe?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}t.rcompareIdentifiers=function(e,t){return Y(t,e)},t.major=function(e,t){return new G(e,t).major},t.minor=function(e,t){return new G(e,t).minor},t.patch=function(e,t){return new G(e,t).patch},t.compare=Q,t.compareLoose=function(e,t){return Q(e,t,!0)},t.rcompare=function(e,t,n){return Q(t,e,n)},t.sort=function(e,n){return e.sort((function(e,r){return t.compare(e,r,n)}))},t.rsort=function(e,n){return e.sort((function(e,r){return t.rcompare(e,r,n)}))},t.gt=J,t.lt=Z,t.eq=ee,t.neq=te,t.gte=ne,t.lte=re,t.cmp=ie,t.Comparator=se;var oe={};function ae(e,t){if(e instanceof ae)return e.loose===t?e:new ae(e.raw,t);if(e instanceof se)return new ae(e.value,t)
;if(!(this instanceof ae))return new ae(e,t);if(this.loose=t,this.raw=e,this.set=e.split(/\s*\|\|\s*/).map((function(e){return this.parseRange(e.trim())}),this).filter((function(e){return e.length})),!this.set.length)throw new TypeError("Invalid SemVer Range: "+e);this.format()}function ce(e){return!e||"x"===e.toLowerCase()||"*"===e}function le(e,t,n,r,i,s,o,a,c,l,u,h,d){return((t=ce(n)?"":ce(r)?">="+n+".0.0":ce(i)?">="+n+"."+r+".0":">="+t)+" "+(a=ce(c)?"":ce(l)?"<"+(+c+1)+".0.0":ce(u)?"<"+c+"."+(+l+1)+".0":h?"<="+c+"."+l+"."+u+"-"+h:"<="+a)).trim()}function ue(e,t){for(var n=0;n<e.length;n++)if(!e[n].test(t))return!1;if(t.prerelease.length){for(n=0;n<e.length;n++)if(r(e[n].semver),e[n].semver!==oe&&e[n].semver.prerelease.length>0){var i=e[n].semver;if(i.major===t.major&&i.minor===t.minor&&i.patch===t.patch)return!0}return!1}return!0}function he(e,t,n){try{t=new ae(t,n)}catch(e){return!1}return t.test(e)}function de(e,t,n,r){var i,s,o,a,c;switch(e=new G(e,r),t=new ae(t,r),n){case">":i=J,s=re,o=Z,a=">",c=">="
;break;case"<":i=Z,s=ne,o=J,a="<",c="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(he(e,t,r))return!1;for(var l=0;l<t.set.length;++l){var u=t.set[l],h=null,d=null;if(u.forEach((function(e){e.semver===oe&&(e=new se(">=0.0.0")),h=h||e,d=d||e,i(e.semver,h.semver,r)?h=e:o(e.semver,d.semver,r)&&(d=e)})),h.operator===a||h.operator===c)return!1;if((!d.operator||d.operator===a)&&s(e,d.semver))return!1;if(d.operator===c&&o(e,d.semver))return!1}return!0}se.prototype.parse=function(e){var t=this.loose?o[z]:o[$],n=e.match(t);if(!n)throw new TypeError("Invalid comparator: "+e);this.operator=n[1],"="===this.operator&&(this.operator=""),n[2]?this.semver=new G(n[2],this.loose):this.semver=oe},se.prototype.toString=function(){return this.value},se.prototype.test=function(e){return r("Comparator.test",e,this.loose),this.semver===oe||("string"==typeof e&&(e=new G(e,this.loose)),ie(e,this.operator,this.semver,this.loose))},se.prototype.intersects=function(e,t){
if(!(e instanceof se))throw new TypeError("a Comparator is required");var n;if(""===this.operator)return n=new ae(e.value,t),he(this.value,n,t);if(""===e.operator)return n=new ae(this.value,t),he(e.semver,n,t);var r=!(">="!==this.operator&&">"!==this.operator||">="!==e.operator&&">"!==e.operator),i=!("<="!==this.operator&&"<"!==this.operator||"<="!==e.operator&&"<"!==e.operator),s=this.semver.version===e.semver.version,o=!(">="!==this.operator&&"<="!==this.operator||">="!==e.operator&&"<="!==e.operator),a=ie(this.semver,"<",e.semver,t)&&(">="===this.operator||">"===this.operator)&&("<="===e.operator||"<"===e.operator),c=ie(this.semver,">",e.semver,t)&&("<="===this.operator||"<"===this.operator)&&(">="===e.operator||">"===e.operator);return r||i||s&&o||a||c},t.Range=ae,ae.prototype.format=function(){return this.range=this.set.map((function(e){return e.join(" ").trim()})).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(e){var t=this.loose
;e=e.trim(),r("range",e,t);var n=t?o[V]:o[W];e=e.replace(n,le),r("hyphen replace",e),e=e.replace(o[B],"$1$2$3"),r("comparator trim",e,o[B]),e=(e=(e=e.replace(o[D],"$1~")).replace(o[F],"$1^")).split(/\s+/).join(" ");var i=t?o[z]:o[$],s=e.split(" ").map((function(e){return function(e,t){return r("comp",e),e=function(e,t){return e.trim().split(/\s+/).map((function(e){return function(e,t){r("caret",e,t);var n=t?o[j]:o[U];return e.replace(n,(function(t,n,i,s,o){var a;return r("caret",e,t,n,i,s,o),ce(n)?a="":ce(i)?a=">="+n+".0.0 <"+(+n+1)+".0.0":ce(s)?a="0"===n?">="+n+"."+i+".0 <"+n+"."+(+i+1)+".0":">="+n+"."+i+".0 <"+(+n+1)+".0.0":o?(r("replaceCaret pr",o),"-"!==o.charAt(0)&&(o="-"+o),a="0"===n?"0"===i?">="+n+"."+i+"."+s+o+" <"+n+"."+i+"."+(+s+1):">="+n+"."+i+"."+s+o+" <"+n+"."+(+i+1)+".0":">="+n+"."+i+"."+s+o+" <"+(+n+1)+".0.0"):(r("no pr"),a="0"===n?"0"===i?">="+n+"."+i+"."+s+" <"+n+"."+i+"."+(+s+1):">="+n+"."+i+"."+s+" <"+n+"."+(+i+1)+".0":">="+n+"."+i+"."+s+" <"+(+n+1)+".0.0"),r("caret return",a),a}))}(e,t)
})).join(" ")}(e,t),r("caret",e),e=function(e,t){return e.trim().split(/\s+/).map((function(e){return function(e,t){var n=t?o[N]:o[A];return e.replace(n,(function(t,n,i,s,o){var a;return r("tilde",e,t,n,i,s,o),ce(n)?a="":ce(i)?a=">="+n+".0.0 <"+(+n+1)+".0.0":ce(s)?a=">="+n+"."+i+".0 <"+n+"."+(+i+1)+".0":o?(r("replaceTilde pr",o),"-"!==o.charAt(0)&&(o="-"+o),a=">="+n+"."+i+"."+s+o+" <"+n+"."+(+i+1)+".0"):a=">="+n+"."+i+"."+s+" <"+n+"."+(+i+1)+".0",r("tilde return",a),a}))}(e,t)})).join(" ")}(e,t),r("tildes",e),e=function(e,t){return r("replaceXRanges",e,t),e.split(/\s+/).map((function(e){return function(e,t){e=e.trim();var n=t?o[R]:o[P];return e.replace(n,(function(t,n,i,s,o,a){r("xRange",e,t,n,i,s,o,a);var c=ce(i),l=c||ce(s),u=l||ce(o);return"="===n&&u&&(n=""),c?t=">"===n||"<"===n?"<0.0.0":"*":n&&u?(l&&(s=0),u&&(o=0),">"===n?(n=">=",l?(i=+i+1,s=0,o=0):u&&(s=+s+1,o=0)):"<="===n&&(n="<",l?i=+i+1:s=+s+1),t=n+i+"."+s+"."+o):l?t=">="+i+".0.0 <"+(+i+1)+".0.0":u&&(t=">="+i+"."+s+".0 <"+i+"."+(+s+1)+".0"),
r("xRange return",t),t}))}(e,t)})).join(" ")}(e,t),r("xrange",e),e=function(e,t){return r("replaceStars",e,t),e.trim().replace(o[H],"")}(e,t),r("stars",e),e}(e,t)})).join(" ").split(/\s+/);return this.loose&&(s=s.filter((function(e){return!!e.match(i)}))),s.map((function(e){return new se(e,t)}))},ae.prototype.intersects=function(e,t){if(!(e instanceof ae))throw new TypeError("a Range is required");return this.set.some((function(n){return n.every((function(n){return e.set.some((function(e){return e.every((function(e){return n.intersects(e,t)}))}))}))}))},t.toComparators=function(e,t){return new ae(e,t).set.map((function(e){return e.map((function(e){return e.value})).join(" ").trim().split(" ")}))},ae.prototype.test=function(e){if(!e)return!1;"string"==typeof e&&(e=new G(e,this.loose));for(var t=0;t<this.set.length;t++)if(ue(this.set[t],e))return!0;return!1},t.satisfies=he,t.maxSatisfying=function(e,t,n){var r=null,i=null;try{var s=new ae(t,n)}catch(e){return null}return e.forEach((function(e){
s.test(e)&&(r&&-1!==i.compare(e)||(i=new G(r=e,n)))})),r},t.minSatisfying=function(e,t,n){var r=null,i=null;try{var s=new ae(t,n)}catch(e){return null}return e.forEach((function(e){s.test(e)&&(r&&1!==i.compare(e)||(i=new G(r=e,n)))})),r},t.validRange=function(e,t){try{return new ae(e,t).range||"*"}catch(e){return null}},t.ltr=function(e,t,n){return de(e,t,"<",n)},t.gtr=function(e,t,n){return de(e,t,">",n)},t.outside=de,t.prerelease=function(e,t){var n=q(e,t);return n&&n.prerelease.length?n.prerelease:null},t.intersects=function(e,t,n){return e=new ae(e,n),t=new ae(t,n),e.intersects(t)},t.coerce=function(e){if(e instanceof G)return e;if("string"!=typeof e)return null;var t=e.match(o[O]);return null==t?null:q((t[1]||"0")+"."+(t[2]||"0")+"."+(t[3]||"0"))}}).call(this,n(1))},function(e,t){var n,r,i=e.exports={};function s(){throw new Error("setTimeout has not been defined")}function o(){throw new Error("clearTimeout has not been defined")}function a(e){if(n===setTimeout)return setTimeout(e,0)
;if((n===s||!n)&&setTimeout)return n=setTimeout,setTimeout(e,0);try{return n(e,0)}catch(t){try{return n.call(null,e,0)}catch(t){return n.call(this,e,0)}}}!function(){try{n="function"==typeof setTimeout?setTimeout:s}catch(e){n=s}try{r="function"==typeof clearTimeout?clearTimeout:o}catch(e){r=o}}();var c,l=[],u=!1,h=-1;function d(){u&&c&&(u=!1,c.length?l=c.concat(l):h=-1,l.length&&f())}function f(){if(!u){var e=a(d);u=!0;for(var t=l.length;t;){for(c=l,l=[];++h<t;)c&&c[h].run();h=-1,t=l.length}c=null,u=!1,function(e){if(r===clearTimeout)return clearTimeout(e);if((r===o||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(e);try{r(e)}catch(t){try{return r.call(null,e)}catch(t){return r.call(this,e)}}}(e)}}function p(e,t){this.fun=e,this.array=t}function m(){}i.nextTick=function(e){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];l.push(new p(e,t)),1!==l.length||u||a(f)},p.prototype.run=function(){this.fun.apply(null,this.array)},i.title="browser",
i.browser=!0,i.env={},i.argv=[],i.version="",i.versions={},i.on=m,i.addListener=m,i.once=m,i.off=m,i.removeListener=m,i.removeAllListeners=m,i.emit=m,i.prependListener=m,i.prependOnceListener=m,i.listeners=function(e){return[]},i.binding=function(e){throw new Error("process.binding is not supported")},i.cwd=function(){return"/"},i.chdir=function(e){throw new Error("process.chdir is not supported")},i.umask=function(){return 0}}])})),define(t[45],n([0,1,3]),(function(e,t,n){"use strict";function r(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)}function i(e,t){return new s(e,t)}Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.peekStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0,t.isReadableStream=r,t.isReadableBufferedStream=function(e){const t=e;return t&&r(t.stream)&&Array.isArray(t.buffer)&&"boolean"==typeof t.ended},t.newWriteableStream=i;class s{
constructor(e,t){this.reducer=e,this.options=t,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){var t;if(!this.state.destroyed)if(this.state.flowing)this.listeners.data.forEach(t=>t(e));else if(this.buffer.data.push(e),"number"==typeof(null===(t=this.options)||void 0===t?void 0:t.highWaterMark)&&this.buffer.data.length>this.options.highWaterMark)return new Promise(e=>this.pendingWritePromises.push(e))}error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){if(!this.state.destroyed)switch(e){
case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}removeListener(e,t){if(this.state.destroyed)return;let n=void 0;switch(e){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error}if(n){const e=n.indexOf(t);e>=0&&n.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const e=this.reducer(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0;const t=[...this.pendingWritePromises];this.pendingWritePromises.length=0,t.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){this.state.destroyed||(this.state.destroyed=!0,
this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}t.consumeReadable=function(e,t){const n=[];let r;for(;null!==(r=e.read());)n.push(r);return t(n)},t.peekReadable=function(e,t,n){const r=[];let i=void 0;for(;null!==(i=e.read())&&r.length<n;)r.push(i);return null===i&&r.length>0?t(r):{read:()=>{if(r.length>0)return r.shift();if(void 0!==i){const e=i;return i=void 0,e}return e.read()}}},t.consumeStream=function(e,t){return new Promise((n,r)=>{const i=[];e.on("data",e=>i.push(e)),e.on("error",e=>r(e)),e.on("end",()=>n(t(i)))})},t.peekStream=function(e,t){return new Promise((r,i)=>{const s=new n.DisposableStore,o=[],a=n=>{if(o.push(n),o.length>t)return s.dispose(),e.pause(),r({stream:e,buffer:o,ended:!1})};s.add(n.toDisposable(()=>e.removeListener("data",a))),e.on("data",a);const c=e=>i(e);s.add(n.toDisposable(()=>e.removeListener("error",c))),e.on("error",c)
;const l=()=>r({stream:e,buffer:o,ended:!0});s.add(n.toDisposable(()=>e.removeListener("end",l))),e.on("end",l)})},t.toStream=function(e,t){const n=i(t);return n.end(e),n},t.toReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},t.transform=function(e,t,n){const r=i(n);return e.on("data",e=>r.write(t.data(e))),e.on("end",()=>r.end()),e.on("error",e=>r.error(t.error?t.error(e):e)),r}})),define(t[13],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.count=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0,
t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length};const n=/{(\d+)}/g;function r(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function i(e,t){if(!e||!t)return e;const n=t.length;if(0===n||0===e.length)return e;let r=0;for(;e.indexOf(t,r)===r;)r+=n;return e.substring(r)}function s(e,t){if(!e||!t)return e;const n=t.length,r=e.length;if(0===n||0===r)return e;let i=r,s=-1;for(;-1!==(s=e.lastIndexOf(t,i-1))&&s+n===i;){if(0===s)return"";i=s}return e.substring(0,i)}function o(e,t,n=0,r=e.length,i=0,s=t.length){for(;n<r&&i<s;n++,i++){let r=e.charCodeAt(n),s=t.charCodeAt(i);if(r<s)return-1;if(r>s)return 1}const o=r-n,a=s-i;return o<a?-1:o>a?1:0}function a(e,t,n=0,r=e.length,i=0,s=t.length){for(;n<r&&i<s;n++,i++){let a=e.charCodeAt(n),u=t.charCodeAt(i);if(a===u)continue;const h=a-u;if((32!==h||!l(u))&&(-32!==h||!l(a)))return c(a)&&c(u)?h:o(e.toLowerCase(),t.toLowerCase(),n,r,i,s)}const a=r-n,u=s-i;return a<u?-1:a>u?1:0}function c(e){return e>=97&&e<=122}function l(e){
return e>=65&&e<=90}function u(e){return c(e)||l(e)}function h(e,t,n=e.length){for(let r=0;r<n;r++){const n=e.charCodeAt(r),i=t.charCodeAt(r);if(n!==i)if(u(n)&&u(i)){const e=Math.abs(n-i);if(0!==e&&32!==e)return!1}else if(String.fromCharCode(n).toLowerCase()!==String.fromCharCode(i).toLowerCase())return!1}return!0}function d(e){return 55296<=e&&e<=56319}function f(e){return 56320<=e&&e<=57343}function p(e,t){return t-56320+(e-55296<<10)+65536}function m(e,t,n){const r=e.charCodeAt(n);if(d(r)&&n+1<t){const t=e.charCodeAt(n+1);if(f(t))return p(r,t)}return r}function g(e,t){const n=e.charCodeAt(t-1);if(f(n)&&t>1){const r=e.charCodeAt(t-2);if(d(r))return p(r,n)}return n}function v(e,t){const n=k.getInstance(),r=e.length,i=t,s=m(e,r,t),o=n.getGraphemeBreakType(s);t+=s>=65536?2:1;let a=o;for(;t<r;){const i=m(e,r,t),s=n.getGraphemeBreakType(i);if(I(a,s))break;t+=i>=65536?2:1,a=s}const c=t;for(t=i,a=o;t>0;){const r=g(e,t),i=n.getGraphemeBreakType(r);if(I(i,a))break;t-=r>=65536?2:1,a=i}return[t,c]}
t.format=function(e,...t){return 0===t.length?e:e.replace(n,(function(e,n){const r=parseInt(n,10);return isNaN(r)||r<0||r>=t.length?e:t[r]}))},t.escape=function(e){return e.replace(/[<>&]/g,(function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}}))},t.escapeRegExpCharacters=r,t.count=function(e,t){let n=0;const r=t.charCodeAt(0);for(let t=e.length-1;t>=0;t--)e.charCodeAt(t)===r&&n++;return n},t.trim=function(e,t=" "){return s(i(e,t),t)},t.ltrim=i,t.rtrim=s,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.createRegExp=function(e,t,n={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=r(e)),n.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let i="";return n.global&&(i+="g"),n.matchCase||(i+="i"),n.multiline&&(i+="m"),n.unicode&&(i+="u"),new RegExp(e,i)},
t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(let t=0,n=e.length;t<n;t++){const n=e.charCodeAt(t);if(32!==n&&9!==n)return t}return-1},t.getLeadingWhitespace=function(e,t=0,n=e.length){for(let r=t;r<n;r++){const n=e.charCodeAt(r);if(32!==n&&9!==n)return e.substring(t,r)}return e.substring(t,n)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){for(let n=t;n>=0;n--){const t=e.charCodeAt(n);if(32!==t&&9!==t)return n}return-1},t.compare=function(e,t){return e<t?-1:e>t?1:0},t.compareSubstring=o,t.compareIgnoreCase=function(e,t){return a(e,t,0,e.length,0,t.length)},t.compareSubstringIgnoreCase=a,t.isLowerAsciiLetter=c,t.isUpperAsciiLetter=l,t.equalsIgnoreCase=function(e,t){
return e.length===t.length&&h(e,t)},t.startsWithIgnoreCase=function(e,t){const n=t.length;return!(t.length>e.length)&&h(e,t,n)},t.commonPrefixLength=function(e,t){let n,r=Math.min(e.length,t.length);for(n=0;n<r;n++)if(e.charCodeAt(n)!==t.charCodeAt(n))return n;return r},t.commonSuffixLength=function(e,t){let n,r=Math.min(e.length,t.length);const i=e.length-1,s=t.length-1;for(n=0;n<r;n++)if(e.charCodeAt(i-n)!==t.charCodeAt(s-n))return n;return r},t.isHighSurrogate=d,t.isLowSurrogate=f,t.computeCodePoint=p,t.getNextCodePoint=m,t.nextCharLength=function(e,t){const n=k.getInstance(),r=t,i=e.length,s=m(e,i,t);t+=s>=65536?2:1;let o=n.getGraphemeBreakType(s);for(;t<i;){const r=m(e,i,t),s=n.getGraphemeBreakType(r);if(I(o,s))break;t+=r>=65536?2:1,o=s}return t-r},t.prevCharLength=function(e,t){const n=k.getInstance(),r=t,i=g(e,t);t-=i>=65536?2:1;let s=n.getGraphemeBreakType(i);for(;t>0;){const r=g(e,t),i=n.getGraphemeBreakType(r);if(I(i,s))break;t-=r>=65536?2:1,s=i}return r-t},t.getCharContainingOffset=function(e,t){
return t>0&&f(e.charCodeAt(t))?v(e,t-1):v(e,t)},t.encodeUTF8=function(e){const t=e.length;let n=0,r=0;for(;r<t;){const i=m(e,t,r);r+=i>=65536?2:1,n+=i<128?1:i<2048?2:i<65536?3:4}const i=new Uint8Array(n);r=0;let s=0;for(;r<t;){const n=m(e,t,r);r+=n>=65536?2:1,n<128?i[s++]=n:n<2048?(i[s++]=192|(1984&n)>>>6,i[s++]=128|(63&n)>>>0):n<65536?(i[s++]=224|(61440&n)>>>12,i[s++]=128|(4032&n)>>>6,i[s++]=128|(63&n)>>>0):(i[s++]=240|(1835008&n)>>>18,i[s++]=128|(258048&n)>>>12,i[s++]=128|(4032&n)>>>6,i[s++]=128|(63&n)>>>0)}return i},t.decodeUTF8=function(e){const t=e.byteLength,n=[];let r=0;for(;r<t;){const i=e[r];let s;if((s=i>=240&&r+3<t?(7&e[r++])<<18>>>0|(63&e[r++])<<12>>>0|(63&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:i>=224&&r+2<t?(15&e[r++])<<12>>>0|(63&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:i>=192&&r+1<t?(31&e[r++])<<6>>>0|(63&e[r++])<<0>>>0:e[r++])>=0&&s<=55295||s>=57344&&s<=65535)n.push(String.fromCharCode(s));else if(s>=65536&&s<=1114111){const e=s-65536,t=55296+((1047552&e)>>>10),r=56320+((1023&e)>>>0)
;n.push(String.fromCharCode(t)),n.push(String.fromCharCode(r))}else n.push(String.fromCharCode(65533))}return n.join("")};const y=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;t.containsRTL=function(e){return y.test(e)};const b=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;t.containsEmoji=function(e){return b.test(e)};const w=/^[\t\n\r\x20-\x7E]*$/;function _(e){
return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}t.isBasicASCII=function(e){return w.test(e)},t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/,t.containsUnusualLineTerminators=function(e){return t.UNUSUAL_LINE_TERMINATORS.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,n=e.length;t<n;t++)if(_(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=_,t.isEmojiImprecise=function(e){return e>=127462&&e<=127487||e>=9728&&e<=10175||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129003||e>=129280&&e<=129535||e>=129648&&e<=129651||e>=129656&&e<=129666||e>=129680&&e<=129685},t.lcut=function(e,t){if(e.length<t)return e;const n=/\b/g;let r=0;for(;n.test(e)&&!(e.length-n.lastIndex<t);)r=n.lastIndex,n.lastIndex+=1;return e.substring(r).replace(/^\s/,"")};const E=/\x1B\x5B[12]?K/g,S=/\x1b\[\d+m/g,C=/\x1b\[0?m/g;function x(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}function I(e,t){
return 0===e?5!==t&&7!==t:(2!==e||3!==t)&&(4===e||2===e||3===e||(4===t||2===t||3===t||(8!==e||8!==t&&9!==t&&11!==t&&12!==t)&&((11!==e&&9!==e||9!==t&&10!==t)&&((12!==e&&10!==e||10!==t)&&(5!==t&&13!==t&&(7!==t&&(1!==e&&((13!==e||14!==t)&&(6!==e||6!==t)))))))))}t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(E,"")).replace(S,"")).replace(C,"")),e},t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=x,t.stripUTF8BOM=function(e){return x(e)?e.substr(1):e},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const n=t.length,r=e.toLowerCase();let i=0,s=-1;for(;i<n;){const e=r.indexOf(t[i],s+1);if(e<0)return!1;s=e,i++}return!0},t.containsUppercaseCharacter=function(e,t=!1){return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let n=-1;do{n=e.indexOf("\n",n+1),t--}while(t>0&&n>=0);return n>=0?e.substr(0,n):e},
t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)},t.getGraphemeBreakType=function(e){return k.getInstance().getGraphemeBreakType(e)},t.breakBetweenGraphemeBreakType=I,function(e){e[e.Other=0]="Other",e[e.Prepend=1]="Prepend",e[e.CR=2]="CR",e[e.LF=3]="LF",e[e.Control=4]="Control",e[e.Extend=5]="Extend",e[e.Regional_Indicator=6]="Regional_Indicator",e[e.SpacingMark=7]="SpacingMark",e[e.L=8]="L",e[e.V=9]="V",e[e.T=10]="T",e[e.LV=11]="LV",e[e.LVT=12]="LVT",e[e.ZWJ=13]="ZWJ",e[e.Extended_Pictographic=14]="Extended_Pictographic"}(t.GraphemeBreakType||(t.GraphemeBreakType={}));class k{constructor(){
this._data=JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")
}static getInstance(){return k._INSTANCE||(k._INSTANCE=new k),k._INSTANCE}getGraphemeBreakType(e){if(e<32)return 10===e?3:13===e?2:4;if(e<127)return 0;const t=this._data,n=t.length/3;let r=1;for(;r<=n;)if(e<t[3*r])r*=2;else{if(!(e>t[3*r+1]))return t[3*r+2];r=2*r+1}return 0}}k._INSTANCE=null})),define(t[19],n([0,1,13,45]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i="undefined"!=typeof Buffer,s="undefined"!=typeof TextEncoder,o="undefined"!=typeof TextDecoder;let a,c;class l{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return new l(i?Buffer.allocUnsafe(e):new Uint8Array(e))}static wrap(e){
return i&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new l(e)}static fromString(e){return i?new l(Buffer.from(e)):s?(a||(a=new TextEncoder),new l(a.encode(e))):new l(n.encodeUTF8(e))}static concat(e,t){if(void 0===t){t=0;for(let n=0,r=e.length;n<r;n++)t+=e[n].byteLength}const n=l.alloc(t);let r=0;for(let t=0,i=e.length;t<i;t++){const i=e[t];n.set(i,r),r+=i.byteLength}return n}toString(){return i?this.buffer.toString():o?(c||(c=new TextDecoder),c.decode(this.buffer)):n.decodeUTF8(this.buffer)}slice(e,t){return new l(this.buffer.subarray(e,t))}set(e,t){e instanceof l?this.buffer.set(e.buffer,t):this.buffer.set(e,t)}readUInt32BE(e){return u(this.buffer,e)}writeUInt32BE(e,t){h(this.buffer,e,t)}readUInt32LE(e){return d(this.buffer,e)}writeUInt32LE(e,t){f(this.buffer,e,t)}readUInt8(e){return p(this.buffer,e)}writeUInt8(e,t){m(this.buffer,e,t)}}function u(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function h(e,t,n){e[n+3]=t,t>>>=8,e[n+2]=t,t>>>=8,e[n+1]=t,t>>>=8,e[n]=t}
function d(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}function f(e,t,n){e[n+0]=255&t,t>>>=8,e[n+1]=255&t,t>>>=8,e[n+2]=255&t,t>>>=8,e[n+3]=255&t}function p(e,t){return e[t]}function m(e,t,n){e[n]=t}function g(e){return r.consumeStream(e,e=>l.concat(e))}t.VSBuffer=l,t.readUInt16LE=function(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0},t.writeUInt16LE=function(e,t,n){e[n+0]=255&t,t>>>=8,e[n+1]=255&t},t.readUInt32BE=u,t.writeUInt32BE=h,t.readUInt32LE=d,t.writeUInt32LE=f,t.readUInt8=p,t.writeUInt8=m,t.readableToBuffer=function(e){return r.consumeReadable(e,e=>l.concat(e))},t.bufferToReadable=function(e){return r.toReadable(e)},t.streamToBuffer=g,t.bufferedStreamToBuffer=async function(e){return e.ended?l.concat(e.buffer):l.concat([...e.buffer,await g(e.stream)])},t.bufferToStream=function(e){return r.toStream(e,e=>l.concat(e))},t.streamToBufferReadableStream=function(e){return r.transform(e,{data:e=>"string"==typeof e?l.fromString(e):l.wrap(e)},e=>l.concat(e))},
t.newWriteableBufferStream=function(e){return r.newWriteableStream(e=>l.concat(e),e)}})),define(t[114],n([0,1,13]),(function(e,t,n){"use strict";function r(e,t){switch(typeof e){case"object":return null===e?i(349,t):Array.isArray(e)?(n=e,o=i(104579,o=t),n.reduce((e,t)=>r(t,e),o)):function(e,t){return t=i(181387,t),Object.keys(e).sort().reduce((t,n)=>(t=s(n,t),r(e[n],t)),t)}(e,t);case"string":return s(e,t);case"boolean":return function(e,t){return i(e?433:863,t)}(e,t);case"number":return i(e,t);case"undefined":return i(937,t);default:return i(617,t)}var n,o}function i(e,t){return(t<<5)-t+e|0}function s(e,t){t=i(149417,t);for(let n=0,r=e.length;n<r;n++)t=i(e.charCodeAt(n),t);return t}Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=t.stringHash=t.doHash=t.hash=void 0,t.hash=function(e){return r(e,0)},t.doHash=r,t.stringHash=s;var o;function a(e,t,n=32){const r=n-t;return(e<<t|(~((1<<r)-1)&e)>>>r)>>>0}function c(e,t=0,n=e.byteLength,r=0){for(let i=0;i<n;i++)e[t+i]=r}function l(e,t=32){
return function(e,t,n="0"){for(;e.length<t;)e=n+e;return e}((e>>>0).toString(16),t/4)}t.Hasher=class{constructor(){this._value=0}get value(){return this._value}hash(e){return this._value=r(e,this._value),this._value}},function(e){e[e.BLOCK_SIZE=64]="BLOCK_SIZE",e[e.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"}(o||(o={}));class u{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(e){const t=e.length;if(0===t)return;const r=this._buff;let i,s,o=this._buffLen,a=this._leftoverHighSurrogate;for(0!==a?(i=a,s=-1,a=0):(i=e.charCodeAt(0),s=0);;){let c=i;if(n.isHighSurrogate(i)){if(!(s+1<t)){a=i;break}{const t=e.charCodeAt(s+1);n.isLowSurrogate(t)?(s++,c=n.computeCodePoint(i,t)):c=65533}}else n.isLowSurrogate(i)&&(c=65533);if(o=this._push(r,o,c),!(++s<t))break;i=e.charCodeAt(s)}this._buffLen=o,
this._leftoverHighSurrogate=a}_push(e,t,n){return n<128?e[t++]=n:n<2048?(e[t++]=192|(1984&n)>>>6,e[t++]=128|(63&n)>>>0):n<65536?(e[t++]=224|(61440&n)>>>12,e[t++]=128|(4032&n)>>>6,e[t++]=128|(63&n)>>>0):(e[t++]=240|(1835008&n)>>>18,e[t++]=128|(258048&n)>>>12,e[t++]=128|(4032&n)>>>6,e[t++]=128|(63&n)>>>0),t>=64&&(this._step(),t-=64,this._totalLen+=64,e[0]=e[64],e[1]=e[65],e[2]=e[66]),t}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const e=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(e/4294967296),!1),this._buffDV.setUint32(60,e%4294967296,!1),this._step()}_step(){const e=u._bigBlock32,t=this._buffDV;for(let n=0;n<64;n+=4)e.setUint32(n,t.getUint32(n,!1),!1)
;for(let t=64;t<320;t+=4)e.setUint32(t,a(e.getUint32(t-12,!1)^e.getUint32(t-32,!1)^e.getUint32(t-56,!1)^e.getUint32(t-64,!1),1),!1);let n,r,i,s=this._h0,o=this._h1,c=this._h2,l=this._h3,h=this._h4;for(let t=0;t<80;t++)t<20?(n=o&c|~o&l,r=1518500249):t<40?(n=o^c^l,r=1859775393):t<60?(n=o&c|o&l|c&l,r=2400959708):(n=o^c^l,r=3395469782),i=a(s,5)+n+h+r+e.getUint32(4*t,!1)&4294967295,h=l,l=c,c=a(o,30),o=s,s=i;this._h0=this._h0+s&4294967295,this._h1=this._h1+o&4294967295,this._h2=this._h2+c&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+h&4294967295}}t.StringSHA1=u,u._bigBlock32=new DataView(new ArrayBuffer(320))})),define(t[73],n([0,1,13]),(function(e,t,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(r||(r={})),function(e){const t="error",r="warning",i="warn",s="info";e.fromValue=function(o){
return o?n.equalsIgnoreCase(t,o)?e.Error:n.equalsIgnoreCase(r,o)||n.equalsIgnoreCase(i,o)?e.Warning:n.equalsIgnoreCase(s,o)?e.Info:e.Ignore:e.Ignore}}(r||(r={})),t.default=r})),define(t[11],n([0,1]),(function(e,t){"use strict";function n(e){return"string"==typeof e}function r(e){return!("object"!=typeof e||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function i(e){return void 0===e}function s(e){return i(e)||null===e}Object.defineProperty(t,"__esModule",{value:!0}),t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0,t.isArray=function(e){return Array.isArray(e)},t.isString=n,t.isStringArray=function(e){return Array.isArray(e)&&e.every(e=>n(e))},
t.isObject=r,t.isNumber=function(e){return"number"==typeof e&&!isNaN(e)},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=i,t.isDefined=function(e){return!s(e)},t.isUndefinedOrNull=s,t.assertType=function(e,t){if(!e)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")},t.assertIsDefined=function(e){if(s(e))throw new Error("Assertion Failed: argument is undefined or null");return e},t.assertAllDefined=function(...e){const t=[];for(let n=0;n<e.length;n++){const r=e[n];if(s(r))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);t.push(r)}return t};const o=Object.prototype.hasOwnProperty;function a(e){return"function"==typeof e}function c(e,t){if(n(t)){if(typeof e!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(e instanceof t)return}catch(e){}if(!s(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return
;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(e){let t=[],n=Object.getPrototypeOf(e);for(;Object.prototype!==n;)t=t.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return t}t.isEmptyObject=function(e){if(!r(e))return!1;for(let t in e)if(o.call(e,t))return!1;return!0},t.isFunction=a,t.areFunctions=function(...e){return e.length>0&&e.every(a)},t.validateConstraints=function(e,t){const n=Math.min(e.length,t.length);for(let r=0;r<n;r++)c(e[r],t[r])},t.validateConstraint=c,t.getAllPropertyNames=l,t.getAllMethodNames=function(e){const t=[];for(const n of l(e))"function"==typeof e[n]&&t.push(n);return t},t.createProxyObject=function(e,t){const n=e=>(function(){const n=Array.prototype.slice.call(arguments,0);return t(e,n)});let r={};for(const t of e)r[t]=n(t);return r},t.withNullAsUndefined=function(e){return null===e?void 0:e},t.withUndefinedAsNull=function(e){
return void 0===e?null:e},t.NotImplementedProxy=function(e){return class{constructor(){return new Proxy({},{get(t,n){if(t[n])return t[n];throw new Error(`Not Implemented: ${e}->${String(n)}`)}})}}}})),define(t[30],n([0,1,5,13,2,11]),(function(e,t,n,r,i,s){"use strict";function o(e){return 47===e||92===e}Object.defineProperty(t,"__esModule",{value:!0}),t.parseLineAndColumnAware=t.indexOfPath=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toSlashes=t.isPathSeparator=void 0,t.isPathSeparator=o,t.toSlashes=function(e){return e.replace(/[\\/]/g,i.posix.sep)},t.getRoot=function(e,t=i.posix.sep){if(!e)return"";const n=e.length,r=e.charCodeAt(0);if(o(r)){if(o(e.charCodeAt(1))&&!o(e.charCodeAt(2))){let r=3;const i=r;for(;r<n&&!o(e.charCodeAt(r));r++);if(i!==r&&!o(e.charCodeAt(r+1)))for(r+=1;r<n;r++)if(o(e.charCodeAt(r)))return e.slice(0,r+1).replace(/[\\/]/g,t)}return t}
if(u(r)&&58===e.charCodeAt(1))return o(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);let s=e.indexOf("://");if(-1!==s)for(s+=3;s<n;s++)if(o(e.charCodeAt(s)))return e.slice(0,s+1);return""},t.isUNC=function(e){if(!n.isWindows)return!1;if(!e||e.length<5)return!1;let t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;let r=2;const i=r;for(;r<e.length&&92!==(t=e.charCodeAt(r));r++);return i!==r&&(t=e.charCodeAt(r+1),!isNaN(t)&&92!==t)};const a=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(e){return e>=65&&e<=90||e>=97&&e<=122}t.isValidBasename=function(e,t=n.isWindows){const r=t?a:c;return!(!e||0===e.length||/^\s+$/.test(e))&&(r.lastIndex=0,!r.test(e)&&((!t||!l.test(e))&&("."!==e&&".."!==e&&((!t||"."!==e[e.length-1])&&((!t||e.length===e.trim().length)&&!(e.length>255))))))},t.isEqual=function(e,t,n){const i=e===t;return!n||i?i:!(!e||!t)&&r.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,t,n,s=i.sep){if(e===t)return!0
;if(!e||!t)return!1;if(t.length>e.length)return!1;if(n){if(!r.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;let n=t.length;return t.charAt(t.length-1)===s&&n--,e.charAt(n)===s}return t.charAt(t.length-1)!==s&&(t+=s),0===e.indexOf(t)},t.isWindowsDriveLetter=u,t.sanitizeFilePath=function(e,t){return n.isWindows&&e.endsWith(":")&&(e+=i.sep),i.isAbsolute(e)||(e=i.join(t,e)),e=i.normalize(e),n.isWindows?(e=r.rtrim(e,i.sep)).endsWith(":")&&(e+=i.sep):(e=r.rtrim(e,i.sep))||(e=i.sep),e},t.isRootOrDriveLetter=function(e){const t=i.normalize(e);return n.isWindows?!(e.length>3)&&(u(t.charCodeAt(0))&&58===t.charCodeAt(1)&&(2===e.length||92===t.charCodeAt(2))):t===i.posix.sep},t.indexOfPath=function(e,t,n){return t.length>e.length?-1:e===t?0:(n&&(e=e.toLowerCase(),t=t.toLowerCase()),e.indexOf(t))},t.parseLineAndColumnAware=function(e){const t=e.split(":");let n=void 0,r=void 0,i=void 0;if(t.forEach(e=>{const t=Number(e);s.isNumber(t)?void 0===r?r=t:void 0===i&&(i=t):n=n?[n,e].join(":"):e}),
!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:void 0!==r?r:void 0,column:void 0!==i?i:void 0!==r?1:void 0}}})),define(t[18],n([0,1,11]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0,t.deepClone=function e(t){if(!t||"object"!=typeof t)return t;if(t instanceof RegExp)return t;const n=Array.isArray(t)?[]:{};return Object.keys(t).forEach(r=>{t[r]&&"object"==typeof t[r]?n[r]=e(t[r]):n[r]=t[r]}),n},t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;const t=[e];for(;t.length>0;){const e=t.shift();Object.freeze(e);for(const n in e)if(r.call(e,n)){const r=e[n];"object"!=typeof r||Object.isFrozen(r)||t.push(r)}}return e};const r=Object.prototype.hasOwnProperty;function i(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1
;if(Array.isArray(e)!==Array.isArray(t))return!1;let n,r;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(n=0;n<e.length;n++)if(!i(e[n],t[n]))return!1}else{const s=[];for(r in e)s.push(r);s.sort();const o=[];for(r in t)o.push(r);if(o.sort(),!i(s,o))return!1;for(n=0;n<s.length;n++)if(!i(e[s[n]],t[s[n]]))return!1}return!0}t.cloneAndChange=function(e,t){return function e(t,i,s){if(n.isUndefinedOrNull(t))return t;const o=i(t);if(void 0!==o)return o;if(n.isArray(t)){const n=[];for(const r of t)n.push(e(r,i,s));return n}if(n.isObject(t)){if(s.has(t))throw new Error("Cannot clone recursive data-structure");s.add(t);const n={};for(let o in t)r.call(t,o)&&(n[o]=e(t[o],i,s));return s.delete(t),n}return t}(e,t,new Set)},t.mixin=function e(t,r,i=!0){return n.isObject(t)?(n.isObject(r)&&Object.keys(r).forEach(s=>{s in t?i&&(n.isObject(t[s])&&n.isObject(r[s])?e(t[s],r[s],i):t[s]=r[s]):t[s]=r[s]}),t):r},t.equals=i,t.safeStringify=function(e){const t=new Set;return JSON.stringify(e,(e,r)=>{
if(n.isObject(r)||Array.isArray(r)){if(t.has(r))return"[Circular]";t.add(r)}return r})},t.getOrDefault=function(e,t,n){const r=t(e);return void 0===r?n:r},t.distinct=function(e,t){const n=Object.create(null);return e&&t?(Object.keys(t).forEach(r=>{const s=e[r],o=t[r];i(s,o)||(n[r]=o)}),n):n},t.getCaseInsensitive=function(e,t){const n=t.toLowerCase(),r=Object.keys(e).find(e=>e.toLowerCase()===n);return r?e[r]:e[t]}})),define(t[4],n([0,1,5,2]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,s=/^\//,o=/^\/\//;const a="",c="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(e,t,n,r,l,u=!1){"object"==typeof e?(this.scheme=e.scheme||a,this.authority=e.authority||a,this.path=e.path||a,this.query=e.query||a,this.fragment=e.fragment||a):(this.scheme=function(e,t){return e||t?e:"file"}(e,u),this.authority=t||a,this.path=function(e,t){switch(e){case"https":case"http":case"file":
t?t[0]!==c&&(t=c+t):t=c}return t}(this.scheme,n||a),this.query=r||a,this.fragment=l||a,function(e,t){if(!e.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`);if(e.scheme&&!i.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!s.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(o.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,u))}static isUri(e){return e instanceof u||!!e&&("string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString)}
get fsPath(){return g(this,!1)}with(e){if(!e)return this;let{scheme:t,authority:n,path:r,query:i,fragment:s}=e;return void 0===t?t=this.scheme:null===t&&(t=a),void 0===n?n=this.authority:null===n&&(n=a),void 0===r?r=this.path:null===r&&(r=a),void 0===i?i=this.query:null===i&&(i=a),void 0===s?s=this.fragment:null===s&&(s=a),t===this.scheme&&n===this.authority&&r===this.path&&i===this.query&&s===this.fragment?this:new d(t,n,r,i,s)}static parse(e,t=!1){const n=l.exec(e);return n?new d(n[2]||a,b(n[4]||a),b(n[5]||a),b(n[7]||a),b(n[9]||a),t):new d(a,a,a,a,a)}static file(e){let t=a;if(n.isWindows&&(e=e.replace(/\\/g,c)),e[0]===c&&e[1]===c){const n=e.indexOf(c,2);-1===n?(t=e.substring(2),e=c):(t=e.substring(2,n),e=e.substring(n)||c)}return new d("file",t,e,a,a)}static from(e){return new d(e.scheme,e.authority,e.path,e.query,e.fragment)}static joinPath(e,...t){if(!e.path)throw new Error("[UriError]: cannot call joinPaths on URI without path");let i
;return i=n.isWindows&&"file"===e.scheme?u.file(r.win32.join(g(e,!0),...t)).path:r.posix.join(e.path,...t),e.with({path:i})}toString(e=!1){return v(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof u)return e;{const t=new d(e);return t._formatted=e.external,t._fsPath=e._sep===h?e.fsPath:null,t}}return e}}t.URI=u;const h=n.isWindows?1:void 0;class d extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(e=!1){return e?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const e={$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=h),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",
36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function p(e,t){let n=void 0,r=-1;for(let i=0;i<e.length;i++){const s=e.charCodeAt(i);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||45===s||46===s||95===s||126===s||t&&47===s)-1!==r&&(n+=encodeURIComponent(e.substring(r,i)),r=-1),void 0!==n&&(n+=e.charAt(i));else{void 0===n&&(n=e.substr(0,i));const t=f[s];void 0!==t?(-1!==r&&(n+=encodeURIComponent(e.substring(r,i)),r=-1),n+=t):-1===r&&(r=i)}}return-1!==r&&(n+=encodeURIComponent(e.substring(r))),void 0!==n?n:e}function m(e){let t=void 0;for(let n=0;n<e.length;n++){const r=e.charCodeAt(n);35===r||63===r?(void 0===t&&(t=e.substr(0,n)),t+=f[r]):void 0!==t&&(t+=e[n])}return void 0!==t?t:e}function g(e,t){let r
;return r=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?t?e.path.substr(1):e.path[1].toLowerCase()+e.path.substr(2):e.path,n.isWindows&&(r=r.replace(/\//g,"\\")),r}function v(e,t){const n=t?m:p;let r="",{scheme:i,authority:s,path:o,query:a,fragment:l}=e;if(i&&(r+=i,r+=":"),(s||"file"===i)&&(r+=c,r+=c),s){let e=s.indexOf("@");if(-1!==e){const t=s.substr(0,e);s=s.substr(e+1),-1===(e=t.indexOf(":"))?r+=n(t,!1):(r+=n(t.substr(0,e),!1),r+=":",r+=n(t.substr(e+1),!1)),r+="@"}-1===(e=(s=s.toLowerCase()).indexOf(":"))?r+=n(s,!1):(r+=n(s.substr(0,e),!1),r+=s.substr(e))}if(o){if(o.length>=3&&47===o.charCodeAt(0)&&58===o.charCodeAt(2)){const e=o.charCodeAt(1);e>=65&&e<=90&&(o=`/${String.fromCharCode(e+32)}:${o.substr(3)}`)}else if(o.length>=2&&58===o.charCodeAt(1)){const e=o.charCodeAt(0)
;e>=65&&e<=90&&(o=`${String.fromCharCode(e+32)}:${o.substr(2)}`)}r+=n(o,!0)}return a&&(r+="?",r+=n(a,!1)),l&&(r+="#",r+=t?l:p(l,!1)),r}t.uriToFsPath=g;const y=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function b(e){return e.match(y)?e.replace(y,e=>(function e(t){try{return decodeURIComponent(t)}catch(n){return t.length>3?t.substr(0,3)+e(t.substr(3)):t}})(e)):e}})),define(t[115],n([0,1,4]),(function(e,t,n){"use strict";function r(e){const t=[];let n;try{const r=JSON.parse(e.arguments),i=r[r.length-1];i&&i.__$stack&&(r.pop(),n=i.__$stack),t.push(...r)}catch(n){t.push("Unable to log remote console arguments",e.arguments)}return{args:t,stack:n}}function i(e){if(!e)return e;const t=e.indexOf("\n");return-1===t?e:e.substring(0,t)}function s(e){return`color: ${e}`}Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0,t.isRemoteConsoleLog=function(e){const t=e;return t&&"string"==typeof t.type&&"string"==typeof t.severity},t.parse=r,t.getFirstFrame=function e(t){
if("string"!=typeof t)return e(r(t).stack);if(t){const e=i(t),r=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(e||"");if(r&&4===r.length)return{uri:n.URI.file(r[1]),line:Number(r[2]),column:Number(r[3])}}},t.log=function(e,t){const{args:n,stack:o}=r(e),a="string"==typeof n[0]&&1===n.length;let c=i(o);c&&(c=`(${c.trim()})`);let l=[];if(l="string"==typeof n[0]?c&&a?[`%c[${t}] %c${n[0]} %c${c}`,s("blue"),s(""),s("grey")]:[`%c[${t}] %c${n[0]}`,s("blue"),s(""),...n.slice(1)]:[`%c[${t}]%`,s("blue"),...n],c&&!a&&l.push(c),"function"!=typeof console[e.severity])throw new Error("Unknown console method");console[e.severity].apply(console,l)}})),define(t[46],n([0,1,19,13,4]),(function(e,t,n,r,i){"use strict";function s(e,t){return t instanceof RegExp?{$mid:2,source:t.source,flags:r.regExpFlags(t)}:t}function o(e,t=0){if(!e||t>200)return e;if("object"==typeof e){switch(e.$mid){case 1:return i.URI.revive(e);case 2:return new RegExp(e.source,e.flags)}
if(e instanceof n.VSBuffer||e instanceof Uint8Array)return e;if(Array.isArray(e))for(let n=0;n<e.length;++n)e[n]=o(e[n],t+1);else for(const n in e)Object.hasOwnProperty.call(e,n)&&(e[n]=o(e[n],t+1))}return e}Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0,t.stringify=function(e){return JSON.stringify(e,s)},t.parse=function(e){let t=JSON.parse(e);return t=o(t)},t.revive=o})),define(t[8],n([0,1,4,5]),(function(e,t,n,r){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.Schemas=void 0,function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.userData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebook="vscode-notebook",
e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeSettings="vscode-settings",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.vscodeWebviewResource="vscode-webview-resource",e.extension="extension"}(i=t.Schemas||(t.Schemas={}));t.RemoteAuthorities=new class{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(e){this._preferredWebSchema=e}setDelegate(e){this._delegate=e}set(e,t,n){this._hosts[e]=t,this._ports[e]=n}setConnectionToken(e,t){this._connectionTokens[e]=t}rewrite(e){if(this._delegate)return this._delegate(e);const t=e.authority;let s=this._hosts[t];s&&-1!==s.indexOf(":")&&(s=`[${s}]`);const o=this._ports[t],a=this._connectionTokens[t];let c=`path=${encodeURIComponent(e.path)}`;return"string"==typeof a&&(c+=`&tkn=${encodeURIComponent(a)}`),n.URI.from({scheme:r.isWeb?this._preferredWebSchema:i.vscodeRemoteResource,authority:`${s}:${o}`,
path:"/vscode-remote-resource",query:c})}};t.FileAccess=new class{asBrowserUri(e,n){const r=this.toUri(e,n);return r.scheme===i.vscodeRemote?t.RemoteAuthorities.rewrite(r):r}asFileUri(e,t){return this.toUri(e,t)}toUri(e,t){return n.URI.isUri(e)?e:n.URI.parse(t.toUrl(e))}}})),define(t[23],n([0,1,4,13,5,8]),(function(e,t,n,r,i,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0,t.getOrSet=function(e,t,n){let r=e.get(t);return void 0===r&&(r=n,e.set(t,r)),r},t.mapToString=function(e){const t=[];return e.forEach((e,n)=>{t.push(`${n} => ${e}`)}),`Map(${e.size}) {${t.join(", ")}}`},t.setToString=function(e){const t=[];return e.forEach(e=>{t.push(e)}),`Set(${e.size}) {${t.join(", ")}}`};class o{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){
return this._pos<this._value.length-1}cmp(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)}value(){return this._value[this._pos]}}t.StringIterator=o;class a{constructor(e=!0,t=!0){this._splitOnBackslash=e,this._caseSensitive=t}reset(e){return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(47===t||this._splitOnBackslash&&92===t){if(!e)break;this._from++}else e=!1}return this}cmp(e){return this._caseSensitive?r.compareSubstring(e,this._value,0,e.length,this._from,this._to):r.compareSubstringIgnoreCase(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}var c;t.PathIterator=a,function(e){e[e.Scheme=1]="Scheme",e[e.Authority=2]="Authority",e[e.Path=3]="Path",e[e.Query=4]="Query",e[e.Fragment=5]="Fragment"}(c||(c={}));class l{constructor(e){
this._ignorePathCasing=e,this._states=[],this._stateIdx=0}reset(e){return this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new a(!1,void 0===this._ignorePathCasing?e.scheme===s.Schemas.file&&i.isLinux:!this._ignorePathCasing),this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(1===this._states[this._stateIdx])return r.compareIgnoreCase(e,this._value.scheme);if(2===this._states[this._stateIdx])return r.compareIgnoreCase(e,this._value.authority);if(3===this._states[this._stateIdx])return this._pathIterator.cmp(e)
;if(4===this._states[this._stateIdx])return r.compare(e,this._value.query);if(5===this._states[this._stateIdx])return r.compare(e,this._value.fragment);throw new Error}value(){if(1===this._states[this._stateIdx])return this._value.scheme;if(2===this._states[this._stateIdx])return this._value.authority;if(3===this._states[this._stateIdx])return this._pathIterator.value();if(4===this._states[this._stateIdx])return this._value.query;if(5===this._states[this._stateIdx])return this._value.fragment;throw new Error}}t.UriIterator=l;class u{isEmpty(){return!(this.left||this.mid||this.right||this.value)}}class h{constructor(e){this._iter=e}static forUris(e){return new h(new l(e))}static forPaths(){return new h(new a)}static forStrings(){return new h(new o)}clear(){this._root=void 0}set(e,t){const n=this._iter.reset(e);let r;for(this._root||(this._root=new u,this._root.segment=n.value()),r=this._root;;){const e=n.cmp(r.segment);if(e>0)r.left||(r.left=new u,r.left.segment=n.value()),
r=r.left;else if(e<0)r.right||(r.right=new u,r.right.segment=n.value()),r=r.right;else{if(!n.hasNext())break;n.next(),r.mid||(r.mid=new u,r.mid.segment=n.value()),r=r.mid}}const i=r.value;return r.value=t,r.key=e,i}get(e){const t=this._iter.reset(e);let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())break;t.next(),n=n.mid}}return n?n.value:void 0}delete(e){return this._delete(e,!1)}deleteSuperstr(e){return this._delete(e,!0)}_delete(e,t){const n=this._iter.reset(e),r=[];let i=this._root;for(;i;){const e=n.cmp(i.segment);if(e>0)r.push([1,i]),i=i.left;else if(e<0)r.push([-1,i]),i=i.right;else{if(!n.hasNext()){for(i.value=void 0;r.length>0&&(i.isEmpty()||t);){let[e,t]=r.pop();switch(e){case 1:t.left=void 0;break;case 0:t.mid=void 0;break;case-1:t.right=void 0}i=t}break}n.next(),r.push([0,i]),i=i.mid}}}findSubstr(e){const t=this._iter.reset(e);let n=this._root,r=void 0;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{
if(!t.hasNext())break;t.next(),r=n.value||r,n=n.mid}}return n&&n.value||r}findSuperstr(e){const t=this._iter.reset(e);let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)n=n.left;else if(e<0)n=n.right;else{if(!t.hasNext())return n.mid?this._values(n.mid):void 0;t.next(),n=n.mid}}}forEach(e){for(const[t,n]of this)e(n,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_values(e){for(const[,t]of this._entries(e))yield t}*_entries(e){e&&(yield*this._entries(e.left),e.value&&(yield[e.key,e.value]),yield*this._entries(e.mid),yield*this._entries(e.right))}}t.TernarySearchTree=h;class d{constructor(e,t){this[Symbol.toStringTag]="ResourceMap",e instanceof d?(this.map=new Map(e.map),this.toKey=null!=t?t:d.defaultToKey):(this.map=new Map,this.toKey=null!=e?e:d.defaultToKey)}set(e,t){return this.map.set(this.toKey(e),t),this}get(e){return this.map.get(this.toKey(e))}has(e){return this.map.has(this.toKey(e))}get size(){return this.map.size}clear(){this.map.clear()}delete(e){
return this.map.delete(this.toKey(e))}forEach(e,t){void 0!==t&&(e=e.bind(t));for(let[t,r]of this.map)e(r,n.URI.parse(t),this)}values(){return this.map.values()}*keys(){for(let e of this.map.keys())yield n.URI.parse(e)}*entries(){for(let e of this.map.entries())yield[n.URI.parse(e[0]),e[1]]}*[Symbol.iterator](){for(let e of this.map)yield[n.URI.parse(e[0]),e[1]]}}t.ResourceMap=d,d.defaultToKey=e=>e.toString(),function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",e[e.AsNew=2]="AsNew"}(t.Touch||(t.Touch={}));class f{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var e;return null===(e=this._head)||void 0===e?void 0:e.value}get last(){var e;return null===(e=this._tail)||void 0===e?void 0:e.value}has(e){return this._map.has(e)}get(e,t=0){const n=this._map.get(e)
;if(n)return 0!==t&&this.touch(n,t),n.value}set(e,t,n=0){let r=this._map.get(e);if(r)r.value=t,0!==n&&this.touch(r,n);else{switch(r={key:e,value:t,next:void 0,previous:void 0},n){case 0:this.addItemLast(r);break;case 1:this.addItemFirst(r);break;case 2:default:this.addItemLast(r)}this._map.set(e,r),this._size++}return this}delete(e){return!!this.remove(e)}remove(e){const t=this._map.get(e);if(t)return this._map.delete(e),this.removeItem(t),this._size--,t.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const e=this._head;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,t){const n=this._state;let r=this._head;for(;r;){if(t?e.bind(t)(r.value,r.key,this):e(r.value,r.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");r=r.next}}keys(){const e=this,t=this._state;let n=this._head;const r={[Symbol.iterator]:()=>r,next(){
if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const e={value:n.key,done:!1};return n=n.next,e}return{value:void 0,done:!0}}};return r}values(){const e=this,t=this._state;let n=this._head;const r={[Symbol.iterator]:()=>r,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const e={value:n.value,done:!1};return n=n.next,e}return{value:void 0,done:!0}}};return r}entries(){const e=this,t=this._state;let n=this._head;const r={[Symbol.iterator]:()=>r,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(n){const e={value:[n.key,n.value],done:!1};return n=n.next,e}return{value:void 0,done:!0}}};return r}[Symbol.iterator](){return this.entries()}trimOld(e){if(e>=this.size)return;if(0===e)return void this.clear();let t=this._head,n=this.size;for(;t&&n>e;)this._map.delete(t.key),t=t.next,n--;this._head=t,this._size=n,t&&(t.previous=void 0),this._state++}addItemFirst(e){if(this._head||this._tail){
if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e,this._state++}addItemLast(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e,this._state++}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next}else if(e===this._tail){if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{const t=e.next,n=e.previous;if(!t||!n)throw new Error("Invalid list");t.previous=n,n.next=t}e.next=void 0,e.previous=void 0,this._state++}touch(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;const t=e.next,n=e.previous;e===this._tail?(n.next=void 0,this._tail=n):(t.previous=n,n.next=t),e.previous=void 0,e.next=this._head,
this._head.previous=e,this._head=e,this._state++}else if(2===t){if(e===this._tail)return;const t=e.next,n=e.previous;e===this._head?(t.previous=void 0,this._head=t):(t.previous=n,n.next=t),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e,this._state++}}toJSON(){const e=[];return this.forEach((t,n)=>{e.push([n,t])}),e}fromJSON(e){this.clear();for(const[t,n]of e)this.set(t,n)}}t.LinkedMap=f;t.LRUCache=class extends f{constructor(e,t=1){super(),this._limit=e,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(e){this._limit=e,this.checkTrim()}get ratio(){return this._ratio}set ratio(e){this._ratio=Math.min(Math.max(0,e),1),this.checkTrim()}get(e,t=2){return super.get(e,t)}peek(e){return super.get(e,0)}set(e,t){return super.set(e,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}})),define(t[116],n([0,1,23,13]),(function(e,t,n,r){"use strict";function i(...e){return function(t,n){
for(let r=0,i=e.length;r<i;r++){const i=e[r](t,n);if(i)return i}return null}}function s(e,t,n){if(!n||n.length<t.length)return null;let i;return(i=e?r.startsWithIgnoreCase(n,t):0===n.indexOf(t))?t.length>0?[{start:0,end:t.length}]:[]:null}function o(e,t){const n=t.toLowerCase().indexOf(e.toLowerCase());return-1===n?null:[{start:n,end:n+e.length}]}function a(e,t){return function e(t,n,r,i){if(r===t.length)return[];if(i===n.length)return null;if(t[r]===n[i]){let s=null;return(s=e(t,n,r+1,i+1))?m({start:i,end:i+1},s):null}return e(t,n,r,i+1)}(e.toLowerCase(),t.toLowerCase(),0,0)}function c(e){return 97<=e&&e<=122}function l(e){return 65<=e&&e<=90}function u(e){return 48<=e&&e<=57}function h(e){return 32===e||9===e||10===e||13===e}Object.defineProperty(t,"__esModule",{value:!0}),
t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0,t.or=i,t.matchesStrictPrefix=s.bind(void 0,!1),t.matchesPrefix=s.bind(void 0,!0),t.matchesContiguousSubString=o,t.matchesSubString=a,t.isUpper=l;const d=new Set;function f(e){return h(e)||d.has(e)}function p(e){return c(e)||l(e)||u(e)}function m(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function g(e,t){for(let n=t;n<e.length;n++){const t=e.charCodeAt(n);if(l(t)||u(t)||n>0&&!p(e.charCodeAt(n-1)))return n}return e.length}function v(e,t,n,r){if(n===e.length)return[];if(r===t.length)return null;if(e[n]!==t[r].toLowerCase())return null;{let i=null,s=r+1;for(i=v(e,t,n+1,r+1);!i&&(s=g(t,s))<t.length;)i=v(e,t,n+1,s),s++;return null===i?null:m({start:r,end:r+1},i)}}function y(e,t){
if(!t)return null;if(0===(t=t.trim()).length)return null;if(!function(e){let t=0,n=0,r=0,i=0;for(let s=0;s<e.length;s++)l(r=e.charCodeAt(s))&&t++,c(r)&&n++,h(r)&&i++;return 0!==t&&0!==n||0!==i?t<=5:e.length<=30}(e))return null;if(t.length>60)return null;const n=function(e){let t=0,n=0,r=0,i=0,s=0;for(let o=0;o<e.length;o++)l(s=e.charCodeAt(o))&&t++,c(s)&&n++,p(s)&&r++,u(s)&&i++;return{upperPercent:t/e.length,lowerPercent:n/e.length,alphaPercent:r/e.length,numericPercent:i/e.length}}(t);if(!function(e){const{upperPercent:t,lowerPercent:n,alphaPercent:r,numericPercent:i}=e;return n>.2&&t<.8&&r>.6&&i<.2}(n)){if(!function(e){const{upperPercent:t,lowerPercent:n}=e;return 0===n&&t>.6}(n))return null;t=t.toLowerCase()}let r=null,i=0;for(e=e.toLowerCase();i<t.length&&null===(r=v(e,t,0,i));)i=g(t,i+1);return r}function b(e,t,n,r,i){if(n===e.length)return[];if(r===t.length)return null;if(s=e.charCodeAt(n),o=t.charCodeAt(r),s===o||f(s)&&f(o)){let s=null,o=r+1;if(s=b(e,t,n+1,r+1,i),
!i)for(;!s&&(o=w(t,o))<t.length;)s=b(e,t,n+1,o,i),o++;return null===s?null:m({start:r,end:r+1},s)}return null;var s,o}function w(e,t){for(let n=t;n<e.length;n++)if(f(e.charCodeAt(n))||n>0&&f(e.charCodeAt(n-1)))return n;return e.length}"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(e=>d.add(e.charCodeAt(0))),t.matchesCamelCase=y,t.matchesWords=function(e,t,n=!1){if(!t||0===t.length)return null;let r=null,i=0;for(e=e.toLowerCase(),t=t.toLowerCase();i<t.length&&null===(r=b(e,t,0,i,n));)i=w(t,i+1);return r};const _=i(t.matchesPrefix,y,o),E=i(t.matchesPrefix,y,a),S=new n.LRUCache(1e4);function C(e){if(void 0===e)return[];const t=e[1].toString(2),n=[];for(let r=e[2];r<x;r++)if("1"===t[t.length-(r+1)]){const e=n[n.length-1];e&&e.end===r?e.end=r+1:n.push({start:r,end:r+1})}return n}t.matchesFuzzy=function(e,t,n=!1){if("string"!=typeof e||"string"!=typeof t)return null;let i=S.get(e);i||(i=new RegExp(r.convertSimple2RegExpPattern(e),"i"),S.set(e,i));const s=i.exec(t);return s?[{start:s.index,
end:s.index+s[0].length}]:n?E(e,t):_(e,t)},t.matchesFuzzy2=function(e,t){const n=M(e,e.toLowerCase(),0,t,t.toLowerCase(),0,!0);return n?C(n):null},t.anyScore=function(e,t,n,r,i,s){const o=M(e,t,0,r,i,0,!0);if(o)return o;let a=0,c=0,l=s;for(let e=0;e<t.length&&e<x;++e){const n=i.indexOf(t.charAt(e),l);if(n>=0)c+=1,a+=2**n,l=n+1;else if(0!==a)break}return[c,a,s]},t.createMatches=C;const x=128;function I(){const e=[],t=[0];for(let e=1;e<=x;e++)t.push(-e);for(let n=0;n<=x;n++){const r=t.slice(0);r[0]=-n,e.push(r)}return e}const k=I(),T=I(),P=I(),R=!1;function O(e,t,n,r,i){function s(e,t,n=" "){for(;e.length<t;)e=n+e;return e}let o=` |   |${r.split("").map(e=>s(e,3)).join("|")}\n`;for(let r=0;r<=n;r++)o+=0===r?" |":`${t[r-1]}|`,o+=e[r].slice(0,i+1).map(e=>s(e.toString(),3)).join("|")+"\n";return o}function L(e,t){if(t<0||t>=e.length)return!1;switch(e.charCodeAt(t)){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:return!0;default:return!1}}function D(e,t,n){return t[e]!==n[e]}
function A(e,t,n,r,i,s){for(;t<n&&i<s;)e[t]===r[i]&&(t+=1),i+=1;return t===n}var N;function M(e,t,n,r,i,s,o){const a=e.length>x?x:e.length,c=r.length>x?x:r.length;if(n>=a||s>=c||a-n>c-s)return;if(!A(t,n,a,i,s,c))return;let l=1,u=1,h=n,d=s,f=!1;for(l=1,h=n;h<a;l++,h++)for(u=1,d=s;d<c;u++,d++){const s=F(e,t,h,n,r,i,d);h===n&&s>1&&(f=!0),T[l][u]=s;const o=k[l-1][u-1]+(s>1?1:s),a=k[l-1][u]+-1,c=k[l][u-1]+-1;c>=a?c>o?(k[l][u]=c,P[l][u]=4):c===o?(k[l][u]=c,P[l][u]=6):(k[l][u]=o,P[l][u]=2):a>o?(k[l][u]=a,P[l][u]=1):a===o?(k[l][u]=a,P[l][u]=3):(k[l][u]=o,P[l][u]=2)}return R&&function(e,t,n,r){e=e.substr(t),n=n.substr(r),console.log(O(k,e,e.length,n,n.length)),console.log(O(P,e,e.length,n,n.length)),console.log(O(T,e,e.length,n,n.length))}(e,n,r,s),(f||o)&&(U=0,z=-100,$=s,B=o,function e(t,n,r,i,s){if(U>=10||r<-25)return;let o=0;for(;t>0&&n>0;){const a=T[t][n],c=P[t][n];if(4===c)n-=1,s?r-=5:0!==i&&(r-=1),s=!1,o=0;else{if(!(2&c))return;if(4&c&&e(t,n-1,0!==i?r-1:r,i,s),r+=a,t-=1,s=!0,i+=2**((n-=1)+$),1===a){if(o+=1,
0===t&&!B)return}else r+=1+o*(a-1),o=0}}r-=n>=3?9:3*n;U+=1;r>z&&(z=r,j=i)}(l-1,u-1,a===c?1:0,0,!1),0!==U)?[z,j,s]:void 0}function F(e,t,n,r,i,s,o){return t[n]!==s[o]?-1:o===n-r?e[n]===i[o]?7:5:!D(o,i,s)||0!==o&&D(o-1,i,s)?!L(s,o)||0!==o&&L(s,o-1)?L(s,o-1)||function(e,t){if(t<0||t>=e.length)return!1;switch(e.charCodeAt(t)){case 32:case 9:return!0;default:return!1}}(s,o-1)?5:1:5:e[n]===i[o]?7:5}t.isPatternInWord=A,function(e){e[e.Top=1]="Top",e[e.Diag=2]="Diag",e[e.Left=4]="Left"}(N||(N={})),function(e){e.Default=Object.freeze([-100,0,0]),e.isDefault=function(e){return!e||-100===e[0]&&0===e[1]&&0===e[2]}}(t.FuzzyScore||(t.FuzzyScore={})),t.fuzzyScore=M;let U=0,j=0,z=0,$=0,B=!1;function W(e,t,n,r,i,s,o,a){let c=M(e,t,n,r,i,s,a);if(c&&!o)return c;if(e.length>=3){const t=Math.min(7,e.length-1);for(let o=n+1;o<t;o++){const t=V(e,o);if(t){const e=M(t,t.toLowerCase(),n,r,i,s,a);e&&(e[0]-=3,(!c||e[0]>c[0])&&(c=e))}}}return c}function V(e,t){if(t+1>=e.length)return;const n=e[t],r=e[t+1]
;return n!==r?e.slice(0,t)+r+n+e.slice(t+2):void 0}t.fuzzyScoreGracefulAggressive=function(e,t,n,r,i,s,o){return W(e,t,n,r,i,s,!0,o)},t.fuzzyScoreGraceful=function(e,t,n,r,i,s,o){return W(e,t,n,r,i,s,!1,o)}})),define(t[117],n([0,1,116,13]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyCodiconAware=t.parseCodicons=t.codiconStartMarker=void 0,t.codiconStartMarker="$(",t.parseCodicons=function(e){const n=e.indexOf(t.codiconStartMarker);return-1===n?{text:e}:function(e,n){const r=[];let i="";function s(e){if(e){i+=e;for(const t of e)r.push(u)}}let o,a,c=-1,l="",u=0,h=n;const d=e.length;s(e.substr(0,n));for(;h<d;){if(o=e[h],a=e[h+1],o===t.codiconStartMarker[0]&&a===t.codiconStartMarker[1])c=h,s(l),l=t.codiconStartMarker,h++;else if(")"===o&&-1!==c){u+=h-c+1,c=-1,l=""}else-1!==c?/^[a-z0-9\-]$/i.test(o)?l+=o:(s(l),c=-1,l=""):s(o);h++}return s(l),{text:i,codiconOffsets:r}}(e,n)},t.matchesFuzzyCodiconAware=function(e,t,i=!1){const{text:s,codiconOffsets:o}=t
;if(!o||0===o.length)return n.matchesFuzzy(e,s,i);const a=r.ltrim(s," "),c=s.length-a.length,l=n.matchesFuzzy(e,a,i);if(l)for(const e of l){const t=o[e.start+c]+c;e.start+=t,e.end+=t}return l}})),define(t[58],n([0,1,117,6]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stripCodicons=t.markdownUnescapeCodicons=t.markdownEscapeEscapedCodicons=t.escapeCodicons=t.Codicon=t.registerIcon=t.iconRegistry=void 0;const i=new class{constructor(){this._icons=new Map,this._onDidRegister=new r.Emitter}add(e){this._icons.has(e.id)?console.error(`Duplicate registration of codicon ${e.id}`):(this._icons.set(e.id,e),this._onDidRegister.fire(e))}get(e){return this._icons.get(e)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}};t.iconRegistry=i,t.registerIcon=function(e,t,n){return new s(e,t)};class s{constructor(e,t,n){this.id=e,this.definition=t,this.description=n,i.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){
return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}t.Codicon=s,function(e){e.add=new e("add",{character:"\\ea60"}),e.plus=new e("plus",{character:"\\ea60"}),e.gistNew=new e("gist-new",{character:"\\ea60"}),e.repoCreate=new e("repo-create",{character:"\\ea60"}),e.lightbulb=new e("lightbulb",{character:"\\ea61"}),e.lightBulb=new e("light-bulb",{character:"\\ea61"}),e.repo=new e("repo",{character:"\\ea62"}),e.repoDelete=new e("repo-delete",{character:"\\ea62"}),e.gistFork=new e("gist-fork",{character:"\\ea63"}),e.repoForked=new e("repo-forked",{character:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{character:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{character:"\\ea64"}),e.recordKeys=new e("record-keys",{character:"\\ea65"}),e.keyboard=new e("keyboard",{character:"\\ea65"}),e.tag=new e("tag",{character:"\\ea66"}),e.tagAdd=new e("tag-add",{character:"\\ea66"}),e.tagRemove=new e("tag-remove",{character:"\\ea66"}),
e.person=new e("person",{character:"\\ea67"}),e.personAdd=new e("person-add",{character:"\\ea67"}),e.personFollow=new e("person-follow",{character:"\\ea67"}),e.personOutline=new e("person-outline",{character:"\\ea67"}),e.personFilled=new e("person-filled",{character:"\\ea67"}),e.gitBranch=new e("git-branch",{character:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{character:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{character:"\\ea68"}),e.sourceControl=new e("source-control",{character:"\\ea68"}),e.mirror=new e("mirror",{character:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{character:"\\ea69"}),e.star=new e("star",{character:"\\ea6a"}),e.starAdd=new e("star-add",{character:"\\ea6a"}),e.starDelete=new e("star-delete",{character:"\\ea6a"}),e.starEmpty=new e("star-empty",{character:"\\ea6a"}),e.comment=new e("comment",{character:"\\ea6b"}),e.commentAdd=new e("comment-add",{character:"\\ea6b"}),e.alert=new e("alert",{character:"\\ea6c"}),e.warning=new e("warning",{character:"\\ea6c"}),
e.search=new e("search",{character:"\\ea6d"}),e.searchSave=new e("search-save",{character:"\\ea6d"}),e.logOut=new e("log-out",{character:"\\ea6e"}),e.signOut=new e("sign-out",{character:"\\ea6e"}),e.logIn=new e("log-in",{character:"\\ea6f"}),e.signIn=new e("sign-in",{character:"\\ea6f"}),e.eye=new e("eye",{character:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{character:"\\ea70"}),e.eyeWatch=new e("eye-watch",{character:"\\ea70"}),e.circleFilled=new e("circle-filled",{character:"\\ea71"}),e.primitiveDot=new e("primitive-dot",{character:"\\ea71"}),e.closeDirty=new e("close-dirty",{character:"\\ea71"}),e.debugBreakpoint=new e("debug-breakpoint",{character:"\\ea71"}),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",{character:"\\ea71"}),e.debugHint=new e("debug-hint",{character:"\\ea71"}),e.primitiveSquare=new e("primitive-square",{character:"\\ea72"}),e.edit=new e("edit",{character:"\\ea73"}),e.pencil=new e("pencil",{character:"\\ea73"}),e.info=new e("info",{character:"\\ea74"}),
e.issueOpened=new e("issue-opened",{character:"\\ea74"}),e.gistPrivate=new e("gist-private",{character:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{character:"\\ea75"}),e.lock=new e("lock",{character:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{character:"\\ea75"}),e.close=new e("close",{character:"\\ea76"}),e.removeClose=new e("remove-close",{character:"\\ea76"}),e.x=new e("x",{character:"\\ea76"}),e.repoSync=new e("repo-sync",{character:"\\ea77"}),e.sync=new e("sync",{character:"\\ea77"}),e.clone=new e("clone",{character:"\\ea78"}),e.desktopDownload=new e("desktop-download",{character:"\\ea78"}),e.beaker=new e("beaker",{character:"\\ea79"}),e.microscope=new e("microscope",{character:"\\ea79"}),e.vm=new e("vm",{character:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{character:"\\ea7a"}),e.file=new e("file",{character:"\\ea7b"}),e.fileText=new e("file-text",{character:"\\ea7b"}),e.more=new e("more",{character:"\\ea7c"}),e.ellipsis=new e("ellipsis",{character:"\\ea7c"}),
e.kebabHorizontal=new e("kebab-horizontal",{character:"\\ea7c"}),e.mailReply=new e("mail-reply",{character:"\\ea7d"}),e.reply=new e("reply",{character:"\\ea7d"}),e.organization=new e("organization",{character:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{character:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{character:"\\ea7e"}),e.newFile=new e("new-file",{character:"\\ea7f"}),e.fileAdd=new e("file-add",{character:"\\ea7f"}),e.newFolder=new e("new-folder",{character:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{character:"\\ea80"}),e.trash=new e("trash",{character:"\\ea81"}),e.trashcan=new e("trashcan",{character:"\\ea81"}),e.history=new e("history",{character:"\\ea82"}),e.clock=new e("clock",{character:"\\ea82"}),e.folder=new e("folder",{character:"\\ea83"}),e.fileDirectory=new e("file-directory",{character:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{character:"\\ea83"}),e.logoGithub=new e("logo-github",{character:"\\ea84"}),
e.markGithub=new e("mark-github",{character:"\\ea84"}),e.github=new e("github",{character:"\\ea84"}),e.terminal=new e("terminal",{character:"\\ea85"}),e.console=new e("console",{character:"\\ea85"}),e.repl=new e("repl",{character:"\\ea85"}),e.zap=new e("zap",{character:"\\ea86"}),e.symbolEvent=new e("symbol-event",{character:"\\ea86"}),e.error=new e("error",{character:"\\ea87"}),e.stop=new e("stop",{character:"\\ea87"}),e.variable=new e("variable",{character:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{character:"\\ea88"}),e.array=new e("array",{character:"\\ea8a"}),e.symbolArray=new e("symbol-array",{character:"\\ea8a"}),e.symbolModule=new e("symbol-module",{character:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{character:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{character:"\\ea8b"}),e.symbolObject=new e("symbol-object",{character:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{character:"\\ea8c"}),e.symbolFunction=new e("symbol-function",{character:"\\ea8c"}),
e.symbolConstructor=new e("symbol-constructor",{character:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{character:"\\ea8f"}),e.symbolNull=new e("symbol-null",{character:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{character:"\\ea90"}),e.symbolNumber=new e("symbol-number",{character:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{character:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{character:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{character:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{character:"\\ea92"}),e.symbolKey=new e("symbol-key",{character:"\\ea93"}),e.symbolText=new e("symbol-text",{character:"\\ea93"}),e.symbolReference=new e("symbol-reference",{character:"\\ea94"}),e.goToFile=new e("go-to-file",{character:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{character:"\\ea95"}),e.symbolValue=new e("symbol-value",{character:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{character:"\\ea96"}),e.symbolUnit=new e("symbol-unit",{character:"\\ea96"}),
e.activateBreakpoints=new e("activate-breakpoints",{character:"\\ea97"}),e.archive=new e("archive",{character:"\\ea98"}),e.arrowBoth=new e("arrow-both",{character:"\\ea99"}),e.arrowDown=new e("arrow-down",{character:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{character:"\\ea9b"}),e.arrowRight=new e("arrow-right",{character:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{character:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{character:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{character:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{character:"\\eaa0"}),e.arrowUp=new e("arrow-up",{character:"\\eaa1"}),e.bell=new e("bell",{character:"\\eaa2"}),e.bold=new e("bold",{character:"\\eaa3"}),e.book=new e("book",{character:"\\eaa4"}),e.bookmark=new e("bookmark",{character:"\\eaa5"}),e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{character:"\\eaa6"}),e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{character:"\\eaa7"}),
e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{character:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{character:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{character:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{character:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{character:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{character:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{character:"\\eaab"}),e.briefcase=new e("briefcase",{character:"\\eaac"}),e.broadcast=new e("broadcast",{character:"\\eaad"}),e.browser=new e("browser",{character:"\\eaae"}),e.bug=new e("bug",{character:"\\eaaf"}),e.calendar=new e("calendar",{character:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{character:"\\eab1"}),e.check=new e("check",{character:"\\eab2"}),e.checklist=new e("checklist",{character:"\\eab3"}),
e.chevronDown=new e("chevron-down",{character:"\\eab4"}),e.chevronLeft=new e("chevron-left",{character:"\\eab5"}),e.chevronRight=new e("chevron-right",{character:"\\eab6"}),e.chevronUp=new e("chevron-up",{character:"\\eab7"}),e.chromeClose=new e("chrome-close",{character:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{character:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{character:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{character:"\\eabb"}),e.circleOutline=new e("circle-outline",{character:"\\eabc"}),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",{character:"\\eabc"}),e.circleSlash=new e("circle-slash",{character:"\\eabd"}),e.circuitBoard=new e("circuit-board",{character:"\\eabe"}),e.clearAll=new e("clear-all",{character:"\\eabf"}),e.clippy=new e("clippy",{character:"\\eac0"}),e.closeAll=new e("close-all",{character:"\\eac1"}),e.cloudDownload=new e("cloud-download",{character:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{character:"\\eac3"}),e.code=new e("code",{
character:"\\eac4"}),e.collapseAll=new e("collapse-all",{character:"\\eac5"}),e.colorMode=new e("color-mode",{character:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{character:"\\eac7"}),e.compareChanges=new e("compare-changes",{character:"\\eafd"}),e.creditCard=new e("credit-card",{character:"\\eac9"}),e.dash=new e("dash",{character:"\\eacc"}),e.dashboard=new e("dashboard",{character:"\\eacd"}),e.database=new e("database",{character:"\\eace"}),e.debugContinue=new e("debug-continue",{character:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{character:"\\ead0"}),e.debugPause=new e("debug-pause",{character:"\\ead1"}),e.debugRestart=new e("debug-restart",{character:"\\ead2"}),e.debugStart=new e("debug-start",{character:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{character:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{character:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{character:"\\ead6"}),e.debugStop=new e("debug-stop",{character:"\\ead7"}),e.debug=new e("debug",{
character:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{character:"\\ead9"}),e.deviceCamera=new e("device-camera",{character:"\\eada"}),e.deviceMobile=new e("device-mobile",{character:"\\eadb"}),e.diffAdded=new e("diff-added",{character:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{character:"\\eadd"}),e.diffModified=new e("diff-modified",{character:"\\eade"}),e.diffRemoved=new e("diff-removed",{character:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{character:"\\eae0"}),e.diff=new e("diff",{character:"\\eae1"}),e.discard=new e("discard",{character:"\\eae2"}),e.editorLayout=new e("editor-layout",{character:"\\eae3"}),e.emptyWindow=new e("empty-window",{character:"\\eae4"}),e.exclude=new e("exclude",{character:"\\eae5"}),e.extensions=new e("extensions",{character:"\\eae6"}),e.eyeClosed=new e("eye-closed",{character:"\\eae7"}),e.fileBinary=new e("file-binary",{character:"\\eae8"}),e.fileCode=new e("file-code",{character:"\\eae9"}),e.fileMedia=new e("file-media",{character:"\\eaea"}),
e.filePdf=new e("file-pdf",{character:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{character:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{character:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{character:"\\eaee"}),e.fileZip=new e("file-zip",{character:"\\eaef"}),e.files=new e("files",{character:"\\eaf0"}),e.filter=new e("filter",{character:"\\eaf1"}),e.flame=new e("flame",{character:"\\eaf2"}),e.foldDown=new e("fold-down",{character:"\\eaf3"}),e.foldUp=new e("fold-up",{character:"\\eaf4"}),e.fold=new e("fold",{character:"\\eaf5"}),e.folderActive=new e("folder-active",{character:"\\eaf6"}),e.folderOpened=new e("folder-opened",{character:"\\eaf7"}),e.gear=new e("gear",{character:"\\eaf8"}),e.gift=new e("gift",{character:"\\eaf9"}),e.gistSecret=new e("gist-secret",{character:"\\eafa"}),e.gist=new e("gist",{character:"\\eafb"}),e.gitCommit=new e("git-commit",{character:"\\eafc"}),e.gitCompare=new e("git-compare",{character:"\\eafd"}),e.gitMerge=new e("git-merge",{
character:"\\eafe"}),e.githubAction=new e("github-action",{character:"\\eaff"}),e.githubAlt=new e("github-alt",{character:"\\eb00"}),e.globe=new e("globe",{character:"\\eb01"}),e.grabber=new e("grabber",{character:"\\eb02"}),e.graph=new e("graph",{character:"\\eb03"}),e.gripper=new e("gripper",{character:"\\eb04"}),e.heart=new e("heart",{character:"\\eb05"}),e.home=new e("home",{character:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{character:"\\eb07"}),e.hubot=new e("hubot",{character:"\\eb08"}),e.inbox=new e("inbox",{character:"\\eb09"}),e.issueClosed=new e("issue-closed",{character:"\\eb0a"}),e.issueReopened=new e("issue-reopened",{character:"\\eb0b"}),e.issues=new e("issues",{character:"\\eb0c"}),e.italic=new e("italic",{character:"\\eb0d"}),e.jersey=new e("jersey",{character:"\\eb0e"}),e.json=new e("json",{character:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{character:"\\eb10"}),e.key=new e("key",{character:"\\eb11"}),e.law=new e("law",{character:"\\eb12"}),
e.lightbulbAutofix=new e("lightbulb-autofix",{character:"\\eb13"}),e.linkExternal=new e("link-external",{character:"\\eb14"}),e.link=new e("link",{character:"\\eb15"}),e.listOrdered=new e("list-ordered",{character:"\\eb16"}),e.listUnordered=new e("list-unordered",{character:"\\eb17"}),e.liveShare=new e("live-share",{character:"\\eb18"}),e.loading=new e("loading",{character:"\\eb19"}),e.location=new e("location",{character:"\\eb1a"}),e.mailRead=new e("mail-read",{character:"\\eb1b"}),e.mail=new e("mail",{character:"\\eb1c"}),e.markdown=new e("markdown",{character:"\\eb1d"}),e.megaphone=new e("megaphone",{character:"\\eb1e"}),e.mention=new e("mention",{character:"\\eb1f"}),e.milestone=new e("milestone",{character:"\\eb20"}),e.mortarBoard=new e("mortar-board",{character:"\\eb21"}),e.move=new e("move",{character:"\\eb22"}),e.multipleWindows=new e("multiple-windows",{character:"\\eb23"}),e.mute=new e("mute",{character:"\\eb24"}),e.noNewline=new e("no-newline",{character:"\\eb25"}),e.note=new e("note",{
character:"\\eb26"}),e.octoface=new e("octoface",{character:"\\eb27"}),e.openPreview=new e("open-preview",{character:"\\eb28"}),e.package_=new e("package",{character:"\\eb29"}),e.paintcan=new e("paintcan",{character:"\\eb2a"}),e.pin=new e("pin",{character:"\\eb2b"}),e.play=new e("play",{character:"\\eb2c"}),e.run=new e("run",{character:"\\eb2c"}),e.plug=new e("plug",{character:"\\eb2d"}),e.preserveCase=new e("preserve-case",{character:"\\eb2e"}),e.preview=new e("preview",{character:"\\eb2f"}),e.project=new e("project",{character:"\\eb30"}),e.pulse=new e("pulse",{character:"\\eb31"}),e.question=new e("question",{character:"\\eb32"}),e.quote=new e("quote",{character:"\\eb33"}),e.radioTower=new e("radio-tower",{character:"\\eb34"}),e.reactions=new e("reactions",{character:"\\eb35"}),e.references=new e("references",{character:"\\eb36"}),e.refresh=new e("refresh",{character:"\\eb37"}),e.regex=new e("regex",{character:"\\eb38"}),e.remoteExplorer=new e("remote-explorer",{character:"\\eb39"}),
e.remote=new e("remote",{character:"\\eb3a"}),e.remove=new e("remove",{character:"\\eb3b"}),e.replaceAll=new e("replace-all",{character:"\\eb3c"}),e.replace=new e("replace",{character:"\\eb3d"}),e.repoClone=new e("repo-clone",{character:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{character:"\\eb3f"}),e.repoPull=new e("repo-pull",{character:"\\eb40"}),e.repoPush=new e("repo-push",{character:"\\eb41"}),e.report=new e("report",{character:"\\eb42"}),e.requestChanges=new e("request-changes",{character:"\\eb43"}),e.rocket=new e("rocket",{character:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{character:"\\eb45"}),e.rootFolder=new e("root-folder",{character:"\\eb46"}),e.rss=new e("rss",{character:"\\eb47"}),e.ruby=new e("ruby",{character:"\\eb48"}),e.saveAll=new e("save-all",{character:"\\eb49"}),e.saveAs=new e("save-as",{character:"\\eb4a"}),e.save=new e("save",{character:"\\eb4b"}),e.screenFull=new e("screen-full",{character:"\\eb4c"}),e.screenNormal=new e("screen-normal",{character:"\\eb4d"}),
e.searchStop=new e("search-stop",{character:"\\eb4e"}),e.server=new e("server",{character:"\\eb50"}),e.settingsGear=new e("settings-gear",{character:"\\eb51"}),e.settings=new e("settings",{character:"\\eb52"}),e.shield=new e("shield",{character:"\\eb53"}),e.smiley=new e("smiley",{character:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{character:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{character:"\\eb56"}),e.splitVertical=new e("split-vertical",{character:"\\eb57"}),e.squirrel=new e("squirrel",{character:"\\eb58"}),e.starFull=new e("star-full",{character:"\\eb59"}),e.starHalf=new e("star-half",{character:"\\eb5a"}),e.symbolClass=new e("symbol-class",{character:"\\eb5b"}),e.symbolColor=new e("symbol-color",{character:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{character:"\\eb5d"}),e.symbolEnumMember=new e("symbol-enum-member",{character:"\\eb5e"}),e.symbolField=new e("symbol-field",{character:"\\eb5f"}),e.symbolFile=new e("symbol-file",{character:"\\eb60"}),
e.symbolInterface=new e("symbol-interface",{character:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{character:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{character:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{character:"\\eb64"}),e.symbolProperty=new e("symbol-property",{character:"\\eb65"}),e.wrench=new e("wrench",{character:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{character:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{character:"\\eb66"}),e.tasklist=new e("tasklist",{character:"\\eb67"}),e.telescope=new e("telescope",{character:"\\eb68"}),e.textSize=new e("text-size",{character:"\\eb69"}),e.threeBars=new e("three-bars",{character:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{character:"\\eb6b"}),e.thumbsup=new e("thumbsup",{character:"\\eb6c"}),e.tools=new e("tools",{character:"\\eb6d"}),e.triangleDown=new e("triangle-down",{character:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{character:"\\eb6f"}),e.triangleRight=new e("triangle-right",{character:"\\eb70"}),
e.triangleUp=new e("triangle-up",{character:"\\eb71"}),e.twitter=new e("twitter",{character:"\\eb72"}),e.unfold=new e("unfold",{character:"\\eb73"}),e.unlock=new e("unlock",{character:"\\eb74"}),e.unmute=new e("unmute",{character:"\\eb75"}),e.unverified=new e("unverified",{character:"\\eb76"}),e.verified=new e("verified",{character:"\\eb77"}),e.versions=new e("versions",{character:"\\eb78"}),e.vmActive=new e("vm-active",{character:"\\eb79"}),e.vmOutline=new e("vm-outline",{character:"\\eb7a"}),e.vmRunning=new e("vm-running",{character:"\\eb7b"}),e.watch=new e("watch",{character:"\\eb7c"}),e.whitespace=new e("whitespace",{character:"\\eb7d"}),e.wholeWord=new e("whole-word",{character:"\\eb7e"}),e.window=new e("window",{character:"\\eb7f"}),e.wordWrap=new e("word-wrap",{character:"\\eb80"}),e.zoomIn=new e("zoom-in",{character:"\\eb81"}),e.zoomOut=new e("zoom-out",{character:"\\eb82"}),e.listFilter=new e("list-filter",{character:"\\eb83"}),e.listFlat=new e("list-flat",{character:"\\eb84"}),
e.listSelection=new e("list-selection",{character:"\\eb85"}),e.selection=new e("selection",{character:"\\eb85"}),e.listTree=new e("list-tree",{character:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{character:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{character:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{character:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{character:"\\eb89"}),e.debugStackframeDot=new e("debug-stackframe-dot",{character:"\\eb8a"}),e.debugStackframe=new e("debug-stackframe",{character:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{character:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{character:"\\eb8c"}),e.symbolString=new e("symbol-string",{character:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{character:"\\eb8e"}),e.debugStepBack=new e("debug-step-back",{
character:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{character:"\\eb90"}),e.callIncoming=new e("call-incoming",{character:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{character:"\\eb93"}),e.menu=new e("menu",{character:"\\eb94"}),e.expandAll=new e("expand-all",{character:"\\eb95"}),e.feedback=new e("feedback",{character:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{character:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{character:"\\eb98"}),e.account=new e("account",{character:"\\eb99"}),e.bellDot=new e("bell-dot",{character:"\\eb9a"}),e.debugConsole=new e("debug-console",{character:"\\eb9b"}),e.library=new e("library",{character:"\\eb9c"}),e.output=new e("output",{character:"\\eb9d"}),e.runAll=new e("run-all",{character:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{character:"\\eb9f"}),e.pinned=new e("pinned",{character:"\\eba0"}),e.githubInverted=new e("github-inverted",{character:"\\eba1"}),e.debugAlt=new e("debug-alt",{character:"\\eb91"}),
e.serverProcess=new e("server-process",{character:"\\eba2"}),e.serverEnvironment=new e("server-environment",{character:"\\eba3"}),e.pass=new e("pass",{character:"\\eba4"}),e.stopCircle=new e("stop-circle",{character:"\\eba5"}),e.playCircle=new e("play-circle",{character:"\\eba6"}),e.record=new e("record",{character:"\\eba7"}),e.debugAltSmall=new e("debug-alt-small",{character:"\\eba8"}),e.vmConnect=new e("vm-connect",{character:"\\eba9"}),e.cloud=new e("cloud",{character:"\\ebaa"}),e.merge=new e("merge",{character:"\\ebab"}),e.exportIcon=new e("export",{character:"\\ebac"}),e.graphLeft=new e("graph-left",{character:"\\ebad"}),e.magnet=new e("magnet",{character:"\\ebae"}),e.notebook=new e("notebook",{character:"\\ebaf"}),e.redo=new e("redo",{character:"\\ebb0"}),e.checkAll=new e("check-all",{character:"\\ebb1"}),e.pinnedDirty=new e("pinned-dirty",{character:"\\ebb2"})}(s=t.Codicon||(t.Codicon={}));const o=/(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;t.escapeCodicons=function(e){
return e.replace(o,(e,t)=>t?e:`\\${e}`)};const a=/\\\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;t.markdownEscapeEscapedCodicons=function(e){return e.replace(a,e=>`\\${e}`)};const c=/(\\)?\$\\\(([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?)\\\)/gi;t.markdownUnescapeCodicons=function(e){return e.replace(c,(e,t,n)=>t?e:`$(${n})`)};const l=/(\s)?(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)(\s)?/gi;t.stripCodicons=function(e){return-1===e.indexOf(n.codiconStartMarker)?e:e.replace(l,(e,t,n,r)=>n?e:t||r||"")}})),define(t[39],n([0,1,13,30,2,23,17]),(function(e,t,n,r,i,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0,t.getEmptyExpression=function(){return Object.create(null)};const a="**",c="/",l="[/\\\\]",u="[^/\\\\]",h=/\//g;function d(e){switch(e){case 0:return"";case 1:return`${u}*?`;default:return`(?:${l}|${u}+${l}|${l}${u}+)*?`}}function f(e,t){if(!e)return[]
;const n=[];let r=!1,i=!1,s="";for(const o of e){switch(o){case t:if(!r&&!i){n.push(s),s="";continue}break;case"{":r=!0;break;case"}":r=!1;break;case"[":i=!0;break;case"]":i=!1}s+=o}return s&&n.push(s),n}t.splitGlobAware=f;const p=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,v=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,b=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,w=new s.LRUCache(1e4),_=function(){return!1},E=function(){return null};function S(e,t){if(!e)return E;let r;const i=`${r=(r="string"!=typeof e?e.pattern:e).trim()}_${!!t.trimForExclusions}`;let s,o=w.get(i);if(o)return C(o,e);if(p.test(r)){const e=r.substr(4);o=function(t,n){return"string"==typeof t&&t.endsWith(e)?r:null}}else o=(s=m.exec(x(r,t)))?function(e,t){const n=`/${e}`,r=`\\${e}`,i=function(i,s){return"string"!=typeof i?null:s?s===e?t:null:i===e||i.endsWith(n)||i.endsWith(r)?t:null},s=[e];return i.basenames=s,i.patterns=[t],
i.allBasenames=s,i}(s[1],r):(t.trimForExclusions?v:g).test(r)?function(e,t){const n=R(e.slice(1,-1).split(",").map(e=>S(e,t)).filter(e=>e!==E),e),r=n.length;if(!r)return E;if(1===r)return n[0];const i=function(t,r){for(let i=0,s=n.length;i<s;i++)if(n[i](t,r))return e;return null},s=n.find(e=>!!e.allBasenames);s&&(i.allBasenames=s.allBasenames);const o=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);o.length&&(i.allPaths=o);return i}(r,t):(s=y.exec(x(r,t)))?I(s[1].substr(1),r,!0):(s=b.exec(x(r,t)))?I(s[1],r,!1):function(e){try{const t=new RegExp(`^${function e(t){if(!t)return"";let r="";const i=f(t,c);if(i.every(e=>e===a))r=".*";else{let t=!1;i.forEach((s,o)=>{if(s===a)return void(t||(r+=d(2),t=!0));let h=!1,p="",m=!1,g="";for(const t of s)if("}"!==t&&h)p+=t;else if(!m||"]"===t&&g)switch(t){case"{":h=!0;continue;case"[":m=!0;continue;case"}":const i=`(?:${f(p,",").map(t=>e(t)).join("|")})`;r+=i,h=!1,p="";break;case"]":r+="["+g+"]",m=!1,g="";break;case"?":r+=u;continue;case"*":r+=d(1);continue;default:
r+=n.escapeRegExpCharacters(t)}else{let e;g+=e="-"===t?t:"^"!==t&&"!"!==t||g?t===c?"":n.escapeRegExpCharacters(t):"^"}o<i.length-1&&(i[o+1]!==a||o+2<i.length)&&(r+=l),t=!1})}return r}(e)}$`);return function(n){return t.lastIndex=0,"string"==typeof n&&t.test(n)?e:null}}catch(e){return E}}(r);return w.set(i,o),C(o,e)}function C(e,t){return"string"==typeof t?e:function(n,s){return r.isEqualOrParent(n,t.base)?e(i.relative(t.base,n),s):null}}function x(e,t){return t.trimForExclusions&&e.endsWith("/**")?e.substr(0,e.length-2):e}function I(e,t,n){const r=i.sep!==i.posix.sep?e.replace(h,i.sep):e,s=i.sep+r,o=n?function(e,n){return"string"!=typeof e||e!==r&&!e.endsWith(s)?null:t}:function(e,n){return"string"==typeof e&&e===r?t:null};return o.allPaths=[(n?"*/":"./")+e],o}function k(e,t={}){if(!e)return _;if("string"==typeof e||P(e)){const n=S(e,t);if(n===E)return _;const r=function(e,t){return!!n(e,t)};return n.allBasenames&&(r.allBasenames=n.allBasenames),n.allPaths&&(r.allPaths=n.allPaths),r}return function(e,t){
const n=R(Object.getOwnPropertyNames(e).map(n=>(function(e,t,n){if(!1===t)return E;const r=S(e,n);if(r===E)return E;if("boolean"==typeof t)return r;if(t){const n=t.when;if("string"==typeof n){const t=(t,i,s,a)=>{if(!a||!r(t,i))return null;const c=a(n.replace("$(basename)",s));return o.isThenable(c)?c.then(t=>t?e:null):c?e:null};return t.requiresSiblings=!0,t}}return r})(n,e[n],t)).filter(e=>e!==E)),r=n.length;if(!r)return E;if(!n.some(e=>!!e.requiresSiblings)){if(1===r)return n[0];const e=function(e,t){for(let r=0,i=n.length;r<i;r++){const i=n[r](e,t);if(i)return i}return null},t=n.find(e=>!!e.allBasenames);t&&(e.allBasenames=t.allBasenames);const i=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);return i.length&&(e.allPaths=i),e}const s=function(e,t,r){let s=void 0;for(let o=0,a=n.length;o<a;o++){const a=n[o];a.requiresSiblings&&r&&(t||(t=i.basename(e)),s||(s=t.substr(0,t.length-i.extname(e).length)));const c=a(e,t,s,r);if(c)return c}return null},a=n.find(e=>!!e.allBasenames)
;a&&(s.allBasenames=a.allBasenames);const c=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);c.length&&(s.allPaths=c);return s}(e,t)}function T(e){const t={};for(const n of e)t[n]=!0;return t}function P(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function R(e,t){const n=e.filter(e=>!!e.basenames);if(n.length<2)return e;const r=n.reduce((e,t)=>{const n=t.basenames;return n?e.concat(n):e},[]);let i;if(t){i=[];for(let e=0,n=r.length;e<n;e++)i.push(t)}else i=n.reduce((e,t)=>{const n=t.patterns;return n?e.concat(n):e},[]);const s=function(e,t){if("string"!=typeof e)return null;if(!t){let n;for(n=e.length;n>0;n--){const t=e.charCodeAt(n-1);if(47===t||92===t)break}t=e.substr(n)}const n=r.indexOf(t);return-1!==n?i[n]:null};s.basenames=r,s.patterns=i,s.allBasenames=r;const o=e.filter(e=>!e.basenames);return o.push(s),o}t.match=function(e,t,n){return!(!e||"string"!=typeof t)&&k(e)(t,void 0,n)},t.parse=k,t.hasSiblingPromiseFn=function(e){if(!e)return;let t
;return n=>(t||(t=(e()||Promise.resolve([])).then(e=>e?T(e):{})),t.then(e=>!!e[n]))},t.hasSiblingFn=function(e){if(!e)return;let t;return n=>{if(!t){const n=e();t=n?T(n):{}}return!!t[n]}},t.isRelativePattern=P,t.getBasenameTerms=function(e){return e.allBasenames||[]},t.getPathTerms=function(e){return e.allPaths||[]}})),define(t[74],n([0,1,16,58,15]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.markedStringsEquals=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0,function(e){e[e.Paragraph=0]="Paragraph",e[e.Break=1]="Break"}(t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class s{constructor(e="",t=!1){var n,r;if(this._value=e,"string"!=typeof this._value)throw i.illegalArgument("value");"boolean"==typeof t?(this._isTrusted=t,this._supportThemeIcons=!1):(this._isTrusted=null!==(n=t.isTrusted)&&void 0!==n&&n,
this._supportThemeIcons=null!==(r=t.supportThemeIcons)&&void 0!==r&&r)}get value(){return this._value}get isTrusted(){return this._isTrusted}get supportThemeIcons(){return this._supportThemeIcons}appendText(e,t=0){return this._value+=(this._supportThemeIcons?r.escapeCodicons(e):e).replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&").replace(/\n/g,1===t?"\\\n":"\n\n"),this}appendMarkdown(e){return this._value+=e,this}appendCodeblock(e,t){return this._value+="\n```",this._value+=e,this._value+="\n",this._value+=t,this._value+="\n```\n",this}}function o(e){return e instanceof s||!(!e||"object"!=typeof e)&&!("string"!=typeof e.value||"boolean"!=typeof e.isTrusted&&void 0!==e.isTrusted||"boolean"!=typeof e.supportThemeIcons&&void 0!==e.supportThemeIcons)}function a(e,t){return e===t||!(!e||!t)&&(e.value===t.value&&e.isTrusted===t.isTrusted&&e.supportThemeIcons===t.supportThemeIcons)}t.MarkdownString=s,t.isEmptyMarkdownString=function e(t){return o(t)?!t.value:!Array.isArray(t)||t.every(e)},t.isMarkdownString=o,
t.markedStringsEquals=function(e,t){return!e&&!t||!(!e||!t)&&(Array.isArray(e)&&Array.isArray(t)?n.equals(e,t,a):!(!o(e)||!o(t))&&a(e,t))},t.removeMarkdownEscapes=function(e){return e?e.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1"):e},t.parseHrefAndDimensions=function(e){const t=[],n=e.split("|").map(e=>e.trim());e=n[0];const r=n[1];if(r){const e=/height=(\d+)/.exec(r),n=/width=(\d+)/.exec(r),i=e?e[1]:"",s=n?n[1]:"",o=isFinite(parseInt(s)),a=isFinite(parseInt(i));o&&t.push(`width="${s}"`),a&&t.push(`height="${i}"`)}return{href:e,dimensions:t}}})),define(t[75],n([0,1,23]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeAccents=t.normalizeNFD=t.normalizeNFC=t.canNormalize=void 0,t.canNormalize="function"==typeof String.prototype.normalize;const r=new n.LRUCache(1e4);t.normalizeNFC=function(e){return a(e,"NFC",r)};const i=new n.LRUCache(1e4);function s(e){return a(e,"NFD",i)}t.normalizeNFD=s;const o=/[^\u0000-\u0080]/;function a(e,n,r){if(!t.canNormalize||!e)return e
;const i=r.get(e);if(i)return i;let s;return s=o.test(e)?e.normalize(n):e,r.set(e,s),s}t.removeAccents=function(){if(t.canNormalize){const e=/[\u0300-\u036f]/g;return function(t){return s(t).replace(e,"")}}return function(e){return e}}()})),define(t[22],n([0,1,30,2,4,13,8,5,39,23]),(function(e,t,n,r,i,s,o,a,c,l){"use strict";function u(e){return i.uriToFsPath(e,!0)}Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.ResourceGlobMatcher=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0,t.originalFSPath=u;class h{constructor(e){this._ignorePathCasing=e}compare(e,t,n=!1){return e===t?0:s.compare(this.getComparisonKey(e,n),this.getComparisonKey(t,n))}
isEqual(e,t,n=!1){return e===t||!(!e||!t)&&this.getComparisonKey(e,n)===this.getComparisonKey(t,n)}getComparisonKey(e,t=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}isEqualOrParent(e,r,i=!1){if(e.scheme===r.scheme){if(e.scheme===o.Schemas.file)return n.isEqualOrParent(u(e),u(r),this._ignorePathCasing(e))&&e.query===r.query&&(i||e.fragment===r.fragment);if(t.isEqualAuthority(e.authority,r.authority))return n.isEqualOrParent(e.path,r.path,this._ignorePathCasing(e),"/")&&e.query===r.query&&(i||e.fragment===r.fragment)}return!1}joinPath(e,...t){return i.URI.joinPath(e,...t)}basenameOrAuthority(e){return t.basename(e)||e.authority}basename(e){return r.posix.basename(e.path)}extname(e){return r.posix.extname(e.path)}dirname(e){if(0===e.path.length)return e;let t;return e.scheme===o.Schemas.file?t=i.URI.file(r.dirname(u(e))).path:(t=r.posix.dirname(e.path),
e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error(`dirname("${e.toString})) resulted in a relative path`),t="/")),e.with({path:t})}normalizePath(e){if(!e.path.length)return e;let t;return t=e.scheme===o.Schemas.file?i.URI.file(r.normalize(u(e))).path:r.posix.normalize(e.path),e.with({path:t})}relativePath(e,i){if(e.scheme!==i.scheme||!t.isEqualAuthority(e.authority,i.authority))return;if(e.scheme===o.Schemas.file){const t=r.relative(u(e),u(i));return a.isWindows?n.toSlashes(t):t}let s=e.path||"/",c=i.path||"/";if(this._ignorePathCasing(e)){let e=0;for(const t=Math.min(s.length,c.length);e<t&&(s.charCodeAt(e)===c.charCodeAt(e)||s.charAt(e).toLowerCase()===c.charAt(e).toLowerCase());e++);s=c.substr(0,e)+s.substr(e)}return r.posix.relative(s,c)}resolvePath(e,t){if(e.scheme===o.Schemas.file){const n=i.URI.file(r.resolve(u(e),t));return e.with({authority:n.authority,path:n.path})}return-1===t.indexOf("/")&&(t=n.toSlashes(t),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t)),e.with({path:r.posix.resolve(e.path,t)})}
isAbsolutePath(e){return!!e.path&&"/"===e.path[0]}isEqualAuthority(e,t){return e===t||s.equalsIgnoreCase(e,t)}hasTrailingPathSeparator(e,t=r.sep){if(e.scheme===o.Schemas.file){const r=u(e);return r.length>n.getRoot(r).length&&r[r.length-1]===t}{const t=e.path;return t.length>1&&47===t.charCodeAt(t.length-1)&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,n=r.sep){return t.hasTrailingPathSeparator(e,n)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,i=r.sep){let s=!1;if(e.scheme===o.Schemas.file){const t=u(e);s=void 0!==t&&t.length===n.getRoot(t).length&&t[t.length-1]===i}else{i="/";const t=e.path;s=1===t.length&&47===t.charCodeAt(t.length-1)}return s||t.hasTrailingPathSeparator(e,i)?e:e.with({path:e.path+"/"})}}t.ExtUri=h,t.extUri=new h(()=>!1),t.extUriBiasedIgnorePathCase=new h(e=>e.scheme!==o.Schemas.file||!a.isLinux),t.extUriIgnorePathCase=new h(e=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),
t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri),t.distinctParents=function(e,n){const r=[];for(let i=0;i<e.length;i++){const s=n(e[i]);e.some((e,r)=>r!==i&&t.isEqualOrParent(s,n(e)))||r.push(e[i])}return r},function(e){e.META_DATA_LABEL="label",
e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){const n=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(e=>{const[t,r]=e.split(":");t&&r&&n.set(t,r)});const r=t.path.substring(0,t.path.indexOf(";"));return r&&n.set(e.META_DATA_MIME,r),n}}(t.DataUri||(t.DataUri={}));t.ResourceGlobMatcher=class{constructor(e,t){this.expressionsByRoot=l.TernarySearchTree.forUris(),this.globalExpression=c.parse(e);for(const e of t)this.expressionsByRoot.set(e.root,{root:e.root,expression:c.parse(e.expression)})}matches(e){const n=this.expressionsByRoot.findSubstr(e);if(n){const r=t.relativePath(n.root,e);if(r&&n.expression(r))return!0}return!!this.globalExpression(e.path)}},t.toLocalResource=function(e,t,n){if(t){let i=e.path;return i&&i[0]!==r.posix.sep&&(i=r.posix.sep+i),e.with({scheme:n,authority:t,path:i})}return e.with({scheme:n})}})),define(t[47],n([0,1,4,2,13,8,5,22]),(function(e,t,n,r,i,s,o,a){"use strict"
;function c(e){return!(!o.isWindows||!e||":"!==e[1])}function l(e){return c(e)?e.charAt(0).toUpperCase()+e.slice(1):e}Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0,t.getPathLabel=function(e,t,i){if("string"==typeof e&&(e=n.URI.file(e)),i){const t=i.getWorkspaceFolder(e);if(t){const n=i.getWorkspace().folders.length>1;let r;if(r=a.isEqual(t.uri,e)?"":a.relativePath(t.uri,e),n){const e=t.name?t.name:a.basename(t.uri);r=r?e+" • "+r:e}return r}}if(e.scheme!==s.Schemas.file&&e.scheme!==s.Schemas.untitled)return e.with({query:null,fragment:null}).toString(!0);if(c(e.fsPath))return r.normalize(l(e.fsPath));let u=r.normalize(e.fsPath);return!o.isWindows&&(null==t?void 0:t.userHome)&&(u=h(u,t.userHome.fsPath)),u},t.getBaseLabel=function(e){if(!e)return;"string"==typeof e&&(e=n.URI.file(e))
;const t=a.basename(e)||(e.scheme===s.Schemas.file?e.fsPath:e.path);return c(t)?l(t):t},t.normalizeDriveLetter=l;let u=Object.create(null);function h(e,t){if(o.isWindows||!e||!t)return e;let n=u.original===t?u.normalized:void 0;return n||(n=`${i.rtrim(t,r.posix.sep)}${r.posix.sep}`,u={original:t,normalized:n}),(o.isLinux?e.startsWith(n):i.startsWithIgnoreCase(e,n))&&(e=`~/${e.substr(n.length)}`),e}t.tildify=h,t.untildify=function(e,t){return e.replace(/^~($|\/|\\)/,`${t}$1`)};const d="…",f="\\\\",p="~";var m;t.shorten=function(e,t=r.sep){const n=new Array(e.length);let i=!1;for(let r=0;r<e.length;r++){let s=e[r];if(""===s){n[r]=`.${t}`;continue}if(!s){n[r]=s;continue}i=!0;let o="";0===s.indexOf(f)?(o=s.substr(0,s.indexOf(f)+f.length),s=s.substr(s.indexOf(f)+f.length)):0===s.indexOf(t)?(o=s.substr(0,s.indexOf(t)+t.length),s=s.substr(s.indexOf(t)+t.length)):0===s.indexOf(p)&&(o=s.substr(0,s.indexOf(p)+p.length),s=s.substr(s.indexOf(p)+p.length));const a=s.split(t)
;for(let s=1;i&&s<=a.length;s++)for(let c=a.length-s;i&&c>=0;c--){i=!1;let l=a.slice(c,c+s).join(t);for(let n=0;!i&&n<e.length;n++)if(n!==r&&e[n]&&e[n].indexOf(l)>-1){const r=c+s===a.length,o=c>0&&e[n].indexOf(t)>-1?t+l:l,u=e[n].endsWith(o);i=!r||u}if(!i){let e="";(a[0].endsWith(":")||""!==o)&&(1===c&&(c=0,s++,l=a[0]+t+l),c>0&&(e=a[0]+t),e=o+e),c>0&&(e=e+d+t),e+=l,c+s<a.length&&(e=e+t+d),n[r]=e}}i&&(n[r]=s)}return n},function(e){e[e.TEXT=0]="TEXT",e[e.VARIABLE=1]="VARIABLE",e[e.SEPARATOR=2]="SEPARATOR"}(m||(m={})),t.template=function(e,t=Object.create(null)){const n=[];let r=!1,i="";for(const s of e)if("$"===s||r&&"{"===s)i&&n.push({value:i,type:m.TEXT}),i="",r=!0;else if("}"===s&&r){const e=t[i];if("string"==typeof e)e.length&&n.push({value:e,type:m.VARIABLE});else if(e){const t=n[n.length-1];t&&t.type===m.SEPARATOR||n.push({value:e.label,type:m.SEPARATOR})}i="",r=!1}else i+=s;return i&&!r&&n.push({value:i,type:m.TEXT}),n.filter((e,t)=>{if(e.type===m.SEPARATOR){
return[n[t-1],n[t+1]].every(e=>e&&(e.type===m.VARIABLE||e.type===m.TEXT)&&e.value.length>0)}return!0}).map(e=>e.value).join("")},t.mnemonicMenuLabel=function(e,t){return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,"").replace(/&/g,o.isMacintosh?"&":"&&"):e.replace(/&&|&/g,e=>"&"===e?"&&":"&")},t.mnemonicButtonLabel=function(e,t){return o.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,""):o.isWindows?e.replace(/&&|&/g,e=>"&"===e?"&&":"&"):e.replace(/&&/g,"_")},t.unmnemonicLabel=function(e){return e.replace(/&/g,"&&")},t.splitName=function(e){const t=-1!==e.indexOf("/")?r.posix:r.win32,n=t.basename(e),i=t.dirname(e);return n.length?{name:n,parentPath:i}:{name:i,parentPath:""}}})),define(t[118],n([0,1,2,13,39,8,22]),(function(e,t,n,r,i,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionForMimeType=t.getMediaMime=t.isUnspecific=t.guessMimeTypes=t.clearTextMimes=t.registerTextMime=t.MIME_UNKNOWN=t.MIME_BINARY=t.MIME_TEXT=void 0,t.MIME_TEXT="text/plain",t.MIME_BINARY="application/octet-stream",
t.MIME_UNKNOWN="application/unknown";let a=[],c=[],l=[];function u(e,t,n){let r=null,s=null,o=null;for(let a=n.length-1;a>=0;a--){const c=n[a];if(t===c.filenameLowercase){r=c;break}if(c.filepattern&&(!s||c.filepattern.length>s.filepattern.length)){const n=c.filepatternOnPath?e:t;i.match(c.filepatternLowercase,n)&&(s=c)}c.extension&&(!o||c.extension.length>o.extension.length)&&t.endsWith(c.extensionLowercase)&&(o=c)}return r?r.mime:s?s.mime:o?o.mime:null}t.registerTextMime=function(e,t=!1){const r=function(e){return{id:e.id,mime:e.mime,filename:e.filename,extension:e.extension,filepattern:e.filepattern,firstline:e.firstline,userConfigured:e.userConfigured,filenameLowercase:e.filename?e.filename.toLowerCase():void 0,extensionLowercase:e.extension?e.extension.toLowerCase():void 0,filepatternLowercase:e.filepattern?e.filepattern.toLowerCase():void 0,filepatternOnPath:!!e.filepattern&&e.filepattern.indexOf(n.posix.sep)>=0}}(e);a.push(r),r.userConfigured?l.push(r):c.push(r),t&&!r.userConfigured&&a.forEach(e=>{
e.mime===r.mime||e.userConfigured||(r.extension&&e.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&e.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&e.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&e.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})},t.clearTextMimes=function(e){e?(a=a.filter(e=>!e.userConfigured),l=[]):(a=[],c=[],l=[])},t.guessMimeTypes=function(e,i){let h;if(e)switch(e.scheme){case s.Schemas.file:h=e.fsPath;break;case s.Schemas.data:h=o.DataUri.parseMetaData(e).get(o.DataUri.META_DATA_LABEL);break;default:h=e.path}if(!h)return[t.MIME_UNKNOWN];h=h.toLowerCase();const d=n.basename(h),f=u(h,d,l);if(f)return[f,t.MIME_TEXT];const p=u(h,d,c);if(p)return[p,t.MIME_TEXT];if(i){
const e=function(e){r.startsWithUTF8BOM(e)&&(e=e.substr(1));if(e.length>0)for(let t=a.length-1;t>=0;t--){const n=a[t];if(!n.firstline)continue;const r=e.match(n.firstline);if(r&&r.length>0)return n.mime}return null}(i);if(e)return[e,t.MIME_TEXT]}return[t.MIME_UNKNOWN]},t.isUnspecific=function e(n){return!n||("string"==typeof n?n===t.MIME_BINARY||n===t.MIME_TEXT||n===t.MIME_UNKNOWN:1===n.length&&e(n[0]))};const h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",
".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};t.getMediaMime=function(e){const t=n.extname(e);return h[t.toLowerCase()]},t.getExtensionForMimeType=function(e){for(const t in h)if(h[t]===e)return t}})),define(t[59],n([0,1,4]),(function(e,t,n){"use strict";function r(e){return e.toJSON()}Object.defineProperty(t,"__esModule",{value:!0}),t.transformAndReviveIncomingURIs=t.transformIncomingURIs=t.transformOutgoingURIs=t.DefaultURITransformer=t.URITransformer=void 0;function i(e,t,r,s){if(!e||s>200)return null;if("object"==typeof e){if(1===e.$mid)return r?n.URI.revive(t.transformIncoming(e)):t.transformIncoming(e)
;for(let n in e)if(Object.hasOwnProperty.call(e,n)){const o=i(e[n],t,r,s+1);null!==o&&(e[n]=o)}}return null}t.URITransformer=class{constructor(e){this._uriTransformer=e}transformIncoming(e){const t=this._uriTransformer.transformIncoming(e);return t===e?e:r(n.URI.from(t))}transformOutgoing(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:r(n.URI.from(t))}transformOutgoingURI(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:n.URI.from(t)}transformOutgoingScheme(e){return this._uriTransformer.transformOutgoingScheme(e)}},t.DefaultURITransformer=new class{transformIncoming(e){return e}transformOutgoing(e){return e}transformOutgoingURI(e){return e}transformOutgoingScheme(e){return e}},t.transformOutgoingURIs=function(e,t){const r=function e(t,r,i){if(!t||i>200)return null;if("object"==typeof t){if(t instanceof n.URI)return r.transformOutgoing(t);for(let n in t)if(Object.hasOwnProperty.call(t,n)){const s=e(t[n],r,i+1);null!==s&&(t[n]=s)}}return null}(e,t,0);return null===r?e:r
},t.transformIncomingURIs=function(e,t){const n=i(e,t,!1,0);return null===n?e:n},t.transformAndReviveIncomingURIs=function(e,t){const n=i(e,t,!0,0);return null===n?e:n}})),define(t[21],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;t.isUUID=function(e){return n.test(e)};const r=new Uint8Array(16),i=[];for(let e=0;e<256;e++)i.push(e.toString(16).padStart(2,"0"));const s=function(e){for(let t=0;t<e.length;t++)e[t]=Math.floor(256*Math.random());return e};t.generateUuid=function(){s(r),r[6]=15&r[6]|64,r[8]=63&r[8]|128;let e=0,t="";return t+=i[r[e++]],t+=i[r[e++]],t+=i[r[e++]],t+=i[r[e++]],t+="-",t+=i[r[e++]],t+=i[r[e++]],t+="-",t+=i[r[e++]],t+=i[r[e++]],t+="-",t+=i[r[e++]],t+=i[r[e++]],t+="-",t+=i[r[e++]],t+=i[r[e++]],t+=i[r[e++]],t+=i[r[e++]],t+=i[r[e++]],t+=i[r[e++]]}})),define(t[76],n([0,1,221]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.LineDecoder=void 0;t.LineDecoder=class{constructor(e="utf8"){this.stringDecoder=new n.StringDecoder(e),this.remaining=null}write(e){const t=[],n=this.remaining?this.remaining+this.stringDecoder.write(e):this.stringDecoder.write(e);if(n.length<1)return t;let r,i=0,s=i;for(;s<n.length;)if(13===(r=n.charCodeAt(s))||10===r){if(t.push(n.substring(i,s)),++s<n.length){const e=r;r=n.charCodeAt(s),(13===e&&10===r||10===e&&13===r)&&s++}i=s}else s++;return this.remaining=i<n.length?n.substr(i):null,t}end(){return this.remaining}}})),"function"==typeof define)define(t[119],n([222,20,223]),(function(e,t,n){return i(require.__$__nodeRequire,e,t,n)}));else{if("object"!=typeof module||"object"!=typeof module.exports)throw new Error("Unknown context");{const e=require("path"),t=require("fs"),n=require("../common/performance");module.exports=i(require,e,t,n)}}define(t[120],n([0,1,25]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMac=void 0
;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function i(e){const t=e.replace(/\-/g,":").toLowerCase();return!r.has(t)}t.getMac=function(){return new Promise(async(e,t)=>{const r=setTimeout(()=>t("Unable to retrieve mac address (timeout after 10s)"),1e4);try{e(await new Promise((e,t)=>{try{const r=n.networkInterfaces();for(const[,t]of Object.entries(r))for(const n of t)if(i(n.mac))return e(n.mac);t("Unable to retrieve mac address (unexpected format)")}catch(e){t(e)}}))}catch(e){t(e)}finally{clearTimeout(r)}})}})),define(t[77],n([0,1,15,21,25,23,120]),(function(e,t,n,r,i,s,o){"use strict";let a;Object.defineProperty(t,"__esModule",{value:!0}),t.getMachineId=t.virtualMachineHint=void 0,t.virtualMachineHint=new class{_isVirtualMachineMacAdress(e){return this._virtualMachineOUIs||(this._virtualMachineOUIs=s.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),
this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(e)}value(){if(void 0===this._value){let e=0,t=0;const n=i.networkInterfaces();for(let r in n)if(Object.prototype.hasOwnProperty.call(n,r))for(const{mac:i,internal:s}of n[r])s||(t+=1,this._isVirtualMachineMacAdress(i.toUpperCase())&&(e+=1));this._value=t>0?e/t:0}return this._value}},t.getMachineId=async function(){return a||(a=(async()=>{return await async function(){try{const t=await new Promise((t,n)=>{e(["crypto"],t,n)}),n=await o.getMac()
;return t.createHash("sha256").update(n,"utf8").digest("hex")}catch(e){return void n.onUnexpectedError(e)}}()||r.generateUuid()})()),a}})),define(t[121],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getDefaultUserDataPath=t.getAppDataPath=void 0;const r=n.FileAccess.asFileUri("paths",e).fsPath,i=e.__$__nodeRequire(r);t.getAppDataPath=i.getAppDataPath,t.getDefaultUserDataPath=i.getDefaultUserDataPath})),define(t[14],n([0,1,2,17,20,25,5,6,48,30,21,75]),(function(e,t,n,r,i,s,o,a,c,l,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.copy=t.move=t.whenDeleted=t.fileExists=t.dirExists=t.readDirsInDir=t.writeFileSync=t.writeFile=t.mkdirp=t.readFile=t.truncate=t.symlink=t.unlink=t.renameIgnoreError=t.rename=t.lstat=t.statLink=t.stat=t.chmod=t.exists=t.readdirSync=t.readdirWithFileTypes=t.readdir=t.rimrafSync=t.rimraf=t.RimRafMode=t.MAX_HEAP_SIZE=t.MAX_FILE_SIZE=void 0;var d;async function f(e,t=d.UNLINK){
if(l.isRootOrDriveLetter(e))throw new Error("rimraf - will refuse to recursively delete root");return t===d.UNLINK?p(e):async function(e){try{const t=n.join(s.tmpdir(),u.generateUuid());try{await _(e,t)}catch(t){return p(e)}p(t)}catch(e){if("ENOENT"!==e.code)throw e}}(e)}async function p(e){try{const t=await w(e);if(!t.isDirectory()||t.isSymbolicLink()){const n=t.mode;return 128&n||await y(e,128|n),E(e)}{const t=await m(e);await Promise.all(t.map(t=>p(n.join(e,t)))),await c.promisify(i.rmdir)(e)}}catch(e){if("ENOENT"!==e.code)throw e}}async function m(e){return v(await c.promisify(i.readdir)(e))}function g(e){return v(i.readdirSync(e))}function v(e){return o.isMacintosh?e.map(e=>h.normalizeNFC(e)):e}function y(e,t){return c.promisify(i.chmod)(e,t)}function b(e){return c.promisify(i.stat)(e)}function w(e){return c.promisify(i.lstat)(e)}function _(e,t){return c.promisify(i.rename)(e,t)}function E(e){return c.promisify(i.unlink)(e)}async function S(e,t){return c.promisify(i.mkdir)(e,{mode:t,recursive:!0})}
t.MAX_FILE_SIZE="ia32"===process.arch?314572800:17179869184,t.MAX_HEAP_SIZE="ia32"===process.arch?734003200:1468006400,function(e){e[e.UNLINK=0]="UNLINK",e[e.MOVE=1]="MOVE"}(d=t.RimRafMode||(t.RimRafMode={})),t.rimraf=f,t.rimrafSync=function e(t){if(l.isRootOrDriveLetter(t))throw new Error("rimraf - will refuse to recursively delete root");try{const r=i.lstatSync(t);if(!r.isDirectory()||r.isSymbolicLink()){const e=r.mode;return 128&e||i.chmodSync(t,128|e),i.unlinkSync(t)}g(t).map(r=>e(n.join(t,r))),i.rmdirSync(t)}catch(e){if("ENOENT"!==e.code)throw e}},t.readdir=m,t.readdirWithFileTypes=async function(e){const t=await c.promisify(i.readdir)(e,{withFileTypes:!0});if(o.isMacintosh)for(const e of t)e.name=h.normalizeNFC(e.name);return t},t.readdirSync=g,t.exists=function(e){return c.promisify(i.exists)(e)},t.chmod=y,t.stat=b,t.statLink=async function(e){let t;try{if(!(t=await w(e)).isSymbolicLink())return{stat:t}}catch(e){}try{return{stat:await b(e),symbolicLink:(null==t?void 0:t.isSymbolicLink())?{dangling:!1
}:void 0}}catch(e){if("ENOENT"===e.code&&t)return{stat:t,symbolicLink:{dangling:!0}};throw e}},t.lstat=w,t.rename=_,t.renameIgnoreError=function(e,t){return new Promise(n=>i.rename(e,t,()=>n()))},t.unlink=E,t.symlink=function(e,t,n){return c.promisify(i.symlink)(e,t,n)},t.truncate=function(e,t){return c.promisify(i.truncate)(e,t)},t.readFile=function(e,t){return c.promisify(i.readFile)(e,t)},t.mkdirp=S;const C=new Map;t.writeFile=function(e,t,n){return function(e){const t=C.get(e);if(t)return t;const n=new r.Queue;return C.set(e,n),a.Event.once(n.onFinished)(()=>{C.delete(e),n.dispose()}),n}(function(e){let t=e;(o.isWindows||o.isMacintosh)&&(t=t.toLowerCase());return t}(e)).queue(()=>{const r=I(n);return new Promise((n,s)=>(function(e,t,n,r){if(!x)return i.writeFile(e,t,{mode:n.mode,flag:n.flag},r);i.open(e,n.flag,n.mode,(e,n)=>{if(e)return r(e);i.writeFile(n,t,e=>{if(e)return i.close(n,()=>r(e))
;i.fdatasync(n,e=>(e&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",e),x=!1),i.close(n,e=>r(e))))})})})(e,t,r,e=>e?s(e):n()))})};let x=!0;function I(e){return e?{mode:"number"==typeof e.mode?e.mode:438,flag:"string"==typeof e.flag?e.flag:"w"}:{mode:438,flag:"w"}}async function k(e){try{return(await b(e)).isDirectory()}catch(e){return!1}}async function T(e,t,r){const s=r||Object.create(null),o=await b(e);if(!o.isDirectory())return async function(e,t,n){return new Promise((r,s)=>{const o=i.createReadStream(e),a=i.createWriteStream(t,{mode:n});let c=!1;const l=e=>{if(!c){if(c=!0,e)return s(e);i.chmod(t,n,e=>e?s(e):r())}};o.once("error",e=>l(e)),a.once("error",e=>l(e)),a.once("close",()=>l()),o.pipe(a)})}(e,t,511&o.mode);if(s[e])return Promise.resolve();s[e]=!0,await S(t,511&o.mode);const a=await m(e);for(let r=0;r<a.length;r++){const i=a[r];await T(n.join(e,i),n.join(t,i),s)}}t.writeFileSync=function(e,t,n){const r=I(n);if(!x)return i.writeFileSync(e,t,{mode:r.mode,
flag:r.flag});const s=i.openSync(e,r.flag,r.mode);try{i.writeFileSync(s,t);try{i.fdatasyncSync(s)}catch(e){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",e),x=!1}}finally{i.closeSync(s)}},t.readDirsInDir=async function(e){const t=await m(e),r=[];for(const i of t)await k(n.join(e,i))&&r.push(i);return r},t.dirExists=k,t.fileExists=async function(e){try{return(await b(e)).isFile()}catch(e){return!1}},t.whenDeleted=function(e){return new Promise(t=>{let n=!1;const r=setInterval(()=>{n||(n=!0,i.exists(e,e=>{n=!1,e||(clearInterval(r),t(void 0))}))},1e3)})},t.move=async function(e,t){if(e===t)return Promise.resolve();async function n(e){const t=await w(e);if(t.isDirectory()||t.isSymbolicLink())return Promise.resolve();const n=await c.promisify(i.open)(e,"a");try{await c.promisify(i.futimes)(n,t.atime,new Date)}catch(e){}return c.promisify(i.close)(n)}try{await _(e,t),await n(t)}catch(r){if(!(e.toLowerCase()!==t.toLowerCase()&&"EXDEV"===r.code||e.endsWith(".")))throw r
;await T(e,t),await f(e,d.MOVE),await n(t)}},t.copy=T})),define(t[122],n([0,1,20,13,2,14,48]),(function(e,t,n,r,i,s,o){"use strict";function a(e){return r.rtrim(i.normalize(e),i.sep)}Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0,t.realcaseSync=function e(t){const n=i.dirname(t);if(t===n)return t;const r=(i.basename(t)||t).toLowerCase();try{const t=s.readdirSync(n).filter(e=>e.toLowerCase()===r);if(1===t.length){const r=e(n);if(r)return i.join(r,t[0])}else if(t.length>1){const s=t.indexOf(r);if(s>=0){const r=e(n);if(r)return i.join(r,t[s])}}}catch(e){}return null},t.realpath=async function(e){try{return await o.promisify(n.realpath)(e)}catch(t){const r=a(e);return await o.promisify(n.access)(r,n.constants.R_OK),r}},t.realpathSync=function(e){try{return n.realpathSync(e)}catch(t){const r=a(e);return n.accessSync(r,n.constants.R_OK),r}}})),define(t[123],n([0,1,78]),(function(e,t,n){"use strict";function r(e){try{e.removeAllListeners("connect"),
e.removeAllListeners("error"),e.end(),e.destroy(),e.unref()}catch(e){console.error(e)}}Object.defineProperty(t,"__esModule",{value:!0}),t.findFreePortFaster=t.findFreePort=t.randomPort=void 0,t.randomPort=function(){return 1025+Math.floor(64510*Math.random())},t.findFreePort=function(e,t,i){let s=!1;return new Promise(o=>{const a=setTimeout(()=>{if(!s)return s=!0,o(0)},i);!function e(t,i,s){if(0===i)return s(0);const o=new n.Socket;o.once("connect",()=>(r(o),e(t+1,i-1,s)));o.once("data",()=>{});o.once("error",n=>(r(o),"ECONNREFUSED"!==n.code?e(t+1,i-1,s):s(t)));o.connect(t,"127.0.0.1")}(e,t,e=>{if(!s)return s=!0,clearTimeout(a),o(e)})})},t.findFreePortFaster=function(e,t,r){let i=!1,s=void 0,o=1;const a=n.createServer({pauseOnConnect:!0});function c(e,t){i||(i=!0,a.removeAllListeners(),a.close(),s&&clearTimeout(s),t(e))}return new Promise(n=>{s=setTimeout(()=>{c(0,n)},r),a.on("listening",()=>{c(e,n)}),a.on("error",r=>{r&&("EADDRINUSE"===r.code||"EACCES"===r.code)&&o<t?(e++,o++,a.listen(e,"127.0.0.1")):c(0,n)
}),a.on("close",()=>{c(0,n)}),a.listen(e,"127.0.0.1")})}})),define(t[79],n([0,1,33,8]),(function(e,t,n,r){"use strict";function i(e,t){const n=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=e.toString().split("\n");for(const e of r){const r=n.exec(e.trim());r&&6===r.length&&t(parseInt(r[1]),parseInt(r[2]),r[5],parseFloat(r[3]),parseFloat(r[4]))}}Object.defineProperty(t,"__esModule",{value:!0}),t.listProcesses=void 0,t.listProcesses=function(t){return new Promise((s,o)=>{let a;const c=new Map;function l(e,n,r,i,s){const o=c.get(n);if(e===t||o){const l={name:u(r),cmd:r,pid:e,ppid:n,load:i,mem:s};c.set(e,l),e===t&&(a=l),o&&(o.children||(o.children=[]),o.children.push(l),o.children.length>1&&(o.children=o.children.sort((e,t)=>e.pid-t.pid)))}}function u(e){const t=/--disable-blink-features=Auxclick/;if(/\\watcher\\win32\\CodeHelper\.exe/.exec(e))return"watcherService ";if(/--crashes-directory/.exec(e))return"electron-crash-reporter"
;if(/\\pipe\\winpty-control/.exec(e))return"winpty-process";if(/conhost\.exe/.exec(e))return"console-window-host (Windows internal process)";let n=/--type=([a-zA-Z-]+)/.exec(e);if(n&&2===n.length)return"renderer"===n[1]?t.exec(e)?"shared-process":"window":n[1];const r=/[a-zA-Z-]+\.js/g;let i="";do{(n=r.exec(e))&&(i+=n+" ")}while(n);return i&&e.indexOf("node ")<0&&e.indexOf("node.exe")<0?`electron_node ${i}`:e}if("win32"===process.platform){const n=e=>0===e.indexOf("\\\\?\\")?e.substr(4):0===e.indexOf("\\??\\")?e.substr(4):0===e.indexOf('"\\\\?\\')?'"'+e.substr(5):0===e.indexOf('"\\??\\')?'"'+e.substr(5):e;new Promise((t,n)=>{e(["windows-process-tree"],t,n)}).then(e=>{e.getProcessList(t,r=>{e.getProcessCpuUsage(r,e=>{const r=new Map;e.forEach(e=>{const t=n(e.commandLine||"");r.set(e.pid,{name:u(t),cmd:t,pid:e.pid,ppid:e.ppid,load:e.cpu||0,mem:e.memory||0})}),(a=r.get(t))?(r.forEach(e=>{const t=r.get(e.ppid);t&&(t.children||(t.children=[]),t.children.push(e))}),r.forEach(e=>{
e.children&&(e.children=e.children.sort((e,t)=>e.pid-t.pid))}),s(a)):o(new Error(`Root process ${t} not found`))})},e.ProcessDataFlag.CommandLine|e.ProcessDataFlag.Memory)})}else{function h(){let i=[a];const l=[];for(;i.length;){const e=i.shift();e&&(l.push(e.pid),e.children&&(i=i.concat(e.children)))}let u=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",e).fsPath);u+=" "+l.join(" "),n.exec(u,{},(e,n,r)=>{if(e||r)o(e||new Error(r.toString()));else{const e=n.toString().split("\n");for(let t=0;t<l.length;t++){c.get(l[t]).load=parseFloat(e[t])}if(!a)return void o(new Error(`Root process ${t} not found`));s(a)}})}n.exec("which ps",{},(c,u,d)=>{if(c||d)if("linux"!==process.platform)o(c||new Error(d.toString()));else{const t=JSON.stringify(r.FileAccess.asFileUri("vs/base/node/ps.sh",e).fsPath);n.exec(t,{},(e,t,n)=>{e||n?o(e||new Error(n.toString())):(i(t,l),h())})}else{const e=u.toString().trim(),r="-ax -o pid=,ppid=,pcpu=,pmem=,command=";n.exec(`${e} ${r}`,{maxBuffer:1024e3,env:{
LC_NUMERIC:"en_US.UTF-8"}},(e,n,r)=>{e||r&&!r.includes("screen size is bogus")?o(e||new Error(r.toString())):(i(n,l),"linux"===process.platform?h():a?s(a):o(new Error(`Root process ${t} not found`)))})}})}})}})),define(t[124],n([0,1,2,20,5,75,3,14]),(function(e,t,n,r,i,s,o,a){"use strict";function c(e,l,u){const h=n.basename(e.path),d=new Map;let f=!1,p=[o.toDisposable(()=>{d.forEach(e=>o.dispose(e)),d.clear()})];try{const m=r.watch(e.path);p.push(o.toDisposable(()=>{m.removeAllListeners(),m.close()}));const g=new Set;e.isDirectory&&a.readdir(e.path).then(e=>e.forEach(e=>g.add(e))),m.on("error",(t,n)=>{f||u(`Failed to watch ${e.path} for changes using fs.watch() (${t}, ${n})`)}),m.on("change",(r,m)=>{if(f)return;let v="";if(m&&(v=m.toString(),i.isMacintosh&&(v=s.normalizeNFC(v))),!v||"change"!==r&&"rename"!==r)return;const y=e.isDirectory?n.join(e.path,v):e.path;if(e.isDirectory)if("rename"===r){const e=d.get(y);e&&o.dispose(e);const n=setTimeout(async()=>{d.delete(y);const e=await a.exists(y);if(f)return
;let t;e?g.has(v)?t="changed":(t="added",g.add(v)):(g.delete(v),t="deleted"),l(t,y)},t.CHANGE_BUFFER_DELAY);d.set(y,o.toDisposable(()=>clearTimeout(n)))}else{let e;g.has(v)?e="changed":(e="added",g.add(v)),l(e,y)}else if("rename"===r||v!==h){const n=setTimeout(async()=>{const t=await a.exists(y);f||(t?(l("changed",y),p=[c(e,l,u)]):l("deleted",y))},t.CHANGE_BUFFER_DELAY);o.dispose(p),p=[o.toDisposable(()=>clearTimeout(n))]}else l("changed",y)})}catch(t){a.exists(e.path).then(n=>{n&&!f&&u(`Failed to watch ${e.path} for changes using fs.watch() (${t.toString()})`)})}return o.toDisposable(()=>{f=!0,p=o.dispose(p)})}Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0,t.watchFile=function(e,t,n){return c({path:e,isDirectory:!1},t,n)},t.watchFolder=function(e,t,n){return c({path:e,isDirectory:!0},t,n)},t.CHANGE_BUFFER_DELAY=100})),define(t[36],n([0,1,6,3,17,28,15,19,16,11,46,13]),(function(e,t,n,r,i,s,o,a,c,l,u,h){"use strict";var d,f;function p(e){switch(e){
case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}function m(e){switch(e){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.createChannelSender=t.createChannelReceiver=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0,function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",e[e.Idle=1]="Idle"}(d||(d={}))
;class g{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class v{constructor(){this.buffers=[]}get buffer(){return a.VSBuffer.concat(this.buffers)}write(e){this.buffers.push(e)}}function y(e){const t=a.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function b(e){return e.read(4).readUInt32BE(0)}function w(e){const t=a.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",e[e.Array=4]="Array",e[e.Object=5]="Object"}(f||(f={}));const _={Undefined:w(f.Undefined),String:w(f.String),Buffer:w(f.Buffer),VSBuffer:w(f.VSBuffer),Array:w(f.Array),Object:w(f.Object)},E="undefined"!=typeof Buffer;function S(e,t){if(void 0===t)e.write(_.Undefined);else if("string"==typeof t){const n=a.VSBuffer.fromString(t);e.write(_.String),e.write(y(n.byteLength)),e.write(n)}else if(E&&Buffer.isBuffer(t)){const n=a.VSBuffer.wrap(t);e.write(_.Buffer),
e.write(y(n.byteLength)),e.write(n)}else if(t instanceof a.VSBuffer)e.write(_.VSBuffer),e.write(y(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(_.Array),e.write(y(t.length));for(const n of t)S(e,n)}else{const n=a.VSBuffer.fromString(JSON.stringify(t));e.write(_.Object),e.write(y(n.byteLength)),e.write(n)}}function C(e){switch(e.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return e.read(b(e)).toString();case f.Buffer:return e.read(b(e)).buffer;case f.VSBuffer:return e.read(b(e));case f.Array:{const t=b(e),n=[];for(let r=0;r<t;r++)n.push(C(e));return n}case f.Object:return JSON.parse(e.read(b(e)).toString())}}class x{constructor(e,t,n=null,r=1e3){this.protocol=e,this.ctx=t,this.logger=n,this.timeoutDelay=r,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),setTimeout(()=>this.flushPendingRequests(e),0)}
sendResponse(e){switch(e.type){case 200:{const t=this.send([e.type]);return void(this.logger&&this.logger.logOutgoing(t,0,1,m(e.type)))}case 201:case 202:case 204:case 203:{const t=this.send([e.type,e.id],e.data);return void(this.logger&&this.logger.logOutgoing(t,e.id,1,m(e.type),e.data))}}}send(e,t){const n=new v;return S(n,e),S(n,t),this.sendBuffer(n.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onRawMessage(e){const t=new g(e),n=C(t),r=C(t),i=n[0];switch(i){case 100:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],1,`${p(i)}: ${n[2]}.${n[3]}`,r),this.onPromise({type:i,id:n[1],channelName:n[2],name:n[3],arg:r});case 102:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],1,`${p(i)}: ${n[2]}.${n[3]}`,r),this.onEventListen({type:i,id:n[1],channelName:n[2],name:n[3],arg:r});case 101:case 103:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],1,`${p(i)}`),this.disposeActiveRequest({type:i,id:n[1]})}}onPromise(e){
const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const n=new s.CancellationTokenSource;let i;try{i=t.call(this.ctx,e.name,e.arg,n.token)}catch(e){i=Promise.reject(e)}const o=e.id;i.then(t=>{this.sendResponse({id:o,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:o,data:{message:t.message,name:t.name,stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:o,data:t,type:203}),this.activeRequests.delete(e.id)});const a=r.toDisposable(()=>n.cancel());this.activeRequests.set(e.id,a)}onEventListen(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const n=e.id,r=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:n,data:e,type:204}));this.activeRequests.set(e.id,r)}disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){
let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const n=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:n})}flushPendingRequests(e){const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=x,function(e){e[e.LocalSide=0]="LocalSide",e[e.OtherSide=1]="OtherSide"}(t.RequestInitiator||(t.RequestInitiator={}));class I{constructor(e,t=null){this.protocol=e,
this.state=d.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new n.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e)),this.logger=t}getChannel(e){const t=this;return{call:(n,r,i)=>t.requestPromise(e,n,r,i),listen:(n,r)=>t.requestEvent(e,n,r)}}requestPromise(e,t,n,a=s.CancellationToken.None){const c=this.lastRequestId++,l={id:c,type:100,channelName:e,name:t,arg:n};if(a.isCancellationRequested)return Promise.reject(o.canceled());let u;return new Promise((e,t)=>{if(a.isCancellationRequested)return t(o.canceled());const n=()=>{this.handlers.set(c,n=>{switch(n.type){case 201:this.handlers.delete(c),e(n.data);break;case 202:this.handlers.delete(c);const r=new Error(n.data.message);r.stack=n.data.stack,r.name=n.data.name,t(r);break;case 203:this.handlers.delete(c),t(n.data)}}),this.sendRequest(l)};let s=null
;this.state===d.Idle?n():(s=i.createCancelablePromise(e=>this.whenInitialized())).then(()=>{s=null,n()});const h=()=>{s?(s.cancel(),s=null):this.sendRequest({id:c,type:101}),t(o.canceled())},f=a.onCancellationRequested(h);u=r.combinedDisposable(r.toDisposable(h),f),this.activeRequests.add(u)}).finally(()=>{this.activeRequests.delete(u)})}requestEvent(e,t,r){const s=this.lastRequestId++,o={id:s,type:102,channelName:e,name:t,arg:r};let a=null;const c=new n.Emitter({onFirstListenerAdd:()=>{(a=i.createCancelablePromise(e=>this.whenInitialized())).then(()=>{a=null,this.activeRequests.add(c),this.sendRequest(o)})},onLastListenerRemove:()=>{a?(a.cancel(),a=null):(this.activeRequests.delete(c),this.sendRequest({id:s,type:103}))}});return this.handlers.set(s,e=>c.fire(e.data)),c.event}sendRequest(e){switch(e.type){case 100:case 102:{const t=this.send([e.type,e.id,e.channelName,e.name],e.arg);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,`${p(e.type)}: ${e.channelName}.${e.name}`,e.arg))}case 101:case 103:{
const t=this.send([e.type,e.id]);return void(this.logger&&this.logger.logOutgoing(t,e.id,0,p(e.type)))}}}send(e,t){const n=new v;return S(n,e),S(n,t),this.sendBuffer(n.buffer)}sendBuffer(e){try{return this.protocol.send(e),e.byteLength}catch(e){return 0}}onBuffer(e){const t=new g(e),n=C(t),r=C(t),i=n[0];switch(i){case 200:return this.logger&&this.logger.logIncoming(e.byteLength,0,0,m(i)),this.onResponse({type:n[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(e.byteLength,n[1],0,m(i),r),this.onResponse({type:n[0],id:n[1],data:r})}}onResponse(e){if(200===e.type)return this.state=d.Idle,void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===d.Idle?Promise.resolve():n.Event.toPromise(this.onDidInitialize)}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=I;t.IPCServer=class{constructor(e){
this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new n.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new n.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,e(({protocol:e,onDidClientDisconnect:t})=>{n.Event.once(e.onMessage)(n=>{const r=C(new g(n)),i=new x(e,r),s=new I(e);this.channels.forEach((e,t)=>i.registerChannel(t,e));const o={channelServer:i,channelClient:s,ctx:r};this._connections.add(o),this._onDidAddConnection.fire(o),t(()=>{i.dispose(),s.dispose(),this._connections.delete(o),this._onDidRemoveConnection.fire(o)})})})}get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const r=this;return{call(i,s,o){let a;if(l.isFunction(t)){let e=c.getRandomElement(r.connections.filter(t));a=e?Promise.resolve(e):n.Event.toPromise(n.Event.filter(r.onDidAddConnection,t))}else a=t.routeCall(r,i,s);return k(a.then(t=>t.channelClient.getChannel(e))).call(i,s,o)},listen(n,i){
if(l.isFunction(t))return r.getMulticastEvent(e,t,n,i);return k(t.routeEvent(r,n,i).then(t=>t.channelClient.getChannel(e))).listen(n,i)}}}getMulticastEvent(e,t,i,s){const o=this;let a=new r.DisposableStore;const c=new n.Emitter({onFirstListenerAdd:()=>{a=new r.DisposableStore;const l=new n.EventMultiplexer,u=new Map,h=t=>{const n=t.channelClient.getChannel(e).listen(i,s),r=l.add(n);u.set(t,r)};o.connections.filter(t).forEach(h),n.Event.filter(o.onDidAddConnection,t)(h,void 0,a),o.onDidRemoveConnection(e=>{const t=u.get(e);t&&(t.dispose(),u.delete(e))},void 0,a),l.event(c.fire,c,a),a.add(l)},onLastListenerRemove:()=>{a.dispose()}});return c.event}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(n=>{n.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}};function k(e){return{call:(t,n,r)=>e.then(e=>e.call(t,n,r)),listen(t,r){const i=new n.Relay
;return e.then(e=>i.input=e.listen(t,r)),i.event}}}t.IPCClient=class{constructor(e,t,n=null){const r=new v;S(r,t),e.send(r.buffer),this.channelClient=new I(e,n),this.channelServer=new x(e,t,n)}getChannel(e){return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=k,t.getNextTickChannel=function(e){let t=!1;return{call:(n,r,s)=>t?e.call(n,r,s):i.timeout(0).then(()=>t=!0).then(()=>e.call(n,r,s)),listen(r,s){if(t)return e.listen(r,s);const o=new n.Relay;return i.timeout(0).then(()=>t=!0).then(()=>o.input=e.listen(r,s)),o.event}}};function T(e){return"o"===e[0]&&"n"===e[1]&&h.isUpperAsciiLetter(e.charCodeAt(2))}t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t)
;return await n.Event.toPromise(e.onDidAddConnection),await this.route(e)}},t.createChannelReceiver=function(e,t){const r=e,i=t&&t.disableMarshalling,s=new Map;for(const e in r)T(e)&&s.set(e,n.Event.buffer(r[e],!0));return new class{listen(e,t){const n=s.get(t);if(n)return n;throw new Error(`Event not found: ${t}`)}call(e,t,n){const s=r[t];if("function"==typeof s){if(!i&&Array.isArray(n))for(let e=0;e<n.length;e++)n[e]=u.revive(n[e]);return s.apply(r,n)}throw new Error(`Method not found: ${t}`)}}},t.createChannelSender=function(e,t){const n=t&&t.disableMarshalling;return new Proxy({},{get(r,i){var s;if("string"==typeof i)return(null===(s=null==t?void 0:t.properties)||void 0===s?void 0:s.has(i))?t.properties.get(i):T(i)?e.listen(i):async function(...r){let s;s=t&&!l.isUndefinedOrNull(t.context)?[t.context,...r]:r;const o=await e.call(i,s);return n?o:u.revive(o)};throw new Error(`Property not found: ${String(i)}`)}})}
;const P=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function R(e){if(Array.isArray(e))return e;if(e&&"object"==typeof e&&"function"==typeof e.toString){let t=e.toString();if("[object Object]"!==t)return t}return e}function O(e,t,n,r,i,s,o){o=function(e){return Array.isArray(e)?e.map(R):R(e)}(o);const a=P[i],c=a[r%a.length];let l=[`%c[${e}]%c[${String(t).padStart(7," ")}]%c[len: ${String(n).padStart(5," ")}]%c${String(r).padStart(5," ")} - ${s}`,"color: darkgreen","color: grey","color: grey",`color: ${c}`];/\($/.test(s)?(l=l.concat(o)).push(")"):l.push(o),console.log.apply(console,l)}t.logWithColors=O;t.IPCLogger=class{constructor(e,t){this._outgoingPrefix=e,this._incomingPrefix=t,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(e,t,n,r,i){this._totalOutgoing+=e,O(this._outgoingPrefix,this._totalOutgoing,e,t,n,r,i)}logIncoming(e,t,n,r,i){this._totalIncoming+=e,O(this._incomingPrefix,this._totalIncoming,e,t,n,r,i)}}})),
define(t[80],n([0,1,6,36,3,19,5,44]),(function(e,t,n,r,i,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PersistentProtocol=t.BufferedEmitter=t.Client=t.Protocol=t.ProtocolConstants=t.ChunkStream=void 0;let c=null;function l(){return c||(c=s.VSBuffer.alloc(0)),c}class u{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return l();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const n=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),n}if(this._chunks[0].byteLength>e){const n=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),n}let n=s.VSBuffer.alloc(e),r=0,i=0;for(;e>0;){const s=this._chunks[i];if(s.byteLength>e){const o=s.slice(0,e);n.set(o,r),r+=e,
t&&(this._chunks[i]=s.slice(e),this._totalLength-=e),e-=e}else n.set(s,r),r+=s.byteLength,t?(this._chunks.shift(),this._totalLength-=s.byteLength):i++,e-=s.byteLength}return n}}var h;t.ChunkStream=u,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect"}(h||(h={})),function(e){e[e.HeaderLength=13]="HeaderLength",e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",e[e.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class d{constructor(e,t,n,r){this.type=e,this.id=t,this.ack=n,this.data=r,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends i.Disposable{constructor(e){super(),this._onMessage=this._register(new n.Emitter),
this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,this._isDisposed=!1,this._incomingData=new u,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,n=this._state.id,r=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new d(t,n,r,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}
class p{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){this.flush(),this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=s.VSBuffer.alloc(13);t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){const n=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,n}_bufferTake(){const e=s.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&o.setImmediate(()=>{this._writeNow()})}_writeNow(){0!==this._totalLength&&this._socket.write(this._bufferTake())}}class m extends i.Disposable{constructor(e){super(),this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onClose=new n.Emitter,
this.onClose=this._onClose.event,this._socket=e,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onClose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(e){this._socketWriter.write(new d(1,0,0,e))}}t.Protocol=m;class g extends r.IPCClient{constructor(e,t,n=null){super(e,t,n),this.protocol=e}static fromSocket(e,t){return new g(new m(e),t)}get onClose(){return this.protocol.onClose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=g;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,a.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{
this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=v;class y{constructor(e){this.data=e,this.next=null}}class b{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,n=this._first;for(;n;)e[t++]=n.data,n=n.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new y(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}class w{constructor(){this.lastRuns=[];const e=Date.now()
;for(let t=0;t<w._HISTORY_LENGTH;t++)this.lastRuns[t]=e-1e3*t;setInterval(()=>{for(let e=w._HISTORY_LENGTH;e>=1;e--)this.lastRuns[e]=this.lastRuns[e-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return w._INSTANCE||(w._INSTANCE=new w),w._INSTANCE}load(){const e=Date.now(),t=1e3*(1+w._HISTORY_LENGTH);let n=0;for(let r=0;r<w._HISTORY_LENGTH;r++)e-this.lastRuns[r]<=t&&n++;return 1-n/w._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}w._HISTORY_LENGTH=10,w._INSTANCE=null;t.PersistentProtocol=class{constructor(e,t=null){this._loadEstimator=w.getInstance(),this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,this.onMessage=this._onMessage.event,this._onClose=new v,this.onClose=this._onClose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new b,this._outgoingMsgId=0,this._outgoingAckId=0,
this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._socketDisposables=[],this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),
this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=i.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const e=new d(5,0,0,l());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new d(4,0,0,l());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{
this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-e,0)+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=i.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._socket=e,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray();for(let t=0,n=e.length;t<n;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onClose.fire()}
_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}1===e.type?e.id>this._incomingMsgId&&(e.id!==this._incomingMsgId+1&&console.error(`PROTOCOL CORRUPTION, LAST SAW MSG ${this._incomingMsgId} AND HAVE NOW RECEIVED MSG ${e.id}`),this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)):2===e.type?this._onControlMessage.fire(e.data):5===e.type&&this._onClose.fire()}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const n=new d(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(n),this._isReconnecting||(this._socketWriter.write(n),this._recvAckCheck())}sendControl(e){const t=new d(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return
;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=2e4&&!this._loadEstimator.hasHighLoad()?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-t,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new d(3,0,this._incomingAckId,l());this._socketWriter.write(e)}}})),define(t[40],n([0,1,60,78,6,36,2,25,21,3,19,80,15,5]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.connect=t.serve=t.Server=t.createStaticIPCHandle=t.createRandomIPCHandle=t.XDG_RUNTIME_DIR=t.WebSocketNodeSocket=t.NodeSocket=void 0;class p{constructor(e){this.socket=e}dispose(){this.socket.destroy()}onData(e){const t=t=>e(u.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){return this.socket.on("close",e),{dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){if(!this.socket.destroyed)try{this.socket.write(e.buffer)}catch(e){if("EPIPE"===e.code)return;d.onUnexpectedError(e)}}end(){this.socket.end()}drain(){return new Promise((e,t)=>{if(0===this.socket.bufferSize)return void e();const n=()=>{this.socket.off("close",n),this.socket.off("end",n),this.socket.off("error",n),this.socket.off("timeout",n),this.socket.off("drain",n),e()};this.socket.on("close",n),this.socket.on("end",n),this.socket.on("error",n),this.socket.on("timeout",n),this.socket.on("drain",n)})}}var m,g;t.NodeSocket=p,
function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(m||(m={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",e[e.Fin=4]="Fin"}(g||(g={}));class v extends l.Disposable{constructor(e){super(),this._onData=this._register(new i.Emitter),this._state={state:1,readLen:2,mask:0},this.socket=e,this._incomingData=new h.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e)))}dispose(){this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this.socket.onClose(e)}onEnd(e){return this.socket.onEnd(e)}write(e){let t=2;e.byteLength<126?t+=0:e.byteLength<65536?t+=2:t+=8;const n=u.VSBuffer.alloc(t);if(n.writeUInt8(130,0),e.byteLength<126)n.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){n.writeUInt8(126,1);let t=1;n.writeUInt8(e.byteLength>>>8&255,++t),n.writeUInt8(e.byteLength>>>0&255,++t)}else{n.writeUInt8(127,1);let t=1;n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(0,++t),n.writeUInt8(0,++t),
n.writeUInt8(e.byteLength>>>24&255,++t),n.writeUInt8(e.byteLength>>>16&255,++t),n.writeUInt8(e.byteLength>>>8&255,++t),n.writeUInt8(e.byteLength>>>0&255,++t)}this.socket.write(u.VSBuffer.concat([n,e]))}end(){this.socket.end()}_acceptChunk(e){if(0!==e.byteLength)for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen).readUInt8(1),t=(128&e)>>>7,n=127&e;this._state.state=2,this._state.readLen=2+(t?4:0)+(126===n?2:0)+(127===n?8:0),this._state.mask=0}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),n=(128&t)>>>7;let r=127&t,i=1;126===r?r=256*e.readUInt8(++i)+e.readUInt8(++i):127===r&&(r=0*e.readUInt8(++i)+0*e.readUInt8(++i)+0*e.readUInt8(++i)+0*e.readUInt8(++i)+e.readUInt8(++i)*2**24+65536*e.readUInt8(++i)+256*e.readUInt8(++i)+e.readUInt8(++i));let s=0;n&&(s=e.readUInt8(++i)*2**24+65536*e.readUInt8(++i)+256*e.readUInt8(++i)+e.readUInt8(++i)),
this._state.state=3,this._state.readLen=r,this._state.mask=s}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);y(e,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._onData.fire(e)}}drain(){return this.socket.drain()}}function y(e,t){if(0===t)return;let n=e.byteLength>>>2;for(let r=0;r<n;r++){const n=e.readUInt32BE(4*r);e.writeUInt32BE(n^t,4*r)}let r=4*n,i=e.byteLength-r;const s=t>>>24&255,o=t>>>16&255,a=t>>>8&255;i>=1&&e.writeUInt8(e.readUInt8(r)^s,r),i>=2&&e.writeUInt8(e.readUInt8(r+1)^o,r+1),i>=3&&e.writeUInt8(e.readUInt8(r+2)^a,r+2)}t.WebSocketNodeSocket=v,t.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const b={2:107,1:103};function w(e){const t=b[f.platform];"number"==typeof t&&e.length>=t&&console.warn(`WARNING: IPC handle "${e}" is longer than ${t} chars, try a shorter --user-data-dir`)}t.createRandomIPCHandle=function(){const e=c.generateUuid();if("win32"===process.platform)return`\\\\.\\pipe\\vscode-ipc-${e}-sock`;let n
;return w(n=t.XDG_RUNTIME_DIR?o.join(t.XDG_RUNTIME_DIR,`vscode-ipc-${e}.sock`):o.join(a.tmpdir(),`vscode-ipc-${e}.sock`)),n},t.createStaticIPCHandle=function(e,r,i){const s=n.createHash("md5").update(e).digest("hex");if("win32"===process.platform)return`\\\\.\\pipe\\${s}-${i}-${r}-sock`;let a;return w(a=t.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o.join(t.XDG_RUNTIME_DIR,`vscode-${s.substr(0,8)}-${i}-${r}.sock`):o.join(e,`${i}-${r}.sock`)),a};class _ extends s.IPCServer{constructor(e){super(_.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){const t=i.Event.fromNodeEventEmitter(e,"connection");return i.Event.map(t,e=>({protocol:new h.Protocol(new p(e)),onDidClientDisconnect:i.Event.once(i.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=_,t.serve=function(e){return new Promise((t,n)=>{const i=r.createServer();i.on("error",n),i.listen(e,()=>{i.removeListener("error",n),t(new _(i))})})},
t.connect=function(e,t){return new Promise((n,i)=>{const s=r.createConnection(e,()=>{s.removeListener("error",i),n(h.Client.fromSocket(new p(s),t))});s.once("error",i)})}})),define(t[125],n([0,1,33,21,5]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getShellEnvironment=void 0;let s=void 0;t.getShellEnvironment=function(e,t){return s||(t.args["disable-user-env-probe"]?(e.trace("getShellEnvironment: disable-user-env-probe set, skipping"),s=Promise.resolve({})):i.isWindows?(e.trace("getShellEnvironment: running on Windows, skipping"),s=Promise.resolve({})):"1"===process.env.VSCODE_CLI&&"1"!==process.env.VSCODE_FORCE_USER_ENV?(e.trace("getShellEnvironment: running on CLI, skipping"),s=Promise.resolve({})):(e.trace("getShellEnvironment: running on Unix"),s=function(e){return new Promise((t,i)=>{const s=process.env.ELECTRON_RUN_AS_NODE;e.trace("getUnixShellEnvironment#runAsNode",s);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;e.trace("getUnixShellEnvironment#noAttach",o)
;const a=r.generateUuid().replace(/-/g,"").substr(0,12),c=new RegExp(a+"(.*)"+a),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),u=`'${process.execPath}' -p '"${a}" + JSON.stringify(process.env) + "${a}"'`;e.trace("getUnixShellEnvironment#env",l),e.trace("getUnixShellEnvironment#spawn",u);const h=n.spawn(process.env.SHELL,["-ilc",u],{detached:!0,stdio:["ignore","pipe",process.stderr],env:l}),d=[];h.on("error",()=>t({})),h.stdout.on("data",e=>d.push(e)),h.on("close",n=>{if(0!==n)return i(new Error("Failed to get environment"));const r=Buffer.concat(d).toString("utf8");e.trace("getUnixShellEnvironment#raw",r);const a=c.exec(r),l=a?a[1]:"{}";try{const n=JSON.parse(l);s?n.ELECTRON_RUN_AS_NODE=s:delete n.ELECTRON_RUN_AS_NODE,o?n.ELECTRON_NO_ATTACH_CONSOLE=o:delete n.ELECTRON_NO_ATTACH_CONSOLE,delete n.XDG_RUNTIME_DIR,e.trace("getUnixShellEnvironment#result",n),t(n)}catch(t){e.error("getUnixShellEnvironment#error",t),i(t)}})}).catch(()=>({}))}(e))),s}})),
define(t[81],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class n{constructor(e,t){this.lineNumber=e,this.column=t}with(e=this.lineNumber,t=this.column){return e===this.lineNumber&&t===this.column?this:new n(e,t)}delta(e=0,t=0){return this.with(this.lineNumber+e,this.column+t)}equals(e){return n.equals(this,e)}static equals(e,t){return!e&&!t||!!e&&!!t&&e.lineNumber===t.lineNumber&&e.column===t.column}isBefore(e){return n.isBefore(this,e)}static isBefore(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<t.column}isBeforeOrEqual(e){return n.isBeforeOrEqual(this,e)}static isBeforeOrEqual(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<=t.column}static compare(e,t){let n=0|e.lineNumber,r=0|t.lineNumber;if(n===r){return(0|e.column)-(0|t.column)}return n-r}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(e){
return new n(e.lineNumber,e.column)}static isIPosition(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column}}t.Position=n})),define(t[61],n([0,1,81]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class r{constructor(e,t,n,r){e>n||e===n&&t>r?(this.startLineNumber=n,this.startColumn=r,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=n,this.endColumn=r)}isEmpty(){return r.isEmpty(this)}static isEmpty(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn}containsPosition(e){return r.containsPosition(this,e)}static containsPosition(e,t){return!(t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber)&&(!(t.lineNumber===e.startLineNumber&&t.column<e.startColumn)&&!(t.lineNumber===e.endLineNumber&&t.column>e.endColumn))}containsRange(e){return r.containsRange(this,e)}static containsRange(e,t){
return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber)&&(!(t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber)&&(!(t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn)&&!(t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn)))}strictContainsRange(e){return r.strictContainsRange(this,e)}static strictContainsRange(e,t){return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber)&&(!(t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber)&&(!(t.startLineNumber===e.startLineNumber&&t.startColumn<=e.startColumn)&&!(t.endLineNumber===e.endLineNumber&&t.endColumn>=e.endColumn)))}plusRange(e){return r.plusRange(this,e)}static plusRange(e,t){let n,i,s,o;return t.startLineNumber<e.startLineNumber?(n=t.startLineNumber,i=t.startColumn):t.startLineNumber===e.startLineNumber?(n=t.startLineNumber,i=Math.min(t.startColumn,e.startColumn)):(n=e.startLineNumber,i=e.startColumn),t.endLineNumber>e.endLineNumber?(s=t.endLineNumber,
o=t.endColumn):t.endLineNumber===e.endLineNumber?(s=t.endLineNumber,o=Math.max(t.endColumn,e.endColumn)):(s=e.endLineNumber,o=e.endColumn),new r(n,i,s,o)}intersectRanges(e){return r.intersectRanges(this,e)}static intersectRanges(e,t){let n=e.startLineNumber,i=e.startColumn,s=e.endLineNumber,o=e.endColumn,a=t.startLineNumber,c=t.startColumn,l=t.endLineNumber,u=t.endColumn;return n<a?(n=a,i=c):n===a&&(i=Math.max(i,c)),s>l?(s=l,o=u):s===l&&(o=Math.min(o,u)),n>s?null:n===s&&i>o?null:new r(n,i,s,o)}equalsRange(e){return r.equalsRange(this,e)}static equalsRange(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(e){return new n.Position(e.endLineNumber,e.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(e){return new n.Position(e.startLineNumber,e.startColumn)}toString(){
return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(e,t){return new r(this.startLineNumber,this.startColumn,e,t)}setStartPosition(e,t){return new r(e,t,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(e){return new r(e.startLineNumber,e.startColumn,e.startLineNumber,e.startColumn)}static fromPositions(e,t=e){return new r(e.lineNumber,e.column,t.lineNumber,t.column)}static lift(e){return e?new r(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null}static isIRange(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn}static areIntersectingOrTouching(e,t){return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn)&&!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn)}static areIntersecting(e,t){
return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<=t.startColumn)&&!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<=e.startColumn)}static compareRangesUsingStarts(e,t){if(e&&t){const n=0|e.startLineNumber,r=0|t.startLineNumber;if(n===r){const n=0|e.startColumn,r=0|t.startColumn;if(n===r){const n=0|e.endLineNumber,r=0|t.endLineNumber;if(n===r){return(0|e.endColumn)-(0|t.endColumn)}return n-r}return n-r}return n-r}return(e?1:0)-(t?1:0)}static compareRangesUsingEnds(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber}static spansMultipleLines(e){return e.endLineNumber>e.startLineNumber}}t.Range=r})),define(t[126],n([0,1,39,2]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.score=void 0,t.score=function e(t,i,s,o){
if(Array.isArray(t)){let n=0;for(const r of t){const t=e(r,i,s,o);if(10===t)return t;t>n&&(n=t)}return n}if("string"==typeof t)return o?"*"===t?5:t===s?10:0:0;if(t){const{language:e,pattern:a,scheme:c,hasAccessToAllModels:l}=t;if(!o&&!l)return 0;let u=0;if(c)if(c===i.scheme)u=10;else{if("*"!==c)return 0;u=5}if(e)if(e===s)u=10;else{if("*"!==e)return 0;u=Math.max(u,5)}if(a){let e;if((e="string"==typeof a?a:Object.assign(Object.assign({},a),{base:r.normalize(a.base)}))!==i.fsPath&&!n.match(e,i.fsPath))return 0;u=10}return u}return 0}})),define(t[127],n([0,1,6,3]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistryImpl=void 0;t.TokenizationRegistryImpl=class{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(e){this._onDidChange.fire({changedLanguages:e,changedColorMap:!1})}register(e,t){return this._map.set(e,t),this.fire([e]),r.toDisposable(()=>{
this._map.get(e)===t&&(this._map.delete(e),this.fire([e]))})}registerPromise(e,t){let n=null,i=!1;return this._promises.set(e,t.then(t=>{this._promises.delete(e),!i&&t&&(n=this.register(e,t))})),r.toDisposable(()=>{i=!0,n&&n.dispose()})}getPromise(e){const t=this.get(e);if(t)return Promise.resolve(t);const n=this._promises.get(e);return n?n.then(t=>this.get(e)):null}get(e){return this._map.get(e)||null}setColorMap(e){this._colorMap=e,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}})),define(t[128],n([10,9]),(function(e,t){return e.create("vs/base/common/actions",t)})),define(t[129],n([0,1,128,3,6]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.RadioGroup=t.ActionRunner=t.Action=void 0;class s extends r.Disposable{constructor(e,t="",n="",r=!0,s){
super(),this._onDidChange=this._register(new i.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._checked=!1,this._id=e,this._label=t,this._cssClass=n,this._enabled=r,this._actionCallback=s}get id(){return this._id}get label(){return this._label}set label(e){this._setLabel(e)}_setLabel(e){this._label!==e&&(this._label=e,this._onDidChange.fire({label:e}))}get tooltip(){return this._tooltip||""}set tooltip(e){this._setTooltip(e)}_setTooltip(e){this._tooltip!==e&&(this._tooltip=e,this._onDidChange.fire({tooltip:e}))}get class(){return this._cssClass}set class(e){this._setClass(e)}_setClass(e){this._cssClass!==e&&(this._cssClass=e,this._onDidChange.fire({class:e}))}get enabled(){return this._enabled}set enabled(e){this._setEnabled(e)}_setEnabled(e){this._enabled!==e&&(this._enabled=e,this._onDidChange.fire({enabled:e}))}get checked(){return this._checked}set checked(e){this._setChecked(e)}_setChecked(e){this._checked!==e&&(this._checked=e,this._onDidChange.fire({checked:e}))}run(e,t){
return this._actionCallback?this._actionCallback(e):Promise.resolve(!0)}}t.Action=s;class o extends r.Disposable{constructor(){super(...arguments),this._onDidBeforeRun=this._register(new i.Emitter),this.onDidBeforeRun=this._onDidBeforeRun.event,this._onDidRun=this._register(new i.Emitter),this.onDidRun=this._onDidRun.event}async run(e,t){if(!e.enabled)return Promise.resolve(null);this._onDidBeforeRun.fire({action:e});try{const n=await this.runAction(e,t);this._onDidRun.fire({action:e,result:n})}catch(t){this._onDidRun.fire({action:e,error:t})}}runAction(e,t){const n=t?e.run(t):e.run();return Promise.resolve(n)}}t.ActionRunner=o;class a extends r.Disposable{constructor(e){super(),this.actions=e;for(const t of e)this._register(t.onDidChange(n=>{if(n.checked&&t.checked)for(const n of e)n!==t&&(n.checked=!1)}))}}t.RadioGroup=a;class c extends s{constructor(e){super(c.ID,e,e?"separator text":"separator"),this.checked=!1,this.enabled=!1}}t.Separator=c,c.ID="vs.actions.separator";t.SubmenuAction=class extends s{
constructor(e,t,n,r){super(e,t,r,!0),this._actions=n}get actions(){return this._actions}};class l extends s{constructor(){super(l.ID,n.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=l,l.ID="vs.actions.empty"})),define(t[130],n([10,9]),(function(e,t){return e.create("vs/base/common/date",t)})),define(t[131],n([0,1,130]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const r=60,i=60*r,s=24*i,o=7*s,a=30*s,c=365*s;t.fromNow=function e(t,l){"number"!=typeof t&&(t=t.getTime());const u=Math.round(((new Date).getTime()-t)/1e3);if(u<-30)return n.localize(0,null,e((new Date).getTime()+1e3*u,!1));if(u<30)return n.localize(1,null);let h;return u<r?(h=u,l?1===h?n.localize(2,null,h):n.localize(3,null,h):1===h?n.localize(4,null,h):n.localize(5,null,h)):u<i?(h=Math.floor(u/r),l?1===h?n.localize(6,null,h):n.localize(7,null,h):1===h?n.localize(8,null,h):n.localize(9,null,h)):u<s?(h=Math.floor(u/i),
l?1===h?n.localize(10,null,h):n.localize(11,null,h):1===h?n.localize(12,null,h):n.localize(13,null,h)):u<o?(h=Math.floor(u/s),l?1===h?n.localize(14,null,h):n.localize(15,null,h):1===h?n.localize(16,null,h):n.localize(17,null,h)):u<a?(h=Math.floor(u/o),l?1===h?n.localize(18,null,h):n.localize(19,null,h):1===h?n.localize(20,null,h):n.localize(21,null,h)):u<c?(h=Math.floor(u/a),l?1===h?n.localize(22,null,h):n.localize(23,null,h):1===h?n.localize(24,null,h):n.localize(25,null,h)):(h=Math.floor(u/c),l?1===h?n.localize(26,null,h):n.localize(27,null,h):1===h?n.localize(28,null,h):n.localize(29,null,h))},t.toLocalISOString=function(e){return e.getFullYear()+"-"+String(e.getMonth()+1).padStart(2,"0")+"-"+String(e.getDate()).padStart(2,"0")+"T"+String(e.getHours()).padStart(2,"0")+":"+String(e.getMinutes()).padStart(2,"0")+":"+String(e.getSeconds()).padStart(2,"0")+"."+(e.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}})),define(t[132],n([10,9]),(function(e,t){return e.create("vs/base/common/errorMessage",t)})),
define(t[49],n([0,1,132,11,16]),(function(e,t,n,r,i){"use strict";function s(e,t){return t&&(e.stack||e.stacktrace)?n.localize(0,null,a(e),o(e.stack)||o(e.stacktrace)):a(e)}function o(e){return Array.isArray(e)?e.join("\n"):e}function a(e){return"string"==typeof e.code&&"number"==typeof e.errno&&"string"==typeof e.syscall?n.localize(1,null,e.message):e.message||n.localize(2,null)}Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0,t.toErrorMessage=function e(t=null,o=!1){if(!t)return n.localize(3,null);if(Array.isArray(t)){const r=i.coalesce(t),s=e(r[0],o);return r.length>1?n.localize(4,null,s,r.length):s}if(r.isString(t))return t;if(t.detail){const e=t.detail;if(e.error)return s(e.error,o);if(e.exception)return s(e.exception,o)}return t.stack?s(t,o):t.message?t.message:n.localize(5,null)}})),define(t[133],n([10,9]),(function(e,t){return e.create("vs/base/common/jsonErrorMessages",t)})),define(t[134],n([0,1,133]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0
}),t.getParseErrorMessage=void 0,t.getParseErrorMessage=function(e){switch(e){case 1:return n.localize(0,null);case 2:return n.localize(1,null);case 3:return n.localize(2,null);case 4:return n.localize(3,null);case 5:return n.localize(4,null);case 6:return n.localize(5,null);case 7:return n.localize(6,null);case 8:return n.localize(7,null);case 9:return n.localize(8,null);default:return""}}})),define(t[135],n([10,9]),(function(e,t){return e.create("vs/base/node/processes",t)})),define(t[82],n([0,1,2,20,48,33,135,11,18,30,5,76,8]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d){"use strict";function f(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(e=process.env){return e.comspec||"cmd.exe"}Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=p;class m{constructor(e,t,n,r){if(void 0!==t&&void 0!==n&&void 0!==r)this.cmd=e,this.args=t,this.shell=n,
this.options=r;else{const t=e;this.cmd=t.command,this.shell=t.isShellCommand,this.args=t.args.slice(0),this.options=t.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const e=Object.create(null);Object.keys(process.env).forEach(t=>{e[t]=process.env[t]}),Object.keys(this.options.env).forEach(t=>{e[t]=this.options.env[t]}),this.options.env=e}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const t=e.lastIndexOf(n.sep);return-1!==t&&(e=e.substring(t+1)),m.WellKnowCommands[e]?e:"other"}start(e){return u.isWindows&&(this.options&&this.options.cwd&&l.isUNC(this.options.cwd)||!this.options&&l.isUNC(process.cwd()))?Promise.reject(new Error(o.localize(0,null))):this.useExec().then(t=>{let n,r;const i=new Promise((e,t)=>{n=e,r=t});if(t){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=s.exec(t,this.options,(t,i,s)=>{this.childProcess=null;t&&t.killed?r({killed:this.terminateRequested,stdout:i.toString(),stderr:s.toString()
}):this.handleExec(n,e,t,i,s)})}else{let t=null;const i=t=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(t,n,e,r);const i={terminated:this.terminateRequested};a.isNumber(t)&&(i.cmdCode=t),n(i)};if(this.shell&&u.isWindows){const e=c.deepClone(this.options);e.windowsVerbatimArguments=!0,e.detached=!1;let n=!1,r=!1;const i=[];let o=this.ensureQuotes(this.cmd);i.push(o.value),n=o.quoted,this.args&&this.args.forEach(e=>{o=this.ensureQuotes(e),i.push(o.value),r=r&&o.quoted});const a=["/s","/c"];n?r?a.push('"'+i.join(" ")+'"'):i.length>1?a.push('"'+i[0]+'" '+i.slice(1).join(" ")):a.push('"'+i[0]+'"'):a.push(i.join(" ")),t=s.spawn(p(),a,e)}else this.cmd&&(t=s.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(a.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",e=>{this.childProcess=null,r({terminated:this.terminateRequested,error:e})}),t.pid&&(this.childProcess.on("close",i),
this.handleSpawn(t,n,e,r,!0)))}return i})}handleClose(e,t,n,r){}ensureQuotes(e){return m.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&'"'===e[0]&&'"'===e[e.length-1]}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,function(t,n){if(u.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};n&&(e.cwd=n);const r=s.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise((e,t)=>{r.once("error",t=>{e({success:!1,error:t})}),r.once("exit",(t,n)=>{e(0===t?{success:!0}:{success:!1,code:null!==t?t:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?f(e.status):1})}else if(u.isLinux||u.isMacintosh)try{const n=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",e).fsPath;return new Promise((e,r)=>{s.execFile(n,[t.pid.toString()],{encoding:"utf8",shell:!0},(t,n,r)=>{
e(t?{success:!1,error:t}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}(t,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(e=>{if(!this.shell||!u.isWindows)return e(!1);const t=s.spawn(p(),["/s","/c"]);t.on("error",t=>e(!0)),t.on("exit",t=>e(!1))})}}t.AbstractProcess=m,m.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},m.regexp=/^[^"].* .*[^"]/;t.LineProcess=class extends m{constructor(e,t,n,r){super(e,t,n,r),this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,t,n,r,i){[r,i].forEach((e,n)=>{const r=new h.LineDecoder;r.write(e).forEach(e=>{t({line:e,source:0===n?0:1})});const i=r.end();i&&t({line:i,source:0===n?0:1})}),e({terminated:this.terminateRequested,error:n})}
handleSpawn(e,t,n,r,i){const s=new h.LineDecoder,o=new h.LineDecoder;e.stdout.on("data",e=>{s.write(e).forEach(e=>n({line:e,source:0}))}),e.stderr.on("data",e=>{o.write(e).forEach(e=>n({line:e,source:1}))}),this.stdoutLineDecoder=s,this.stderrLineDecoder=o}handleClose(e,t,n,r){const i=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;i&&n({line:i,source:0});const s=this.stderrLineDecoder?this.stderrLineDecoder.end():null;s&&n({line:s,source:1})}},t.createQueuedSender=function(e){let t=[],n=!1;const r=function(i){if(n)return void t.push(i);e.send(i,e=>{if(e&&console.error(e),n=!1,t.length>0){const e=t.slice(0);t=[],e.forEach(e=>r(e))}})&&!u.isWindows||(n=!0)};return{send:r}},function(e){e.findExecutable=async function(e,t,s){if(n.isAbsolute(e))return e;if(void 0===t&&(t=process.cwd()),"."!==n.dirname(e))return n.join(t,e);if(void 0===s&&a.isString(process.env.PATH)&&(s=process.env.PATH.split(n.delimiter)),void 0===s||0===s.length)return n.join(t,e);async function o(e){
return!!await i.promisify(r.exists)(e)&&!(await i.promisify(r.stat)(e)).isDirectory()}for(let r of s){let i;if(i=n.isAbsolute(r)?n.join(r,e):n.join(t,r,e),await o(i))return i;let s=i+".com";if(await o(s))return s;if(s=i+".exe",await o(s))return s}return n.join(t,e)}}(t.win32||(t.win32={}))})),define(t[83],n([0,1,33,3,17,18,6,82,36,115,28,15,19,5]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class p extends c.ChannelServer{constructor(e){super({send:e=>{try{process.send&&process.send(e.buffer.toString("base64"))}catch(e){}},onMessage:o.Event.fromNodeEventEmitter(process,"message",e=>d.VSBuffer.wrap(Buffer.from(e,"base64")))},e),process.once("disconnect",()=>this.dispose())}}t.Server=p;t.Client=class{constructor(e,t){this.modulePath=e,this.options=t,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new o.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const n=t&&t.timeout?t.timeout:6e4
;this.disposeDelayer=new i.Delayer(n),this.child=null,this._client=null}getChannel(e){const t=this;return{call:(n,r,i)=>t.requestPromise(e,n,r,i),listen:(n,r)=>t.requestEvent(e,n,r)}}requestPromise(e,t,n,s=u.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(h.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(e),a=i.createCancelablePromise(e=>o.call(t,n,e)),c=s.onCancellationRequested(()=>a.cancel()),l=r.toDisposable(()=>a.cancel());return this.activeRequests.add(l),a.finally(()=>{c.dispose(),this.activeRequests.delete(l),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(e,t,n){if(!this.disposeDelayer)return o.Event.None;let r;this.disposeDelayer.cancel();const i=new o.Emitter({onFirstListenerAdd:()=>{const s=this.getCachedChannel(e).listen(t,n);r=s(i.fire,i),this.activeRequests.add(r)},onLastListenerRemove:()=>{
this.activeRequests.delete(r),r.dispose(),0===this.activeRequests.size&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return i.event}get client(){if(!this._client){const e=this.options&&this.options.args?this.options.args:[],t=Object.create(null);t.env=Object.assign(Object.assign({},s.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(t.env=Object.assign(Object.assign({},t.env),this.options.env)),this.options&&this.options.freshExecArgv&&(t.execArgv=[]),this.options&&"number"==typeof this.options.debug&&(t.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&"number"==typeof this.options.debugBrk&&(t.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),f.isMacintosh&&t.env&&delete t.env.DYLD_LIBRARY_PATH,this.child=n.fork(this.modulePath,e,t);const i=new o.Emitter;o.Event.fromNodeEventEmitter(this.child,"message",e=>e)(e=>{
l.isRemoteConsoleLog(e)?l.log(e,`IPC Library: ${this.options.serverName}`):i.fire(d.VSBuffer.wrap(Buffer.from(e,"base64")))});const u=this.options.useQueue?a.createQueuedSender(this.child):this.child,h={send:e=>this.child&&this.child.connected&&u.send(e.buffer.toString("base64")),onMessage:i.event};this._client=new c.ChannelClient(h);const p=()=>this.disposeClient();process.once("exit",p),this.child.on("error",e=>console.warn('IPC "'+this.options.serverName+'" errored with '+e)),this.child.on("exit",(e,t)=>{process.removeListener("exit",p),this.activeRequests.forEach(e=>r.dispose(e)),this.activeRequests.clear(),0!==e&&"SIGTERM"!==t&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+e+" and signal "+t),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:e,signal:t})})}return this._client}getCachedChannel(e){let t=this.channels.get(e);return t||(t=this.client.getChannel(e),this.channels.set(e,t)),t}disposeClient(){
this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}})),define(t[136],n([10,9]),(function(e,t){return e.create("vs/base/node/zip",t)})),define(t[137],n([10,9]),(function(e,t){return e.create("vs/code/node/cliProcessMain",t)})),define(t[138],n([10,9]),(function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)})),define(t[139],n([10,9]),(function(e,t){return e.create("vs/platform/environment/node/argv",t)})),define(t[140],n([10,9]),(function(e,t){return e.create("vs/platform/extensionManagement/common/extensionManagement",t)})),define(t[141],n([10,9]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionManagementService",t)})),define(t[142],n([10,9]),(function(e,t){
return e.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)})),define(t[143],n([10,9]),(function(e,t){return e.create("vs/platform/extensionManagement/node/extensionsScanner",t)})),define(t[144],n([10,9]),(function(e,t){return e.create("vs/platform/extensions/common/extensionValidator",t)})),define(t[145],n([10,9]),(function(e,t){return e.create("vs/platform/files/common/fileService",t)})),define(t[146],n([10,9]),(function(e,t){return e.create("vs/platform/files/common/files",t)})),define(t[147],n([10,9]),(function(e,t){return e.create("vs/platform/files/common/io",t)})),define(t[148],n([10,9]),(function(e,t){return e.create("vs/platform/files/node/diskFileSystemProvider",t)})),define(t[149],n([10,9]),(function(e,t){return e.create("vs/platform/markers/common/markers",t)})),define(t[150],n([10,9]),(function(e,t){return e.create("vs/platform/request/common/request",t)})),define(t[151],n([10,9]),(function(e,t){return e.create("vs/platform/telemetry/common/telemetryService",t)})),
define(t[152],n([10,9]),(function(e,t){return e.create("vs/platform/workspaces/common/workspaces",t)})),define(t[153],n([10,9]),(function(e,t){return e.create("vs/server/remoteAgentEnvironmentImpl",t)})),define(t[154],n([10,9]),(function(e,t){return e.create("vs/workbench/common/editor",t)})),define(t[155],n([10,9]),(function(e,t){return e.create("vs/workbench/contrib/terminal/common/terminal",t)})),define(t[156],n([10,9]),(function(e,t){return e.create("vs/workbench/contrib/terminal/node/terminalProcess",t)})),define(t[157],n([10,9]),(function(e,t){return e.create("vs/workbench/services/configurationResolver/common/variableResolver",t)})),define(t[158],n([10,9]),(function(e,t){return e.create("vs/workbench/services/extensions/node/extensionPoints",t)})),define(t[159],n([0,1,6,3]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostDebugChannelClient=t.ExtensionHostDebugBroadcastChannel=void 0;class i{constructor(){this._onCloseEmitter=new n.Emitter,
this._onReloadEmitter=new n.Emitter,this._onTerminateEmitter=new n.Emitter,this._onLogToEmitter=new n.Emitter,this._onAttachEmitter=new n.Emitter}call(e,t,n){switch(t){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:n[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:n[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:n[0]}));case"log":return Promise.resolve(this._onLogToEmitter.fire({sessionId:n[0],log:n[1]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:n[0],port:n[1],subId:n[2]}))}throw new Error("Method not implemented.")}listen(e,t,n){switch(t){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"log":return this._onLogToEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}t.ExtensionHostDebugBroadcastChannel=i,
i.ChannelName="extensionhostdebugservice";class s extends r.Disposable{constructor(e){super(),this.channel=e}reload(e){this.channel.call("reload",[e])}get onReload(){return this.channel.listen("reload")}close(e){this.channel.call("close",[e])}get onClose(){return this.channel.listen("close")}attachSession(e,t,n){this.channel.call("attach",[e,t,n])}get onAttachSession(){return this.channel.listen("attach")}logToSession(e,t){this.channel.call("log",[e,t])}get onLogToSession(){return this.channel.listen("log")}terminateSession(e,t){this.channel.call("terminate",[e,t])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(e,t,n){return this.channel.call("openExtensionDevelopmentHostWindow",[e,t,n])}}t.ExtensionHostDebugChannelClient=s})),define(t[160],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isRemoteDiagnosticError=void 0,t.isRemoteDiagnosticError=function(e){return!!e.hostName&&!!e.errorMessage}})),
define(t[161],n([0,1,4]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadServiceChannelClient=t.DownloadServiceChannel=void 0;t.DownloadServiceChannel=class{constructor(e){this.service=e}listen(e,t,n){throw new Error("Invalid listen")}call(e,t,r){switch(t){case"download":return this.service.download(n.URI.revive(r[0]),n.URI.revive(r[1]))}throw new Error("Invalid call")}};t.DownloadServiceChannelClient=class{constructor(e,t){this.channel=e,this.getUriTransformer=t}async download(e,t){const n=this.getUriTransformer();n&&(e=n.transformOutgoingURI(e),t=n.transformOutgoingURI(t)),await this.channel.call("download",[e,t])}}})),define(t[162],n([0,1,224,139,5]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildVersionMessage=t.buildHelpMessage=t.formatOptions=t.parseArgs=t.OPTIONS=void 0;const s={o:r.localize(0,null),e:r.localize(1,null),t:r.localize(2,null)};t.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],
description:r.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:r.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:r.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:r.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:r.localize(7,null)},"folder-uri":{type:"string[]",cat:"o",args:"uri",description:r.localize(8,null)},"file-uri":{type:"string[]",cat:"o",args:"uri",description:r.localize(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:r.localize(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:r.localize(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:r.localize(12,null)},help:{type:"boolean",cat:"o",alias:"h",description:r.localize(13,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:r.localize(14,null)},"extensions-download-dir":{
type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:r.localize(15,null)},"show-versions":{type:"boolean",cat:"e",description:r.localize(16,null)},category:{type:"string",cat:"e",description:r.localize(17,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:r.localize(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:r.localize(19,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:r.localize(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:r.localize(21,null)},verbose:{type:"boolean",cat:"t",description:r.localize(22,null)},log:{type:"string",cat:"t",args:"level",description:r.localize(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:r.localize(24,null)},"prof-startup":{type:"boolean",cat:"t",description:r.localize(25,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"
},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:r.localize(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:r.localize(27,null)},sync:{type:"string",cat:"t",description:r.localize(28,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:r.localize(29,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:r.localize(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:r.localize(31,null)},"max-memory":{type:"string",cat:"t",description:r.localize(32,null)},telemetry:{type:"boolean",cat:"t",description:r.localize(33,null)},remote:{type:"string"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{
type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"disable-user-env-probe":{type:"boolean"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},
"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const o={onUnknownOption:()=>{},onMultipleValues:()=>{}};function a(e,t){let n="";return t.args&&(n=Array.isArray(t.args)?` <${t.args.join("> <")}>`:` <${t.args}>`),t.alias?`-${t.alias} --${e}${n}`:`--${e}${n}`}function c(e,t){let n=0,r=[];for(const t in e){const i=e[t],s=a(t,i);n=Math.max(n,s.length),r.push([s,i.description])}let i=n+2+1;if(t-i<25)return r.reduce((e,t)=>e.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let s=t-i-1,o=[];for(const e of r){let t=e[0],n=u(e[1],s),r=l(i-t.length-2);o.push("  "+t+r+n[0]);for(let e=1;e<n.length;e++)o.push(l(i)+n[e])}return o}function l(e){
return" ".repeat(e)}function u(e,t){let n=[];for(;e.length;){let r=e.length<t?e.length:e.lastIndexOf(" ",t),i=e.slice(0,r).trim();e=e.slice(r),n.push(i)}return n}t.parseArgs=function(e,t,r=o){const i={},s=[],a=[];for(let e in t){if("_"===e[0])continue;const n=t[e];n.alias&&(i[e]=n.alias),"string"===n.type||"string[]"===n.type?(s.push(e),n.deprecates&&s.push(n.deprecates)):"boolean"===n.type&&(a.push(e),n.deprecates&&a.push(n.deprecates))}const c=n(e,{string:s,boolean:a,alias:i}),l={},u=c;l._=c._.map(e=>String(e)).filter(e=>e.length>0),delete u._;for(let e in t){const n=t[e];n.alias&&delete u[n.alias];let i=u[e];n.deprecates&&u.hasOwnProperty(n.deprecates)&&(i||(i=u[n.deprecates]),delete u[n.deprecates]),void 0!==i&&("string[]"===n.type?i&&!Array.isArray(i)&&(i=[i]):"string"===n.type&&Array.isArray(i)&&(i=i.pop(),r.onMultipleValues(e,i)),l[e]=i),delete u[e]}for(let e in u)r.onUnknownOption(e);return l},t.formatOptions=c,t.buildHelpMessage=function(e,t,n,o,a=!0){
const l=process.stdout.isTTY&&process.stdout.columns||80;let u=[`${e} ${n}`];u.push(""),u.push(`${r.localize(34,null)}: ${t} [${r.localize(35,null)}][${r.localize(36,null)}...]`),u.push(""),a&&(i.isWindows?u.push(r.localize(37,null,t)):u.push(r.localize(38,null,t)),u.push(""));const h={};for(const e in o){const t=o[e];if(t.description&&t.cat){let n=h[t.cat];n||(h[t.cat]=n={}),n[e]=t}}for(let e in h){const t=e;let n=h[t];n&&(u.push(s[t]),u.push(...c(n,l)),u.push(""))}return u.join("\n")},t.buildVersionMessage=function(e,t){return`${e||r.localize(39,null)}\n${t||r.localize(40,null)}\n${process.arch}`}})),define(t[163],n([0,1,6,4,59,18]),(function(e,t,n,r,i,s){"use strict";function o(e,t){return r.URI.revive(t?t.transformIncoming(e):e)}function a(e,t){t=t||i.DefaultURITransformer;const n=e.manifest,r=i.transformAndReviveIncomingURIs(Object.assign(Object.assign({},e),{manifest:void 0}),t);return Object.assign(Object.assign({},r),{manifest:n})}function c(e,t){
return t?s.cloneAndChange(e,e=>e instanceof r.URI?t.transformOutgoingURI(e):void 0):e}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionTipsChannel=t.ExtensionManagementChannelClient=t.ExtensionManagementChannel=void 0;t.ExtensionManagementChannel=class{constructor(e,t){this.service=e,this.getUriTransformer=t,this.onInstallExtension=n.Event.buffer(e.onInstallExtension,!0),this.onDidInstallExtension=n.Event.buffer(e.onDidInstallExtension,!0),this.onUninstallExtension=n.Event.buffer(e.onUninstallExtension,!0),this.onDidUninstallExtension=n.Event.buffer(e.onDidUninstallExtension,!0)}listen(e,t){const r=this.getUriTransformer(e);switch(t){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return n.Event.map(this.onDidInstallExtension,e=>Object.assign(Object.assign({},e),{local:e.local?c(e.local,r):e.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}
call(e,t,n){const r=this.getUriTransformer(e);switch(t){case"zip":return this.service.zip(a(n[0],r)).then(e=>(function(e,t){return t?t.transformOutgoingURI(e):e})(e,r));case"unzip":return this.service.unzip(o(n[0],r));case"install":return this.service.install(o(n[0],r));case"getManifest":return this.service.getManifest(o(n[0],r));case"canInstall":return this.service.canInstall(n[0]);case"installFromGallery":return this.service.installFromGallery(n[0],n[1]);case"uninstall":return this.service.uninstall(a(n[0],r),n[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(a(n[0],r));case"getInstalled":return this.service.getInstalled(n[0]).then(e=>e.map(e=>c(e,r)));case"updateMetadata":return this.service.updateMetadata(a(n[0],r),n[1]).then(e=>c(e,r));case"updateExtensionScope":return this.service.updateExtensionScope(a(n[0],r),n[1]).then(e=>c(e,r));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}};t.ExtensionManagementChannelClient=class{
constructor(e){this.channel=e}get onInstallExtension(){return this.channel.listen("onInstallExtension")}get onDidInstallExtension(){return n.Event.map(this.channel.listen("onDidInstallExtension"),e=>Object.assign(Object.assign({},e),{local:e.local?a(e.local,null):e.local}))}get onUninstallExtension(){return this.channel.listen("onUninstallExtension")}get onDidUninstallExtension(){return this.channel.listen("onDidUninstallExtension")}zip(e){return Promise.resolve(this.channel.call("zip",[e]).then(e=>r.URI.revive(e)))}unzip(e){return Promise.resolve(this.channel.call("unzip",[e]))}install(e){return Promise.resolve(this.channel.call("install",[e])).then(e=>a(e,null))}getManifest(e){return Promise.resolve(this.channel.call("getManifest",[e]))}async canInstall(e){return!0}installFromGallery(e,t){return Promise.resolve(this.channel.call("installFromGallery",[e,t])).then(e=>a(e,null))}uninstall(e,t=!1){return Promise.resolve(this.channel.call("uninstall",[e,t]))}reinstallFromGallery(e){
return Promise.resolve(this.channel.call("reinstallFromGallery",[e]))}getInstalled(e=null){return Promise.resolve(this.channel.call("getInstalled",[e])).then(e=>e.map(e=>a(e,null)))}updateMetadata(e,t){return Promise.resolve(this.channel.call("updateMetadata",[e,t])).then(e=>a(e,null))}updateExtensionScope(e,t){return Promise.resolve(this.channel.call("updateExtensionScope",[e,t])).then(e=>a(e,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}};t.ExtensionTipsChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error("Invalid listen")}call(e,t,n){switch(t){case"getConfigBasedTips":return this.service.getConfigBasedTips(r.URI.revive(n[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}})),
define(t[164],n([0,1,18]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const r=/^%([\w\d.-]+)%$/i;t.localizeManifest=function(e,t){return n.cloneAndChange(e,e=>{if("string"!=typeof e)return;const n=r.exec(e);return n?t[n[1]]||e:void 0})}})),define(t[62],n([0,1,144]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isVersionValid=t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const r=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function i(e){return"*"===(e=e.trim())||r.test(e)}function s(e){if(!i(e))return null;if("*"===(e=e.trim()))return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let t=e.match(r);return t?{hasCaret:"^"===t[1],hasGreaterEquals:">="===t[1],majorBase:"x"===t[2]?0:parseInt(t[2],10),majorMustEqual:"x"!==t[2],
minorBase:"x"===t[4]?0:parseInt(t[4],10),minorMustEqual:"x"!==t[4],patchBase:"x"===t[6]?0:parseInt(t[6],10),patchMustEqual:"x"!==t[6],preRelease:t[8]||null}:null}function o(e){if(!e)return null;let t=e.majorBase,n=e.majorMustEqual,r=e.minorBase,i=e.minorMustEqual,s=e.patchBase,o=e.patchMustEqual;return e.hasCaret&&(0===t?o=!1:(i=!1,o=!1)),{majorBase:t,majorMustEqual:n,minorBase:r,minorMustEqual:i,patchBase:s,patchMustEqual:o,isMinimum:e.hasGreaterEquals}}function a(e,t){let n,r;if(n="string"==typeof e?o(s(e)):e,r="string"==typeof t?o(s(t)):t,!n||!r)return!1;let i=n.majorBase,a=n.minorBase,c=n.patchBase,l=r.majorBase,u=r.minorBase,h=r.patchBase,d=r.majorMustEqual,f=r.minorMustEqual,p=r.patchMustEqual;return r.isMinimum?i>l||!(i<l)&&(a>u||!(a<u)&&c>=h):(1!==i||0!==l||d&&f&&p||(l=1,u=0,h=0,d=!0,f=!1,p=!1),!(i<l)&&(i>l?!d:!(a<u)&&(a>u?!f:!(c<h)&&(!(c>h)||!p))))}function c(e,t,r=[]){let i=o(s(t));if(!i)return r.push(n.localize(0,null,t)),!1;if(0===i.majorBase){
if(!i.majorMustEqual||!i.minorMustEqual)return r.push(n.localize(1,null,t)),!1}else if(!i.majorMustEqual)return r.push(n.localize(2,null,t)),!1;return!!a(e,i)||(r.push(n.localize(3,null,e,t)),!1)}t.isValidVersionStr=i,t.parseVersion=s,t.normalizeVersion=o,t.isValidVersion=a,t.isValidExtensionVersion=function(e,t,n){return!(!t.isBuiltin&&void 0!==t.main)||c(e,t.engines.vscode,n)},t.isEngineValid=function(e,t){return"*"===e||c(t,e)},t.isVersionValid=c})),define(t[165],n([0,1,36,83,3,8]),(function(e,t,n,r,i,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class o extends i.Disposable{constructor(e,t,n,r){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=r,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new r.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{
AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=n.createChannelSender(n.getNextTickChannel(t.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.setFolders(this.folders)}setVerboseLogging(e){this.verboseLogging=e,!this.isDisposed&&this.service&&this.service.setVerboseLogging(e)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${e}`})}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){
this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5})),define(t[166],n([0,1,36,83,3,8]),(function(e,t,n,r,i,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class o extends i.Disposable{constructor(e,t,n,r,i={}){super(),this.folders=e,this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=r,this.watcherOptions=i,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const t=this._register(new r.Client(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true"}}));this._register(t.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=o.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,
this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=n.createChannelSender(n.getNextTickChannel(t.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(e=>!this.isDisposed&&this.onDidFilesChange(e))),this._register(this.service.onDidLogMessage(e=>this.onLogMessage(e))),this.service.setRoots(this.folders)}error(e){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${e}`})}setVerboseLogging(e){this.verboseLogging=e,this.service&&this.service.setVerboseLogging(e)}setFolders(e){this.folders=e,this.service&&this.service.setRoots(e)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=o,o.MAX_RESTARTS=5})),define(t[167],n([0,1,33,76,39,8]),(function(e,t,n,r,i,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class o{
constructor(e,t,n,r,s){this.watchedFolder=e,this.eventCallback=n,this.logCallback=r,this.verboseLogging=s,this.restartCounter=0,Array.isArray(t)?this.ignored=t.map(e=>i.parse(e)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${e}`),this.startWatcher()}startWatcher(){const t=[this.watchedFolder];this.verboseLogging&&t.push("-verbose"),this.handle=n.spawn(s.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",e).fsPath,t);const i=new r.LineDecoder;this.handle.stdout.on("data",e=>{const t=[];i.write(e).forEach(e=>{const n=e.split("|");if(2===n.length){const e=Number(n[0]),r=n[1];if(e>=0&&e<3){if(this.ignored&&this.ignored.some(e=>e(r)))return void(this.verboseLogging&&this.log(r));t.push({type:o.changeTypeMap[e],path:r})}else this.log(n[1])}}),t.length>0&&this.eventCallback(t)}),this.handle.on("error",e=>this.onError(e)),this.handle.stderr.on("data",e=>this.onError(e)),this.handle.on("exit",(e,t)=>this.onExit(e,t))}onError(e){this.error("process error: "+e.toString())}
onExit(e,t){this.handle&&(this.error(`terminated unexpectedly (code: ${e}, signal: ${t})`),this.restartCounter<=o.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(e){this.logCallback({type:"error",message:`[File Watcher (C#)] ${e}`})}log(e){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${e}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=o,o.MAX_RESTARTS=5,o.changeTypeMap=[0,1,2]})),define(t[168],n([0,1,167,2,13]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;t.FileWatcher=class{constructor(e,t,n,s){this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=s,this.service=void 0,this.folder=e[0],
0===this.folder.path.indexOf("\\\\")&&this.folder.path.endsWith(r.posix.sep)&&(this.folder.path=i.rtrim(this.folder.path,r.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new n.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,e=>this.onFileEvents(e),e=>this.onLogMessage(e),this.verboseLogging)}setVerboseLogging(e){this.verboseLogging=e,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(e){this.isDisposed||e.length>0&&this.onDidFilesChange(e)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}})),define(t[50],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class n{constructor(e,t=[],n=!1){this.ctor=e,this.staticArguments=t,this.supportsDelayedInstantiation=n}}t.SyncDescriptor=n;t.createSyncDescriptor=(e,...t)=>new n(e,t)})),define(t[169],n([0,1]),(function(e,t){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class n{constructor(e){this.incoming=new Map,this.outgoing=new Map,this.data=e}}t.Node=n;t.Graph=class{constructor(e){this._hashFn=e,this._nodes=new Map}roots(){const e=[];for(let t of this._nodes.values())0===t.outgoing.size&&e.push(t);return e}insertEdge(e,t){const n=this.lookupOrInsertNode(e),r=this.lookupOrInsertNode(t);n.outgoing.set(this._hashFn(t),r),r.incoming.set(this._hashFn(e),n)}removeNode(e){const t=this._hashFn(e);this._nodes.delete(t);for(let e of this._nodes.values())e.outgoing.delete(t),e.incoming.delete(t)}lookupOrInsertNode(e){const t=this._hashFn(e);let r=this._nodes.get(t);return r||(r=new n(e),this._nodes.set(t,r)),r}lookup(e){return this._nodes.get(this._hashFn(e))}isEmpty(){return 0===this._nodes.size}toString(){let e=[];for(let[t,n]of this._nodes)e.push(`${t}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return e.join("\n")}}})),
define(t[7],n([0,1]),(function(e,t){"use strict";var n;function r(e,t,r,i){t[n.DI_TARGET]===t?t[n.DI_DEPENDENCIES].push({id:e,index:r,optional:i}):(t[n.DI_DEPENDENCIES]=[{id:e,index:r,optional:i}],t[n.DI_TARGET]=t)}function i(e){if(n.serviceIds.has(e))return n.serviceIds.get(e);const t=function(e,n,i){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(t,e,i,!1)};return t.toString=()=>e,n.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0}),t.optional=t.createDecorator=t.IInstantiationService=t._util=void 0,function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(n=t._util||(t._util={})),t.IInstantiationService=i("instantiationService"),t.createDecorator=i,t.optional=function(e){return function(t,n,i){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");r(e,t,i,!0)}}})),
define(t[170],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.IModelService=void 0,t.IModelService=n.createDecorator("modelService"),t.shouldSynchronizeModel=function(e){return!e.isTooLargeForSyncing()&&!e.isForSimpleWidget}})),define(t[171],n([0,1,6,114,3,23,112,126,170]),(function(e,t,n,r,i,s,o,a,c){"use strict";function l(e){return"string"!=typeof e&&(Array.isArray(e)?e.every(l):!!e.exclusive)}Object.defineProperty(t,"__esModule",{value:!0}),t.LanguageFeatureRequestDelays=t.LanguageFeatureRegistry=void 0;class u{constructor(){this._clock=0,this._entries=[],this._onDidChange=new n.Emitter}get onDidChange(){return this._onDidChange.event}register(e,t){let n={selector:e,provider:t,_score:-1,_time:this._clock++};return this._entries.push(n),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),i.toDisposable(()=>{if(n){let e=this._entries.indexOf(n);e>=0&&(this._entries.splice(e,1),this._lastCandidate=void 0,
this._onDidChange.fire(this._entries.length),n=void 0)}})}has(e){return this.all(e).length>0}all(e){if(!e)return[];this._updateScores(e);const t=[];for(let e of this._entries)e._score>0&&t.push(e.provider);return t}ordered(e){const t=[];return this._orderedForEach(e,e=>t.push(e.provider)),t}orderedGroups(e){const t=[];let n,r;return this._orderedForEach(e,e=>{n&&r===e._score?n.push(e.provider):(r=e._score,n=[e.provider],t.push(n))}),t}_orderedForEach(e,t){if(e){this._updateScores(e);for(const e of this._entries)e._score>0&&t(e)}}_updateScores(e){let t={uri:e.uri.toString(),language:e.getLanguageIdentifier().language};if(!this._lastCandidate||this._lastCandidate.language!==t.language||this._lastCandidate.uri!==t.uri){this._lastCandidate=t;for(let t of this._entries)if(t._score=a.score(t.selector,e.uri,e.getLanguageIdentifier().language,c.shouldSynchronizeModel(e)),l(t.selector)&&t._score>0){for(let e of this._entries)e._score=0;t._score=1e3;break}this._entries.sort(u._compareByScoreAndTime)}}
static _compareByScoreAndTime(e,t){return e._score<t._score?1:e._score>t._score?-1:e._time<t._time?1:e._time>t._time?-1:0}}t.LanguageFeatureRegistry=u;t.LanguageFeatureRequestDelays=class{constructor(e,t,n=Number.MAX_SAFE_INTEGER){this._registry=e,this.min=t,this.max=n,this._cache=new s.LRUCache(50,.7)}_key(e){return e.id+r.hash(this._registry.all(e))}_clamp(e){return void 0===e?this.min:Math.min(this.max,Math.max(this.min,Math.floor(1.3*e)))}get(e){const t=this._key(e),n=this._cache.get(t);return this._clamp(null==n?void 0:n.value)}update(e,t){const n=this._key(e);let r=this._cache.get(n);return r||(r=new o.MovingAverage,this._cache.set(n,r)),r.update(t),this.get(e)}}})),define(t[172],n([0,1,4,61,171,127,58]),(function(e,t,n,r,i,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.TokenizationRegistry=t.DocumentRangeSemanticTokensProviderRegistry=t.DocumentSemanticTokensProviderRegistry=t.FoldingRangeProviderRegistry=t.SelectionRangeRegistry=t.ColorProviderRegistry=t.LinkProviderRegistry=t.OnTypeFormattingEditProviderRegistry=t.DocumentRangeFormattingEditProviderRegistry=t.DocumentFormattingEditProviderRegistry=t.CodeActionProviderRegistry=t.CodeLensProviderRegistry=t.TypeDefinitionProviderRegistry=t.ImplementationProviderRegistry=t.DeclarationProviderRegistry=t.DefinitionProviderRegistry=t.OnTypeRenameProviderRegistry=t.DocumentHighlightProviderRegistry=t.DocumentSymbolProviderRegistry=t.EvaluatableExpressionProviderRegistry=t.HoverProviderRegistry=t.SignatureHelpProviderRegistry=t.CompletionProviderRegistry=t.RenameProviderRegistry=t.ReferenceProviderRegistry=t.CommentMode=t.CommentThreadCollapsibleState=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.completionKindFromString=t.completionKindToCssClass=t.CompletionItemKind=t.TokenMetadata=t.MetadataConsts=t.StandardTokenType=t.ColorId=t.FontStyle=t.LanguageIdentifier=t.LanguageId=void 0,
function(e){e[e.Null=0]="Null",e[e.PlainText=1]="PlainText"}(t.LanguageId||(t.LanguageId={}));t.LanguageIdentifier=class{constructor(e,t){this.language=e,this.id=t}},function(e){e[e.NotSet=-1]="NotSet",e[e.None=0]="None",e[e.Italic=1]="Italic",e[e.Bold=2]="Bold",e[e.Underline=4]="Underline"}(t.FontStyle||(t.FontStyle={})),function(e){e[e.None=0]="None",e[e.DefaultForeground=1]="DefaultForeground",e[e.DefaultBackground=2]="DefaultBackground"}(t.ColorId||(t.ColorId={})),function(e){e[e.Other=0]="Other",e[e.Comment=1]="Comment",e[e.String=2]="String",e[e.RegEx=4]="RegEx"}(t.StandardTokenType||(t.StandardTokenType={})),function(e){e[e.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",e[e.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",e[e.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",e[e.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",e[e.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",e[e.ITALIC_MASK=2048]="ITALIC_MASK",e[e.BOLD_MASK=4096]="BOLD_MASK",e[e.UNDERLINE_MASK=8192]="UNDERLINE_MASK",e[e.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",
e[e.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",e[e.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",e[e.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",e[e.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",e[e.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",e[e.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",e[e.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",e[e.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",e[e.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"}(t.MetadataConsts||(t.MetadataConsts={}));t.TokenMetadata=class{static getLanguageId(e){return(255&e)>>>0}static getTokenType(e){return(1792&e)>>>8}static getFontStyle(e){return(14336&e)>>>11}static getForeground(e){return(8372224&e)>>>14}static getBackground(e){return(4286578688&e)>>>23}static getClassNameFromMetadata(e){let t="mtk"+this.getForeground(e),n=this.getFontStyle(e);return 1&n&&(t+=" mtki"),2&n&&(t+=" mtkb"),4&n&&(t+=" mtku"),t}static getInlineStyleFromMetadata(e,t){const n=this.getForeground(e),r=this.getFontStyle(e);let i=`color: ${t[n]};`
;return 1&r&&(i+="font-style: italic;"),2&r&&(i+="font-weight: bold;"),4&r&&(i+="text-decoration: underline;"),i}},function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"}(t.CompletionItemKind||(t.CompletionItemKind={})),t.completionKindToCssClass=function(){let e=Object.create(null);return e[0]="symbol-method",e[1]="symbol-function",
e[2]="symbol-constructor",e[3]="symbol-field",e[4]="symbol-variable",e[5]="symbol-class",e[6]="symbol-struct",e[7]="symbol-interface",e[8]="symbol-module",e[9]="symbol-property",e[10]="symbol-event",e[11]="symbol-operator",e[12]="symbol-unit",e[13]="symbol-value",e[14]="symbol-constant",e[15]="symbol-enum",e[16]="symbol-enum-member",e[17]="symbol-keyword",e[27]="symbol-snippet",e[18]="symbol-text",e[19]="symbol-color",e[20]="symbol-file",e[21]="symbol-reference",e[22]="symbol-customcolor",e[23]="symbol-folder",e[24]="symbol-type-parameter",e[25]="account",e[26]="issues",function(t){const n=e[t];let r=n&&o.iconRegistry.get(n);return r||(console.info("No codicon found for CompletionItemKind "+t),r=o.Codicon.symbolProperty),r.classNames}}(),t.completionKindFromString=function(){let e=Object.create(null);return e.method=0,e.function=1,e.constructor=2,e.field=3,e.variable=4,e.class=5,e.struct=6,e.interface=7,e.module=8,e.property=9,e.event=10,e.operator=11,e.unit=12,e.value=13,e.constant=14,e.enum=15,
e["enum-member"]=16,e.enumMember=16,e.keyword=17,e.snippet=27,e.text=18,e.color=19,e.file=20,e.reference=21,e.customcolor=22,e.folder=23,e["type-parameter"]=24,e.typeParameter=24,e.account=25,e.issue=26,function(t,n){let r=e[t];return void 0!==r||n||(r=9),r}}(),function(e){e[e.Deprecated=1]="Deprecated"}(t.CompletionItemTag||(t.CompletionItemTag={})),function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"}(t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(t.CompletionTriggerKind||(t.CompletionTriggerKind={})),function(e){e[e.Auto=1]="Auto",e[e.Manual=2]="Manual"}(t.CodeActionTriggerType||(t.CodeActionTriggerType={})),function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={})),function(e){
e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(t.DocumentHighlightKind||(t.DocumentHighlightKind={})),t.isLocationLink=function(e){return e&&n.URI.isUri(e.uri)&&r.Range.isIRange(e.range)&&(r.Range.isIRange(e.originSelectionRange)||r.Range.isIRange(e.targetSelectionRange))},function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"}(t.SymbolKind||(t.SymbolKind={})),function(e){
e[e.Deprecated=1]="Deprecated"}(t.SymbolTag||(t.SymbolTag={})),function(e){const t=new Map;t.set("file",0),t.set("module",1),t.set("namespace",2),t.set("package",3),t.set("class",4),t.set("method",5),t.set("property",6),t.set("field",7),t.set("constructor",8),t.set("enum",9),t.set("interface",10),t.set("function",11),t.set("variable",12),t.set("constant",13),t.set("string",14),t.set("number",15),t.set("boolean",16),t.set("array",17),t.set("object",18),t.set("key",19),t.set("null",20),t.set("enum-member",21),t.set("struct",22),t.set("event",23),t.set("operator",24),t.set("type-parameter",25);const n=new Map;n.set(0,"file"),n.set(1,"module"),n.set(2,"namespace"),n.set(3,"package"),n.set(4,"class"),n.set(5,"method"),n.set(6,"property"),n.set(7,"field"),n.set(8,"constructor"),n.set(9,"enum"),n.set(10,"interface"),n.set(11,"function"),n.set(12,"variable"),n.set(13,"constant"),n.set(14,"string"),n.set(15,"number"),n.set(16,"boolean"),n.set(17,"array"),n.set(18,"object"),n.set(19,"key"),n.set(20,"null"),
n.set(21,"enum-member"),n.set(22,"struct"),n.set(23,"event"),n.set(24,"operator"),n.set(25,"type-parameter"),e.fromString=function(e){return t.get(e)},e.toString=function(e){return n.get(e)},e.toCssClassName=function(e,t){const r=n.get(e);let i=r&&o.iconRegistry.get("symbol-"+r);return i||(console.info("No codicon found for SymbolKind "+e),i=o.Codicon.symbolProperty),`${t?"inline":"block"} ${i.classNames}`}}(t.SymbolKinds||(t.SymbolKinds={}));class a{constructor(e){this.value=e}}t.FoldingRangeKind=a,a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region"),function(e){e[e.Collapsed=0]="Collapsed",e[e.Expanded=1]="Expanded"}(t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={})),function(e){e[e.Editing=0]="Editing",e[e.Preview=1]="Preview"}(t.CommentMode||(t.CommentMode={})),t.ReferenceProviderRegistry=new i.LanguageFeatureRegistry,t.RenameProviderRegistry=new i.LanguageFeatureRegistry,t.CompletionProviderRegistry=new i.LanguageFeatureRegistry,
t.SignatureHelpProviderRegistry=new i.LanguageFeatureRegistry,t.HoverProviderRegistry=new i.LanguageFeatureRegistry,t.EvaluatableExpressionProviderRegistry=new i.LanguageFeatureRegistry,t.DocumentSymbolProviderRegistry=new i.LanguageFeatureRegistry,t.DocumentHighlightProviderRegistry=new i.LanguageFeatureRegistry,t.OnTypeRenameProviderRegistry=new i.LanguageFeatureRegistry,t.DefinitionProviderRegistry=new i.LanguageFeatureRegistry,t.DeclarationProviderRegistry=new i.LanguageFeatureRegistry,t.ImplementationProviderRegistry=new i.LanguageFeatureRegistry,t.TypeDefinitionProviderRegistry=new i.LanguageFeatureRegistry,t.CodeLensProviderRegistry=new i.LanguageFeatureRegistry,t.CodeActionProviderRegistry=new i.LanguageFeatureRegistry,t.DocumentFormattingEditProviderRegistry=new i.LanguageFeatureRegistry,t.DocumentRangeFormattingEditProviderRegistry=new i.LanguageFeatureRegistry,t.OnTypeFormattingEditProviderRegistry=new i.LanguageFeatureRegistry,t.LinkProviderRegistry=new i.LanguageFeatureRegistry,
t.ColorProviderRegistry=new i.LanguageFeatureRegistry,t.SelectionRangeRegistry=new i.LanguageFeatureRegistry,t.FoldingRangeProviderRegistry=new i.LanguageFeatureRegistry,t.DocumentSemanticTokensProviderRegistry=new i.LanguageFeatureRegistry,t.DocumentRangeSemanticTokensProviderRegistry=new i.LanguageFeatureRegistry,t.TokenizationRegistry=new s.TokenizationRegistryImpl})),define(t[51],n([0,1,13,7,5]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SET_CONTEXT_COMMAND_ID=t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyNotInExpr=t.ContextKeyInExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.ContextKeyExprType=void 0;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",i.isMacintosh),s.set("isLinux",i.isLinux),s.set("isWindows",i.isWindows),s.set("isWeb",i.isWeb),
s.set("isMacNative",i.isMacintosh&&!i.isWeb);const o=Object.prototype.hasOwnProperty;!function(e){e[e.False=0]="False",e[e.True=1]="True",e[e.Defined=2]="Defined",e[e.Not=3]="Not",e[e.Equals=4]="Equals",e[e.NotEquals=5]="NotEquals",e[e.And=6]="And",e[e.Regex=7]="Regex",e[e.NotRegex=8]="NotRegex",e[e.Or=9]="Or",e[e.In=10]="In",e[e.NotIn=11]="NotIn"}(t.ContextKeyExprType||(t.ContextKeyExprType={}));class a{static false(){return l.INSTANCE}static true(){return u.INSTANCE}static has(e){return h.create(e)}static equals(e,t){return d.create(e,t)}static notEquals(e,t){return m.create(e,t)}static regex(e,t){return v.create(e,t)}static in(e,t){return f.create(e,t)}static not(e){return g.create(e)}static and(...e){return b.create(e)}static or(...e){return w.create(e)}static deserialize(e,t=!1){if(e)return this._deserializeOrExpression(e,t)}static _deserializeOrExpression(e,t){let n=e.split("||");return w.create(n.map(e=>this._deserializeAndExpression(e,t)))}static _deserializeAndExpression(e,t){let n=e.split("&&")
;return b.create(n.map(e=>this._deserializeOne(e,t)))}static _deserializeOne(e,t){if((e=e.trim()).indexOf("!=")>=0){let n=e.split("!=");return m.create(n[0].trim(),this._deserializeValue(n[1],t))}if(e.indexOf("==")>=0){let n=e.split("==");return d.create(n[0].trim(),this._deserializeValue(n[1],t))}if(e.indexOf("=~")>=0){let n=e.split("=~");return v.create(n[0].trim(),this._deserializeRegexValue(n[1],t))}if(e.indexOf(" in ")>=0){let t=e.split(" in ");return f.create(t[0].trim(),t[1].trim())}return/^\!\s*/.test(e)?g.create(e.substr(1).trim()):h.create(e)}static _deserializeValue(e,t){if("true"===(e=e.trim()))return!0;if("false"===e)return!1;let n=/^'([^']*)'$/.exec(e);return n?n[1].trim():e}static _deserializeRegexValue(e,t){if(n.isFalsyOrWhitespace(e)){if(t)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let r=e.indexOf("/"),i=e.lastIndexOf("/");if(r===i||r<0){if(t)throw new Error(`bad regexp-value '${e}', missing /-enclosure`)
;return console.warn(`bad regexp-value '${e}', missing /-enclosure`),null}let s=e.slice(r+1,i),o="i"===e[i+1]?"i":"";try{return new RegExp(s,o)}catch(n){if(t)throw new Error(`bad regexp-value '${e}', parse error: ${n}`);return console.warn(`bad regexp-value '${e}', parse error: ${n}`),null}}}function c(e,t){return e.cmp(t)}t.ContextKeyExpr=a;class l{constructor(){this.type=0}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!1}serialize(){return"false"}keys(){return[]}map(e){return this}negate(){return u.INSTANCE}}t.ContextKeyFalseExpr=l,l.INSTANCE=new l;class u{constructor(){this.type=1}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!0}serialize(){return"true"}keys(){return[]}map(e){return this}negate(){return l.INSTANCE}}t.ContextKeyTrueExpr=u,u.INSTANCE=new u;class h{constructor(e){this.key=e,this.type=2}static create(e){const t=s.get(e);return"boolean"==typeof t?t?u.INSTANCE:l.INSTANCE:new h(e)}cmp(e){
return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!!e.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(e){return e.mapDefined(this.key)}negate(){return g.create(this.key)}}t.ContextKeyDefinedExpr=h;class d{constructor(e,t){this.key=e,this.value=t,this.type=4}static create(e,t){if("boolean"==typeof t)return t?h.create(e):g.create(e);const n=s.get(e);if("boolean"==typeof n){return t===(n?"true":"false")?u.INSTANCE:l.INSTANCE}return new d(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)==this.value}serialize(){return this.key+" == '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}
t.ContextKeyEqualsExpr=d;class f{constructor(e,t){this.key=e,this.valueKey=t,this.type=10}static create(e,t){return new f(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.valueKey<e.valueKey?-1:this.valueKey>e.valueKey?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.valueKey===e.valueKey)}evaluate(e){const t=e.getValue(this.valueKey),n=e.getValue(this.key);return Array.isArray(t)?t.indexOf(n)>=0:"string"==typeof n&&"object"==typeof t&&null!==t&&o.call(t,n)}serialize(){return this.key+" in '"+this.valueKey+"'"}keys(){return[this.key,this.valueKey]}map(e){return e.mapIn(this.key,this.valueKey)}negate(){return p.create(this)}}t.ContextKeyInExpr=f;class p{constructor(e){this._actual=e,this.type=11}static create(e){return new p(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){
throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new p(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotInExpr=p;class m{constructor(e,t){this.key=e,this.value=t,this.type=5}static create(e,t){if("boolean"==typeof t)return t?g.create(e):h.create(e);const n=s.get(e);if("boolean"==typeof n){return t===(n?"true":"false")?l.INSTANCE:u.INSTANCE}return new m(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)!=this.value}serialize(){return this.key+" != '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}t.ContextKeyNotEqualsExpr=m;class g{constructor(e){this.key=e,this.type=3}static create(e){const t=s.get(e);return"boolean"==typeof t?t?l.INSTANCE:u.INSTANCE:new g(e)}
cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!e.getValue(this.key)}serialize(){return"!"+this.key}keys(){return[this.key]}map(e){return e.mapNot(this.key)}negate(){return h.create(this.key)}}t.ContextKeyNotExpr=g;class v{constructor(e,t){this.key=e,this.regexp=t,this.type=7}static create(e,t){return new v(e,t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.key<e.key)return-1;if(this.key>e.key)return 1;const t=this.regexp?this.regexp.source:"",n=e.regexp?e.regexp.source:"";return t<n?-1:t>n?1:0}equals(e){if(e.type===this.type){const t=this.regexp?this.regexp.source:"",n=e.regexp?e.regexp.source:"";return this.key===e.key&&t===n}return!1}evaluate(e){let t=e.getValue(this.key);return!!this.regexp&&this.regexp.test(t)}serialize(){const e=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${e}`}keys(){return[this.key]}map(e){
return e.mapRegex(this.key,this.regexp)}negate(){return y.create(this)}}t.ContextKeyRegexExpr=v;class y{constructor(e){this._actual=e,this.type=8}static create(e){return new y(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(e){return new y(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=y;class b{constructor(e){this.expr=e,this.type=6}static create(e){return b._normalizeArr(e)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,n=this.expr.length;t<n;t++){const n=c(this.expr[t],e.expr[t]);if(0!==n)return n}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1
;for(let t=0,n=this.expr.length;t<n;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,n=this.expr.length;t<n;t++)if(!this.expr[t].evaluate(e))return!1;return!0}static _normalizeArr(e){const t=[];let n=!1;for(const r of e)if(r)if(1!==r.type){if(0===r.type)return l.INSTANCE;6!==r.type?t.push(r):t.push(...r.expr)}else n=!0;if(0===t.length&&n)return u.INSTANCE;if(0!==t.length){if(1===t.length)return t[0];for(t.sort(c);t.length>1;){const e=t[t.length-1];if(9!==e.type)break;t.pop();const n=t.pop(),r=w.create(e.expr.map(e=>b.create([e,n])));r&&(t.push(r),t.sort(c))}return 1===t.length?t[0]:new b(t)}}serialize(){return this.expr.map(e=>e.serialize()).join(" && ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new b(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());return w.create(e)}}t.ContextKeyAndExpr=b;class w{constructor(e){this.expr=e,this.type=9}static create(e){const t=w._normalizeArr(e)
;if(0!==t.length)return 1===t.length?t[0]:new w(t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,n=this.expr.length;t<n;t++){const n=c(this.expr[t],e.expr[t]);if(0!==n)return n}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let t=0,n=this.expr.length;t<n;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,n=this.expr.length;t<n;t++)if(this.expr[t].evaluate(e))return!0;return!1}static _normalizeArr(e){let t=[],n=!1;if(e){for(let r=0,i=e.length;r<i;r++){const i=e[r];if(i)if(0!==i.type){if(1===i.type)return[u.INSTANCE];9!==i.type?t.push(i):t=t.concat(i.expr)}else n=!0}if(0===t.length&&n)return[l.INSTANCE];t.sort(c)}return t}serialize(){return this.expr.map(e=>e.serialize()).join(" || ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new w(this.expr.map(t=>t.map(e)))}negate(){let e=[]
;for(let t of this.expr)e.push(t.negate());const t=e=>9===e.type?e.expr:[e];for(;e.length>1;){const n=e.shift(),r=e.shift(),i=[];for(const e of t(n))for(const n of t(r))i.push(a.and(e,n));e.unshift(a.or(...i))}return e[0]}}t.ContextKeyOrExpr=w;t.RawContextKey=class extends h{constructor(e,t){super(e),this._defaultValue=t}bindTo(e){return e.createKey(this.key,this._defaultValue)}getValue(e){return e.getContextKeyValue(this.key)}toNegated(){return a.not(this.key)}isEqualTo(e){return a.equals(this.key,e)}notEqualsTo(e){return a.notEquals(this.key,e)}},t.IContextKeyService=r.createDecorator("contextKeyService"),t.SET_CONTEXT_COMMAND_ID="setContext"})),define(t[84],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=n.createDecorator("downloadService")})),define(t[26],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,
t.IEnvironmentService=n.createDecorator("environmentService"),t.INativeEnvironmentService=n.createDecorator("nativeEnvironmentService")})),define(t[31],n([0,1,140,7,8]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),
t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=5]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"}(t.SortBy||(t.SortBy={})),function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"}(t.SortOrder||(t.SortOrder={})),function(e){e.Uninstall="uninstall"}(t.StatisticType||(t.StatisticType={})),function(e){e[e.None=0]="None",e[e.Install=1]="Install",e[e.Update=2]="Update"}(t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=r.createDecorator("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class s extends Error{constructor(e,t){
super(e),this.code=t}}t.ExtensionManagementError=s,t.IExtensionManagementService=r.createDecorator("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=r.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=r.createDecorator("IExtensionTipsService"),t.DefaultIconPath=i.FileAccess.asBrowserUri("./media/defaultIcon.png",e).toString(!0),t.ExtensionsLabel=n.localize(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=n.localize(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"}})),define(t[41],n([0,1,13,7]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Themes","Testing","Visualization","Other"],function(e){e[e.System=0]="System",e[e.User=1]="User"}(t.ExtensionType||(t.ExtensionType={}));t.ExtensionIdentifier=class{constructor(e){this.value=e,this._lower=e.toLowerCase()}static equals(e,t){if(null==e)return null==t;if(null==t)return!1
;if("string"==typeof e||"string"==typeof t){let r="string"==typeof e?e:e.value,i="string"==typeof t?t:t.value;return n.equalsIgnoreCase(r,i)}return e._lower===t._lower}static toKey(e){return"string"==typeof e?e.toLowerCase():e._lower}},t.isLanguagePackExtension=function(e){return!(!e.contributes||!e.contributes.localizations)&&e.contributes.localizations.length>0},t.isAuthenticaionProviderExtension=function(e){return!(!e.contributes||!e.contributes.authentication)&&e.contributes.authentication.length>0},t.IBuiltinExtensionsScannerService=r.createDecorator("IBuiltinExtensionsScannerService")})),define(t[34],n([0,1,13,41]),(function(e,t,n,r){"use strict";function i(e,t){return e.uuid&&t.uuid?e.uuid===t.uuid:e.id===t.id||0===n.compareIgnoreCase(e.id,t.id)}Object.defineProperty(t,"__esModule",{value:!0}),
t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0,t.areSameExtensions=i;class s{constructor(e,t){this.version=t,this.id=e.id,this.uuid=e.uuid}key(){return`${this.id}-${this.version}`}equals(e){return e instanceof s&&(i(this,e)&&this.version===e.version)}}t.ExtensionIdentifierWithVersion=s,t.adoptToGalleryExtensionId=function(e){return e.toLocaleLowerCase()},t.getGalleryExtensionId=function(e,t){return`${e.toLocaleLowerCase()}.${t.toLocaleLowerCase()}`},t.groupByExtension=function(e,t){const n=[],r=e=>{for(const r of n)if(r.some(n=>i(t(n),t(e))))return r;return null};for(const t of e){const e=r(t);e?e.push(t):n.push([t])}return n},t.getLocalExtensionTelemetryData=function(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,
publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}},t.getGalleryExtensionTelemetryData=function(e){return Object.assign({id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0)},e.telemetryData)},t.BetterMergeId=new r.ExtensionIdentifier("pprice.better-merge"),t.getMaliciousExtensionsSet=function(e){const t=new Set;for(const n of e)n.malicious&&t.add(n.id.id);return t}})),define(t[173],n([0,1,3,2,41,14]),(function(e,t,n,r,i,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class o extends n.Disposable{constructor(e,t){super(),this.environmentService=e,this.extensionsManifestCache=r.join(this.environmentService.userDataPath,i.MANIFEST_CACHE_FOLDER,i.USER_MANIFEST_CACHE_FILE),
this._register(t.onDidInstallExtension(e=>this.onDidInstallExtension(e))),this._register(t.onDidUninstallExtension(e=>this.onDidUnInstallExtension(e)))}onDidInstallExtension(e){e.error||this.invalidate()}onDidUnInstallExtension(e){e.error||this.invalidate()}invalidate(){s.rimraf(this.extensionsManifestCache,s.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=o})),define(t[27],n([0,1,146,2,4,7,13,11,23]),(function(e,t,n,r,i,s,o,a,c){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),
t.BinarySize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FileType=t.IFileService=void 0,t.IFileService=s.createDecorator("fileService"),function(e){e[e.Unknown=0]="Unknown",e[e.File=1]="File",e[e.Directory=2]="Directory",e[e.SymbolicLink=64]="SymbolicLink"}(t.FileType||(t.FileType={})),function(e){e[e.FileReadWrite=2]="FileReadWrite",
e[e.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",e[e.FileReadStream=16]="FileReadStream",e[e.FileFolderCopy=8]="FileFolderCopy",e[e.PathCaseSensitive=1024]="PathCaseSensitive",e[e.Readonly=2048]="Readonly",e[e.Trash=4096]="Trash"}(t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={})),t.hasReadWriteCapability=function(e){return!!(2&e.capabilities)},t.hasFileFolderCopyCapability=function(e){return!!(8&e.capabilities)},t.hasOpenReadWriteCloseCapability=function(e){return!!(4&e.capabilities)},t.hasFileReadStreamCapability=function(e){return!!(16&e.capabilities)},function(e){e.FileExists="EntryExists",e.FileNotFound="EntryNotFound",e.FileNotADirectory="EntryNotADirectory",e.FileIsADirectory="EntryIsADirectory",e.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",e.FileTooLarge="EntryTooLarge",e.NoPermissions="NoPermissions",e.Unavailable="Unavailable",e.Unknown="Unknown"}(l=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class u extends Error{constructor(e,t){super(e),
this.code=t}}function h(e,t){const n=new u(e.toString(),t);return d(n,t),n}function d(e,t){return e.name=t?`${t} (FileSystemError)`:"FileSystemError",e}function f(e){if(!e)return l.Unknown;if(e instanceof u)return e.code;const t=/^(.+) \(FileSystemError\)$/.exec(e.name);if(!t)return l.Unknown;switch(t[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileExceedsMemoryLimit:return l.FileExceedsMemoryLimit;case l.FileTooLarge:return l.FileTooLarge;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}t.FileSystemProviderError=u,t.createFileSystemProviderError=h,t.ensureFileSystemProviderError=function(e){return e||h(n.localize(0,null),l.Unknown)},t.markAsFileSystemProviderError=d,t.toFileSystemProviderErrorCode=f,t.toFileOperationResult=function(e){if(e instanceof m)return e.fileOperationResult;switch(f(e)){
case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 10;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileExceedsMemoryLimit:return 9;case l.FileTooLarge:return 7;default:return 11}},function(e){e[e.CREATE=0]="CREATE",e[e.DELETE=1]="DELETE",e[e.MOVE=2]="MOVE",e[e.COPY=3]="COPY"}(t.FileOperation||(t.FileOperation={}));t.FileOperationEvent=class{constructor(e,t,n){this.resource=e,this.operation=t,this.target=n}isOperation(e){return this.operation===e}},function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));class p{constructor(e,t){this.ignorePathCasing=t,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=e;for(const t of e)switch(t.type){case 1:this.added||(this.added=c.TernarySearchTree.forUris(this.ignorePathCasing)),this.added.set(t.resource,t);break;case 0:this.updated||(this.updated=c.TernarySearchTree.forUris(this.ignorePathCasing)),
this.updated.set(t.resource,t);break;case 2:this.deleted||(this.deleted=c.TernarySearchTree.forUris(this.ignorePathCasing)),this.deleted.set(t.resource,t)}}contains(e,...t){return this.doContains(e,{includeChildren:!1},...t)}affects(e,...t){return this.doContains(e,{includeChildren:!0},...t)}doContains(e,t,...n){var r,i,s,o,a,c;if(!e)return!1;const l=n.length>0;if(!l||n.includes(1)){if(null===(r=this.added)||void 0===r?void 0:r.get(e))return!0;if(t.includeChildren&&(null===(i=this.added)||void 0===i?void 0:i.findSuperstr(e)))return!0}if(!l||n.includes(0)){if(null===(s=this.updated)||void 0===s?void 0:s.get(e))return!0;if(t.includeChildren&&(null===(o=this.updated)||void 0===o?void 0:o.findSuperstr(e)))return!0}if(!l||n.includes(2)){if(null===(a=this.deleted)||void 0===a?void 0:a.findSubstr(e))return!0;if(t.includeChildren&&(null===(c=this.deleted)||void 0===c?void 0:c.findSuperstr(e)))return!0}return!1}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}
gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(e){const t=[],n=1===e?this.added:0===e?this.updated:this.deleted;if(n)for(const[,e]of n)t.push(e);return t}filter(e){return new p(this.changes.filter(t=>e(t)),this.ignorePathCasing)}}t.FileChangesEvent=p,t.isParent=function(e,t,n){return!(!e||!t||e===t)&&(!(t.length>e.length)&&(t.charAt(t.length-1)!==r.sep&&(t+=r.sep),n?o.startsWithIgnoreCase(e,t):0===e.indexOf(t)))};class m extends Error{constructor(e,t,n){super(e),this.fileOperationResult=t,this.options=n}static isFileOperationError(e){return e instanceof Error&&!a.isUndefinedOrNull(e.fileOperationResult)}}t.FileOperationError=m,function(e){e[e.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=5]="FILE_READ_ONLY",
e[e.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",e[e.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",e[e.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",e[e.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",e[e.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"}(t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"}(t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="",t.etag=function(e){if("number"==typeof e.size&&"number"==typeof e.mtime)return e.mtime.toString(29)+e.size.toString(31)},t.whenProviderRegistered=function(e,t){return t.canHandleResource(i.URI.from({scheme:e.scheme
}))?Promise.resolve():new Promise(n=>{const r=t.onDidChangeFileSystemProviderRegistrations(t=>{t.scheme===e.scheme&&t.added&&(r.dispose(),n())})})},t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class g{static formatSize(e){return a.isNumber(e)||(e=0),e<g.KB?n.localize(1,null,e.toFixed(0)):e<g.MB?n.localize(2,null,(e/g.KB).toFixed(2)):e<g.GB?n.localize(3,null,(e/g.MB).toFixed(2)):e<g.TB?n.localize(4,null,(e/g.GB).toFixed(2)):n.localize(5,null,(e/g.TB).toFixed(2))}}t.BinarySize=g,g.KB=1024,g.MB=g.KB*g.KB,g.GB=g.MB*g.KB,g.TB=g.GB*g.KB})),define(t[85],n([0,1,147,19,27,15]),(function(e,t,n,r,i,s){"use strict";function o(e){if(e.isCancellationRequested)throw s.canceled();return!0}function a(e,t){if(null==t?void 0:t.limits){if("number"==typeof t.limits.memory&&e>t.limits.memory)throw i.createFileSystemProviderError(n.localize(0,null),i.FileSystemProviderErrorCode.FileExceedsMemoryLimit)
;if("number"==typeof t.limits.size&&e>t.limits.size)throw i.createFileSystemProviderError(n.localize(1,null),i.FileSystemProviderErrorCode.FileTooLarge)}return!0}Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0,t.readFileIntoStream=async function(e,t,n,s,c,l){let u=void 0;try{await async function(e,t,n,s,c,l){o(l);const u=await e.open(t,{create:!1});o(l);try{let t=0,i=0,h=c&&"number"==typeof c.length?c.length:void 0,d=r.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),f=c&&"number"==typeof c.position?c.position:0,p=0;do{i=await e.read(u,f,d.buffer,p,d.byteLength-p),f+=i,t+=i,"number"==typeof h&&(h-=i),(p+=i)===d.byteLength&&(await n.write(s(d)),d=r.VSBuffer.alloc(Math.min(c.bufferSize,"number"==typeof h?h:c.bufferSize)),p=0)}while(i>0&&("number"!=typeof h||h>0)&&o(l)&&a(t,c));if(p>0){let e=p;"number"==typeof h&&(e=Math.min(p,h)),n.write(s(d.slice(0,e)))}}catch(e){throw i.ensureFileSystemProviderError(e)}finally{await e.close(u)}}(e,t,n,s,c,l)}catch(e){u=e
}finally{u&&c.errorTransformer&&(u=c.errorTransformer(u)),n.end(u)}}})),define(t[86],n([0,1,4,27,5]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0,t.toFileChanges=function(e){return e.map(e=>({type:e.type,resource:n.URI.file(e.path)}))},t.normalizeFileChanges=function(e){const t=new s;for(const n of e)t.processEvent(n);return t.normalize()};class s{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(e){const t=this.mapPathToChange.get(e.path);if(t){const n=t.type,r=e.type;1===n&&2===r?(this.mapPathToChange.delete(e.path),this.normalized.splice(this.normalized.indexOf(t),1)):2===n&&1===r?t.type=0:1===n&&0===r||(t.type=r)}else this.normalized.push(e),this.mapPathToChange.set(e.path,e)}normalize(){const e=[],t=[];return this.normalized.filter(t=>2===t.type||(e.push(t),!1)).sort((e,t)=>e.path.length-t.path.length).filter(e=>!t.some(t=>r.isParent(e.path,t,!i.isLinux))&&(t.push(e.path),!0)).concat(e)}}})),
define(t[174],n([0,1,86,3,14,122,124,17,2]),(function(e,t,n,r,i,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class l extends r.Disposable{constructor(e,t,n,r){super(),this.path=e,this.onDidFilesChange=t,this.onLogMessage=n,this.verboseLogging=r,this.fileChangesDelayer=this._register(new a.ThrottledDelayer(2*o.CHANGE_BUFFER_DELAY)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(e){this.verboseLogging=e}async startWatching(){try{const{stat:e,symbolicLink:t}=await i.statLink(this.path);if(this.isDisposed)return;let n=this.path;if(t)try{n=await s.realpath(n)}catch(e){this.onError(e)}e.isDirectory()?this._register(o.watchFolder(n,(e,t)=>{this.onFileChange({type:"changed"===e?0:"added"===e?1:2,path:c.join(this.path,c.basename(t))})},e=>this.onError(e))):this._register(o.watchFile(n,e=>{this.onFileChange({type:"changed"===e?0:2,path:this.path})},e=>this.onError(e)))}catch(e){this.onError(e)}}onFileChange(e){this.fileChangesBuffer.push(e),
this.verboseLogging&&this.onVerbose(`${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`),this.fileChangesDelayer.trigger(async()=>{const e=this.fileChangesBuffer;this.fileChangesBuffer=[];const t=n.normalizeFileChanges(e);this.verboseLogging&&t.forEach(e=>{this.onVerbose(`>> normalized ${1===e.type?"[ADDED]":2===e.type?"[DELETED]":"[CHANGED]"} ${e.path}`)}),t.length>0&&this.onDidFilesChange(t)})}onError(e){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${e}`})}onVerbose(e){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${e}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=l})),define(t[52],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;t.ServiceCollection=class{constructor(...e){this._entries=new Map;for(let[t,n]of e)this.set(t,n)}set(e,t){const n=this._entries.get(e);return this._entries.set(e,t),n}has(e){return this._entries.has(e)}get(e){
return this._entries.get(e)}}})),define(t[63],n([0,1,15,169,50,7,52,17]),(function(e,t,n,r,i,s,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class l extends Error{constructor(e){super("cyclic dependency between services"),this.message=e.toString()}}class u{constructor(e=new o.ServiceCollection,t=!1,n){this._services=e,this._strict=t,this._parent=n,this._services.set(s.IInstantiationService,this)}createChild(e){return new u(e,this._strict,this)}invokeFunction(e,...t){let r=d.traceInvocation(e),i=!1;try{return e({get:(e,t)=>{if(i)throw n.illegalState("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(e,r);if(!o&&t!==s.optional)throw new Error(`[invokeFunction] unknown service '${e}'`);return o}},...t)}finally{i=!0,r.stop()}}createInstance(e,...t){let n,r;return e instanceof i.SyncDescriptor?(n=d.traceCreation(e.ctor),
r=this._createInstance(e.ctor,e.staticArguments.concat(t),n)):(n=d.traceCreation(e),r=this._createInstance(e,t,n)),n.stop(),r}_createInstance(e,t=[],n){let r=s._util.getServiceDependencies(e).sort((e,t)=>e.index-t.index),i=[];for(const t of r){let r=this._getOrCreateServiceInstance(t.id,n);if(!r&&this._strict&&!t.optional)throw new Error(`[createInstance] ${e.name} depends on UNKNOWN service ${t.id}.`);i.push(r)}let o=r.length>0?r[0].index:t.length;if(t.length!==o){console.warn(`[createInstance] First service dependency of ${e.name} at position ${o+1} conflicts with ${t.length} static arguments`);let n=o-t.length;t=n>0?t.concat(new Array(n)):t.slice(0,o)}return new e(...[...t,...i])}_setServiceInstance(e,t){if(this._services.get(e)instanceof i.SyncDescriptor)this._services.set(e,t);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(e,t)}}_getServiceInstanceOrDescriptor(e){let t=this._services.get(e)
;return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t}_getOrCreateServiceInstance(e,t){let n=this._getServiceInstanceOrDescriptor(e);return n instanceof i.SyncDescriptor?this._createAndCacheServiceInstance(e,n,t.branch(e,!0)):(t.branch(e,!1),n)}_createAndCacheServiceInstance(e,t,n){const o=new r.Graph(e=>e.id.toString());let a=0;const c=[{id:e,desc:t,_trace:n}];for(;c.length;){const t=c.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new l(o);for(let n of s._util.getServiceDependencies(t.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(n.id);if(r||n.optional||console.warn(`[createInstance] ${e} depends on ${n.id} which is NOT registered.`),r instanceof i.SyncDescriptor){const e={id:n.id,desc:r,_trace:t._trace.branch(n.id,!0)};o.insertEdge(t,e),c.push(e)}}}for(;;){const e=o.roots();if(0===e.length){if(!o.isEmpty())throw new l(o);break}for(const{data:t}of e){if(this._getServiceInstanceOrDescriptor(t.id)instanceof i.SyncDescriptor){
const e=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this._setServiceInstance(t.id,e)}o.removeNode(t)}}return this._getServiceInstanceOrDescriptor(e)}_createServiceInstanceWithOwner(e,t,n=[],r,s){if(this._services.get(e)instanceof i.SyncDescriptor)return this._createServiceInstance(t,n,r,s);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,n,r,s);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(e,t=[],n,r){if(n){const n=new a.IdleValue(()=>this._createInstance(e,t,r));return new Proxy(Object.create(null),{get(e,t){if(t in e)return e[t];let r=n.value,i=r[t];return"function"!=typeof i?i:(i=i.bind(r),e[t]=i,i)},set:(e,t,r)=>(n.value[t]=r,!0)})}return this._createInstance(e,t,r)}}var h;t.InstantiationService=u,function(e){e[e.Creation=0]="Creation",e[e.Invocation=1]="Invocation",e[e.Branch=2]="Branch"}(h||(h={}));class d{constructor(e,t){this.type=e,this.name=t,
this._start=Date.now(),this._dep=[]}static traceInvocation(e){return c?new d(1,e.name||e.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(e){return c?new d(0,e.name):d._None}branch(e,t){let n=new d(2,e.toString());return this._dep.push([e,t,n]),n}stop(){let e=Date.now()-this._start;d._totals+=e;let t=!1;let n=[`${0===this.type?"CREATE":"CALL"} ${this.name}`,`${function e(n,r){let i=[],s=new Array(n+1).join("\t");for(const[o,a,c]of r._dep)if(a&&c){t=!0,i.push(`${s}CREATES -> ${o}`);let r=e(n+1,c);r&&i.push(r)}else i.push(`${s}uses -> ${o}`);return i.join("\n")}(1,this)}`,`DONE, took ${e.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(e>2||t)&&console.log(n.join("\n"))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0})),define(t[175],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ILabelService=void 0,t.ILabelService=n.createDecorator("labelService")})),
define(t[87],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=n.createDecorator("localizationsService"),t.isValidLocalization=function(e){if("string"!=typeof e.languageId)return!1;if(!Array.isArray(e.translations)||0===e.translations.length)return!1;for(const t of e.translations){if("string"!=typeof t.id)return!1;if("string"!=typeof t.path)return!1}return(!e.languageName||"string"==typeof e.languageName)&&(!e.localizedLanguageName||"string"==typeof e.localizedLanguageName)}})),define(t[12],n([0,1,7,3,5,6,49]),(function(e,t,n,r,i,s,o){"use strict";function a(){return(new Date).toISOString()}var c;Object.defineProperty(t,"__esModule",{value:!0}),
t.getLogLevel=t.NullLogService=t.DelegatedLogService=t.MultiplexLogService=t.ConsoleLogInMainService=t.LogServiceAdapter=t.ConsoleLogService=t.ConsoleLogMainService=t.AbstractLogService=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=n.createDecorator("logService"),t.ILoggerService=n.createDecorator("loggerService"),function(e){e[e.Trace=0]="Trace",e[e.Debug=1]="Debug",e[e.Info=2]="Info",e[e.Warning=3]="Warning",e[e.Error=4]="Error",e[e.Critical=5]="Critical",e[e.Off=6]="Off"}(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;class l extends r.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new s.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogService=l;t.ConsoleLogMainService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),
this.useColors=!i.isWindows}trace(e,...t){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}debug(e,...t){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}info(e,...t){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}warn(e,...t){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${a()}][0m`,e,...t):console.warn(`[main ${a()}]`,e,...t))}error(e,...t){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}critical(e,...t){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}dispose(){}flush(){}};t.ConsoleLogService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e)}trace(e,...t){
this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}};class u extends l{constructor(e,n=t.DEFAULT_LOG_LEVEL){super(),this.adapter=e,this.setLevel(n)}trace(e,...t){this.getLevel()<=c.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=c.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=c.Info&&this.adapter.consoleLog("info",[this.extractMessage(e),...t])}warn(e,...t){
this.getLevel()<=c.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=c.Error&&this.adapter.consoleLog("error",[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=c.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(e),...t])}extractMessage(e){return"string"==typeof e?e:o.toErrorMessage(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.LogServiceAdapter=u;t.ConsoleLogInMainService=class extends u{constructor(e,n=t.DEFAULT_LOG_LEVEL){super({consoleLog:(t,n)=>e.consoleLog(t,n)},n)}};t.MultiplexLogService=class extends l{constructor(e){super(),this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const n of this.logServices)n.trace(e,...t)}debug(e,...t){for(const n of this.logServices)n.debug(e,...t)}info(e,...t){for(const n of this.logServices)n.info(e,...t)}warn(e,...t){for(const n of this.logServices)n.warn(e,...t)}error(e,...t){
for(const n of this.logServices)n.error(e,...t)}critical(e,...t){for(const n of this.logServices)n.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}};class h extends r.Disposable{constructor(e){super(),this.logService=e,this._register(e)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(e){this.logService.setLevel(e)}getLevel(){return this.logService.getLevel()}trace(e,...t){this.logService.trace(e,...t)}debug(e,...t){this.logService.debug(e,...t)}info(e,...t){this.logService.info(e,...t)}warn(e,...t){this.logService.warn(e,...t)}error(e,...t){this.logService.error(e,...t)}critical(e,...t){this.logService.critical(e,...t)}flush(){this.logService.flush()}}t.DelegatedLogService=h;t.NullLogService=class{constructor(){this.onDidChangeLogLevel=(new s.Emitter).event}setLevel(e){}getLevel(){return c.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}},
t.getLogLevel=function(e){if(e.verbose)return c.Trace;if("string"==typeof e.logLevel){switch(e.logLevel.toLowerCase()){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}return t.DEFAULT_LOG_LEVEL}}));var s=this&&this.__decorate||function(e,t,n,r){var i,s=arguments.length,o=s<3?t:null===r?r=Object.getOwnPropertyDescriptor(t,n):r;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)o=Reflect.decorate(e,t,n,r);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(o=(s<3?i(o):s>3?i(t,n,o):i(t,n))||o);return s>3&&o&&Object.defineProperty(t,n,o),o},o=this&&this.__param||function(e,t){return function(n,r){t(n,r,e)}};define(t[176],n([0,1,3,27,31,26,4,22,34,12,21,53]),(function(e,t,n,r,i,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends n.Disposable{
constructor(e,t,n,r){super(),this.fileService=t,this.extensionGalleryService=n,this.logService=r,this.extensionsDownloadDir=c.URI.file(e.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(e,t){await this.cleanUpPromise;const n=l.joinPath(this.extensionsDownloadDir,this.getName(e));return await this.download(e,n,t),n}async delete(e){}async download(e,t,n){await this.fileService.exists(t)||await this.extensionGalleryService.download(e,t,n)}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir))return void this.logService.trace("Extension VSIX downlads cache dir does not exist");const e=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(e.children){const t=[],n=[];for(const t of e.children){const e=this.parse(t.name);e&&n.push([e,t])}const r=u.groupByExtension(n,([e])=>e),i=[];for(const e of r)e.sort((e,t)=>f.rcompare(e[0].version,t[0].version)),t.push(...e.slice(1).map(e=>e[1].resource)),i.push(e[0][1])
;i.sort((e,t)=>e.mtime-t.mtime),t.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(e=>e.resource)),await Promise.all(t.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(e){this.logService.error(e)}}getName(e){return this.cache?new u.ExtensionIdentifierWithVersion(e.identifier,e.version).key().toLowerCase():d.generateUuid()}parse(e){const t=p.exec(e);return t&&t[1]&&t[2]?new u.ExtensionIdentifierWithVersion({id:t[1]},t[2]):null}};m=s([o(0,a.INativeEnvironmentService),o(1,r.IFileService),o(2,i.IExtensionGalleryService),o(3,h.ILogService)],m),t.ExtensionsDownloader=m})),define(t[177],n([0,1,3,12,33,49,2,17,6,8,14,26]),(function(e,t,n,r,i,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let p=class extends n.Disposable{constructor(e,t){super(),this.environmentService=e,this.logService=t,this.processesLimiter=new l.Limiter(5)}async postUninstall(e){const t=this.parseScript(e,"uninstall")
;return t&&(this.logService.info(e.identifier.id,e.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(t.script,"uninstall",t.args,!0,e).then(()=>this.logService.info(e.identifier.id,e.manifest.version,"Finished running post uninstall script"),t=>this.logService.error(e.identifier.id,e.manifest.version,`Failed to run post uninstall script: ${t}`)))),d.rimraf(this.getExtensionStoragePath(e)).then(void 0,e=>this.logService.error("Error while removing extension storage path",e))}parseScript(e,t){const n=`vscode:${t}`;if(e.location.scheme===h.Schemas.file&&e.manifest&&e.manifest.scripts&&"string"==typeof e.manifest.scripts[n]){const t=e.manifest.scripts[n].split(" ");return t.length<2||"node"!==t[0]||!t[1]?(this.logService.warn(e.identifier.id,e.manifest.version,`${n} should be a node script`),null):{script:c.join(e.location.fsPath,t[1]),args:t.slice(2)||[]}}return null}runLifecycleHook(e,t,n,r,i){return new Promise((s,o)=>{const c=this.start(e,t,n,i)
;let l;const u=e=>{l&&(clearTimeout(l),l=null),e?o(e):s(void 0)};c.on("error",e=>{u(a.toErrorMessage(e)||"Unknown")}),c.on("exit",(e,n)=>{u(e?`post-${t} process exited with code ${e}`:void 0)}),r&&(l=setTimeout(()=>{l=null,c.kill(),o("timed out")},5e3))})}start(e,t,n,r){const s={silent:!0,execArgv:void 0},o=i.fork(e,[`--type=extension-post-${t}`,...n],s);o.stdout.setEncoding("utf8"),o.stderr.setEncoding("utf8");const a=u.Event.fromNodeEventEmitter(o.stdout,"data"),c=u.Event.fromNodeEventEmitter(o.stderr,"data");a(e=>this.logService.info(r.identifier.id,r.manifest.version,`post-${t}`,e)),c(e=>this.logService.error(r.identifier.id,r.manifest.version,`post-${t}`,e));const l=u.Event.any(u.Event.map(a,e=>({data:`%c${e}`,format:[""]})),u.Event.map(c,e=>({data:`%c${e}`,format:["color: red"]})));return u.Event.debounce(l,(e,t)=>e?{data:e.data+t.data,format:[...e.format,...t.format]}:{data:t.data,format:t.format},100)(e=>{console.group(r.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),o}
getExtensionStoragePath(e){return c.join(this.environmentService.globalStorageHome.fsPath,e.identifier.id.toLowerCase())}};p=s([o(0,f.IEnvironmentService),o(1,r.ILogService)],p),t.ExtensionsLifecycle=p})),define(t[64],n([0,1,3,27,6,22,145,23,16,47,12,19,45,17,28,8,85,57]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g,v,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let w=class extends n.Disposable{constructor(e){super(),this.logService=e,this.BUFFER_SIZE=65536,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,
this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueues=new Map}registerProvider(e,t){if(this.provider.has(e))throw new Error(`A filesystem provider for the scheme '${e}' is already registered.`);this.provider.set(e,t),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:e,provider:t});const i=new n.DisposableStore;return i.add(t.onDidChangeFile(e=>this._onDidFilesChange.fire(new r.FileChangesEvent(e,!this.isPathCaseSensitive(t))))),i.add(t.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:t,scheme:e}))),"function"==typeof t.onDidErrorOccur&&i.add(t.onDidErrorOccur(e=>this._onError.fire(new Error(e)))),n.toDisposable(()=>{
this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:e,provider:t}),this.provider.delete(e),n.dispose(i)})}async activateProvider(e){const t=[];this._onWillActivateFileSystemProvider.fire({scheme:e,join(e){e&&t.push(e)}}),this.provider.has(e)||await Promise.all(t)}canHandleResource(e){return this.provider.has(e.scheme)}hasCapability(e,t){const n=this.provider.get(e.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return b.Iterable.map(this.provider,([e,t])=>({scheme:e,capabilities:t.capabilities}))}async withProvider(e){if(!a.isAbsolutePath(e))throw new r.FileOperationError(c.localize(0,null,this.resourceForError(e)),8);await this.activateProvider(e.scheme);const t=this.provider.get(e.scheme);if(!t){const t=new Error;throw t.name="ENOPRO",t.message=c.localize(1,null,e.toString()),t}return t}async withReadProvider(e){const t=await this.withProvider(e);if(r.hasOpenReadWriteCloseCapability(t)||r.hasReadWriteCapability(t)||r.hasFileReadStreamCapability(t))return t
;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(e){const t=await this.withProvider(e);if(r.hasOpenReadWriteCloseCapability(t)||r.hasReadWriteCapability(t))return t;throw new Error(`Filesystem provider for scheme '${e.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(e,t){try{return await this.doResolveFile(e,t)}catch(t){if(r.toFileSystemProviderErrorCode(t)===r.FileSystemProviderErrorCode.FileNotFound)throw new r.FileOperationError(c.localize(2,null,this.resourceForError(e)),1);throw r.ensureFileSystemProviderError(t)}}async doResolveFile(e,t){const n=await this.withProvider(e),r=null==t?void 0:t.resolveTo,i=null==t?void 0:t.resolveSingleChildDescendants,s=null==t?void 0:t.resolveMetadata,o=await n.stat(e);let a
;return this.toFileStat(n,e,o,void 0,!!s,(t,n)=>(a||((a=l.TernarySearchTree.forUris()).set(e,!0),u.isNonEmptyArray(r)&&r.forEach(e=>a.set(e,!0))),!!Boolean(a.findSuperstr(t.resource)||a.get(t.resource))||!(!t.isDirectory||!i)&&1===n))}async toFileStat(e,t,n,i,s,o){const c={resource:t,name:h.getBaseLabel(t),isFile:0!=(n.type&r.FileType.File),isDirectory:0!=(n.type&r.FileType.Directory),isSymbolicLink:0!=(n.type&r.FileType.SymbolicLink),mtime:n.mtime,ctime:n.ctime,size:n.size,etag:r.etag({mtime:n.mtime,size:n.size})};if(c.isDirectory&&o(c,i)){try{const n=await e.readdir(t),r=await Promise.all(n.map(async([r,i])=>{try{const c=a.joinPath(t,r),l=s?await e.stat(c):{type:i};return await this.toFileStat(e,c,l,n.length,s,o)}catch(e){return this.logService.trace(e),null}}));c.children=u.coalesce(r)}catch(e){this.logService.trace(e),c.children=[]}return c}return c}async resolveAll(e){return Promise.all(e.map(async e=>{try{return{stat:await this.doResolveFile(e.resource,e.options),success:!0}}catch(e){
return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(e){const t=await this.withProvider(e);try{return!!await t.stat(e)}catch(e){return!1}}async canCreateFile(e,t){try{await this.doValidateCreateFile(e,t)}catch(e){return e}return!0}async doValidateCreateFile(e,t){if(!(null==t?void 0:t.overwrite)&&await this.exists(e))throw new r.FileOperationError(c.localize(3,null,this.resourceForError(e)),3,t)}async createFile(e,t=f.VSBuffer.fromString(""),n){await this.doValidateCreateFile(e,n);const i=await this.writeFile(e,t);return this._onDidRunOperation.fire(new r.FileOperationEvent(e,0,i)),i}async writeFile(e,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e);try{let s;if(await this.validateWriteFile(i,e,n)||await this.mkdirp(i,a.dirname(e)),!r.hasReadWriteCapability(i)||t instanceof f.VSBuffer)s=t;else if(p.isReadableStream(t)){const e=await p.peekStream(t,3);s=e.ended?f.VSBuffer.concat(e.buffer):e}else s=p.peekReadable(t,e=>f.VSBuffer.concat(e),3)
;!r.hasOpenReadWriteCloseCapability(i)||r.hasReadWriteCapability(i)&&s instanceof f.VSBuffer?await this.doWriteUnbuffered(i,e,s):await this.doWriteBuffered(i,e,s instanceof f.VSBuffer?f.bufferToReadable(s):s)}catch(t){throw new r.FileOperationError(c.localize(4,null,this.resourceForError(e),r.ensureFileSystemProviderError(t).toString()),r.toFileOperationResult(t),n)}return this.resolve(e,{resolveMetadata:!0})}async validateWriteFile(e,t,n){let i=void 0;try{i=await e.stat(t)}catch(e){return}if(0!=(i.type&r.FileType.Directory))throw new r.FileOperationError(c.localize(5,null,this.resourceForError(t)),0,n);if(n&&"number"==typeof n.mtime&&"string"==typeof n.etag&&n.etag!==r.ETAG_DISABLED&&"number"==typeof i.mtime&&"number"==typeof i.size&&n.mtime<i.mtime&&n.etag!==r.etag({mtime:n.mtime,size:i.size}))throw new r.FileOperationError(c.localize(6,null),3,n);return i}async readFile(e,t){const n=await this.withReadProvider(e),r=await this.doReadAsFileStream(n,e,Object.assign(Object.assign({},t),{preferUnbuffered:!0}))
;return Object.assign(Object.assign({},r),{value:await f.streamToBuffer(r.value)})}async readFileStream(e,t){const n=await this.withReadProvider(e);return this.doReadAsFileStream(n,e,t)}async doReadAsFileStream(e,t,n){const i=new g.CancellationTokenSource,s=this.validateReadFile(t,n).then(e=>e,e=>{throw i.cancel(),e});try{let o;n&&"string"==typeof n.etag&&n.etag!==r.ETAG_DISABLED&&await s,o=!r.hasOpenReadWriteCloseCapability(e)&&!r.hasFileReadStreamCapability(e)||r.hasReadWriteCapability(e)&&(null==n?void 0:n.preferUnbuffered)?this.readFileUnbuffered(e,t,n):r.hasFileReadStreamCapability(e)?Promise.resolve(this.readFileStreamed(e,t,i.token,n)):Promise.resolve(this.readFileBuffered(e,t,i.token,n));const[a,c]=await Promise.all([s,o]);return Object.assign(Object.assign({},a),{value:c})}catch(e){throw new r.FileOperationError(c.localize(7,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),n)}}readFileStreamed(e,t,n,i=Object.create(null)){
const s=e.readFileStream(t,i,n);return p.transform(s,{data:e=>e instanceof f.VSBuffer?e:f.VSBuffer.wrap(e),error:e=>new r.FileOperationError(c.localize(8,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),i)},e=>f.VSBuffer.concat(e))}readFileBuffered(e,t,n,i=Object.create(null)){const s=f.newWriteableBufferStream();return y.readFileIntoStream(e,t,s,e=>e,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:e=>new r.FileOperationError(c.localize(9,null,this.resourceForError(t),r.ensureFileSystemProviderError(e).toString()),r.toFileOperationResult(e),i)}),n),s}async readFileUnbuffered(e,t,n){let r=await e.readFile(t);return n&&"number"==typeof n.position&&(r=r.slice(n.position)),n&&"number"==typeof n.length&&(r=r.slice(0,n.length)),this.validateReadFileLimits(t,r.byteLength,n),f.bufferToStream(f.VSBuffer.wrap(r))}async validateReadFile(e,t){const n=await this.resolve(e,{resolveMetadata:!0})
;if(n.isDirectory)throw new r.FileOperationError(c.localize(10,null,this.resourceForError(e)),0,t);if(t&&"string"==typeof t.etag&&t.etag!==r.ETAG_DISABLED&&t.etag===n.etag)throw new r.FileOperationError(c.localize(11,null),2,t);return this.validateReadFileLimits(e,n.size,t),n}validateReadFileLimits(e,t,n){if(null==n?void 0:n.limits){let i=void 0;if("number"==typeof n.limits.memory&&t>n.limits.memory&&(i=9),"number"==typeof n.limits.size&&t>n.limits.size&&(i=7),"number"==typeof i)throw new r.FileOperationError(c.localize(12,null,this.resourceForError(e)),i)}}async canMove(e,t,n){return this.doCanMoveCopy(e,t,"move",n)}async canCopy(e,t,n){return this.doCanMoveCopy(e,t,"copy",n)}async doCanMoveCopy(e,t,n,r){if(e.toString()!==t.toString())try{const i="move"===n?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e):await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t);await this.doValidateMoveCopy(i,e,s,t,n,r)}catch(e){return e}return!0}
async move(e,t,n){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(e),e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,e,s,t,"move",!!n),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new r.FileOperationEvent(e,"move"===o?2:3,a)),a}async copy(e,t,n){const i=await this.withReadProvider(e),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(t),t),o=await this.doMoveCopy(i,e,s,t,"copy",!!n),a=await this.resolve(t,{resolveMetadata:!0});return this._onDidRunOperation.fire(new r.FileOperationEvent(e,"copy"===o?3:2,a)),a}async doMoveCopy(e,t,n,i,s,o){if(t.toString()===i.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(e,t,n,i,s,o);if(c&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(n,a.dirname(i)),"copy"===s){if(e===n&&r.hasFileFolderCopyCapability(e))await e.copy(t,i,{overwrite:o});else{const r=await this.resolve(t)
;r.isDirectory?await this.doCopyFolder(e,r,n,i):await this.doCopyFile(e,t,n,i)}return s}return e===n?(await e.rename(t,i,{overwrite:o}),s):(await this.doMoveCopy(e,t,n,i,"copy",o),await this.del(t,{recursive:!0}),"copy")}async doCopyFile(e,t,n,i){return r.hasOpenReadWriteCloseCapability(e)&&r.hasOpenReadWriteCloseCapability(n)?this.doPipeBuffered(e,t,n,i):r.hasOpenReadWriteCloseCapability(e)&&r.hasReadWriteCapability(n)?this.doPipeBufferedToUnbuffered(e,t,n,i):r.hasReadWriteCapability(e)&&r.hasOpenReadWriteCloseCapability(n)?this.doPipeUnbufferedToBuffered(e,t,n,i):r.hasReadWriteCapability(e)&&r.hasReadWriteCapability(n)?this.doPipeUnbuffered(e,t,n,i):void 0}async doCopyFolder(e,t,n,r){await n.mkdir(r),Array.isArray(t.children)&&await Promise.all(t.children.map(async t=>{const i=a.joinPath(r,t.name);return t.isDirectory?this.doCopyFolder(e,await this.resolve(t.resource),n,i):this.doCopyFile(e,t.resource,n,i)}))}async doValidateMoveCopy(e,t,n,i,s,o){let a=!1;if(e===n){
const{extUri:n,isPathCaseSensitive:r}=this.getExtUri(e);if(r||(a=n.isEqual(t,i)),a&&"copy"===s)throw new Error(c.localize(13,null,this.resourceForError(t),this.resourceForError(i)));if(!a&&n.isEqualOrParent(i,t))throw new Error(c.localize(14,null,this.resourceForError(t),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!a){if(!o)throw new r.FileOperationError(c.localize(15,null,this.resourceForError(t),this.resourceForError(i)),4);if(e===n){const{extUri:n}=this.getExtUri(e);if(n.isEqualOrParent(t,i))throw new Error(c.localize(16,null,this.resourceForError(t),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:a}}getExtUri(e){const t=this.isPathCaseSensitive(e);return{extUri:t?a.extUri:a.extUriIgnorePathCase,isPathCaseSensitive:t}}isPathCaseSensitive(e){return!!(1024&e.capabilities)}async createFolder(e){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);await this.mkdirp(t,e);const n=await this.resolve(e,{resolveMetadata:!0})
;return this._onDidRunOperation.fire(new r.FileOperationEvent(e,0,n)),n}async mkdirp(e,t){const n=[],{extUri:i}=this.getExtUri(e);for(;!i.isEqual(t,a.dirname(t));)try{if(0==((await e.stat(t)).type&r.FileType.Directory))throw new Error(c.localize(17,null,this.resourceForError(t)));break}catch(e){if(r.toFileSystemProviderErrorCode(e)!==r.FileSystemProviderErrorCode.FileNotFound)throw e;n.push(a.basename(t)),t=a.dirname(t)}for(let i=n.length-1;i>=0;i--){t=a.joinPath(t,n[i]);try{await e.mkdir(t)}catch(e){if(r.toFileSystemProviderErrorCode(e)!==r.FileSystemProviderErrorCode.FileExists)throw e}}}async canDelete(e,t){try{await this.doValidateDelete(e,t)}catch(e){return e}return!0}async doValidateDelete(e,t){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(e),e);if(!!(null==t?void 0:t.useTrash)&&!(4096&n.capabilities))throw new Error(c.localize(18,null,this.resourceForError(e)));const i=await this.exists(e);if(!i)throw new r.FileOperationError(c.localize(19,null,this.resourceForError(e)),1)
;if(!!!(null==t?void 0:t.recursive)&&i){const t=await this.resolve(e);if(t.isDirectory&&Array.isArray(t.children)&&t.children.length>0)throw new Error(c.localize(20,null,this.resourceForError(e)))}return n}async del(e,t){const n=await this.doValidateDelete(e,t),i=!!(null==t?void 0:t.useTrash),s=!!(null==t?void 0:t.recursive);await n.delete(e,{recursive:s,useTrash:i}),this._onDidRunOperation.fire(new r.FileOperationEvent(e,1))}watch(e,t={recursive:!1,excludes:[]}){let r=!1,i=n.toDisposable(()=>r=!0);return this.doWatch(e,t).then(e=>{r?n.dispose(e):i=e},e=>this.logService.error(e)),n.toDisposable(()=>n.dispose(i))}async doWatch(e,t){const r=await this.withProvider(e),i=this.toWatchKey(r,e,t),s=this.activeWatchers.get(i)||{count:0,disposable:r.watch(e,t)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,s),s.count+=1,n.toDisposable(()=>{s.count--,0===s.count&&(n.dispose(s.disposable),this.activeWatchers.delete(i))})}toWatchKey(e,t,n){const{extUri:r}=this.getExtUri(e)
;return[r.getComparisonKey(t),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(e=>n.dispose(e.disposable)),this.activeWatchers.clear()}ensureWriteQueue(e,t){const{extUri:r}=this.getExtUri(e),s=r.getComparisonKey(t);let o=this.writeQueues.get(s);if(!o){o=new m.Queue,this.writeQueues.set(s,o),i.Event.once(o.onFinished)(()=>{this.writeQueues.delete(s),n.dispose(o)})}return o}async doWriteBuffered(e,t,n){return this.ensureWriteQueue(e,t).queue(async()=>{const i=await e.open(t,{create:!0});try{p.isReadableStream(n)||p.isReadableBufferedStream(n)?await this.doWriteStreamBufferedQueued(e,i,n):await this.doWriteReadableBufferedQueued(e,i,n)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await e.close(i)}})}async doWriteStreamBufferedQueued(e,t,n){let r,i=0;if(p.isReadableBufferedStream(n)){if(n.buffer.length>0){const r=f.VSBuffer.concat(n.buffer);await this.doWriteBuffer(e,t,r,r.byteLength,i,0),i+=r.byteLength}if(n.ended)return;r=n.stream}else r=n
;return new Promise(async(n,s)=>{r.on("data",async n=>{r.pause();try{await this.doWriteBuffer(e,t,n,n.byteLength,i,0)}catch(e){return s(e)}i+=n.byteLength,setTimeout(()=>r.resume())}),r.on("error",e=>s(e)),r.on("end",()=>n())})}async doWriteReadableBufferedQueued(e,t,n){let r,i=0;for(;null!==(r=n.read());)await this.doWriteBuffer(e,t,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(e,t,n,r,i,s){let o=0;for(;o<r;){o+=await e.write(t,i+o,n.buffer,s+o,r-o)}}async doWriteUnbuffered(e,t,n){return this.ensureWriteQueue(e,t).queue(()=>this.doWriteUnbufferedQueued(e,t,n))}async doWriteUnbufferedQueued(e,t,n){let r;r=n instanceof f.VSBuffer?n:p.isReadableStream(n)?await f.streamToBuffer(n):p.isReadableBufferedStream(n)?await f.bufferedStreamToBuffer(n):f.readableToBuffer(n),await e.writeFile(t,r.buffer,{create:!0,overwrite:!0})}async doPipeBuffered(e,t,n,r){return this.ensureWriteQueue(n,r).queue(()=>this.doPipeBufferedQueued(e,t,n,r))}async doPipeBufferedQueued(e,t,n,i){let s=void 0,o=void 0;try{
s=await e.open(t,{create:!1}),o=await n.open(i,{create:!0});const r=f.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,c=0,l=0;do{l=await e.read(s,a,r.buffer,c,r.byteLength-c),await this.doWriteBuffer(n,o,r,l,a,c),a+=l,(c+=l)===r.byteLength&&(c=0)}while(l>0)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{await Promise.all(["number"==typeof s?e.close(s):Promise.resolve(),"number"==typeof o?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(e,t,n,r){return this.ensureWriteQueue(n,r).queue(()=>this.doPipeUnbufferedQueued(e,t,n,r))}async doPipeUnbufferedQueued(e,t,n,r){return n.writeFile(r,await e.readFile(t),{create:!0,overwrite:!0})}async doPipeUnbufferedToBuffered(e,t,n,r){return this.ensureWriteQueue(n,r).queue(()=>this.doPipeUnbufferedToBufferedQueued(e,t,n,r))}async doPipeUnbufferedToBufferedQueued(e,t,n,i){const s=await n.open(i,{create:!0});try{const r=await e.readFile(t);await this.doWriteBuffer(n,s,f.VSBuffer.wrap(r),r.byteLength,0,0)}catch(e){throw r.ensureFileSystemProviderError(e)}finally{
await n.close(s)}}async doPipeBufferedToUnbuffered(e,t,n,r){const i=await f.streamToBuffer(this.readFileBuffered(e,t,g.CancellationToken.None));await this.doWriteUnbuffered(n,r,i)}throwIfFileSystemIsReadonly(e,t){if(2048&e.capabilities)throw new r.FileOperationError(c.localize(21,null,this.resourceForError(t)),6);return e}resourceForError(e){return e.scheme===v.Schemas.file?e.fsPath:e.toString(!0)}};w=s([o(0,d.ILogService)],w),t.FileService=w})),define(t[54],n([0,1,20,48,3,27,6,5,14,2,22,30,17,12,148,86,166,168,165,174,45,85,16,19]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p,m,g,v,y,b,w,_,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class C extends i.Disposable{constructor(e,t){var n;super(),this.logService=e,this.options=t,this.BUFFER_SIZE=(null===(n=this.options)||void 0===n?void 0:n.bufferSize)||65536,this.onDidChangeCapabilities=o.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Set,this.canFlush=!0,
this._onDidWatchErrorOccur=this._register(new o.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new o.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new d.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=30,a.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:t,symbolicLink:n}=await c.statLink(this.toFilePath(e));return{type:this.toType(t,n),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(e){try{const t=await c.readdirWithFileTypes(this.toFilePath(e)),n=[];return await Promise.all(t.map(async t=>{try{let r;r=t.isSymbolicLink()?(await this.stat(u.joinPath(e,t.name))).type:this.toType(t),n.push([t.name,r])}catch(e){this.logService.trace(e)}})),n}catch(e){throw this.toFileSystemProviderError(e)}}toType(e,t){let n
;return n=(null==t?void 0:t.dangling)?s.FileType.Unknown:e.isFile()?s.FileType.File:e.isDirectory()?s.FileType.Directory:s.FileType.Unknown,t&&(n|=s.FileType.SymbolicLink),n}async readFile(e){try{const t=this.toFilePath(e);return await c.readFile(t)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(e,t,n){const r=w.newWriteableStream(e=>S.VSBuffer.concat(e.map(e=>S.VSBuffer.wrap(e))).buffer);return _.readFileIntoStream(this,e,r,e=>e.buffer,Object.assign(Object.assign({},t),{bufferSize:this.BUFFER_SIZE}),n),r}async writeFile(e,t,n){let r=void 0;try{const i=this.toFilePath(e);if(!n.create||!n.overwrite){if(await c.exists(i)){if(!n.overwrite)throw s.createFileSystemProviderError(p.localize(0,null),s.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw s.createFileSystemProviderError(p.localize(1,null),s.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(e,{create:!0}),await this.write(r,0,t,0,t.byteLength)}catch(e){throw this.toFileSystemProviderError(e)}finally{
"number"==typeof r&&await this.close(r)}}async open(e,t){try{const i=this.toFilePath(e);let s=void 0;if(t.create){if(a.isWindows&&await c.exists(i))try{await c.truncate(i,0),s="r+"}catch(e){this.logService.trace(e)}s||(s="w")}else s="r";const o=await r.promisify(n.open)(i,s);return this.mapHandleToPos.set(o,0),t.create&&this.writeHandles.add(o),o}catch(e){throw this.toFileSystemProviderError(e)}}async close(e){try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&this.canFlush)try{await r.promisify(n.fdatasync)(e)}catch(e){this.canFlush=!1,this.logService.error(e)}return await r.promisify(n.close)(e)}catch(e){throw this.toFileSystemProviderError(e)}}async read(e,t,i,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await r.promisify(n.read)(e,i,s,o,a);return c="number"==typeof t?t:t.bytesRead}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}normalizePos(e,t){return t===this.mapHandleToPos.get(e)?null:t}updatePos(e,t,n){const r=this.mapHandleToPos.get(e)
;"number"==typeof r&&("number"==typeof t||("number"==typeof n?this.mapHandleToPos.set(e,r+n):this.mapHandleToPos.delete(e)))}async write(e,t,n,r,i){return d.retry(()=>this.doWrite(e,t,n,r,i),100,3)}async doWrite(e,t,i,s,o){const a=this.normalizePos(e,t);let c=null;try{const t=await r.promisify(n.write)(e,i,s,o,a);return c="number"==typeof t?t:t.bytesWritten}catch(e){throw this.toFileSystemProviderError(e)}finally{this.updatePos(e,a,c)}}async mkdir(e){try{await r.promisify(n.mkdir)(this.toFilePath(e))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(e,t){try{const n=this.toFilePath(e);await this.doDelete(n,t)}catch(e){throw this.toFileSystemProviderError(e)}}async doDelete(e,t){t.recursive?await c.rimraf(e,c.RimRafMode.MOVE):await c.unlink(e)}async rename(e,t,n){const r=this.toFilePath(e),i=this.toFilePath(t);if(r!==i)try{await this.validateTargetDeleted(e,t,"move",n.overwrite),await c.move(r,i)}catch(e){
throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(p.localize(2,null,l.basename(r),l.basename(l.dirname(i)),e.toString()))),this.toFileSystemProviderError(e)}}async copy(e,t,n){const r=this.toFilePath(e),i=this.toFilePath(t);if(r!==i)try{await this.validateTargetDeleted(e,t,"copy",n.overwrite),await c.copy(r,i)}catch(e){throw"EINVAL"!==e.code&&"EBUSY"!==e.code&&"ENAMETOOLONG"!==e.code||(e=new Error(p.localize(3,null,l.basename(r),l.basename(l.dirname(i)),e.toString()))),this.toFileSystemProviderError(e)}}async validateTargetDeleted(e,t,n,r){const i=this.toFilePath(e),o=this.toFilePath(t);let a=!1;if(!!(1024&this.capabilities)||(a=h.isEqual(i,o,!0)),a&&"copy"===n)throw s.createFileSystemProviderError(p.localize(4,null),s.FileSystemProviderErrorCode.FileExists);if(!a&&await c.exists(o)){if(!r)throw s.createFileSystemProviderError(p.localize(5,null),s.FileSystemProviderErrorCode.FileExists);await this.delete(t,{recursive:!0,useTrash:!1})}}watch(e,t){
return t.recursive?this.watchRecursive(e,t.excludes):this.watchNonRecursive(e)}watchRecursive(e,t){const n={path:this.toFilePath(e),excludes:t},r=E.insert(this.recursiveFoldersToWatch,n);return this.refreshRecursiveWatchers(),i.toDisposable(()=>{r(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var e,t,n;if(this.recursiveWatcher instanceof y.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(i.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let r,i=void 0;(null===(t=null===(e=this.options)||void 0===e?void 0:e.watcher)||void 0===t?void 0:t.usePolling)?(r=g.FileWatcher,i=null===(n=this.options)||void 0===n?void 0:n.watcher):r=1===this.recursiveFoldersToWatch.length?a.isWindows?v.FileWatcher:g.FileWatcher:y.FileWatcher,
this.recursiveWatcher=new r(this.recursiveFoldersToWatch,e=>this._onDidChangeFile.fire(m.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace,i),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))}}watchNonRecursive(e){const t=new b.FileWatcher(this.toFilePath(e),e=>this._onDidChangeFile.fire(m.toFileChanges(e)),e=>{"error"===e.type&&this._onDidWatchErrorOccur.fire(e.message),this.logService[e.type](e.message)},this.logService.getLevel()===f.LogLevel.Trace),n=this.logService.onDidChangeLogLevel(()=>{t.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return i.combinedDisposable(t,n)}toFilePath(e){return l.normalize(e.fsPath)}toFileSystemProviderError(e){if(e instanceof s.FileSystemProviderError)return e
;let t;switch(e.code){case"ENOENT":t=s.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=s.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=s.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=s.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=s.FileSystemProviderErrorCode.NoPermissions;break;default:t=s.FileSystemProviderErrorCode.Unknown}return s.createFileSystemProviderError(e,t)}dispose(){super.dispose(),i.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,i.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=C})),define(t[88],n([0,1,14,60,31,3,26,17,34,12,87,16,6,8,2]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let v=class extends a.Disposable{constructor(e,t,n){super(),this.extensionManagementService=e,this.logService=n,
this._onDidLanguagesChange=this._register(new p.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new y(t,n)),this._register(e.onDidInstallExtension(({local:e})=>this.onDidInstallExtension(e))),this._register(e.onDidUninstallExtension(({identifier:e})=>this.onDidUninstallExtension(e)))}getLanguageIds(){return this.cache.getLanguagePacks().then(e=>{const t=["en",...Object.keys(e)];return f.distinct(t)})}onDidInstallExtension(e){e&&e.manifest&&e.manifest.contributes&&e.manifest.contributes.localizations&&e.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",e.identifier.id),this.update().then(e=>{e&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(e){this.cache.getLanguagePacks().then(t=>{Object.keys(t).some(n=>t[n]&&t[n].extensions.some(t=>u.areSameExtensions(t.extensionIdentifier,e)))&&(this.logService.debug("Removing language packs from the extension",e.id),this.update().then(e=>{
e&&this._onDidLanguagesChange.fire()}))})}update(){return Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]).then(([e,t])=>this.cache.update(t).then(t=>!f.equals(Object.keys(e),Object.keys(t))))}};v=s([o(0,i.IExtensionManagementService),o(1,c.INativeEnvironmentService),o(2,h.ILogService)],v),t.LocalizationsService=v;let y=class extends a.Disposable{constructor(e,t){super(),this.logService=t,this.languagePacks={},this.languagePacksFilePath=g.join(e.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new l.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(e){return this.withLanguagePacks(t=>{Object.keys(t).forEach(e=>delete t[e]),this.createLanguagePacksFromExtensions(t,...e)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(e,...t){
for(const n of t)n&&n.manifest&&n.manifest.contributes&&n.manifest.contributes.localizations&&n.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(e,n);Object.keys(e).forEach(t=>this.updateHash(e[t]))}createLanguagePacksFromExtension(e,t){const n=t.identifier,r=t.manifest.contributes&&t.manifest.contributes.localizations?t.manifest.contributes.localizations:[];for(const i of r)if(t.location.scheme===m.Schemas.file&&d.isValidLocalization(i)){let r=e[i.languageId];r||(r={hash:"",extensions:[],translations:{}},e[i.languageId]=r);let s=r.extensions.filter(e=>u.areSameExtensions(e.extensionIdentifier,n))[0];s?s.version=t.manifest.version:r.extensions.push({extensionIdentifier:n,version:t.manifest.version});for(const e of i.translations)r.translations[e.id]=g.join(t.location.fsPath,e.path)}}updateHash(e){if(e){const t=r.createHash("md5");for(const n of e.extensions)t.update(n.extensionIdentifier.uuid||n.extensionIdentifier.id).update(n.version);e.hash=t.digest("hex")}}
withLanguagePacks(e=(()=>null)){return this.languagePacksFileLimiter.queue(()=>{let t=null;return n.readFile(this.languagePacksFilePath,"utf8").then(void 0,e=>"ENOENT"===e.code?Promise.resolve("{}"):Promise.reject(e)).then(e=>{try{return JSON.parse(e)}catch(e){return{}}}).then(n=>(t=e(n),n)).then(e=>{for(const t of Object.keys(e))e[t]||delete e[t];this.languagePacks=e,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),n.writeFile(this.languagePacksFilePath,t)}).then(()=>t,e=>this.logService.error(e))})}};y=s([o(0,c.INativeEnvironmentService),o(1,h.ILogService)],y)})),define(t[178],n([0,1,12,6]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FollowerLogService=t.LoggerChannelClient=t.LoggerChannel=void 0;t.LoggerChannel=class{constructor(e){this.service=e,this.onDidChangeLogLevel=r.Event.buffer(e.onDidChangeLogLevel,!0)}listen(e,t){switch(t){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}
throw new Error(`Event not found: ${t}`)}call(e,t,n){switch(t){case"setLevel":return this.service.setLevel(n),Promise.resolve();case"consoleLog":return this.consoleLog(n[0],n[1]),Promise.resolve()}throw new Error(`Call not found: ${t}`)}consoleLog(e,t){let n=console.log;switch(e){case"error":n=console.error;break;case"warn":n=console.warn;break;case"info":n=console.info}n.call(console,...t)}};class i{constructor(e){this.channel=e}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(e){i.setLevel(this.channel,e)}static setLevel(e,t){return e.call("setLevel",t)}consoleLog(e,t){this.channel.call("consoleLog",[e,t])}}t.LoggerChannelClient=i;class s extends n.DelegatedLogService{constructor(e,t){super(t),this.parent=e,this._register(e.onDidChangeLogLevel(e=>t.setLevel(e)))}setLevel(e){super.setLevel(e),this.parent.setLevel(e)}}t.FollowerLogService=s})),define(t[89],n([0,1,2,12]),(function(e,t,n,r){"use strict";function i(e,t,n){switch(t){case r.LogLevel.Trace:e.trace(n);break
;case r.LogLevel.Debug:e.debug(n);break;case r.LogLevel.Info:e.info(n);break;case r.LogLevel.Warning:e.warn(n);break;case r.LogLevel.Error:e.error(n);break;case r.LogLevel.Critical:e.critical(n);break;default:throw new Error("Invalid log level")}}Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogService=t.createRotatingLogger=void 0,t.createRotatingLogger=function(t,n,r,i){return e.__$__nodeRequire("spdlog").createRotatingLogger(t,n,r,i)};class s extends r.AbstractLogService{constructor(e,t,n){super(),this.name=e,this.logsFolder=t,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(n),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=async function(t,r){try{const i=await new Promise((t,n)=>{e(["spdlog"],t,n)});i.setAsyncMode(8192,500);const s=n.join(r,`${t}.log`);return i.createRotatingLoggerAsync(t,s,5242880,6)}catch(e){console.error(e)}
return null}(this.name,this.logsFolder).then(e=>{if(e){this._logger=e,this._logger.setLevel(this.getLevel());for(const{level:e,message:t}of this.buffer)i(this._logger,e,t);this.buffer=[]}})),this._loggerCreationPromise}_log(e,t){this._logger?i(this._logger,e,t):this.getLevel()<=e&&this.buffer.push({level:e,message:t})}trace(e,...t){this.getLevel()<=r.LogLevel.Trace&&this._log(r.LogLevel.Trace,this.format([e,...t]))}debug(e,...t){this.getLevel()<=r.LogLevel.Debug&&this._log(r.LogLevel.Debug,this.format([e,...t]))}info(e,...t){this.getLevel()<=r.LogLevel.Info&&this._log(r.LogLevel.Info,this.format([e,...t]))}warn(e,...t){this.getLevel()<=r.LogLevel.Warning&&this._log(r.LogLevel.Warning,this.format([e,...t]))}error(e,...t){if(this.getLevel()<=r.LogLevel.Error)if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(r.LogLevel.Error,this.format(t))}else this._log(r.LogLevel.Error,this.format([e,...t]))}critical(e,...t){
this.getLevel()<=r.LogLevel.Critical&&this._log(r.LogLevel.Critical,this.format([e,...t]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(e){let t="";for(let n=0;n<e.length;n++){let r=e[n];if("object"==typeof r)try{r=JSON.stringify(r)}catch(e){}t+=(n>0?" ":"")+r}return t}}t.SpdLogService=s})),define(t[179],n([0,1,7,149,73]),(function(e,t,n,r,i){"use strict";var s;Object.defineProperty(t,"__esModule",{value:!0}),t.IMarkerService=t.IMarkerData=t.MarkerSeverity=t.MarkerTag=void 0,function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"}(t.MarkerTag||(t.MarkerTag={})),function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"
}(s=t.MarkerSeverity||(t.MarkerSeverity={})),function(e){e.compare=function(e,t){return t-e};const t=Object.create(null);t[e.Error]=r.localize(0,null),t[e.Warning]=r.localize(1,null),t[e.Info]=r.localize(2,null),e.toString=function(e){return t[e]||""},e.fromSeverity=function(t){switch(t){case i.default.Error:return e.Error;case i.default.Warning:return e.Warning;case i.default.Info:return e.Info;case i.default.Ignore:return e.Hint}},e.toSeverity=function(t){switch(t){case e.Error:return i.default.Error;case e.Warning:return i.default.Warning;case e.Info:return i.default.Info;case e.Hint:return i.default.Ignore}}}(s=t.MarkerSeverity||(t.MarkerSeverity={})),function(e){const t="";function n(e,n){let r=[t];return e.source?r.push(e.source.replace("¦","\\¦")):r.push(t),e.code?"string"==typeof e.code?r.push(e.code.replace("¦","\\¦")):r.push(e.code.value.replace("¦","\\¦")):r.push(t),void 0!==e.severity&&null!==e.severity?r.push(s.toString(e.severity)):r.push(t),
e.message&&n?r.push(e.message.replace("¦","\\¦")):r.push(t),void 0!==e.startLineNumber&&null!==e.startLineNumber?r.push(e.startLineNumber.toString()):r.push(t),void 0!==e.startColumn&&null!==e.startColumn?r.push(e.startColumn.toString()):r.push(t),void 0!==e.endLineNumber&&null!==e.endLineNumber?r.push(e.endLineNumber.toString()):r.push(t),void 0!==e.endColumn&&null!==e.endColumn?r.push(e.endColumn.toString()):r.push(t),r.push(t),r.join("¦")}e.makeKey=function(e){return n(e,!0)},e.makeKeyOptionalMessage=n}(t.IMarkerData||(t.IMarkerData={})),t.IMarkerService=n.createDecorator("markerService")})),define(t[180],n([0,1,73,7,6]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NoOpProgress=t.NoOpNotification=t.NotificationsFilter=t.NeverShowAgainScope=t.INotificationService=t.Severity=void 0,t.Severity=n.default,t.INotificationService=r.createDecorator("notificationService"),function(e){e[e.WORKSPACE=0]="WORKSPACE",e[e.GLOBAL=1]="GLOBAL"
}(t.NeverShowAgainScope||(t.NeverShowAgainScope={})),function(e){e[e.OFF=0]="OFF",e[e.SILENT=1]="SILENT",e[e.ERROR=2]="ERROR"}(t.NotificationsFilter||(t.NotificationsFilter={}));t.NoOpNotification=class{constructor(){this.progress=new s,this.onDidClose=i.Event.None,this.onDidChangeVisibility=i.Event.None}updateSeverity(e){}updateMessage(e){}updateActions(e){}close(){}};class s{infinite(){}done(){}total(e){}worked(e){}}t.NoOpProgress=s})),define(t[24],n([0,1,5,44,8,22]),(function(e,t,n,r,i,s){"use strict";let o;if(Object.defineProperty(t,"__esModule",{value:!0}),n.isWeb||void 0===e||"function"!=typeof e.__$__nodeRequire)o={webBuiltInExtensions:[{name:"ms-vscode.github-browser",version:"0.0.13",repo:"https://github.com/microsoft/vscode-github-browser",metadata:{id:"c1bcff4b-4ecb-466e-b8f6-b02788b5fb5a",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],nameShort:"Code",
nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",
updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}",
"Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}",
"EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}",
"Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py,**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],
pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{
name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{
name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",
windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",
windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{
friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-maven":{name:"Maven for Java"}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{
"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",
windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{
friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",
extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],
ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},
extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{
"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",
keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://www.research.net/r/Z2RMYRJ",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",
settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],
extensionAllowedProposedApi:["GitHub.codespaces","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.vscode-ai","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.references-view","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","sandy081.999-test-github-issue-notebooks"],
tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"]},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{
loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["https://management.core.windows.net/.default","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.14",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.5",
repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.71",repo:"https://github.com/microsoft/vscode-reference-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.8",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.51.0",
repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.11",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.51.1",commit:"e5a624b788d92b8d34d1392e4c4d9789406efe8f",date:"2020-11-10T23:20:27.310Z"},0===Object.keys(o).length&&Object.assign(o,{version:"1.51.0-dev",nameShort:n.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:n.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",
licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/master/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.references-view","ms-vscode.github-browser"]});else{const t=s.dirname(i.FileAccess.asFileUri("",e));o=e.__$__nodeRequire(s.joinPath(t,"product.json").fsPath);const n=e.__$__nodeRequire(s.joinPath(t,"package.json").fsPath);r.env.VSCODE_DEV&&Object.assign(o,{nameShort:`${o.nameShort} Dev`,nameLong:`${o.nameLong} Dev`,dataFolderName:`${o.dataFolderName}-dev`}),Object.assign(o,{version:n.version})}t.default=o})),define(t[90],n([0,1,121,25,2,22,108,24,131,8,4,40]),(function(e,t,n,r,i,o,a,c,l,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseUserDataDir=t.parsePathArg=t.parseSearchPort=t.parseExtensionHostPort=t.NativeEnvironmentService=void 0;class f{constructor(e){if(this._args=e,!process.env.VSCODE_LOGS){const e=l.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")
;process.env.VSCODE_LOGS=i.join(this.userDataPath,"logs",e)}this.logsPath=process.env.VSCODE_LOGS}get args(){return this._args}get appRoot(){return i.dirname(u.FileAccess.asFileUri("",e).fsPath)}get userHome(){return h.URI.file(r.homedir())}get userDataPath(){const e=process.env.VSCODE_PORTABLE;return e?i.join(e,"user-data"):v(this._args,process)}get appSettingsHome(){return h.URI.file(i.join(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(r.tmpdir())}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return o.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return o.joinPath(this.userRoamingDataHome,"sync")}get userDataSyncLogResource(){return h.URI.file(i.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return o.joinPath(h.URI.file(i.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return h.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){
return h.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return o.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return o.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const e=process.env.VSCODE_PORTABLE;return e?h.URI.file(i.join(e,"argv.json")):o.joinPath(this.userHome,c.default.dataFolderName,"argv.json")}get snippetsHome(){return o.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this._args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file(i.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return i.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const t=g(this._args["builtin-extensions-dir"],process);return t||i.normalize(i.join(u.FileAccess.asFileUri("",e).fsPath,"..","extensions"))}get extensionsDownloadPath(){const e=g(this._args["extensions-download-dir"],process)
;return e||i.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const e=g(this._args["extensions-dir"],process);if(e)return e;const t=process.env.VSCODE_EXTENSIONS;if(t)return t;const n=process.env.VSCODE_PORTABLE;return n?i.join(n,"extensions"):o.joinPath(this.userHome,c.default.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const e=this._args.extensionDevelopmentPath;if(Array.isArray(e))return e.map(e=>/^[^:/?#]+?:\/\//.test(e)?h.URI.parse(e):h.URI.file(i.normalize(e)))}get extensionTestsLocationURI(){const e=this._args.extensionTestsPath;if(e)return/^[^:/?#]+?:\/\//.test(e)?h.URI.parse(e):h.URI.file(i.normalize(e))}get disableExtensions(){if(this._args["disable-extensions"])return!0;const e=this._args["disable-extension"];if(e){if("string"==typeof e)return[e];if(Array.isArray(e)&&e.length>0)return e}return!1}get debugExtensionHost(){return p(this._args,this.isBuilt)}get debugRenderer(){return!!this._args.debugRenderer}get isBuilt(){return!process.env.VSCODE_DEV}
get verbose(){return!!this._args.verbose}get logLevel(){return this._args.log}get sharedIPCHandle(){return d.createStaticIPCHandle(this.userDataPath,"shared",c.default.version)}get serviceMachineIdResource(){return o.joinPath(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this._args["crash-reporter-id"]}get crashReporterDirectory(){return this._args["crash-reporter-directory"]}get driverHandle(){return this._args.driver}get telemetryLogResource(){return h.URI.file(i.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this._args["disable-telemetry"]}}function p(e,t){return m(e["inspect-extensions"],e["inspect-brk-extensions"],5870,t,e.debugId)}function m(e,t,n,r,i){const s=Number(t||e)||(r?null:n);return{port:s,break:!!s&&Boolean(!!t),debugId:i}}function g(e,t){if(!e)return;const n=i.resolve(e);return i.normalize(e)===n?n:i.resolve(t.env.VSCODE_CWD||t.cwd(),e)}function v(e,t){return g(e["user-data-dir"],t)||i.resolve(n.getDefaultUserDataPath(t.platform))}
s([a.memoize],f.prototype,"appRoot",null),s([a.memoize],f.prototype,"userHome",null),s([a.memoize],f.prototype,"userDataPath",null),s([a.memoize],f.prototype,"appSettingsHome",null),s([a.memoize],f.prototype,"tmpDir",null),s([a.memoize],f.prototype,"userRoamingDataHome",null),s([a.memoize],f.prototype,"settingsResource",null),s([a.memoize],f.prototype,"userDataSyncHome",null),s([a.memoize],f.prototype,"userDataSyncLogResource",null),s([a.memoize],f.prototype,"sync",null),s([a.memoize],f.prototype,"machineSettingsResource",null),s([a.memoize],f.prototype,"globalStorageHome",null),s([a.memoize],f.prototype,"workspaceStorageHome",null),s([a.memoize],f.prototype,"keybindingsResource",null),s([a.memoize],f.prototype,"keyboardLayoutResource",null),s([a.memoize],f.prototype,"argvResource",null),s([a.memoize],f.prototype,"snippetsHome",null),s([a.memoize],f.prototype,"isExtensionDevelopment",null),s([a.memoize],f.prototype,"untitledWorkspacesHome",null),s([a.memoize],f.prototype,"installSourcePath",null),
s([a.memoize],f.prototype,"builtinExtensionsPath",null),s([a.memoize],f.prototype,"extensionsPath",null),s([a.memoize],f.prototype,"extensionDevelopmentLocationURI",null),s([a.memoize],f.prototype,"extensionTestsLocationURI",null),s([a.memoize],f.prototype,"debugExtensionHost",null),s([a.memoize],f.prototype,"sharedIPCHandle",null),s([a.memoize],f.prototype,"serviceMachineIdResource",null),s([a.memoize],f.prototype,"telemetryLogResource",null),t.NativeEnvironmentService=f,t.parseExtensionHostPort=p,t.parseSearchPort=function(e,t){return m(e["inspect-search"],e["inspect-brk-search"],5876,t)},t.parsePathArg=g,t.parseUserDataDir=v})),define(t[42],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=n.createDecorator("productService")})),define(t[32],n([0,1,11,107]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;t.Registry=new class{constructor(){this.data=new Map}add(e,t){
r.ok(n.isString(e)),r.ok(n.isObject(t)),r.ok(!this.data.has(e),"There is already an extension with this id"),this.data.set(e,t)}knows(e){return this.data.has(e)}as(e){return this.data.get(e)||null}}})),define(t[181],n([0,1,32,6]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};const i=new class{constructor(){this._onDidChangeSchema=new r.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(e,t){var n;this.schemasById[(n=e,n.length>0&&"#"===n.charAt(n.length-1)?n.substring(0,n.length-1):n)]=t,this._onDidChangeSchema.fire(e)}notifySchemaChanged(e){this._onDidChangeSchema.fire(e)}getSchemaContributions(){return{schemas:this.schemasById}}};n.Registry.add(t.Extensions.JSONContribution,i)})),define(t[43],n([0,1,138,6,32,11,181]),(function(e,t,n,r,i,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"},function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"}(t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},
t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const a=i.Registry.as(o.Extensions.JSONContribution);function c(e){return e.substring(1,e.length-1)}function l(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.OVERRIDE_PROPERTY_PATTERN=new RegExp("\\[.*\\]$"),t.overrideIdentifierFromKey=c,t.getDefaultValue=l;const u=new class{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new r.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new r.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:n.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},
patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(e,t=!0){this.registerConfigurations([e],t)}registerConfigurations(e,n=!0){const r=[];e.forEach(e=>{r.push(...this.validateAndRegisterProperties(e,n)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterConfigurations(e){const n=[],r=e=>{if(e.properties)for(const t in e.properties)n.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,e.properties[t]);e.allOf&&e.allOf.forEach(e=>r(e))};for(const t of e){r(t);const e=this.configurationContributors.indexOf(t)
;-1!==e&&this.configurationContributors.splice(e,1)}a.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}registerDefaultConfigurations(e){const r=[],i=[];for(const s of e)for(const e in s)if(r.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]=Object.assign(Object.assign({},this.defaultValues[e]||{}),s[e]);const r={type:"object",default:this.defaultValues[e],description:n.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};i.push(c(e)),this.configurationProperties[e]=r,this.defaultLanguageConfigurationOverridesNode.properties[e]=r}else{this.defaultValues[e]=s[e];const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.registerOverrideIdentifiers(i),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(r)}deregisterDefaultConfigurations(e){const n=[];for(const r of e)for(const e in r)if(n.push(e),
delete this.defaultValues[e],t.OVERRIDE_PROPERTY_PATTERN.test(e))delete this.configurationProperties[e],delete this.defaultLanguageConfigurationOverridesNode.properties[e];else{const t=this.configurationProperties[e];t&&(this.updatePropertyDefaultValue(e,t),this.updateSchema(e,t))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const t of e)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(e,n=!0,r=3){r=s.isUndefinedOrNull(e.scope)?r:e.scope;let i=[],o=e.properties;if(o)for(let e in o){if(n&&h(e)){delete o[e];continue}const a=o[e];this.updatePropertyDefaultValue(e,a),t.OVERRIDE_PROPERTY_PATTERN.test(e)?a.scope=void 0:a.scope=s.isUndefinedOrNull(a.scope)?r:a.scope,!o[e].hasOwnProperty("included")||o[e].included?(this.configurationProperties[e]=o[e],
!o[e].deprecationMessage&&o[e].markdownDeprecationMessage&&(o[e].deprecationMessage=o[e].markdownDeprecationMessage),i.push(e)):(this.excludedConfigurationProperties[e]=o[e],delete o[e])}let a=e.allOf;if(a)for(let e of a)i.push(...this.validateAndRegisterProperties(e,n,r));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(e){const t=e=>{let n=e.properties;if(n)for(const e in n)this.updateSchema(e,n[e]);let r=e.allOf;r&&r.forEach(t)};t(e)}updateSchema(e,n){switch(t.allSettings.properties[e]=n,n.scope){case 1:t.applicationSettings.properties[e]=n;break;case 2:t.machineSettings.properties[e]=n;break;case 6:t.machineOverridableSettings.properties[e]=n;break;case 3:t.windowSettings.properties[e]=n;break;case 4:t.resourceSettings.properties[e]=n;break;case 5:t.resourceSettings.properties[e]=n,
this.resourceLanguageSettingsSchema.properties[e]=n}}removeFromSchema(e,n){switch(delete t.allSettings.properties[e],n.scope){case 1:delete t.applicationSettings.properties[e];break;case 2:delete t.machineSettings.properties[e];break;case 6:delete t.machineOverridableSettings.properties[e];break;case 3:delete t.windowSettings.properties[e];break;case 4:case 5:delete t.resourceSettings.properties[e]}}updateOverridePropertyPatternKey(){for(const e of this.overrideIdentifiers.values()){const r=`[${e}]`,i={type:"object",description:n.localize(2,null),errorMessage:n.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,i),t.allSettings.properties[r]=i,t.applicationSettings.properties[r]=i,t.machineSettings.properties[r]=i,t.machineOverridableSettings.properties[r]=i,t.windowSettings.properties[r]=i,t.resourceSettings.properties[r]=i}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(e,t){let n=this.defaultValues[e];s.isUndefined(n)&&(n=t.default),
s.isUndefined(n)&&(n=l(t.type)),t.default=n}};function h(e){return t.OVERRIDE_PROPERTY_PATTERN.test(e)?n.localize(4,null,e):void 0!==u.getConfigurationProperties()[e]?n.localize(5,null,e):null}i.Registry.add(t.Extensions.Configuration,u),t.validateProperty=h,t.getScopes=function(){const e=[],t=u.getConfigurationProperties();for(const n of Object.keys(t))e.push([n,t[n].scope]);return e.push(["launch",4]),e.push(["task",4]),e}})),define(t[29],n([0,1,18,11,4,32,7,43]),(function(e,t,n,r,i,s,o,a){"use strict";function c(e,t){const n=Object.create(null);for(let r in e)l(n,r,e[r],t);return n}function l(e,t,n,r){const i=t.split("."),s=i.pop();let o=e;for(let e=0;e<i.length;e++){let n=i[e],s=o[n];switch(typeof s){case"undefined":s=o[n]=Object.create(null);break;case"object":break;default:return void r(`Ignoring ${t} as ${i.slice(0,e+1).join(".")} is ${JSON.stringify(s)}`)}o=s}if("object"==typeof o&&null!==o)try{o[s]=n}catch(e){r(`Ignoring ${t} as ${i.join(".")} is ${JSON.stringify(o)}`)
}else r(`Ignoring ${t} as ${i.join(".")} is ${JSON.stringify(o)}`)}function u(e,t,n){const r=function(e,t){let n=e;for(const e of t){if("object"!=typeof n||null===n)return;n=n[e]}return n}(e,t.split("."));return void 0===r?n:r}function h(e){return`[${e}]`}Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=o.createDecorator("configurationService"),t.isConfigurationOverrides=function(e){return e&&"object"==typeof e&&(!e.overrideIdentifier||"string"==typeof e.overrideIdentifier)&&(!e.resource||e.resource instanceof i.URI)},function(e){e[e.USER=1]="USER",e[e.USER_LOCAL=2]="USER_LOCAL",e[e.USER_REMOTE=3]="USER_REMOTE",e[e.WORKSPACE=4]="WORKSPACE",
e[e.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",e[e.DEFAULT=6]="DEFAULT",e[e.MEMORY=7]="MEMORY"}(t.ConfigurationTarget||(t.ConfigurationTarget={})),t.ConfigurationTargetToString=function(e){switch(e){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}},t.compare=function e(t,r){const i=r?t?r.keys.filter(e=>-1===t.keys.indexOf(e)):[...r.keys]:[],s=t?r?t.keys.filter(e=>-1===r.keys.indexOf(e)):[...t.keys]:[],o=[];if(r&&t)for(const e of t.keys)if(-1!==r.keys.indexOf(e)){const i=u(t.contents,e),s=u(r.contents,e);n.equals(i,s)||o.push(e)}const c=[],l=e=>{const t={};for(const n of e)for(const e of n.identifiers)t[h(e)]=n;return t},d=r?l(r.overrides):{},f=t?l(t.overrides):{};if(Object.keys(d).length)for(const e of i){const t=d[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}if(Object.keys(f).length)for(const e of s){const t=f[e];t&&c.push([a.overrideIdentifierFromKey(e),t.keys])}
if(Object.keys(d).length&&Object.keys(f).length)for(const t of o){const n=f[t],r=d[t];if(n&&r){const i=e({contents:n.contents,keys:n.keys,overrides:[]},{contents:r.contents,keys:r.keys,overrides:[]});c.push([a.overrideIdentifierFromKey(t),[...i.added,...i.removed,...i.updated]])}}return{added:i,removed:s,updated:o,overrides:c}},t.toOverrides=function(e,t){const n=[];for(const r of Object.keys(e))if(a.OVERRIDE_PROPERTY_PATTERN.test(r)){const i={};for(const t in e[r])i[t]=e[r][t];n.push({identifiers:[a.overrideIdentifierFromKey(r).trim()],keys:Object.keys(i),contents:c(i,t)})}return n},t.toValuesTree=c,t.addToValueTree=l,t.removeFromValueTree=function(e,t){!function e(t,n){const r=n.shift();if(0===n.length)return void delete t[r];if(-1!==Object.keys(t).indexOf(r)){const i=t[r];"object"!=typeof i||Array.isArray(i)||(e(i,n),0===Object.keys(i).length&&delete t[r])}}(e,t.split("."))},t.getConfigurationValue=u,t.merge=function e(t,n,i){Object.keys(n).forEach(s=>{
"__proto__"!==s&&(s in t?r.isObject(t[s])&&r.isObject(n[s])?e(t[s],n[s],i):i&&(t[s]=n[s]):t[s]=n[s])})},t.getConfigurationKeys=function(){const e=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();return Object.keys(e)},t.getDefaultValues=function(){const e=Object.create(null),t=s.Registry.as(a.Extensions.Configuration).getConfigurationProperties();for(let n in t){l(e,n,t[n].default,e=>console.error(`Conflict in default settings: ${e}`))}return e},t.keyFromOverrideIdentifier=h,t.getMigratedSettingValue=function(e,t,n){const r=e.inspect(t),i=e.inspect(n);return void 0!==r.userValue||void 0!==r.workspaceValue||void 0!==r.workspaceFolderValue?r.value:void 0!==i.userValue||void 0!==i.workspaceValue||void 0!==i.workspaceFolderValue?i.value:r.defaultValue}})),define(t[182],n([0,1,35,23,16,11,18,4,43,29,32,3,6,22]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class p{constructor(e={},t=[],n=[]){this._contents=e,this._keys=t,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length}getValue(e){return e?l.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,t){const n=this.getContentsForOverrideIdentifer(t);return n?e?l.getConfigurationValue(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.keys;return[]}override(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||"object"!=typeof t||!Object.keys(t).length)return this;let n={}
;for(const e of i.distinct([...Object.keys(this.contents),...Object.keys(t)])){let r=this.contents[e],i=t[e];i&&("object"==typeof r&&"object"==typeof i?(r=o.deepClone(r),this.mergeContents(r,i)):r=i),n[e]=r}return new p(n,this.keys,this.overrides)}merge(...e){const t=o.deepClone(this.contents),n=o.deepClone(this.overrides),r=[...this.keys];for(const s of e){this.mergeContents(t,s.contents);for(const e of s.overrides){const[t]=n.filter(t=>i.equals(t.identifiers,e.identifiers));t?this.mergeContents(t.contents,e.contents):n.push(o.deepClone(e))}for(const e of s.keys)-1===r.indexOf(e)&&r.push(e)}return new p(t,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,t){for(const n of Object.keys(t))n in e&&s.isObject(e[n])&&s.isObject(t[n])?this.mergeContents(e[n],t[n]):e[n]=o.deepClone(t[n])}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?o.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.contents;return null}toJSON(){return{
contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),l.addToValueTree(this.contents,e,t,e=>{throw new Error(e)})}removeValue(e){this.removeKey(e)&&l.removeFromValueTree(this.contents,e)}addKey(e){let t=this.keys.length;for(let n=0;n<t;n++)0===e.indexOf(this.keys[n])&&(t=n);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return-1!==t&&(this.keys.splice(t,1),!0)}}t.ConfigurationModel=p;t.DefaultConfigurationModel=class extends p{constructor(){const e=l.getDefaultValues(),t=l.getConfigurationKeys(),n=[];for(const t of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(t)&&n.push({identifiers:[c.overrideIdentifierFromKey(t).trim()],keys:Object.keys(e[t]),contents:l.toValuesTree(e[t],e=>console.error(`Conflict in default settings file: ${e}`))});super(e,t,n)}};class m{constructor(e,t){this._name=e,this._scopes=t,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new p}get errors(){
return this._parseErrors}parseContent(e){if(!s.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t)}}parseRaw(e){this._raw=e;const t=this.doParseRaw(e);this._configurationModel=new p(t.contents,t.keys,t.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let t={},r=null,i=[],s=[],o=[];function a(e){Array.isArray(i)?i.push(e):r&&(i[r]=e)}let c={onObjectBegin:()=>{let e={};a(e),s.push(i),i=e,r=null},onObjectProperty:e=>{r=e},onObjectEnd:()=>{i=s.pop()},onArrayBegin:()=>{let e=[];a(e),s.push(i),i=e,r=null},onArrayEnd:()=>{i=s.pop()},onLiteralValue:a,onError:(e,t,n)=>{o.push({error:e,offset:t,length:n})}};if(e)try{n.visit(e,c),t=i[0]||{}}catch(e){console.error(`Error while parsing settings file ${this._name}: ${e}`),this._parseErrors=[e]}return t}doParseRaw(e){if(this._scopes){const t=u.Registry.as(c.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,t,!0,this._scopes)}return{
contents:l.toValuesTree(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`)),keys:Object.keys(e),overrides:l.toOverrides(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`))}}filterByScope(e,t,n,r){const i={};for(let s in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(s)&&n)i[s]=this.filterByScope(e[s],t,!1,r);else{const n=this.getScope(s,t);void 0!==n&&-1===r.indexOf(n)||(i[s]=e[s])}return i}getScope(e,t){const n=t[e];return n?void 0!==n.scope?n.scope:3:void 0}}t.ConfigurationModelParser=m;class g extends h.Disposable{constructor(e,t,n){super(),this.userSettingsResource=e,this.scopes=t,this.fileService=n,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(f.dirname(this.userSettingsResource))),this._register(d.Event.filter(this.fileService.onDidFilesChange,e=>e.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}
async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new p}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=g;class v{constructor(e,t,n=new p,i=new p,s=new r.ResourceMap,o=new p,a=new r.ResourceMap,c=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=n,this._workspaceConfiguration=i,this._folderConfigurations=s,this._memoryConfiguration=o,this._memoryConfigurationByResource=a,this._freeze=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new r.ResourceMap,this._userConfiguration=null}getValue(e,t,n){return this.getConsolidateConfigurationModel(t,n).getValue(e)}updateValue(e,t,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource))||(r=new p,this._memoryConfigurationByResource.set(n.resource,r)):r=this._memoryConfiguration,
void 0===t?r.removeValue(e):r.setValue(e,t),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,n){
const r=this.getConsolidateConfigurationModel(t,n),s=this.getFolderConfigurationModelForResource(t.resource,n),o=t.resource&&this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration,a=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),c=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),l=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),u=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),h=n?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,d=s?t.overrideIdentifier?s.freeze().override(t.overrideIdentifier).getValue(e):s.freeze().getValue(e):void 0,f=t.overrideIdentifier?o.override(t.overrideIdentifier).getValue(e):o.getValue(e),p=r.getValue(e),m=i.distinct(i.flatten(r.overrides.map(e=>e.identifiers))).filter(t=>void 0!==r.getOverrideValue(e,t))
;return{defaultValue:a,userValue:c,userLocalValue:l,userRemoteValue:u,workspaceValue:h,workspaceFolderValue:d,memoryValue:f,value:p,default:void 0!==a?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:void 0!==c?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:void 0!==l?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:void 0!==u?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:void 0!==h?{value:this._workspaceConfiguration.freeze().getValue(e),
override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:void 0!==d?{value:null==s?void 0:s.freeze().getValue(e),override:t.overrideIdentifier?null==s?void 0:s.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:void 0!==f?{value:o.getValue(e),override:t.overrideIdentifier?o.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:m.length?m:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,
this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const n=t.filter(e=>c.OVERRIDE_PROPERTY_PATTERN.test(e)).map(t=>{
const n=c.overrideIdentifierFromKey(t),r=this._defaultConfiguration.getKeysForOverrideIdentifier(n),i=e.getKeysForOverrideIdentifier(n),s=[...i.filter(e=>-1===r.indexOf(e)),...r.filter(e=>-1===i.indexOf(e)),...r.filter(t=>!o.equals(this._defaultConfiguration.override(n).getValue(t),e.override(n).getValue(t)))];return[n,s]});return this.updateDefaultConfiguration(e),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:n,removed:r,overrides:i}=l.compare(this.localUserConfiguration,e),s=[...t,...n,...r];return s.length&&this.updateLocalUserConfiguration(e),{keys:s,overrides:i}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:n,removed:r,overrides:i}=l.compare(this.remoteUserConfiguration,e);let s=[...t,...n,...r];return s.length&&this.updateRemoteUserConfiguration(e),{keys:s,overrides:i}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:n,removed:r,overrides:i}=l.compare(this.workspaceConfiguration,e);let s=[...t,...n,...r]
;return s.length&&this.updateWorkspaceConfiguration(e),{keys:s,overrides:i}}compareAndUpdateFolderConfiguration(e,t){const n=this.folderConfigurations.get(e),{added:r,updated:i,removed:s,overrides:o}=l.compare(n,t);let a=[...r,...i,...s];return!a.length&&n||this.updateFolderConfiguration(e,t),{keys:a,overrides:o}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:i,overrides:s}=l.compare(t,void 0);return{keys:[...n,...r,...i],overrides:s}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){
return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let n=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},t){let n=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const r=t.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const i=this._memoryConfigurationByResource.get(e);i&&(n=n.merge(i))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){
let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(t=n.merge(r),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=n}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const n=t.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:n,overrides:r,keys:i}=this._folderConfigurations.get(t);return e.push([t,{contents:n,overrides:r,keys:i}]),e},[])}}allKeys(){
const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(t=>e.add(t))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e))),[...t.values()]}static parse(e){const t=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),i=this.parseConfigurationModel(e.workspace),s=e.folders.reduce((e,t)=>(e.set(a.URI.revive(t[0]),this.parseConfigurationModel(t[1])),e),new r.ResourceMap);return new v(t,n,new p,i,s,new p,new r.ResourceMap,!1)}
static parseConfigurationModel(e){return new p(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v,t.mergeChanges=function(...e){if(0===e.length)return{keys:[],overrides:[]};if(1===e.length)return e[0];const t=new Set,n=new Map;for(const i of e)i.keys.forEach(e=>t.add(e)),i.overrides.forEach(([e,t])=>{const i=r.getOrSet(n,e,new Set);t.forEach(e=>i.add(e))});const i=[];return n.forEach((e,t)=>i.push([t,[...e.values()]])),{keys:[...t.values()],overrides:i}};class y{constructor(e,t,n,r){this.change=e,this.previous=t,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const i=new Set;e.keys.forEach(e=>i.add(e)),e.overrides.forEach(([,e])=>e.forEach(e=>i.add(e))),this.affectedKeys=[...i.values()];const s=new p;this.affectedKeys.forEach(e=>s.setValue(e,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}
affectsConfiguration(e,t){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,t,null===(n=this.previous)||void 0===n?void 0:n.workspace):void 0,i=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!o.equals(r,i)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let n,r=l.toValuesTree({[t]:!0},()=>{});for(;"object"==typeof r&&(n=Object.keys(r)[0]);){if(!(e=e[n]))return!1;r=r[n]}return!0}}t.ConfigurationChangeEvent=y;t.AllKeysConfigurationChangeEvent=class extends y{constructor(e,t,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,t),this.source=n,this.sourceConfig=r}}})),define(t[65],n([0,1,32,43,3,29,182,6,17]),(function(e,t,n,r,i,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class l extends i.Disposable{constructor(e,t){super(),this.settingsResource=e,this._onDidChangeConfiguration=this._register(new a.Emitter),
this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new o.UserSettings(this.settingsResource,void 0,t)),this.configuration=new o.Configuration(new o.DefaultConfigurationModel,new o.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new c.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(n.Registry.as(r.Extensions.Configuration).onDidUpdateConfiguration(e=>this.onDidDefaultConfigurationChange(e))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const e=await this.userConfiguration.loadConfiguration();this.configuration=new o.Configuration(new o.DefaultConfigurationModel,e)}getConfigurationData(){return this.configuration.toData()}getValue(e,t){const n="string"==typeof e?e:void 0,r=s.isConfigurationOverrides(e)?e:s.isConfigurationOverrides(t)?t:{};return this.configuration.getValue(n,r,void 0)}updateValue(e,t,n,r){
return Promise.reject(new Error("not supported"))}inspect(e){return this.configuration.inspect(e,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const e=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(e)}onDidChangeUserConfiguration(e){const t=this.configuration.toData(),n=this.configuration.compareAndUpdateLocalUserConfiguration(e);this.trigger(n,t,1)}onDidDefaultConfigurationChange(e){const t=this.configuration.toData(),n=this.configuration.compareAndUpdateDefaultConfiguration(new o.DefaultConfigurationModel,e);this.trigger(n,t,6)}trigger(e,t,n){const r=new o.ConfigurationChangeEvent(e,{data:t},this.configuration);r.source=n,r.sourceConfig=this.getTargetConfiguration(n),this._onDidChangeConfiguration.fire(r)}getTargetConfiguration(e){switch(e){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=l})),define(t[91],n([0,1,7]),(function(e,t,n){
"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAuthorityResolverError=t.RemoteAuthorityResolverErrorCode=t.IRemoteAuthorityResolverService=void 0,t.IRemoteAuthorityResolverService=n.createDecorator("remoteAuthorityResolverService"),function(e){e.Unknown="Unknown",e.NotAvailable="NotAvailable",e.TemporarilyNotAvailable="TemporarilyNotAvailable",e.NoResolverFound="NoResolverFound"}(r=t.RemoteAuthorityResolverErrorCode||(t.RemoteAuthorityResolverErrorCode={}));class i extends Error{constructor(e,t=r.Unknown,n){super(e),this._message=e,this._code=t,this._detail=n,this.isHandled=t===r.NotAvailable&&!0===n,"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,i.prototype)}static isTemporarilyNotAvailable(e){return e instanceof i&&e._code===r.TemporarilyNotAvailable}static isNoResolverFound(e){return e instanceof i&&e._code===r.NoResolverFound}static isHandled(e){return e instanceof i&&e.isHandled}}t.RemoteAuthorityResolverError=i})),
define(t[183],n([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=void 0,t.getRemoteAuthority=function(e){return e.scheme===n.Schemas.vscodeRemote?e.authority:void 0},t.getRemoteName=function(e){if(!e)return;const t=e.indexOf("+");return t<0?e:e.substr(0,t)}})),define(t[55],n([0,1,150,7,43,32,19]),(function(e,t,n,r,i,s,o){"use strict";function a(e){return e.res.statusCode&&e.res.statusCode>=200&&e.res.statusCode<300||1223===e.res.statusCode}function c(e){return 204===e.res.statusCode}Object.defineProperty(t,"__esModule",{value:!0}),t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=r.createDecorator("requestService"),t.isSuccess=a,t.asText=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);return c(e)?null:(await o.streamToBuffer(e.stream)).toString()},t.asJson=async function(e){if(!a(e))throw new Error("Server returned "+e.res.statusCode);if(c(e))return null
;const t=(await o.streamToBuffer(e.stream)).toString();try{return JSON.parse(t)}catch(e){throw e.message+=":\n"+t,e}},s.Registry.as(i.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:n.localize(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:n.localize(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:n.localize(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:n.localize(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[n.localize(4,null),n.localize(5,null),n.localize(6,null)],default:"override",description:n.localize(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:n.localize(8,null)}}})})),define(t[184],n([0,1,28,19]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestChannelClient=t.RequestChannel=void 0
;t.RequestChannel=class{constructor(e){this.service=e}listen(e,t){throw new Error("Invalid listen")}call(e,t,i){switch(t){case"request":return this.service.request(i[0],n.CancellationToken.None).then(async({res:e,stream:t})=>{const n=await r.streamToBuffer(t);return[{statusCode:e.statusCode,headers:e.headers},n]})}throw new Error("Invalid call")}};class i{constructor(e){this.channel=e}async request(e,t){return i.request(this.channel,e,t)}static async request(e,t,n){const[i,s]=await e.call("request",[t]);return{res:i,stream:r.bufferToStream(s)}}}t.RequestChannelClient=i})),define(t[185],n([0,1,66,11]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0,t.getProxyAgent=async function(t,i={}){const s=n.parse(t),o=i.proxyUrl||function(e){return"http:"===e.protocol?process.env.HTTP_PROXY||process.env.http_proxy||null:"https:"===e.protocol&&(process.env.HTTPS_PROXY||process.env.https_proxy||process.env.HTTP_PROXY||process.env.http_proxy)||null}(s)
;if(!o)return null;const a=n.parse(o);if(!/^https?:$/.test(a.protocol||""))return null;const c={host:a.hostname||"",port:a.port||("https"===a.protocol?"443":"80"),auth:a.auth,rejectUnauthorized:!r.isBoolean(i.strictSSL)||i.strictSSL};return"http:"===s.protocol?new(await new Promise((t,n)=>{e(["http-proxy-agent"],t,n)}))(c):new(await new Promise((t,n)=>{e(["https-proxy-agent"],t,n)}))(c)}})),define(t[186],n([0,1,21,19]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0,t.getServiceMachineId=async function(e,t,i){let s=i&&i.get("storage.serviceMachineId",0)||null;if(s)return s;try{const r=(await t.readFile(e.serviceMachineIdResource)).value.toString();s=n.isUUID(r)?r:null}catch(e){s=null}if(!s){s=n.generateUuid();try{await t.writeFile(e.serviceMachineIdResource,r.VSBuffer.fromString(s))}catch(e){}}return i&&i.store("storage.serviceMachineId",s,0),s}})),define(t[187],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0
}),t.IStateService=void 0,t.IStateService=n.createDecorator("stateService")})),define(t[188],n([0,1,2,20,26,14,11,12]),(function(e,t,n,r,i,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class u{constructor(e,t){this.dbPath=e,this.onError=t,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(this._database)return;const e=await this.loadAsync();this._database||(this._database=e)}loadSync(){try{return this.lastFlushedSerializedDatabase=r.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await a.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(e){return"ENOENT"!==e.code&&this.onError(e),{}}}getItem(e,t){const n=this.database[e];return c.isUndefinedOrNull(n)?t:n
}setItem(e,t){if(c.isUndefinedOrNull(t))return this.removeItem(e);("string"!=typeof t&&"number"!=typeof t&&"boolean"!=typeof t||this.database[e]!==t)&&(this.database[e]=t,this.saveSync())}removeItem(e){c.isUndefined(this.database[e])||(this.database[e]=void 0,this.saveSync())}saveSync(){const e=JSON.stringify(this.database,null,4);if(e!==this.lastFlushedSerializedDatabase)try{a.writeFileSync(this.dbPath,e),this.lastFlushedSerializedDatabase=e}catch(e){this.onError(e)}}}t.FileStorage=u;let h=class e{constructor(t,r){this.fileStorage=new u(n.join(t.userDataPath,e.STATE_FILE),e=>r.error(e))}init(){return this.fileStorage.init()}getItem(e,t){return this.fileStorage.getItem(e,t)}setItem(e,t){this.fileStorage.setItem(e,t)}removeItem(e){this.fileStorage.removeItem(e)}};h.STATE_FILE="storage.json",h=s([o(0,i.INativeEnvironmentService),o(1,l.ILogService)],h),t.StateService=h})),define(t[189],n([0,1,7,6,3,11]),(function(e,t,n,r,i,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),
t.logStorage=t.InMemoryStorageService=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker",t.IStorageService=n.createDecorator("storageService"),function(e){e[e.NONE=0]="NONE",e[e.SHUTDOWN=1]="SHUTDOWN"}(o=t.WillSaveStateReason||(t.WillSaveStateReason={})),function(e){e[e.GLOBAL=0]="GLOBAL",e[e.WORKSPACE=1]="WORKSPACE"}(t.StorageScope||(t.StorageScope={}));class a extends i.Disposable{constructor(){super(...arguments),this._onDidChangeStorage=this._register(new r.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onWillSaveState=this._register(new r.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.globalCache=new Map,this.workspaceCache=new Map}getCache(e){return 0===e?this.globalCache:this.workspaceCache}get(e,t,n){const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?n:r}getBoolean(e,t,n){const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?n:"true"===r}getNumber(e,t,n){
const r=this.getCache(t).get(e);return s.isUndefinedOrNull(r)?n:parseInt(r,10)}store(e,t,n){if(s.isUndefinedOrNull(t))return this.remove(e,n);const r=String(t);return this.getCache(n).get(e)===r?Promise.resolve():(this.getCache(n).set(e,r),this._onDidChangeStorage.fire({scope:n,key:e}),Promise.resolve())}remove(e,t){return this.getCache(t).delete(e)?(this._onDidChangeStorage.fire({scope:t,key:e}),Promise.resolve()):Promise.resolve()}logStorage(){c(this.globalCache,this.workspaceCache,"inMemory","inMemory")}async migrate(e){}flush(){this._onWillSaveState.fire({reason:o.NONE})}isNew(){return!0}async close(){}}async function c(e,t,n,r){const i=e=>{try{return JSON.parse(e)}catch(t){return e}},s=new Map,o=new Map;e.forEach((e,t)=>{s.set(t,e),o.set(t,i(e))});const a=new Map,c=new Map;t.forEach((e,t)=>{a.set(t,e),c.set(t,i(e))}),console.group(`Storage: Global (path: ${n})`);let l=[];s.forEach((e,t)=>{l.push({key:t,value:e})}),console.table(l),console.groupEnd(),console.log(o),
console.group(`Storage: Workspace (path: ${r})`);let u=[];a.forEach((e,t)=>{u.push({key:t,value:e})}),console.table(u),console.groupEnd(),console.log(c)}t.InMemoryStorageService=a,t.logStorage=c})),define(t[190],n([0,1,16,15,3,18]),(function(e,t,n,r,i,s){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.ErrorEvent=void 0,function(e){e.compare=function(e,t){return e.callstack<t.callstack?-1:e.callstack>t.callstack?1:0}}(o=t.ErrorEvent||(t.ErrorEvent={}));class a{constructor(e,t=a.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new i.DisposableStore,this._telemetryService=e,this._flushDelay=t;const n=r.errorHandler.addListener(e=>this._onErrorEvent(e));this._disposables.add(i.toDisposable(n)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(e){if(!e)return;e.detail&&e.detail.stack&&(e=e.detail)
;let t=Array.isArray(e.stack)?e.stack.join("\n"):e.stack,n=e.message?e.message:s.safeStringify(e);t&&this._enqueue({msg:n,callstack:t})}_enqueue(e){const t=n.binarySearch(this._buffer,e,o.compare);t<0?(e.count=1,this._buffer.splice(~t,0,e)):(this._buffer[t].count||(this._buffer[t].count=0),this._buffer[t].count+=1),-1===this._flushHandle&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let e of this._buffer)this._telemetryService.publicLogError2("UnhandledError",e);this._buffer.length=0}}t.default=a,a.ERROR_FLUSH_TIMEOUT=5e3})),define(t[37],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ITelemetryService=void 0,t.ITelemetryService=n.createDecorator("telemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",
t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"})),define(t[191],n([0,1,25,77,160,20,2,35,79,24,5,4,37,7,57,8]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g,v){"use strict";async function y(e,t){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",
filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,i=new Map,s=2e4;const o={count:0,maxReached:!1};await function e(t,o,l,u){const h=o.substring(t.length+1);return new Promise(d=>{a.readdir(o,{withFileTypes:!0},async(a,f)=>{var p,m,g;if(a)return void d();if(u.count>=s)return u.count+=f.length,u.maxReached=!0,void d();let v=f.length;if(0===v)return void d();let y=f;u.count+f.length>s&&(u.maxReached=!0,v=s-u.count,y=f.slice(0,v)),u.count+=f.length;for(const s of y)if(s.isDirectory()){if(l.includes(s.name)||await e(t,c.join(o,s.name),l,u),0==--v)return void d()}else{const e=s.name.lastIndexOf(".");if(e>=0){const t=s.name.substring(e+1);t&&r.set(t,(null!==(p=r.get(t))&&void 0!==p?p:0)+1)}for(const e of n)!1!==(null===(m=e.relativePathPattern)||void 0===m?void 0:m.test(h))&&e.filePattern.test(s.name)&&i.set(e.tag,(null!==(g=i.get(e.tag))&&void 0!==g?g:0)+1);if(0==--v)return void d()}})
})}(e,e,t,o);const l=await _(e);return{configFiles:b(i),fileTypes:b(r),fileCount:o.count,maxFilesReached:o.maxReached,launchConfigFiles:l}}function b(e){return[...g.Iterable.map(e.entries(),([e,t])=>({name:e,count:t}))].sort((e,t)=>t.count-e.count)}function w(){const e=1073741824,t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/e).toFixed(2)}GB (${(n.freemem()/e).toFixed(2)}GB free)`,vmHint:`${Math.round(100*r.virtualMachineHint.value())}%`},i=n.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}function _(e){let t=new Map,n=c.join(e,".vscode","launch.json");return new Promise((e,r)=>{a.exists(n,r=>{if(!r)return e([]);a.readFile(n,(r,i)=>{if(r)return e([]);const s=[],o=l.parse(i.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),e([]);if("object"===l.getNodeType(o)&&o.configurations)for(const e of o.configurations){const n=e.type;n&&(t.has(n)?t.set(n,t.get(n)+1):t.set(n,1))}return e(b(t))})})})}Object.defineProperty(t,"__esModule",{
value:!0}),t.DiagnosticsService=t.collectLaunchConfigs=t.getMachineInfo=t.collectWorkspaceStats=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=m.createDecorator(t.ID),t.collectWorkspaceStats=y,t.getMachineInfo=w,t.collectLaunchConfigs=_;let E=class{constructor(e){this.telemetryService=e}formatMachineInfo(e){const t=[];return t.push(`OS Version:       ${e.os}`),t.push(`CPUs:             ${e.cpus}`),t.push(`Memory (System):  ${e.memory}`),t.push(`VM:               ${e.vmHint}`),t.join("\n")}formatEnvironment(e){const t=1073741824,i=[];i.push(`Version:          ${h.default.nameShort} ${h.default.version} (${h.default.commit||"Commit unknown"}, ${h.default.date||"Date unknown"})`),i.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const s=n.cpus();return s&&s.length>0&&i.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),i.push(`Memory (System):  ${(n.totalmem()/t).toFixed(2)}GB (${(n.freemem()/t).toFixed(2)}GB free)`),
d.isWindows||i.push(`Load (avg):       ${n.loadavg().map(e=>Math.round(e)).join(", ")}`),i.push(`VM:               ${Math.round(100*r.virtualMachineHint.value())}%`),i.push(`Screen Reader:    ${e.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${e.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(e.gpuFeatureStatus)}`),i.join("\n")}async getPerformanceInfo(e,t){return Promise.all([u.listProcesses(e.mainPID),this.formatWorkspaceMetadata(e)]).then(async n=>{let[r,s]=n,o=this.formatProcessList(e,r);return t.forEach(t=>{if(i.isRemoteDiagnosticError(t))o+=`\n${t.errorMessage}`,s+=`\n${t.errorMessage}`;else if(o+=`\n\nRemote: ${t.hostName}`,t.processes&&(o+=`\n${this.formatProcessList(e,t.processes)}`),t.workspaceMetadata){s+=`\n|  Remote: ${t.hostName}`;for(const e of Object.keys(t.workspaceMetadata)){const n=t.workspaceMetadata[e];let r=`${n.fileCount} files`;n.maxFilesReached&&(r=`more than ${r}`),s+=`|    Folder (${e}): ${r}`,s+=this.formatWorkspaceStats(n)}}}),{processInfo:o,
workspaceInfo:s}})}async getSystemInfo(e,t){const{memory:r,vmHint:i,os:s,cpus:o}=w(),a={os:s,memory:r,cpus:o,vmHint:i,processArgs:`${e.mainArguments.join(" ")}`,gpuStatus:e.gpuFeatureStatus,screenReader:`${e.screenReader?"yes":"no"}`,remoteData:t};return d.isWindows||(a.load=`${n.loadavg().map(e=>Math.round(e)).join(", ")}`),d.isLinux&&(a.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(a)}async getDiagnostics(e,t){const n=[];return u.listProcesses(e.mainPID).then(async r=>(n.push(""),n.push(this.formatEnvironment(e)),n.push(""),n.push(this.formatProcessList(e,r)),e.windows.some(e=>e.folderURIs&&e.folderURIs.length>0&&!e.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.formatWorkspaceMetadata(e))),t.forEach(t=>{if(i.isRemoteDiagnosticError(t))n.push(`\n${t.errorMessage}`);else if(n.push("\n\n"),
n.push(`Remote:           ${t.hostName}`),n.push(this.formatMachineInfo(t.machineInfo)),t.processes&&n.push(this.formatProcessList(e,t.processes)),t.workspaceMetadata)for(const e of Object.keys(t.workspaceMetadata)){const r=t.workspaceMetadata[e];let i=`${r.fileCount} files`;r.maxFilesReached&&(i=`more than ${i}`),n.push(`Folder (${e}): ${i}`),n.push(this.formatWorkspaceStats(r))}}),n.push(""),n.push(""),n.join("\n")))}formatWorkspaceStats(e){const t=[];let n=0;const r=(e,r)=>{const s=` ${e}(${r})`;n+s.length>60?(t.push(i),n=(i="|                 ").length):n+=s.length,i+=s};let i="|      File types:";let s=e.fileTypes.length>10?10:e.fileTypes.length;for(let t=0;t<s;t++){const n=e.fileTypes[t];r(n.name,n.count)}if(t.push(i),e.configFiles.length>=0&&(i="|      Conf files:",n=0,e.configFiles.forEach(e=>{r(e.name,e.count)}),t.push(i)),e.launchConfigFiles.length>0){let n="|      Launch Configs:";e.launchConfigFiles.forEach(e=>{const t=e.count>1?` ${e.name}(${e.count})`:` ${e.name}`;n+=t}),t.push(n)}
return t.join("\n")}expandGPUFeatures(e){const t=Math.max(...Object.keys(e).map(e=>e.length));return Object.keys(e).map(n=>`${n}:  ${" ".repeat(t-n.length)}  ${e[n]}`).join("\n                  ")}formatWorkspaceMetadata(e){const t=[],n=[];return e.windows.forEach(e=>{0===e.folderURIs.length||e.remoteAuthority||(t.push(`|  Window (${e.title})`),e.folderURIs.forEach(e=>{const r=f.URI.revive(e);if(r.scheme===v.Schemas.file){const e=r.fsPath;n.push(y(e,["node_modules",".git"]).then(n=>{let r=`${n.fileCount} files`;n.maxFilesReached&&(r=`more than ${r}`),t.push(`|    Folder (${c.basename(e)}): ${r}`),t.push(this.formatWorkspaceStats(n))}).catch(n=>{t.push(`|      Error: Unable to collect workspace stats for folder ${e} (${n.toString()})`)}))}else t.push(`|    Folder (${r.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(e=>t.join("\n")).catch(e=>`Unable to collect workspace stats: ${e}`)}formatProcessList(e,t){const n=new Map;e.windows.forEach(e=>n.set(e.pid,e.title));const r=[]
;return r.push("CPU %\tMem MB\t   PID\tProcess"),t&&this.formatProcessItem(e.mainPID,n,r,t,0),r.join("\n")}formatProcessItem(e,t,r,i,s){let o;0===s?o=i.pid===e?`${h.default.applicationName} main`:"remote agent":(o=`${"  ".repeat(s)} ${i.name}`,"window"===i.name&&(o=`${o} (${t.get(i.pid)})`));const a="win32"===process.platform?i.mem:n.totalmem()*(i.mem/100);r.push(`${i.load.toFixed(0).padStart(5," ")}\t${(a/1048576).toFixed(0).padStart(6," ")}\t${i.pid.toFixed(0).padStart(6," ")}\t${o}`),Array.isArray(i.children)&&i.children.forEach(n=>this.formatProcessItem(e,t,r,n,s+1))}async reportWorkspaceStats(e){for(const{uri:t}of e.folders){const n=f.URI.revive(t);if(n.scheme!==v.Schemas.file)continue;const r=n.fsPath;try{const t=await y(r,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":e.telemetryId,rendererSessionId:e.rendererSessionId}),t.fileTypes.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:e.rendererSessionId,type:t.name,
count:t.count})}),t.launchConfigFiles.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})}),t.configFiles.forEach(t=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:e.rendererSessionId,type:t.name,count:t.count})})}catch(e){}}}};E=s([o(0,p.ITelemetryService)],E),t.DiagnosticsService=E})),define(t[67],n([0,1,15,31,34,18,37,55,62,26,28,12,27,4,42,189,186,7,22]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g,v,y,b,w){"use strict";var _,E;Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0,function(e){e[e.None=0]="None",e[e.IncludeVersions=1]="IncludeVersions",e[e.IncludeFiles=2]="IncludeFiles",e[e.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",e[e.IncludeSharedAccounts=8]="IncludeSharedAccounts",e[e.IncludeVersionProperties=16]="IncludeVersionProperties",e[e.ExcludeNonValidated=32]="ExcludeNonValidated",
e[e.IncludeInstallationTargets=64]="IncludeInstallationTargets",e[e.IncludeAssetUri=128]="IncludeAssetUri",e[e.IncludeStatistics=256]="IncludeStatistics",e[e.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",e[e.Unpublished=4096]="Unpublished"}(_||(_={})),function(e){e[e.Tag=1]="Tag",e[e.ExtensionId=4]="ExtensionId",e[e.Category=5]="Category",e[e.ExtensionName=7]="ExtensionName",e[e.Target=8]="Target",e[e.Featured=9]="Featured",e[e.SearchText=10]="SearchText",e[e.ExcludeWithFlags=12]="ExcludeWithFlags"}(E||(E={}));const S={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},C={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",
ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},x={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:_.None,criteria:[],assetTypes:[]};class I{constructor(e=x){this.state=e}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(e,t=this.state.pageSize){return new I(Object.assign(Object.assign({},this.state),{pageNumber:e,pageSize:t}))}withFilter(e,...t){const n=[...this.state.criteria,...t.length?t.map(t=>({filterType:e,value:t})):[{filterType:e}]];return new I(Object.assign(Object.assign({},this.state),{criteria:n}))}withSortBy(e){return new I(Object.assign(Object.assign({},this.state),{sortBy:e}))}withSortOrder(e){return new I(Object.assign(Object.assign({},this.state),{
sortOrder:e}))}withFlags(...e){return new I(Object.assign(Object.assign({},this.state),{flags:e.reduce((e,t)=>e|t,0)}))}withAssetTypes(...e){return new I(Object.assign(Object.assign({},this.state),{assetTypes:e}))}get raw(){const{criteria:e,pageNumber:t,pageSize:n,sortBy:r,sortOrder:i,flags:s,assetTypes:o}=this.state;return{filters:[{criteria:e,pageNumber:t,pageSize:n,sortBy:r,sortOrder:i}],assetTypes:o,flags:s}}get searchText(){const e=this.state.criteria.filter(e=>e.filterType===E.SearchText)[0];return e&&e.value?e.value:""}}function k(e,t){const n=(e||[]).filter(e=>e.statisticName===t)[0];return n?n.value:0}function T(e){return e.files.filter(e=>0===e.assetType.indexOf("Microsoft.VisualStudio.Code.Translation.")).reduce((t,n)=>{const r=L(e,n.assetType);return r&&t.push([n.assetType.substring("Microsoft.VisualStudio.Code.Translation.".length),r]),t},[])}function P(e){if(e.properties){
const t=e.properties.filter(e=>e.key===S.Repository),n=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),r=t.filter(e=>n.test(e.value))[0];return r?{uri:r.value,fallbackUri:r.value}:null}return L(e,S.Repository)}function R(e){return{uri:`${e.fallbackAssetUri}/${S.VSIX}?redirect=true`,fallbackUri:`${e.fallbackAssetUri}/${S.VSIX}`}}function O(e){const t=L(e,S.Icon);if(t)return t;const n=r.DefaultIconPath;return{uri:n,fallbackUri:n}}function L(e,t){return e.files.filter(e=>e.assetType===t)[0]?{uri:`${e.assetUri}/${t}`,fallbackUri:`${e.fallbackAssetUri}/${t}`}:null}function D(e,t){const n=e.properties?e.properties.filter(e=>e.key===t):[],r=n.length>0&&n[0].value;return r?r.split(",").map(e=>i.adoptToGalleryExtensionId(e)):[]}function A(e){const t=e.properties?e.properties.filter(e=>e.key===C.Engine):[];return t.length>0&&t[0].value||""}function N(e){const t=e.properties?e.properties.filter(e=>e.key===C.LocalizedLanguages):[],n=t.length>0&&t[0].value||"";return n?n.split(","):[]}
function M(e){const t=e.properties?e.properties.find(e=>e.key===C.WebExtension):void 0;return!!t&&"true"===t.value}function F(e){return e.files.some(e=>e.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?w.joinPath(m.URI.parse(e.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function U(e,t,n,r,s){const o={manifest:L(t,S.Manifest),readme:L(t,S.Details),changelog:L(t,S.Changelog),license:L(t,S.License),repository:P(t),download:R(t),icon:O(t),coreTranslations:T(t)};return{identifier:{id:i.getGalleryExtensionId(e.publisher.publisherName,e.extensionName),uuid:e.extensionId},name:e.extensionName,version:t.version,date:t.lastUpdated,displayName:e.displayName,publisherId:e.publisher.publisherId,publisher:e.publisher.publisherName,publisherDisplayName:e.publisher.displayName,description:e.shortDescription||"",installCount:k(e.statistics,"install"),rating:k(e.statistics,"averagerating"),ratingCount:k(e.statistics,"ratingcount"),assetUri:m.URI.parse(t.assetUri),webResource:F(t),
assetTypes:t.files.map(({assetType:e})=>e),assets:o,properties:{dependencies:D(t,C.Dependency),extensionPack:D(t,C.ExtensionPack),engine:A(t),localizedLanguages:N(t),webExtension:M(t)},telemetryData:{index:(r.pageNumber-1)*r.pageSize+n,searchText:r.searchText,querySource:s},preview:(a=e.flags,-1!==a.indexOf("preview"))};var a}let j=class{constructor(e,t,n,r,i,s,o){this.requestService=e,this.logService=t,this.environmentService=n,this.telemetryService=r,this.fileService=i,this.productService=s;const a=s.extensionsGallery;this.extensionsGalleryUrl=a&&a.serviceUrl,this.extensionsControlUrl=a&&a.controlUrl,this.commonHeadersPromise=z(s.version,this.environmentService,this.fileService,o)}api(e=""){return`${this.extensionsGalleryUrl}${e}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(e,t){const n=[];let{total:r,firstPage:i,getPage:s}=await this.query({names:e,pageSize:e.length},t);n.push(...i);for(let e=1;n.length<r&&(i=await s(e,t)).length;e++)n.push(...i);return n}
async getCompatibleExtension(e,t){const n=await this.getCompatibleExtensionByEngine(e,t);return(null==n?void 0:n.properties.webExtension)?n.webResource?n:null:n}async getCompatibleExtensionByEngine(e,t){const n=r.isIExtensionIdentifier(e)?null:e;if(n&&n.properties.engine&&u.isEngineValid(n.properties.engine,this.productService.version))return n;const{id:i,uuid:s}=n?n.identifier:e;let o=(new I).withFlags(_.IncludeAssetUri,_.IncludeStatistics,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,1).withFilter(E.Target,"Microsoft.VisualStudio.Code");o=s?o.withFilter(E.ExtensionId,s):o.withFilter(E.ExtensionName,i);const{galleryExtensions:a}=await this.queryGallery(o,d.CancellationToken.None),[c]=a;if(!c||!c.versions.length)return null;if(t){const e=c.versions.filter(e=>e.version===t)[0];if(e){const t=U(c,e,0,o);if(t.properties.engine&&u.isEngineValid(t.properties.engine,this.productService.version))return t}return null}const l=await this.getLastValidExtensionVersion(c,c.versions);return l?U(c,l,0,o):null}
async query(e,t){const r=d.CancellationToken.isCancellationToken(e)?{}:e,i=d.CancellationToken.isCancellationToken(e)?e:t;if(!this.isEnabled())throw new Error("No extension gallery service configured.");const s=r.names?"ids":r.text?"text":"all";let o=r.text||"";const c=a.getOrDefault(r,e=>e.pageSize,50);this.telemetryService.publicLog2("galleryService:query",{type:s,text:o});let l=(new I).withFlags(_.IncludeLatestVersionOnly,_.IncludeAssetUri,_.IncludeStatistics,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,c).withFilter(E.Target,"Microsoft.VisualStudio.Code");o?((o=(o=(o=(o=o.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,n)=>(l=l.withFilter(E.Category,n||t),""))).replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(e,t,n)=>(l=l.withFilter(E.Tag,n||t),""))).replace(/\bfeatured(\s+|\b|$)/g,()=>(l=l.withFilter(E.Featured),""))).trim())&&(o=o.length<200?o:o.substring(0,200),l=l.withFilter(E.SearchText,o)),
l=l.withSortBy(0)):l=r.ids?l.withFilter(E.ExtensionId,...r.ids):r.names?l.withFilter(E.ExtensionName,...r.names):l.withSortBy(4),"number"==typeof r.sortBy&&(l=l.withSortBy(r.sortBy)),"number"==typeof r.sortOrder&&(l=l.withSortOrder(r.sortOrder));const{galleryExtensions:u,total:h}=await this.queryGallery(l,i);return{firstPage:u.map((e,t)=>U(e,e.versions[0],t,l,r.source)),total:h,pageSize:l.pageSize,getPage:async(e,t)=>{if(t.isCancellationRequested)throw n.canceled();const i=l.withPage(e+1),{galleryExtensions:s}=await this.queryGallery(i,t);return s.map((e,t)=>U(e,e.versions[0],t,i,r.source))}}}async queryGallery(e,t){if(!this.isEnabled())throw new Error("No extension gallery service configured.");e=e.withFlags(e.flags,_.ExcludeNonValidated).withFilter(E.ExcludeWithFlags,function(...e){return String(e.reduce((e,t)=>e|t,0))}(_.Unpublished));const n=await this.commonHeadersPromise,r=JSON.stringify(e.raw),i=Object.assign(Object.assign({},n),{"Content-Type":"application/json",
Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(r.length)}),s=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:r,headers:i},t);if(s.res.statusCode&&s.res.statusCode>=400&&s.res.statusCode<500)return{galleryExtensions:[],total:0};const o=await l.asJson(s);if(o){const e=o.results[0],t=e.extensions,n=e.resultMetadata&&e.resultMetadata.filter(e=>"ResultCount"===e.metadataType)[0];return{galleryExtensions:t,total:n&&n.metadataItems.filter(e=>"TotalCount"===e.name)[0].count||0}}return{galleryExtensions:[],total:0}}async reportStatistic(e,t,n,r){if(!this.isEnabled())return;const i=await this.commonHeadersPromise,s=Object.assign(Object.assign({},i),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${e}/extensions/${t}/${n}/stats?statType=${r}`),headers:s},d.CancellationToken.None)}catch(e){}}async download(e,t,n){
this.logService.trace("ExtensionGalleryService#download",e.identifier.id);const r=i.getGalleryExtensionTelemetryData(e),s=(new Date).getTime(),o=1===n?"install":2===n?"update":"",a=o?{uri:`${e.assets.download.uri}&${o}=true`,fallbackUri:`${e.assets.download.fallbackUri}?${o}=true`}:e.assets.download,c=await this.getAsset(a);await this.fileService.writeFile(t,c.stream),(e=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},r),{duration:e})))((new Date).getTime()-s)}async getReadme(e,t){if(e.assets.readme){const n=await this.getAsset(e.assets.readme,{},t);return await l.asText(n)||""}return""}async getManifest(e,t){if(e.assets.manifest){const n=await this.getAsset(e.assets.manifest,{},t),r=await l.asText(n);return r?JSON.parse(r):null}return null}async getCoreTranslation(e,t){const n=e.assets.coreTranslations.filter(e=>e[0]===t.toUpperCase())[0];if(n){const e=await this.getAsset(n[1]),t=await l.asText(e);return t?JSON.parse(t):null}return null}async getChangelog(e,t){
if(e.assets.changelog){const n=await this.getAsset(e.assets.changelog,{},t);return await l.asText(n)||""}return""}async getAllVersions(e,t){let n=(new I).withFlags(_.IncludeVersions,_.IncludeFiles,_.IncludeVersionProperties).withPage(1,1).withFilter(E.Target,"Microsoft.VisualStudio.Code");n=e.identifier.uuid?n.withFilter(E.ExtensionId,e.identifier.uuid):n.withFilter(E.ExtensionName,e.identifier.id);const r=[],{galleryExtensions:i}=await this.queryGallery(n,d.CancellationToken.None);return i.length&&(t?await Promise.all(i[0].versions.map(async e=>{let t;try{t=await this.getEngine(e)}catch(e){}t&&u.isEngineValid(t,this.productService.version)&&r.push({version:e.version,date:e.lastUpdated})})):r.push(...i[0].versions.map(e=>({version:e.version,date:e.lastUpdated})))),r}async getAsset(e,t={},r=d.CancellationToken.None){const i=await this.commonHeadersPromise,s=Object.assign(Object.assign({},i),t.headers||{});t=Object.assign(Object.assign(Object.assign({},t),{type:"GET"}),{headers:s})
;const o=e.uri,a=e.fallbackUri,c=Object.assign(Object.assign({},t),{url:o});try{const e=await this.requestService.request(c,r);if(200===e.res.statusCode)return e;const t=await l.asText(e);throw new Error(`Expected 200, got back ${e.res.statusCode} instead.\n\n${t}`)}catch(e){if(n.isPromiseCanceledError(e))throw e;const i=n.getErrorMessage(e);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:o,message:i});const s=Object.assign(Object.assign({},t),{url:a});return this.requestService.request(s,r)}}async getLastValidExtensionVersion(e,t){const n=this.getLastValidExtensionVersionFromProperties(e,t);return n||this.getLastValidExtensionVersionRecursively(e,t)}getLastValidExtensionVersionFromProperties(e,t){for(const e of t){const t=A(e);if(!t)return null;if(u.isEngineValid(t,this.productService.version))return e}return null}async getEngine(e){const t=A(e);if(t)return t;const n=L(e,S.Manifest);if(!n)throw new Error("Manifest was not found");const r=await this.getAsset(n,{headers:{
"Accept-Encoding":"gzip"}}),i=await l.asJson(r);if(i)return i.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(e,t){if(!t.length)return null;const n=t[0],r=await this.getEngine(n);return u.isEngineValid(r,this.productService.version)?(n.properties=n.properties||[],n.properties.push({key:C.Engine,value:r}),n):this.getLastValidExtensionVersionRecursively(e,t.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const e=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},d.CancellationToken.None);if(200!==e.res.statusCode)throw new Error("Could not get extensions report.");const t=await l.asJson(e),n=new Map;if(t)for(const e of t.malicious){const t=n.get(e)||{id:{id:e},malicious:!0,slow:!1};t.malicious=!0,n.set(e,t)}return[...n.values()]}};async function z(e,t,n,r){const i={"X-Market-Client-Id":`VSCode ${e}`,
"User-Agent":`VSCode ${e}`},s=await y.getServiceMachineId(t,n,r);return i["X-Market-User-Id"]=s,i}j=s([o(0,l.IRequestService),o(1,f.ILogService),o(2,h.IEnvironmentService),o(3,c.ITelemetryService),o(4,p.IFileService),o(5,g.IProductService),o(6,b.optional(v.IStorageService))],j),t.ExtensionGalleryService=j,t.resolveMarketplaceHeaders=z})),define(t[92],n([0,1,24,151,13,7,29,43,3,18,32]),(function(e,t,n,r,i,a,c,l,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let f=class{constructor(e,t){this._configurationService=t,this._experimentProperties={},this._disposables=new u.DisposableStore,this._cleanupPatterns=[],this._appender=e.appender,this._commonProperties=e.commonProperties||Promise.resolve({}),this._piiPaths=e.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!e.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi]
;for(let e of this._piiPaths)this._cleanupPatterns.push(new RegExp(i.escapeRegExpCharacters(e),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(e=>{const t=/^[a-f0-9]+$/i.test(e["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!t})}))}setExperimentProperty(e,t){this._experimentProperties[e]=t}setEnabled(e){this._enabled=e}_updateUserOptIn(){var e;const t=null===(e=this._configurationService)||void 0===e?void 0:e.getValue(p);this._userOptIn=t?t.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const e=await this._commonProperties;return{sessionId:e.sessionID,instanceId:e["common.instanceId"],machineId:e["common.machineId"],msftInternal:e["common.msftInternal"]}}dispose(){this._disposables.dispose()}publicLog(e,t,n){
return this.isOptedIn?this._commonProperties.then(r=>{t=h.mixin(t,r),t=h.mixin(t,this._experimentProperties),t=h.cloneAndChange(t,e=>{if("string"==typeof e)return this._cleanupInfo(e,n)}),this._appender.log(e,t)},e=>{console.error(e)}):Promise.resolve(void 0)}publicLog2(e,t,n){return this.publicLog(e,t,n)}publicLogError(e,t){return this.sendErrorTelemetry?this.publicLog(e,t,!0):Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}_cleanupInfo(e,t){let n=e;if(t){const t=[];for(let n of this._cleanupPatterns)for(;;){const r=n.exec(e);if(!r)break;t.push([r.index,n.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(n="";;){const o=i.exec(e);if(!o)break;!r.test(o[0])&&t.every(([e,t])=>o.index<e||o.index>=t)&&(n+=e.substring(s,o.index)+"<REDACTED: user-file-path>",s=i.lastIndex)}s<e.length&&(n+=e.substr(s))}for(let e of this._cleanupPatterns)n=n.replace(e,"");return n}}
;f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=s([o(1,a.optional(c.IConfigurationService))],f),t.TelemetryService=f;const p="telemetry";d.Registry.as(l.Extensions.Configuration).registerConfiguration({id:p,order:110,type:"object",title:r.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:n.default.privacyStatementUrl?r.localize(2,null,n.default.privacyStatementUrl):r.localize(1,null),default:!0,tags:["usesOnlineServices"]}}})})),define(t[56],n([0,1,29,18,11]),(function(e,t,n,r,i){"use strict";function s(e){if(!e)return[];const t=[];return function e(t,n,r){r&&"object"==typeof r&&!Array.isArray(r)?Object.keys(r).forEach(i=>e(t,n?`${n}.${i}`:i,r[i])):t.push(n)}(t,"",e),t}Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,
this.isOptedIn=!0}publicLog(e,t){return Promise.resolve(void 0)}publicLog2(e,t){return this.publicLog(e,t)}publicLogError(e,t){return Promise.resolve(void 0)}publicLogError2(e,t){return this.publicLogError(e,t)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId"})}},t.combinedAppender=function(...e){return{log:(t,n)=>e.forEach(e=>e.log(t,n)),flush:()=>Promise.all(e.map(e=>e.flush()))}},t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)},t.configurationTelemetry=function(e,t){return t.onDidChangeConfiguration(t=>{6!==t.source&&e.publicLog2("updateConfiguration",{configurationSource:n.ConfigurationTargetToString(t.source),configurationKeys:s(t.sourceConfig)})})},t.validateTelemetryData=function(e){const t=Object.create(null),n=Object.create(null),s=Object.create(null);!function e(t,n,s=0,o){if(!t)return;for(let a of Object.getOwnPropertyNames(t)){const c=t[a],l=o?o+a:a
;Array.isArray(c)?n[l]=r.safeStringify(c):c instanceof Date?n[l]=c.toISOString():i.isObject(c)?s<2?e(c,n,s+1,l+"."):n[l]=r.safeStringify(c):n[l]=c}}(e,s);for(let e in s){const r=s[e=e.length>150?e.substr(e.length-149):e];"number"==typeof r?n[e]=r:"boolean"==typeof r?n[e]=r?1:0:"string"==typeof r?t[e]=r.substring(0,1023):null!=r&&(t[e]=r)}return{properties:t,measurements:n}},t.cleanRemoteAuthority=function(e){if(!e)return"none";let t="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(n=>{0===e.indexOf(`${n}+`)&&(t=n)}),t}})),define(t[93],n([0,1,225,18,56]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;t.AppInsightsAppender=class{constructor(e,t,r){this._eventPrefix=e,this._defaultData=t,this._defaultData||(this._defaultData=Object.create(null)),"string"==typeof r?this._aiClient=function(e){let t
;return n.defaultClient?(t=new n.TelemetryClient(e)).channel.setUseDiskRetryCaching(!0):(n.setup(e).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),t=n.defaultClient),0===e.indexOf("AIF-")&&(t.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),t}(r):"function"==typeof r&&(this._aiClient=r())}log(e,t){this._aiClient&&(t=r.mixin(t,this._defaultData),t=i.validateTelemetryData(t),this._aiClient.trackEvent({name:this._eventPrefix+"/"+e,properties:t.properties,measurements:t.measurements}))}flush(){return this._aiClient?new Promise(e=>{this._aiClient.flush({callback:()=>{this._aiClient=void 0,e(void 0)}})}):Promise.resolve(void 0)}}})),define(t[94],n([0,1,5,25,21,14]),(function(e,t,n,r,i,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveCommonProperties=void 0,
t.resolveCommonProperties=async function(e,t,o,a,c,l){const u=Object.create(null);u["common.machineId"]=o,u.sessionID=i.generateUuid()+Date.now(),u.commitHash=e,u.version=t,u["common.platformVersion"]=(r.release()||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=n.PlatformToString(n.platform),u["common.nodePlatform"]=process.platform,u["common.nodeArch"]=process.arch,u["common.product"]=l||"desktop";const h=function(e){if(!process||!process.env||!process.env.USERDNSDOMAIN)return!1;const t=process.env.USERDNSDOMAIN.toLowerCase();return e.some(e=>t===e)}(a||[]);h&&(u["common.msftInternal"]=h);let d=0;const f=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),"linux"===process.platform&&process.env.SNAP&&process.env.SNAP_REVISION&&(u["common.snap"]="true");try{const e=await s.readFile(c,"utf8");u["common.source"]=e.slice(0,30)}catch(e){}return u
}})),define(t[192],n([0,1,15,190]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0});class i extends r.default{installErrorListeners(){n.setUnexpectedErrorHandler(e=>console.error(e));const e=[];process.on("unhandledRejection",(t,r)=>{e.push(r),setTimeout(()=>{const i=e.indexOf(r);i>=0&&r.catch(r=>{e.splice(i,1),console.warn(`rejected promise not handled within 1 second: ${r}`),r.stack&&console.warn(`stack trace: ${r.stack}`),n.onUnexpectedError(t)})},1e3)}),process.on("rejectionHandled",t=>{const n=e.indexOf(t);n>=0&&e.splice(n,1)}),process.on("uncaughtException",e=>{n.onUnexpectedError(e)})}}t.default=i})),define(t[193],n([0,1,14,20,2]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0,t.buildTelemetryMessage=function(e,t){const s=Object.create(null),o=(e,t)=>{const n=JSON.parse(e);s[t]=n};if(t){const e=n.readdirSync(t).filter(e=>{try{return r.statSync(i.join(t,e)).isDirectory()}catch(e){return!1}}),s=[]
;e.forEach(e=>{1===n.readdirSync(i.join(t,e)).filter(e=>"telemetry.json"===e).length&&s.push(e)}),s.forEach(e=>{const n=r.readFileSync(i.join(t,e,"telemetry.json")).toString();o(n,e)})}let a=r.readFileSync(i.join(e,"telemetry-core.json")).toString();return o(a,"vscode-core"),a=r.readFileSync(i.join(e,"telemetry-extensions.json")).toString(),o(a,"vscode-extensions"),JSON.stringify(s,null,4)}})),define(t[95],n([0,1,7,152,4,5,2,22,110,35,8,47,30,183]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f){"use strict";function p(e){return e.hasOwnProperty("folderUri")}function m(e){return g(e)||v(e)}function g(e){return e&&"object"==typeof e&&"string"==typeof e.path&&(!e.name||"string"==typeof e.name)}function v(e){return e&&"object"==typeof e&&"string"==typeof e.uri&&(!e.name||"string"==typeof e.name)}function y(e){return e instanceof i.URI}Object.defineProperty(t,"__esModule",{value:!0}),
t.toStoreData=t.restoreRecentlyOpened=t.useSlashForPath=t.rewriteWorkspaceFileForNewLocation=t.getStoredWorkspaceFolder=t.hasWorkspaceFileExtension=t.isSingleFolderWorkspaceInitializationPayload=t.isUntitledWorkspace=t.toWorkspaceIdentifier=t.isWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.isRawUriWorkspaceFolder=t.isRawFileWorkspaceFolder=t.isStoredWorkspaceFolder=t.reviveWorkspaceIdentifier=t.isRecentFile=t.isRecentFolder=t.isRecentWorkspace=t.IWorkspacesService=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=void 0,t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_FILTER=[{name:r.localize(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json",t.IWorkspacesService=n.createDecorator("workspacesService"),t.isRecentWorkspace=function(e){return e.hasOwnProperty("workspace")},t.isRecentFolder=p,t.isRecentFile=function(e){return e.hasOwnProperty("fileUri")},t.reviveWorkspaceIdentifier=function(e){return{id:e.id,configPath:i.URI.revive(e.configPath)}
},t.isStoredWorkspaceFolder=m,t.isRawFileWorkspaceFolder=g,t.isRawUriWorkspaceFolder=v,t.isSingleFolderWorkspaceIdentifier=y,t.isWorkspaceIdentifier=function(e){const t=e;return t&&"string"==typeof t.id&&t.configPath instanceof i.URI},t.toWorkspaceIdentifier=function(e){return e.configuration?{configPath:e.configuration,id:e.id}:1===e.folders.length?e.folders[0].uri:void 0},t.isUntitledWorkspace=function(e,t){return a.extUriBiasedIgnorePathCase.isEqualOrParent(e,t.untitledWorkspacesHome)},t.isSingleFolderWorkspaceInitializationPayload=function(e){return y(e.folder)};const b="."+t.WORKSPACE_EXTENSION;t.hasWorkspaceFileExtension=function(e){return("string"==typeof e?o.extname(e):a.extname(e))===b};const w="/";function _(e,t,n,r,i=!s.isWindows){if(e.scheme!==r.scheme)return{name:n,uri:e.toString(!0)};let o=t?void 0:a.relativePath(r,e);if(void 0!==o)0===o.length?o=".":s.isWindows&&e.scheme===u.Schemas.file&&!i&&(o=o.replace(/\//g,"\\"));else if(e.scheme===u.Schemas.file)o=e.fsPath,
s.isWindows&&(o=h.normalizeDriveLetter(o),i&&(o=d.toSlashes(o)));else{if(!a.isEqualAuthority(e.authority,r.authority))return{name:n,uri:e.toString(!0)};o=e.path}return{name:n,path:o}}function E(e){return!s.isWindows||e.some(e=>g(e)&&e.path.indexOf(w)>=0)}t.getStoredWorkspaceFolder=_,t.rewriteWorkspaceFileForNewLocation=function(e,t,n,r){let u=function(e,t){let n=l.parse(t);if(!n||!Array.isArray(n.folders))throw new Error(`${e} looks like an invalid workspace file.`);n.folders=n.folders.filter(e=>m(e));return n}(t,e);const h=a.dirname(t),d=a.dirname(r),p=[],v=E(u.folders);for(const e of u.folders){const t=g(e)?a.resolvePath(h,e.path):i.URI.parse(e.uri);let r;r=!n&&(!g(e)||o.isAbsolute(e.path)),p.push(_(t,r,e.name,d,v))}const y={insertSpaces:!1,tabSize:4,eol:s.isLinux||s.isMacintosh?"\n":"\r\n"},b=c.setProperty(e,["folders"],p,y);let w=c.applyEdits(e,b);return u.remoteAuthority===f.getRemoteAuthority(r)&&(w=c.applyEdits(w,c.removeProperty(w,["remoteAuthority"],y))),w},t.useSlashForPath=E,
t.restoreRecentlyOpened=function(e,t){const n={workspaces:[],files:[]};if(e){const r=function(e,n){for(let r=0;r<e.length;r++)try{n(e[r],r)}catch(n){t.warn(`Error restoring recent entry ${JSON.stringify(e[r])}: ${n.toString()}. Skip entry.`)}},s=e;Array.isArray(s.workspaces3)&&r(s.workspaces3,(e,t)=>{const r=Array.isArray(s.workspaceLabels)&&s.workspaceLabels[t]||void 0;"object"==typeof e&&"string"==typeof e.id&&"string"==typeof e.configURIPath?n.workspaces.push({label:r,workspace:{id:e.id,configPath:i.URI.parse(e.configURIPath)}}):"string"==typeof e&&n.workspaces.push({label:r,folderUri:i.URI.parse(e)})}),Array.isArray(s.files2)&&r(s.files2,(e,t)=>{const r=Array.isArray(s.fileLabels)&&s.fileLabels[t]||void 0;"string"==typeof e&&n.files.push({label:r,fileUri:i.URI.parse(e)})})}return n},t.toStoreData=function(e){const t={workspaces3:[],files2:[]};let n=!1;const r=[];for(const i of e.workspaces)p(i)?t.workspaces3.push(i.folderUri.toString()):t.workspaces3.push({id:i.workspace.id,
configURIPath:i.workspace.configPath.toString()}),r.push(i.label||null),n=n||!!i.label;n&&(t.workspaceLabels=r),n=!1;const i=[];for(const r of e.files)t.files2.push(r.fileUri.toString()),i.push(r.label||null),n=n||!!r.label;return n&&(t.fileLabels=i),t}})),define(t[194],n([0,1,4,22,7,23,95]),(function(e,t,n,r,i,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toWorkspaceFolders=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.IWorkspaceFolder=t.IWorkspace=t.WorkbenchState=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=i.createDecorator("contextService"),function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"}(t.WorkbenchState||(t.WorkbenchState={})),function(e){e.isIWorkspace=function(e){return!(!e||"object"!=typeof e||"string"!=typeof e.id||!Array.isArray(e.folders))}}(t.IWorkspace||(t.IWorkspace={})),function(e){e.isIWorkspaceFolder=function(e){
return!(!e||"object"!=typeof e||!n.URI.isUri(e.uri)||"string"!=typeof e.name||"function"!=typeof e.toResource)}}(t.IWorkspaceFolder||(t.IWorkspaceFolder={}));t.Workspace=class{constructor(e,t=[],n=null){this._id=e,this._configuration=n,this._foldersMap=s.TernarySearchTree.forUris(),this.folders=t}update(e){this._id=e.id,this._configuration=e.configuration,this.folders=e.folders}get folders(){return this._folders}set folders(e){this._folders=e,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(e){this._configuration=e}getFolder(e){return e&&this._foldersMap.findSubstr(e.with({scheme:e.scheme,authority:e.authority,path:e.path}))||null}updateFoldersMap(){this._foldersMap=s.TernarySearchTree.forUris();for(const e of this.folders)this._foldersMap.set(e.uri,e)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}};class a{constructor(e,t){this.raw=t,this.uri=e.uri,this.index=e.index,this.name=e.name}toResource(e){
return r.joinPath(this.uri,e)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=a,t.toWorkspaceFolder=function(e){return new a({uri:e,index:0,name:r.basenameOrAuthority(e)},{uri:e.toString()})},t.toWorkspaceFolders=function(e,t){let i=[],s=new Set;const c=r.dirname(t);for(let t of e){let e=null;if(o.isRawFileWorkspaceFolder(t))t.path&&(e=r.resolvePath(c,t.path));else if(o.isRawUriWorkspaceFolder(t))try{"/"!==(e=n.URI.parse(t.uri)).path[0]&&(e=e.with({path:"/"+e.path}))}catch(e){console.warn(e)}if(e){let n=r.getComparisonKey(e);if(!s.has(n)){s.add(n);const o=t.name||r.basenameOrAuthority(e);i.push(new a({uri:e,name:o,index:i.length},t))}}}return i}})),define(t[96],n([0,1,20,8,2,119,24]),(function(e,t,n,r,i,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InternalNLSConfiguration=t.getNLSConfiguration=void 0;const a=i.join(r.FileAccess.asFileUri("",e).fsPath,"nls.metadata.json"),c=new Map;var l;t.getNLSConfiguration=function(e,t){return(r=a,
new Promise(e=>n.exists(r,e))).then(n=>{if(!n||!o.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let r=`${e}||${t}`,i=c.get(r);return i||(i=s.getNLSConfiguration(o.default.commit,t,a,e).then(e=>(l.is(e)&&(e._languagePackSupport=!0),e)),c.set(r,i)),i});var r},function(e){e.is=function(e){return e&&"string"==typeof e._languagePackId}}(l=t.InternalNLSConfiguration||(t.InternalNLSConfiguration={}))})),define(t[38],n([0,1,59,8]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createRemoteURITransformer=t.uriTransformerPath=void 0,t.uriTransformerPath=r.FileAccess.asFileUri("vs/server/uriTransformer.js",e).fsPath,t.createRemoteURITransformer=function(r){const i=e.__$__nodeRequire(t.uriTransformerPath)(r);return new n.URITransformer(i)}})),define(t[97],n([0,1,33,96,38,8,2,6,40,125]),(function(e,t,n,r,i,s,o,a,c,l){"use strict";async function u(e={},t,n,i){
const s=await r.getNLSConfiguration(t,n.userDataPath),a=await l.getShellEnvironment(i,n),c=n.isBuilt?o.join(n.appRoot,"bin"):o.join(n.appRoot,"resources","server","bin-dev"),u=process.env;let h=e.PATH||a.PATH||u.PATH;h=h?c+o.delimiter+h:c;const d=Object.assign(Object.assign(Object.assign(Object.assign({},u),a),{AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",PIPE_LOGGING:"true",VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(s,void 0,0)}),e);return function(e,t,n){const r=Object.keys(e).filter(e=>e.toLowerCase()===t.toLowerCase()),i=r.length>0?r[0]:t;e[i]=n}(d,"PATH",h),function(e){for(let t of Object.keys(e))null===e[t]&&delete e[t]}(d),d}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostConnection=t.buildUserEnvironment=void 0,t.buildUserEnvironment=u;t.ExtensionHostConnection=class{constructor(e,t,n,r,i,s){this._environmentService=e,this._logService=t,this._reconnectionToken=n,
this._onClose=new a.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=r,this._extensionHostProcess=null;const{skipWebSocketFrames:o,socket:c}=this._getUnderlyingSocket(i);this._skipWebSocketFrames=o,this._rendererConnection=c,this._rendererConnection.pause(),this._initialDataChunk=s,this._log("New connection established.")}_log(e){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${e}`)}_logError(e){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${e}`)}_getUnderlyingSocket(e){return e instanceof c.NodeSocket?{skipWebSocketFrames:!0,socket:e.socket}:{skipWebSocketFrames:!1,socket:e.socket.socket}}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;this._extensionHostProcess.send({type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"})}acceptReconnection(e,t,n){this._remoteAddress=e,this._log("The client has reconnected.")
;const{skipWebSocketFrames:r,socket:i}=this._getUnderlyingSocket(t);if(!this._extensionHostProcess)return this._skipWebSocketFrames=r,this._rendererConnection=i,this._rendererConnection.pause(),void(this._initialDataChunk=n);i.pause();const s={type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:n.buffer.toString("base64"),skipWebSocketFrames:r};this._extensionHostProcess.send(s,i)}_cleanResources(){this._disposed||(this._disposed=!0,this._rendererConnection&&(this._rendererConnection.end(),this._rendererConnection=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(t){try{let r=[];t.port&&!process.pkg&&(r=[`--inspect${t.break?"-brk":""}=0.0.0.0:${t.port}`]);const o={env:await u(t.env,t.language,this._environmentService,this._logService),execArgv:r,silent:!0},c=["--type=extensionHost",`--uriTransformerPath=${i.uriTransformerPath}`],l=this._environmentService.args["use-host-proxy"];void 0!==l&&c.push(`--useHostProxy=${l}`),
this._extensionHostProcess=n.fork(s.FileAccess.asFileUri("bootstrap-fork",e).fsPath,c,o);const h=this._extensionHostProcess.pid;this._log(`<${h}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const d=a.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),f=a.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");d(e=>console.log("EXTHOST-STDOUT::::::::"+e)),f(e=>console.log("EXTHOST-STDERR::::::::"+e)),this._extensionHostProcess.on("message",e=>{e&&"__$console"===e.type&&(console.log("EXTHOST-LOG:::::"),console.log(e.arguments))}),this._extensionHostProcess.on("error",e=>{this._logError(`<${h}> Extension Host Process had an error`),this._logService.error(e),this._cleanResources()}),this._extensionHostProcess.on("exit",(e,t)=>{this._log(`<${h}> Extension Host Process exited with code: ${e}, signal: ${t}.`),this._cleanResources()});const p=e=>{if("VSCODE_EXTHOST_IPC_READY"===e.type){
this._extensionHostProcess.removeListener("message",p);const e={type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this._initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this._skipWebSocketFrames};this._extensionHostProcess.send(e,this._rendererConnection),this._initialDataChunk=null,this._rendererConnection=null}};this._extensionHostProcess.on("message",p)}catch(e){console.error("ExtensionHostConnection errored"),e&&console.error(e)}}}})),define(t[195],n([0,1,6,3,4,38,54,19,2,28]),(function(e,t,n,r,i,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAgentFileSystemChannel=void 0;class u extends r.Disposable{constructor(e,t,n,r){super(),this.logService=e,this.environmentService=t,this.uriTransformer=n,this.watcherRequests=new Map,this.fileWatcher=this._register(new o.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(r)}registerListeners(e){const t=this._register(new n.Emitter);this._register(t.event(t=>{
e.fire(t.map(e=>({resource:this.uriTransformer.transformOutgoingURI(e.resource),type:e.type})))})),this._register(this.fileWatcher.onDidChangeFile(e=>t.fire(e))),this._register(this.fileWatcher.onDidErrorOccur(t=>e.fire(t)))}getWatcherOptions(){const e=this.environmentService.args.fileWatcherPolling,t=Number(e);if(t>0)return{usePolling:!0,pollingInterval:t}}watch(e,t,n){const s=i.URI.revive(this.uriTransformer.transformIncoming(t));return this.environmentService.extensionsPath&&(n.excludes=[...n.excludes||[],c.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(e,this.fileWatcher.watch(s,n)),r.toDisposable(()=>{r.dispose(this.watcherRequests.get(e)),this.watcherRequests.delete(e)})}dispose(){super.dispose(),this.watcherRequests.forEach(e=>r.dispose(e)),this.watcherRequests.clear()}}class h extends r.Disposable{constructor(e,t){super(),this.logService=e,this.environmentService=t,this.BUFFER_SIZE=262144,this.uriTransformerCache=new Map,this.fileWatchers=new Map,
this.fsProvider=this._register(new o.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(e,t,n){const r=this.getUriTransformer(e.remoteAuthority);switch(t){case"stat":return this.stat(r,n[0]);case"readdir":return this.readdir(r,n[0]);case"open":return this.open(r,n[0],n[1]);case"close":return this.close(n[0]);case"read":return this.read(n[0],n[1],n[2]);case"readFile":return this.readFile(r,n[0]);case"write":return this.write(n[0],n[1],n[2],n[3],n[4]);case"writeFile":return this.writeFile(r,n[0],n[1],n[2]);case"rename":return this.rename(r,n[0],n[1],n[2]);case"copy":return this.copy(r,n[0],n[1],n[2]);case"mkdir":return this.mkdir(r,n[0]);case"delete":return this.delete(r,n[0],n[1]);case"watch":return Promise.resolve(this.watch(n[0],n[1],n[2],n[3]));case"unwatch":return Promise.resolve(this.unwatch(n[0],n[1]))}throw new Error(`IPC Command ${t} not found`)}listen(e,t,n){const r=this.getUriTransformer(e.remoteAuthority);switch(t){case"filechange":
return this.onFileChange(r,n[0]);case"readFileStream":return this.onReadFileStream(r,n[0],n[1])}throw new Error(`Unknown event ${t}`)}onFileChange(e,t){const i=new n.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(t,new u(this.logService,this.environmentService,e,i))},onLastListenerRemove:()=>{r.dispose(this.fileWatchers.get(t)),this.fileWatchers.delete(t)}});return i.event}onReadFileStream(e,t,r){const i=this.transformIncoming(e,t,!0),s=new l.CancellationTokenSource,o=new n.Emitter({onLastListenerRemove:()=>{s.cancel()}}),c=this.fsProvider.readFileStream(i,r,s.token);return c.on("data",e=>o.fire(a.VSBuffer.wrap(e))),c.on("error",e=>o.fire(e)),c.on("end",()=>{o.fire("end"),o.dispose(),s.dispose()}),o.event}getUriTransformer(e){let t=this.uriTransformerCache.get(e);return t||(t=s.createRemoteURITransformer(e),this.uriTransformerCache.set(e,t)),t}stat(e,t){const n=this.transformIncoming(e,t,!0);return this.fsProvider.stat(n)}readdir(e,t){const n=this.transformIncoming(e,t)
;return this.fsProvider.readdir(n)}open(e,t,n){const r=this.transformIncoming(e,t,!0);return this.fsProvider.open(r,n)}close(e){return this.fsProvider.close(e)}async read(e,t,n){const r=a.VSBuffer.alloc(n);return[r,await this.fsProvider.read(e,t,r.buffer,0,n)]}async readFile(e,t){const n=this.transformIncoming(e,t,!0),r=await this.fsProvider.readFile(n);return a.VSBuffer.wrap(r)}write(e,t,n,r,i){return this.fsProvider.write(e,t,n.buffer,r,i)}writeFile(e,t,n,r){const i=this.transformIncoming(e,t);return this.fsProvider.writeFile(i,n.buffer,r)}rename(e,t,n,r){const s=i.URI.revive(e.transformIncoming(t)),o=i.URI.revive(e.transformIncoming(n));return this.fsProvider.rename(s,o,r)}copy(e,t,n,r){const i=this.transformIncoming(e,t),s=this.transformIncoming(e,n);return this.fsProvider.copy(i,s,r)}mkdir(e,t){const n=this.transformIncoming(e,t);return this.fsProvider.mkdir(n)}delete(e,t,n){const r=this.transformIncoming(e,t);return this.fsProvider.delete(r,n)}transformIncoming(e,t,n=!1){
if(n&&"/vscode-resource"===t.path&&t.query){const e=JSON.parse(t.query).requestResourcePath;return i.URI.from({scheme:"file",path:e})}return i.URI.revive(e.transformIncoming(t))}watch(e,t,n,r){const i=e+t,s=this.fileWatchers.get(e);if(s){const e=s.watch(t,n,r);this.watchRequests.set(i,e)}}unwatch(e,t){const n=e+t,i=this.watchRequests.get(n);i&&(r.dispose(i),this.watchRequests.delete(n))}dispose(){super.dispose(),this.watchRequests.forEach(e=>r.dispose(e)),this.watchRequests.clear(),this.fileWatchers.forEach(e=>r.dispose(e)),this.fileWatchers.clear()}}t.RemoteAgentFileSystemChannel=h})),define(t[196],n([0,1,20,66,48,226,60,30,118,5,4,38,24,2,8]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WebClientServer=t.serveFile=t.serveError=void 0;const m={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function g(e,t,n,r){t.writeHead(n,{"Content-Type":"text/plain"}),t.end(r)}
async function v(e,t,r,s,o=Object.create(null)){try{const e=await i.promisify(n.stat)(s),a=`W/"${[e.ino,e.size,e.mtime.getTime()].join("-")}"`;if(t.headers["if-none-match"]===a)return r.writeHead(304),r.end();o["Content-Type"]=m[f.extname(s)]||c.getMediaMime(s)||"text/plain",o.Etag=a,r.writeHead(200,o),n.createReadStream(s).pipe(r)}catch(t){return"ENOENT"!==t.code&&(e.error(t),console.error(t.toString())),r.writeHead(404,{"Content-Type":"text/plain"}),r.end("Not found")}}t.serveError=g,t.serveFile=v;const y=f.dirname(p.FileAccess.asFileUri("",e).fsPath);t.WebClientServer=class{constructor(e,t,n){this._connectionToken=e,this._environmentService=t,this._logService=n,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(e,t,n){try{const r=n.pathname
;return"/favicon.ico"===r||"/manifest.json"===r||"/code-192.png"===r||"/code-512.png"===r?v(this._logService,e,t,f.join(y,"resources","server",r.substr(1))):/^\/static\//.test(r)?this._handleStatic(e,t,n):"/"===r?this._handleRoot(e,t,n):"/callback"===r?this._handleCallback(e,t,n):"/fetch-callback"===r?this._handleFetchCallback(e,t,n):g(0,t,404,"Not found.")}catch(e){return this._logService.error(e),console.error(e.toString()),g(0,t,500,"Internal Server Error.")}}_hasCorrectTokenCookie(e){return s.parse(e.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(e,t,n){const r=Object.create(null),i=decodeURIComponent(n.pathname),s=f.normalize(i.substr("/static/".length)),o=f.join(y,s);return a.isEqualOrParent(o,y,!l.isLinux)?v(this._logService,e,t,o,r):g(0,t,400,"Bad request.")}async _handleRoot(t,o,a){if(!t.headers.host)return g(0,o,400,"Bad request.");const c=a.query.tkn;if("string"==typeof c){const e=Object.create(null);e["Set-Cookie"]=s.serialize("vscode-tkn",c,{maxAge:604800})
;const t=Object.create(null);for(let e in a.query)"tkn"!==e&&(t[e]=a.query[e]);const n=r.format({pathname:"/",query:t});return e.Location=n,o.writeHead(302,e),o.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(t))return g(0,o,403,"Forbidden.");const l=t.headers.host,d=h.createRemoteURITransformer(l),{workspacePath:f,isFolder:m}=await this._getWorkspaceFromCLI();let v=void 0;this._environmentService.driverHandle&&(v=!1);const y=p.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",e).fsPath,b=(await i.promisify(n.readFile)(y)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",JSON.stringify({folderUri:f&&m?d.transformOutgoing(u.URI.file(f)):void 0,workspaceUri:f&&!m?d.transformOutgoing(u.URI.file(f)):void 0,remoteAuthority:l,webviewEndpoint:this._webviewEndpoint,_wrapWebWorkerExtHostInIframe:v,driver:"web"===this._environmentService.driverHandle||void 0}).replace(/"/g,"&quot;"))
;const w=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(b).join(" ")} 'sha256-O98pkmgtvUCQGVoddaGy891K52PVRnySDRxRszVLPNQ=' http://${l};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return o.writeHead(200,{"Content-Type":"text/html","Set-Cookie":s.serialize("vscode-tkn",this._connectionToken,{maxAge:604800}),"Content-Security-Policy":w}),o.end(b)}_getScriptCspHashes(e){const t=/<script>([\s\S]+?)<\/script>/gim,n=[];let r;for(;r=t.exec(e);){const e=o.createHash("sha256"),t=r[1].replace(/\r\n/g,"\n"),i=e.update(Buffer.from(t)).digest().toString("base64");n.push(`'sha256-${i}'`)}return n}async _getWorkspaceFromCLI(){
const e=process.env.VSCODE_CWD||process.cwd(),t=this._environmentService.args.workspace;if(t&&t.length>0){const r=a.sanitizeFilePath(t,e);if(await i.promisify(n.exists)(r))return{workspacePath:r}}const r=this._environmentService.args.folder;if(r&&r.length>0){const t=a.sanitizeFilePath(r,e);if(await i.promisify(n.exists)(t))return{workspacePath:t,isFolder:!0}}return{}}_getFirstQueryValue(e,t){const n=e.query[t];return Array.isArray(n)?n[0]:n}_getFirstQueryValues(e,t){const n=new Map;for(const r in e.query){if(t&&t.indexOf(r)>=0)continue;const i=this._getFirstQueryValue(e,r);"string"==typeof i&&n.set(r,i)}return n}async _handleCallback(t,n,r){const i=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[s,o,a,c,l,h]=i.map(e=>{const t=this._getFirstQueryValue(r,e);return t?decodeURIComponent(t):t});if(!s)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");let f=l,m=0;return this._getFirstQueryValues(r,i).forEach((e,t)=>{f||(f="")
;const n=0==m++?"":"&";f+=`${n}${t}=${e}`}),this._mapCallbackUriToRequestId.set(s,u.URI.from({scheme:o||d.default.urlProtocol,authority:a,path:c,query:f,fragment:h}).toJSON()),v(this._logService,t,n,p.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",e).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(e,t,n){const r=this._getFirstQueryValue(n,"vscode-requestId");if(!r)return t.writeHead(400,{"Content-Type":"text/plain"}),t.end("Bad request.");const i=this._mapCallbackUriToRequestId.get(r);return i&&this._mapCallbackUriToRequestId.delete(r),t.writeHead(200,{"Content-Type":"text/json"}),t.end(JSON.stringify(i))}}})),define(t[197],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostRpcService=t.IExtHostRpcService=void 0,t.IExtHostRpcService=n.createDecorator("IExtHostRpcService");t.ExtHostRpcService=class{constructor(e){this.getProxy=e.getProxy.bind(e),this.set=e.set.bind(e),this.assertRegistered=e.assertRegistered.bind(e),
this.drain=e.drain.bind(e)}}})),define(t[198],n([0,1,154,6,11,4,3,7,51,32,129,16]),(function(e,t,n,r,i,s,o,a,c,l,u,h){"use strict";var d;Object.defineProperty(t,"__esModule",{value:!0}),
t.computeEditorAriaLabel=t.EditorsOrder=t.pathsToEditors=t.Extensions=t.CloseDirection=t.EditorResourceAccessor=t.SideBySideEditor=t.EditorCommandsContextActionRunner=t.TextEditorOptions=t.EditorOptions=t.isEditorInputWithOptions=t.EditorModel=t.SideBySideEditorInput=t.isEditorInputWithPreferredResource=t.EncodingMode=t.EditorInput=t.SaveReason=t.Verbosity=t.isTextEditorPane=t.BINARY_DIFF_EDITOR_ID=t.TEXT_DIFF_EDITOR_ID=t.EditorAreaVisibleContext=t.SplitEditorsVertically=t.IsCenteredLayoutContext=t.InEditorZenModeContext=t.EditorsVisibleContext=t.SingleEditorGroupsContext=t.MultipleEditorGroupsContext=t.ActiveEditorGroupLastContext=t.ActiveEditorGroupIndexContext=t.ActiveEditorGroupEmptyContext=t.EditorGroupEditorsCountContext=t.TextCompareEditorActiveContext=t.TextCompareEditorVisibleContext=t.ActiveEditorAvailableEditorIdsContext=t.ActiveEditorContext=t.ActiveEditorReadonlyContext=t.ActiveEditorStickyContext=t.ActiveEditorPinnedContext=t.ActiveEditorDirtyContext=void 0,
t.ActiveEditorDirtyContext=new c.RawContextKey("activeEditorIsDirty",!1),t.ActiveEditorPinnedContext=new c.RawContextKey("activeEditorIsNotPreview",!1),t.ActiveEditorStickyContext=new c.RawContextKey("activeEditorIsPinned",!1),t.ActiveEditorReadonlyContext=new c.RawContextKey("activeEditorIsReadonly",!1),t.ActiveEditorContext=new c.RawContextKey("activeEditor",null),t.ActiveEditorAvailableEditorIdsContext=new c.RawContextKey("activeEditorAvailableEditorIds",""),t.TextCompareEditorVisibleContext=new c.RawContextKey("textCompareEditorVisible",!1),t.TextCompareEditorActiveContext=new c.RawContextKey("textCompareEditorActive",!1),t.EditorGroupEditorsCountContext=new c.RawContextKey("groupEditorsCount",0),t.ActiveEditorGroupEmptyContext=new c.RawContextKey("activeEditorGroupEmpty",!1),t.ActiveEditorGroupIndexContext=new c.RawContextKey("activeEditorGroupIndex",0),t.ActiveEditorGroupLastContext=new c.RawContextKey("activeEditorGroupLast",!1),
t.MultipleEditorGroupsContext=new c.RawContextKey("multipleEditorGroups",!1),t.SingleEditorGroupsContext=t.MultipleEditorGroupsContext.toNegated(),t.EditorsVisibleContext=new c.RawContextKey("editorIsOpen",!1),t.InEditorZenModeContext=new c.RawContextKey("inZenMode",!1),t.IsCenteredLayoutContext=new c.RawContextKey("isCenteredLayout",!1),t.SplitEditorsVertically=new c.RawContextKey("splitEditorsVertically",!1),t.EditorAreaVisibleContext=new c.RawContextKey("editorAreaVisible",!0),t.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",t.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor",t.isTextEditorPane=function(e){const t=e;return"function"==typeof(null==t?void 0:t.getViewState)},function(e){e[e.SHORT=0]="SHORT",e[e.MEDIUM=1]="MEDIUM",e[e.LONG=2]="LONG"}(t.Verbosity||(t.Verbosity={})),function(e){e[e.EXPLICIT=1]="EXPLICIT",e[e.AUTO=2]="AUTO",e[e.FOCUS_CHANGE=3]="FOCUS_CHANGE",e[e.WINDOW_CHANGE=4]="WINDOW_CHANGE"}(t.SaveReason||(t.SaveReason={}));class f extends o.Disposable{constructor(){
super(...arguments),this._onDidChangeDirty=this._register(new r.Emitter),this.onDidChangeDirty=this._onDidChangeDirty.event,this._onDidChangeLabel=this._register(new r.Emitter),this.onDidChangeLabel=this._onDidChangeLabel.event,this._onDispose=this._register(new r.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}getName(){return`Editor ${this.getTypeId()}`}getDescription(e){}getTitle(e){return this.getName()}getAriaLabel(){return this.getTitle(0)}getPreferredEditorId(e){return h.firstOrDefault(e)}getTelemetryDescriptor(){return{typeId:this.getTypeId()}}isReadonly(){return!0}isUntitled(){return!1}isDirty(){return!1}isSaving(){return!1}async resolve(){return null}async save(e,t){return this}async saveAs(e,t){return this}async revert(e,t){}rename(e,t){}supportsSplitEditor(){return!0}matches(e){return this===e}isDisposed(){return this.disposed}dispose(){this.disposed||(this.disposed=!0,this._onDispose.fire()),super.dispose()}}function p(e){return e&&!!e.preferredResource}t.EditorInput=f,function(e){
e[e.Encode=0]="Encode",e[e.Decode=1]="Decode"}(t.EncodingMode||(t.EncodingMode={})),t.isEditorInputWithPreferredResource=p;class m extends f{constructor(e,t,n,r){super(),this.name=e,this.description=t,this._secondary=n,this._primary=r,this.registerListeners()}registerListeners(){const e=r.Event.once(this.secondary.onDispose);this._register(e(()=>{this.isDisposed()||this.dispose()}));const t=r.Event.once(this.primary.onDispose);this._register(t(()=>{this.isDisposed()||this.dispose()})),this._register(this.primary.onDidChangeDirty(()=>this._onDidChangeDirty.fire())),this._register(this.primary.onDidChangeLabel(()=>this._onDidChangeLabel.fire()))}get resource(){}get primary(){return this._primary}get secondary(){return this._secondary}getTypeId(){return m.ID}getName(){return this.name?this.name:n.localize(0,null,this._secondary.getName(),this._primary.getName())}getDescription(){return this.description}isReadonly(){return this.primary.isReadonly()}isUntitled(){return this.primary.isUntitled()}isDirty(){
return this.primary.isDirty()}isSaving(){return this.primary.isSaving()}save(e,t){return this.primary.save(e,t)}saveAs(e,t){return this.primary.saveAs(e,t)}revert(e,t){return this.primary.revert(e,t)}getTelemetryDescriptor(){const e=this.primary.getTelemetryDescriptor();return Object.assign(e,super.getTelemetryDescriptor())}matches(e){return e===this||e instanceof m&&(this.primary.matches(e.primary)&&this.secondary.matches(e.secondary))}}t.SideBySideEditorInput=m,m.ID="workbench.editorinputs.sidebysideEditorInput";class g extends o.Disposable{constructor(){super(...arguments),this._onDispose=this._register(new r.Emitter),this.onDispose=this._onDispose.event,this.disposed=!1}async load(){return this}isResolved(){return!0}isDisposed(){return this.disposed}dispose(){this.disposed=!0,this._onDispose.fire(),super.dispose()}}t.EditorModel=g,t.isEditorInputWithOptions=function(e){return!!e&&!!e.editor};class v{static create(e){const t=new v;return t.overwrite(e),t}overwrite(e){
return"boolean"==typeof e.forceReload&&(this.forceReload=e.forceReload),"boolean"==typeof e.revealIfVisible&&(this.revealIfVisible=e.revealIfVisible),"boolean"==typeof e.revealIfOpened&&(this.revealIfOpened=e.revealIfOpened),"boolean"==typeof e.preserveFocus&&(this.preserveFocus=e.preserveFocus),"number"==typeof e.activation&&(this.activation=e.activation),"boolean"==typeof e.pinned&&(this.pinned=e.pinned),"boolean"==typeof e.sticky&&(this.sticky=e.sticky),"boolean"==typeof e.inactive&&(this.inactive=e.inactive),"boolean"==typeof e.ignoreError&&(this.ignoreError=e.ignoreError),"number"==typeof e.index&&(this.index=e.index),"string"!=typeof e.override&&!1!==e.override||(this.override=e.override),"number"==typeof e.context&&(this.context=e.context),this}}t.EditorOptions=v;class y extends v{static from(e){if(null==e?void 0:e.options)return y.create(e.options)}static create(e=Object.create(null)){const t=new y;return t.overwrite(e),t}overwrite(e){var t,n;return super.overwrite(e),e.selection&&(this.selection={
startLineNumber:e.selection.startLineNumber,startColumn:e.selection.startColumn,endLineNumber:null!==(t=e.selection.endLineNumber)&&void 0!==t?t:e.selection.startLineNumber,endColumn:null!==(n=e.selection.endColumn)&&void 0!==n?n:e.selection.startColumn}),e.viewState&&(this.editorViewState=e.viewState),void 0!==e.selectionRevealType&&(this.selectionRevealType=e.selectionRevealType),this}hasOptionsDefined(){return!!this.editorViewState||!!this.selectionRevealType||!!this.selection}static fromEditor(e,t){const n=y.create(t);return n.editorViewState=i.withNullAsUndefined(e.saveViewState()),n}apply(e,t){var n,r;let i=!1;if(this.editorViewState)e.restoreViewState(this.editorViewState),i=!0;else if(this.selection){const s={startLineNumber:this.selection.startLineNumber,startColumn:this.selection.startColumn,endLineNumber:null!==(n=this.selection.endLineNumber)&&void 0!==n?n:this.selection.startLineNumber,endColumn:null!==(r=this.selection.endColumn)&&void 0!==r?r:this.selection.startColumn};e.setSelection(s),
2===this.selectionRevealType?e.revealRangeNearTop(s,t):3===this.selectionRevealType?e.revealRangeNearTopIfOutsideViewport(s,t):1===this.selectionRevealType?e.revealRangeInCenterIfOutsideViewport(s,t):e.revealRangeInCenter(s,t),i=!0}return i}}t.TextEditorOptions=y;class b extends u.ActionRunner{constructor(e){super(),this.context=e}run(e){return super.run(e,this.context)}}t.EditorCommandsContextActionRunner=b,function(e){e[e.PRIMARY=1]="PRIMARY",e[e.SECONDARY=2]="SECONDARY",e[e.BOTH=3]="BOTH"}(d=t.SideBySideEditor||(t.SideBySideEditor={}));t.EditorResourceAccessor=new class{getOriginalUri(e,t){if(!e)return;if((null==t?void 0:t.supportSideBySide)&&e instanceof m){if((null==t?void 0:t.supportSideBySide)===d.BOTH)return{primary:this.getOriginalUri(e.primary,{filterByScheme:t.filterByScheme}),secondary:this.getOriginalUri(e.secondary,{filterByScheme:t.filterByScheme})};e=t.supportSideBySide===d.PRIMARY?e.primary:e.secondary}const n=p(e)?e.preferredResource:e.resource
;return n&&t&&t.filterByScheme?this.filterUri(n,t.filterByScheme):n}getCanonicalUri(e,t){if(!e)return;if((null==t?void 0:t.supportSideBySide)&&e instanceof m){if((null==t?void 0:t.supportSideBySide)===d.BOTH)return{primary:this.getCanonicalUri(e.primary,{filterByScheme:t.filterByScheme}),secondary:this.getCanonicalUri(e.secondary,{filterByScheme:t.filterByScheme})};e=t.supportSideBySide===d.PRIMARY?e.primary:e.secondary}const n=e.resource;return n&&t&&t.filterByScheme?this.filterUri(n,t.filterByScheme):n}filterUri(e,t){if(Array.isArray(t)){if(t.some(t=>e.scheme===t))return e}else if(t===e.scheme)return e}},function(e){e[e.LEFT=0]="LEFT",e[e.RIGHT=1]="RIGHT"}(t.CloseDirection||(t.CloseDirection={}));t.Extensions={EditorInputFactories:"workbench.contributions.editor.inputFactories"},l.Registry.add(t.Extensions.EditorInputFactories,new class{constructor(){this.customEditorInputFactoryInstances=new Map,this.editorInputFactoryConstructors=new Map,this.editorInputFactoryInstances=new Map}start(e){
const t=this.instantiationService=e.get(a.IInstantiationService);this.editorInputFactoryConstructors.forEach((e,n)=>{this.createEditorInputFactory(n,e,t)}),this.editorInputFactoryConstructors.clear()}createEditorInputFactory(e,t,n){const r=n.createInstance(t);this.editorInputFactoryInstances.set(e,r)}registerFileEditorInputFactory(e){this.fileEditorInputFactory=e}getFileEditorInputFactory(){return i.assertIsDefined(this.fileEditorInputFactory)}registerCustomEditorInputFactory(e,t){this.customEditorInputFactoryInstances.set(e,t)}getCustomEditorInputFactory(e){return this.customEditorInputFactoryInstances.get(e)}registerEditorInputFactory(e,t){return this.instantiationService?this.createEditorInputFactory(e,t,this.instantiationService):this.editorInputFactoryConstructors.set(e,t),o.toDisposable(()=>{this.editorInputFactoryConstructors.delete(e),this.editorInputFactoryInstances.delete(e)})}getEditorInputFactory(e){return this.editorInputFactoryInstances.get(e)}}),t.pathsToEditors=async function(e,t){
if(!e||!e.length)return[];const n=await Promise.all(e.map(async e=>{const n=s.URI.revive(e.fileUri);if(!n||!t.canHandleResource(n))return;const r="boolean"==typeof e.exists?e.exists:await t.exists(n);if(!r&&e.openOnlyIfExists)return;const i=r&&"number"==typeof e.lineNumber?{selection:{startLineNumber:e.lineNumber,startColumn:e.columnNumber||1},pinned:!0,override:e.overrideId}:{pinned:!0,override:e.overrideId};let o;return o=r?{resource:n,options:i,forceFile:!0}:{resource:n,options:i,forceUntitled:!0}}));return h.coalesce(n)},function(e){e[e.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",e[e.SEQUENTIAL=1]="SEQUENTIAL"}(t.EditorsOrder||(t.EditorsOrder={})),t.computeEditorAriaLabel=function(e,t,r,i){let s=e.getAriaLabel();return r&&!r.isPinned(e)&&(s=n.localize(1,null,s)),r&&r.isSticky(null!=t?t:e)&&(s=n.localize(2,null,s)),r&&i>1&&(s=`${s}, ${r.ariaLabel}`),s}})),define(t[98],n([0,1,39,21,8,2,5,51]),(function(e,t,n,r,i,s,o,a){"use strict";var c,l;Object.defineProperty(t,"__esModule",{value:!0}),
t.CellStatusbarAlignment=t.NotebookTextDiffEditorPreview=t.ShowCellStatusBarKey=t.CellToolbarLocKey=t.DisplayOrderKey=t.CellSequence=t.notebookDocumentFilterMatch=t.isDocumentExcludePattern=t.NotebookEditorPriority=t.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=t.diff=t.sortMimeTypes=t.mimeTypeSupportedByCore=t.CellUri=t.getCellUndoRedoComparisonKey=t.CellEditType=t.NotebookCellsChangeType=t.outputHasDynamicHeight=t.RenderOutputType=t.addIdToOutput=t.isTransformedDisplayOutput=t.MimeTypeRendererResolver=t.NotebookCellRunState=t.notebookDocumentMetadataDefaults=t.NotebookRunState=t.BUILTIN_RENDERER_ID=t.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=t.NOTEBOOK_DISPLAY_ORDER=t.CellOutputKind=t.CellKind=void 0,function(e){e[e.Markdown=1]="Markdown",e[e.Code=2]="Code"}(t.CellKind||(t.CellKind={})),function(e){e[e.Text=1]="Text",e[e.Error=2]="Error",e[e.Rich=3]="Rich"}(c=t.CellOutputKind||(t.CellOutputKind={})),
t.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],t.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],t.BUILTIN_RENDERER_ID="_builtin",function(e){e[e.Running=1]="Running",e[e.Idle=2]="Idle"}(l=t.NotebookRunState||(t.NotebookRunState={})),t.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,displayOrder:t.NOTEBOOK_DISPLAY_ORDER,custom:{},runState:l.Idle},function(e){e[e.Running=1]="Running",e[e.Idle=2]="Idle",e[e.Success=3]="Success",e[e.Error=4]="Error"}(t.NotebookCellRunState||(t.NotebookCellRunState={})),function(e){e[e.Core=0]="Core",e[e.Active=1]="Active",e[e.Lazy=2]="Lazy"}(t.MimeTypeRendererResolver||(t.MimeTypeRendererResolver={})),t.isTransformedDisplayOutput=function(e){return e.outputKind===c.Rich&&!!e.outputId}
;t.addIdToOutput=(e,t=r.generateUuid())=>e.outputKind===c.Rich?Object.assign(Object.assign({},e),{outputId:t}):e,function(e){e[e.None=0]="None",e[e.Html=1]="Html",e[e.Extension=2]="Extension"}(t.RenderOutputType||(t.RenderOutputType={}));var u;function h(e,t){return o.isWindows&&(e=e.replace(/\//g,"\\"),t=t.replace(/\//g,"\\")),n.match(e,t)}function d(e,t,n,r){let i=0;for(let n=0;n<t.length;n++){if(h(t[n],e))return i;i++}for(let t=0;t<n.length;t++){if(h(n[t],e))return i;i++}for(let t=0;t<r.length;t++){if(h(r[t],e))return i;i++}return i}function f(e){const t=e;return!("string"!=typeof t.include&&!n.isRelativePattern(t.include)||"string"!=typeof t.exclude&&!n.isRelativePattern(t.exclude))}t.outputHasDynamicHeight=e=>2!==e.type&&e.hasDynamicHeight,function(e){e[e.ModelChange=1]="ModelChange",e[e.Move=2]="Move",e[e.CellClearOutput=3]="CellClearOutput",e[e.CellsClearOutput=4]="CellsClearOutput",e[e.ChangeLanguage=5]="ChangeLanguage",e[e.Initialize=6]="Initialize",e[e.ChangeCellMetadata=7]="ChangeCellMetadata",
e[e.Output=8]="Output",e[e.ChangeCellContent=9]="ChangeCellContent",e[e.ChangeDocumentMetadata=10]="ChangeDocumentMetadata",e[e.Unknown=11]="Unknown"}(t.NotebookCellsChangeType||(t.NotebookCellsChangeType={})),function(e){e[e.Replace=1]="Replace",e[e.Output=2]="Output",e[e.Metadata=3]="Metadata",e[e.CellLanguage=4]="CellLanguage",e[e.DocumentMetadata=5]="DocumentMetadata",e[e.OutputsSplice=6]="OutputsSplice",e[e.Move=7]="Move",e[e.Unknown=8]="Unknown",e[e.CellContent=9]="CellContent"}(t.CellEditType||(t.CellEditType={})),t.getCellUndoRedoComparisonKey=function(e){const t=u.parse(e);return t?t.notebook.toString():e.toString()},function(e){e.scheme=i.Schemas.vscodeNotebookCell;const t=/^\d{7,}/;e.generate=function(t,n){return t.with({scheme:e.scheme,fragment:`${n.toString().padStart(7,"0")}${t.scheme!==i.Schemas.file?t.scheme:""}`})},e.generateCellMetadataUri=function(e,t){return e.with({scheme:i.Schemas.vscode,authority:"vscode-notebook-cell-metadata",
fragment:`${t.toString().padStart(7,"0")}${e.scheme!==i.Schemas.file?e.scheme:""}`})},e.parse=function(n){if(n.scheme!==e.scheme)return;const r=t.exec(n.fragment);return r?{handle:Number(r[0]),notebook:n.with({scheme:n.fragment.substr(r[0].length)||i.Schemas.file,fragment:null})}:void 0}}(u=t.CellUri||(t.CellUri={})),t.mimeTypeSupportedByCore=function(e){return["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain","text/x-javascript"].indexOf(e)>-1},t.sortMimeTypes=function(e,t,n,r){return e.sort((e,i)=>d(e,t,n,r)-d(i,t,n,r))},t.diff=function(e,t,n,r=((e,t)=>e===t)){const i=[];function s(e,t,n){if(0===t&&0===n.length)return;const r=i[i.length-1];r&&r.start+r.deleteCount===e?(r.deleteCount+=t,r.toInsert.push(...n)):i.push({start:e,deleteCount:t,toInsert:n})}let o=0,a=0;for(;;){if(o===e.length){s(o,0,t.slice(a));break}if(a===t.length){s(o,e.length-o,[]);break}const i=e[o],c=t[a];r(i,c)?(o+=1,a+=1):n(c)?(s(o,1,[]),o+=1):(s(o,0,[c]),a+=1)}
return i},t.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new a.RawContextKey("notebookEditorCursorAtBoundary","none"),function(e){e.default="default",e.option="option"}(t.NotebookEditorPriority||(t.NotebookEditorPriority={})),t.isDocumentExcludePattern=f,t.notebookDocumentFilterMatch=function(e,t,r){if(Array.isArray(e.viewType)&&e.viewType.indexOf(t)>=0)return!0;if(e.viewType===t)return!0;if(e.filenamePattern){let t=f(e.filenamePattern)?e.filenamePattern.include:e.filenamePattern,i=f(e.filenamePattern)?e.filenamePattern.exclude:void 0;if(n.match(t,s.basename(r.fsPath).toLowerCase()))return!i||!n.match(i,s.basename(r.fsPath).toLowerCase())}return!1};t.CellSequence=class{constructor(e){this.textModel=e}getElements(){const e=new Int32Array(this.textModel.cells.length);for(let t=0;t<this.textModel.cells.length;t++)e[t]=this.textModel.cells[t].getHashValue();return e}},t.DisplayOrderKey="notebook.displayOrder",t.CellToolbarLocKey="notebook.cellToolbarLocation",t.ShowCellStatusBarKey="notebook.showCellStatusBar",
t.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",function(e){e[e.LEFT=0]="LEFT",e[e.RIGHT=1]="RIGHT"}(t.CellStatusbarAlignment||(t.CellStatusbarAlignment={}))}));var a=this&&this.__classPrivateFieldSet||function(e,t,n){if(!t.has(e))throw new TypeError("attempted to set private field on non-instance");return t.set(e,n),n},c=this&&this.__classPrivateFieldGet||function(e,t){if(!t.has(e))throw new TypeError("attempted to get private field on non-instance");return t.get(e)};define(t[99],n([0,1,16,58,15,74,23,11,4,21,27,91,98]),(function(e,t,n,r,i,o,l,u,h,d,f,p,m){"use strict";var g,v,y,b,w,_,E,S,C,x,I,k,T,P,R;function O(e){function t(){return Reflect.construct(e,arguments,this.constructor)}return Object.defineProperty(t,"name",Object.getOwnPropertyDescriptor(e,"name")),Object.setPrototypeOf(t,e),Object.setPrototypeOf(t.prototype,e.prototype),t}Object.defineProperty(t,"__esModule",{value:!0}),
t.StandardTokenType=t.ExtensionRuntime=t.ExtensionMode=t.TimelineItem=t.NotebookEditorRevealType=t.NotebookCellStatusBarAlignment=t.NotebookRunState=t.NotebookCellRunState=t.CellOutputKind=t.CellKind=t.NotebookCellOutput=t.NotebookCellOutputItem=t.ColorThemeKind=t.ColorTheme=t.FileDecoration=t.ExtensionKind=t.QuickInputButtons=t.DebugConfigurationProviderTriggerKind=t.DebugConsoleMode=t.SemanticTokensEdits=t.SemanticTokensEdit=t.SemanticTokens=t.SemanticTokensBuilder=t.SemanticTokensLegend=t.CommentMode=t.CommentThreadCollapsibleState=t.FoldingRangeKind=t.FoldingRange=t.FileSystemError=t.FileChangeType=t.LogLevel=t.EvaluatableExpression=t.DebugAdapterInlineImplementation=t.DebugAdapterNamedPipeServer=t.DebugAdapterServer=t.DebugAdapterExecutable=t.DataBreakpoint=t.FunctionBreakpoint=t.SourceBreakpoint=t.Breakpoint=t.RelativePattern=t.ConfigurationTarget=t.ThemeColor=t.ThemeIcon=t.TreeItemCollapsibleState=t.TreeItem=t.ProgressLocation=t.Task=t.CustomExecution=t.TaskScope=t.ShellQuoting=t.ShellExecution=t.ProcessExecution=t.TaskGroup=t.TaskPanelKind=t.TaskRevealKind=t.SourceControlInputBoxValidationType=t.ColorFormat=t.ColorPresentation=t.ColorInformation=t.Color=t.DocumentLink=t.DecorationRangeBehavior=t.TextEditorSelectionChangeKind=t.TextEditorRevealType=t.TextDocumentSaveReason=t.TextEditorLineNumbersStyle=t.StatusBarAlignment=t.ViewColumn=t.CompletionList=t.CompletionItem=t.CompletionItemTag=t.CompletionItemKind=t.CompletionTriggerKind=t.SignatureHelpTriggerKind=t.SignatureHelp=t.SignatureInformation=t.ParameterInformation=t.MarkdownString=t.CodeInset=t.CodeLens=t.CallHierarchyOutgoingCall=t.CallHierarchyIncomingCall=t.CallHierarchyItem=t.SelectionRange=t.CodeActionKind=t.CodeAction=t.CodeActionTrigger=t.DocumentSymbol=t.SymbolInformation=t.SymbolTag=t.SymbolKind=t.DocumentHighlight=t.DocumentHighlightKind=t.Hover=t.Diagnostic=t.DiagnosticRelatedInformation=t.Location=t.DiagnosticSeverity=t.DiagnosticTag=t.SnippetString=t.WorkspaceEdit=t.FileEditType=t.TextEdit=t.EnvironmentVariableMutatorType=t.EndOfLine=t.RemoteAuthorityResolverError=t.ResolvedAuthority=t.Selection=t.Range=t.Position=t.Disposable=void 0
;let L=v=class{constructor(e){g.set(this,void 0),a(this,g,e)}static from(...e){let t=e;return new v((function(){if(t){for(const e of t)e&&"function"==typeof e.dispose&&e.dispose();t=void 0}}))}dispose(){"function"==typeof c(this,g)&&(c(this,g).call(this),a(this,g,void 0))}};g=new WeakMap,L=v=s([O],L),t.Disposable=L;let D=y=class{constructor(e,t){if(e<0)throw i.illegalArgument("line must be non-negative");if(t<0)throw i.illegalArgument("character must be non-negative");this._line=e,this._character=t}static Min(...e){if(0===e.length)throw new TypeError;let t=e[0];for(let n=1;n<e.length;n++){const r=e[n];r.isBefore(t)&&(t=r)}return t}static Max(...e){if(0===e.length)throw new TypeError;let t=e[0];for(let n=1;n<e.length;n++){const r=e[n];r.isAfter(t)&&(t=r)}return t}static isPosition(e){if(!e)return!1;if(e instanceof y)return!0;let{line:t,character:n}=e;return"number"==typeof t&&"number"==typeof n}get line(){return this._line}get character(){return this._character}isBefore(e){
return this._line<e._line||!(e._line<this._line)&&this._character<e._character}isBeforeOrEqual(e){return this._line<e._line||!(e._line<this._line)&&this._character<=e._character}isAfter(e){return!this.isBeforeOrEqual(e)}isAfterOrEqual(e){return!this.isBefore(e)}isEqual(e){return this._line===e._line&&this._character===e._character}compareTo(e){return this._line<e._line?-1:this._line>e.line?1:this._character<e._character?-1:this._character>e._character?1:0}translate(e,t=0){if(null===e||null===t)throw i.illegalArgument();let n;return void 0===e?n=0:"number"==typeof e?n=e:(n="number"==typeof e.lineDelta?e.lineDelta:0,t="number"==typeof e.characterDelta?e.characterDelta:0),0===n&&0===t?this:new y(this.line+n,this.character+t)}with(e,t=this.character){if(null===e||null===t)throw i.illegalArgument();let n;return void 0===e?n=this.line:"number"==typeof e?n=e:(n="number"==typeof e.line?e.line:this.line,t="number"==typeof e.character?e.character:this.character),n===this.line&&t===this.character?this:new y(n,t)}
toJSON(){return{line:this.line,character:this.character}}};D=y=s([O],D),t.Position=D;let A=b=class{constructor(e,t,n,r){let i,s;if("number"==typeof e&&"number"==typeof t&&"number"==typeof n&&"number"==typeof r?(i=new D(e,t),s=new D(n,r)):e instanceof D&&t instanceof D&&(i=e,s=t),!i||!s)throw new Error("Invalid arguments");i.isBefore(s)?(this._start=i,this._end=s):(this._start=s,this._end=i)}static isRange(e){return e instanceof b||!!e&&(D.isPosition(e.start)&&D.isPosition(e.end))}get start(){return this._start}get end(){return this._end}contains(e){return e instanceof b?this.contains(e._start)&&this.contains(e._end):e instanceof D&&(!e.isBefore(this._start)&&!this._end.isBefore(e))}isEqual(e){return this._start.isEqual(e._start)&&this._end.isEqual(e._end)}intersection(e){const t=D.Max(e.start,this._start),n=D.Min(e.end,this._end);if(!t.isAfter(n))return new b(t,n)}union(e){if(this.contains(e))return this;if(e.contains(this))return e;const t=D.Min(e.start,this._start),n=D.Max(e.end,this.end);return new b(t,n)}
get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(e,t=this.end){if(null===e||null===t)throw i.illegalArgument();let n;return e?D.isPosition(e)?n=e:(n=e.start||this.start,t=e.end||this.end):n=this.start,n.isEqual(this._start)&&t.isEqual(this.end)?this:new b(n,t)}toJSON(){return[this.start,this.end]}};A=b=s([O],A),t.Range=A;let N=w=class extends A{constructor(e,t,n,r){let i,s;if("number"==typeof e&&"number"==typeof t&&"number"==typeof n&&"number"==typeof r?(i=new D(e,t),s=new D(n,r)):e instanceof D&&t instanceof D&&(i=e,s=t),!i||!s)throw new Error("Invalid arguments");super(i,s),this._anchor=i,this._active=s}static isSelection(e){return e instanceof w||!!e&&(A.isRange(e)&&D.isPosition(e.anchor)&&D.isPosition(e.active)&&"boolean"==typeof e.isReversed)}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor
}}};N=w=s([O],N),t.Selection=N;t.ResolvedAuthority=class{constructor(e,t,n){if("string"!=typeof e||0===e.length)throw i.illegalArgument("host");if("number"!=typeof t||0===t||Math.round(t)!==t)throw i.illegalArgument("port");if(void 0!==n&&("string"!=typeof n||0===n.length||!/^[0-9A-Za-z\-]+$/.test(n)))throw i.illegalArgument("connectionToken");this.host=e,this.port=Math.round(t),this.connectionToken=n}};class M extends Error{constructor(e,t=p.RemoteAuthorityResolverErrorCode.Unknown,n){super(e),this._message=e,this._code=t,this._detail=n,"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,M.prototype)}static NotAvailable(e,t){return new M(e,p.RemoteAuthorityResolverErrorCode.NotAvailable,t)}static TemporarilyNotAvailable(e){return new M(e,p.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}t.RemoteAuthorityResolverError=M,function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.EndOfLine||(t.EndOfLine={})),function(e){e[e.Replace=1]="Replace",e[e.Append=2]="Append",e[e.Prepend=3]="Prepend"
}(t.EnvironmentVariableMutatorType||(t.EnvironmentVariableMutatorType={}));let F=_=class{constructor(e,t){this._range=e,this._newText=t}static isTextEdit(e){return e instanceof _||!!e&&(A.isRange(e)&&"string"==typeof e.newText)}static replace(e,t){return new _(e,t)}static insert(e,t){return _.replace(new A(e,e),t)}static delete(e){return _.replace(e,"")}static setEndOfLine(e){const t=new _(new A(new D(0,0),new D(0,0)),"");return t.newEol=e,t}get range(){return this._range}set range(e){if(e&&!A.isRange(e))throw i.illegalArgument("range");this._range=e}get newText(){return this._newText||""}set newText(e){if(e&&"string"!=typeof e)throw i.illegalArgument("newText");this._newText=e}get newEol(){return this._newEol}set newEol(e){if(e&&"number"!=typeof e)throw i.illegalArgument("newEol");this._newEol=e}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};F=_=s([O],F),t.TextEdit=F,function(e){e[e.File=1]="File",e[e.Text=2]="Text",e[e.Cell=3]="Cell"}(t.FileEditType||(t.FileEditType={}))
;let U=class{constructor(){this._edits=new Array}_allEntries(){return this._edits}renameFile(e,t,n,r){this._edits.push({_type:1,from:e,to:t,options:n,metadata:r})}createFile(e,t,n){this._edits.push({_type:1,from:void 0,to:e,options:t,metadata:n})}deleteFile(e,t,n){this._edits.push({_type:1,from:e,to:void 0,options:t,metadata:n})}replaceNotebookMetadata(e,t,n){this._edits.push({_type:3,metadata:n,uri:e,notebookMetadata:t})}replaceNotebookCells(e,t,n,r,i){(t!==n||r.length>0)&&this._edits.push({_type:3,metadata:i,uri:e,edit:{editType:1,index:t,count:n-t,cells:r.map(e=>Object.assign(Object.assign({},e),{outputs:e.outputs.map(e=>m.addIdToOutput(e))}))}})}replaceNotebookCellOutput(e,t,n,r){this._edits.push({_type:3,metadata:r,uri:e,edit:{editType:2,index:t,outputs:n.map(e=>ze.isNotebookCellOutput(e)?m.addIdToOutput(e.toJSON()):m.addIdToOutput(e))}})}replaceNotebookCellMetadata(e,t,n,r){this._edits.push({_type:3,metadata:r,uri:e,edit:{editType:3,index:t,metadata:n}})}replace(e,t,n,r){this._edits.push({_type:2,uri:e,
edit:new F(t,n),metadata:r})}insert(e,t,n,r){this.replace(e,new A(t,t),n,r)}delete(e,t,n){this.replace(e,t,"",n)}has(e){return this._edits.some(t=>2===t._type&&t.uri.toString()===e.toString())}set(e,t){if(t)for(const n of t)n&&this._edits.push({_type:2,uri:e,edit:n});else{for(let t=0;t<this._edits.length;t++){const n=this._edits[t];2===n._type&&n.uri.toString()===e.toString()&&(this._edits[t]=void 0)}n.coalesceInPlace(this._edits)}}get(e){const t=[];for(let n of this._edits)2===n._type&&n.uri.toString()===e.toString()&&t.push(n.edit);return t}entries(){const e=new l.ResourceMap;for(let t of this._edits)if(2===t._type){let n=e.get(t.uri);n||(n=[t.uri,[]],e.set(t.uri,n)),n[1].push(t.edit)}return[...e.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};U=s([O],U),t.WorkspaceEdit=U;let j=E=class{constructor(e){this._tabstop=1,this.value=e||""}static isSnippetString(e){return e instanceof E||!!e&&"string"==typeof e.value}static _escape(e){return e.replace(/\$|}|\\/g,"\\$&")}
appendText(e){return this.value+=E._escape(e),this}appendTabstop(e=this._tabstop++){return this.value+="$",this.value+=e,this}appendPlaceholder(e,t=this._tabstop++){if("function"==typeof e){const t=new E;t._tabstop=this._tabstop,e(t),this._tabstop=t._tabstop,e=t.value}else e=E._escape(e);return this.value+="${",this.value+=t,this.value+=":",this.value+=e,this.value+="}",this}appendChoice(e,t=this._tabstop++){const n=e.map(e=>e.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=t,this.value+="|",this.value+=n,this.value+="|}",this}appendVariable(e,t){if("function"==typeof t){const e=new E;e._tabstop=this._tabstop,t(e),this._tabstop=e._tabstop,t=e.value}else"string"==typeof t&&(t=t.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=e,t&&(this.value+=":",this.value+=t),this.value+="}",this}};var z;j=E=s([O],j),t.SnippetString=j,function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"}(t.DiagnosticTag||(t.DiagnosticTag={})),function(e){e[e.Hint=3]="Hint",
e[e.Information=2]="Information",e[e.Warning=1]="Warning",e[e.Error=0]="Error"}(z=t.DiagnosticSeverity||(t.DiagnosticSeverity={}));let $=S=class{constructor(e,t){if(this.uri=e,t)if(t instanceof A)this.range=t;else{if(!(t instanceof D))throw new Error("Illegal argument");this.range=new A(t,t)}else;}static isLocation(e){return e instanceof S||!!e&&(A.isRange(e.range)&&h.URI.isUri(e.uri))}toJSON(){return{uri:this.uri,range:this.range}}};$=S=s([O],$),t.Location=$;let B=class{constructor(e,t){this.location=e,this.message=t}static is(e){return!!e&&("string"==typeof e.message&&e.location&&A.isRange(e.location.range)&&h.URI.isUri(e.location.uri))}static isEqual(e,t){return e===t||!(!e||!t)&&(e.message===t.message&&e.location.range.isEqual(t.location.range)&&e.location.uri.toString()===t.location.uri.toString())}};B=s([O],B),t.DiagnosticRelatedInformation=B;let W=class{constructor(e,t,n=z.Error){if(!A.isRange(e))throw new TypeError("range must be set");if(!t)throw new TypeError("message must be set");this.range=e,
this.message=t,this.severity=n}toJSON(){return{severity:z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(e,t){return e===t||!(!e||!t)&&(e.message===t.message&&e.severity===t.severity&&e.code===t.code&&e.severity===t.severity&&e.source===t.source&&e.range.isEqual(t.range)&&n.equals(e.tags,t.tags)&&n.equals(e.relatedInformation,t.relatedInformation,B.isEqual))}};W=s([O],W),t.Diagnostic=W;let V=class{constructor(e,t){if(!e)throw new Error("Illegal argument, contents must be defined");Array.isArray(e)?this.contents=e:(o.isMarkdownString(e),this.contents=[e]),this.range=t}};var H;V=s([O],V),t.Hover=V,function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(H=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));let K=class{constructor(e,t=H.Text){this.range=e,this.kind=t}toJSON(){return{range:this.range,kind:H[this.kind]}}};var q;K=s([O],K),t.DocumentHighlight=K,function(e){e[e.File=0]="File",e[e.Module=1]="Module",
e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"}(q=t.SymbolKind||(t.SymbolKind={})),function(e){e[e.Deprecated=1]="Deprecated"}(t.SymbolTag||(t.SymbolTag={}));let G=C=class{constructor(e,t,n,r,i){this.name=e,this.kind=t,this.containerName=i,"string"==typeof n&&(this.containerName=n),r instanceof $?this.location=r:n instanceof A&&(this.location=new $(r,n)),C.validate(this)}static validate(e){if(!e.name)throw new Error("name must not be falsy")}toJSON(){
return{name:this.name,kind:q[this.kind],location:this.location,containerName:this.containerName}}};G=C=s([O],G),t.SymbolInformation=G;let X=x=class{constructor(e,t,n,r,i){this.name=e,this.detail=t,this.kind=n,this.range=r,this.selectionRange=i,this.children=[],x.validate(this)}static validate(e){if(!e.name)throw new Error("name must not be falsy");if(!e.range.contains(e.selectionRange))throw new Error("selectionRange must be contained in fullRange");e.children&&e.children.forEach(x.validate)}};X=x=s([O],X),t.DocumentSymbol=X,function(e){e[e.Automatic=1]="Automatic",e[e.Manual=2]="Manual"}(t.CodeActionTrigger||(t.CodeActionTrigger={}));let Y=class{constructor(e,t){this.title=e,this.kind=t}};Y=s([O],Y),t.CodeAction=Y;let Q=I=class{constructor(e){this.value=e}append(e){return new I(this.value?this.value+I.sep+e:e)}intersects(e){return this.contains(e)||e.contains(this)}contains(e){return this.value===e.value||e.value.startsWith(this.value+I.sep)}};Q.sep=".",Q=I=s([O],Q),t.CodeActionKind=Q,Q.Empty=new Q(""),
Q.QuickFix=Q.Empty.append("quickfix"),Q.Refactor=Q.Empty.append("refactor"),Q.RefactorExtract=Q.Refactor.append("extract"),Q.RefactorInline=Q.Refactor.append("inline"),Q.RefactorRewrite=Q.Refactor.append("rewrite"),Q.Source=Q.Empty.append("source"),Q.SourceOrganizeImports=Q.Source.append("organizeImports"),Q.SourceFixAll=Q.Source.append("fixAll");let J=class{constructor(e,t){if(this.range=e,this.parent=t,t&&!t.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=s([O],J),t.SelectionRange=J;t.CallHierarchyItem=class{constructor(e,t,n,r,i,s){this.kind=e,this.name=t,this.detail=n,this.uri=r,this.range=i,this.selectionRange=s}};t.CallHierarchyIncomingCall=class{constructor(e,t){this.fromRanges=t,this.from=e}};t.CallHierarchyOutgoingCall=class{constructor(e,t){this.fromRanges=t,this.to=e}};let Z=class{constructor(e,t){this.range=e,this.command=t}get isResolved(){return!!this.command}};Z=s([O],Z),t.CodeLens=Z;t.CodeInset=class{constructor(e,t){this.range=e,this.height=t
}};let ee=k=class{constructor(e,t=!1){this.value=null!=e?e:"",this.supportThemeIcons=t}appendText(e){return this.value+=(this.supportThemeIcons?r.escapeCodicons(e):e).replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&").replace(/\n/,"\n\n"),this}appendMarkdown(e){return this.value+=e,this}appendCodeblock(e,t=""){return this.value+="\n```",this.value+=t,this.value+="\n",this.value+=e,this.value+="\n```\n",this}static isMarkdownString(e){return e instanceof k||e&&e.appendCodeblock&&e.appendMarkdown&&e.appendText&&void 0!==e.value}};ee=k=s([O],ee),t.MarkdownString=ee;let te=class{constructor(e,t){this.label=e,this.documentation=t}};te=s([O],te),t.ParameterInformation=te;let ne=class{constructor(e,t){this.label=e,this.documentation=t,this.parameters=[]}};ne=s([O],ne),t.SignatureInformation=ne;let re=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};var ie;re=s([O],re),t.SignatureHelp=re,function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",
e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(t.CompletionTriggerKind||(t.CompletionTriggerKind={})),function(e){e[e.Text=0]="Text",e[e.Method=1]="Method",e[e.Function=2]="Function",e[e.Constructor=3]="Constructor",e[e.Field=4]="Field",e[e.Variable=5]="Variable",e[e.Class=6]="Class",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Unit=10]="Unit",e[e.Value=11]="Value",e[e.Enum=12]="Enum",e[e.Keyword=13]="Keyword",e[e.Snippet=14]="Snippet",e[e.Color=15]="Color",e[e.File=16]="File",e[e.Reference=17]="Reference",e[e.Folder=18]="Folder",e[e.EnumMember=19]="EnumMember",e[e.Constant=20]="Constant",e[e.Struct=21]="Struct",e[e.Event=22]="Event",e[e.Operator=23]="Operator",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue"
}(ie=t.CompletionItemKind||(t.CompletionItemKind={})),function(e){e[e.Deprecated=1]="Deprecated"}(t.CompletionItemTag||(t.CompletionItemTag={}));let se=class{constructor(e,t){this.label=e,this.kind=t}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&ie[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};se=s([O],se),t.CompletionItem=se;let oe=class{constructor(e=[],t=!1){this.items=e,this.isIncomplete=t}};oe=s([O],oe),t.CompletionList=oe,function(e){e[e.Active=-1]="Active",e[e.Beside=-2]="Beside",e[e.One=1]="One",e[e.Two=2]="Two",e[e.Three=3]="Three",e[e.Four=4]="Four",e[e.Five=5]="Five",e[e.Six=6]="Six",e[e.Seven=7]="Seven",e[e.Eight=8]="Eight",e[e.Nine=9]="Nine"}(t.ViewColumn||(t.ViewColumn={})),function(e){e[e.Left=1]="Left",e[e.Right=2]="Right"}(t.StatusBarAlignment||(t.StatusBarAlignment={})),function(e){e[e.Off=0]="Off",e[e.On=1]="On",
e[e.Relative=2]="Relative"}(t.TextEditorLineNumbersStyle||(t.TextEditorLineNumbersStyle={})),function(e){e[e.Manual=1]="Manual",e[e.AfterDelay=2]="AfterDelay",e[e.FocusOut=3]="FocusOut"}(t.TextDocumentSaveReason||(t.TextDocumentSaveReason={})),function(e){e[e.Default=0]="Default",e[e.InCenter=1]="InCenter",e[e.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",e[e.AtTop=3]="AtTop"}(t.TextEditorRevealType||(t.TextEditorRevealType={})),function(e){e[e.Keyboard=1]="Keyboard",e[e.Mouse=2]="Mouse",e[e.Command=3]="Command"}(t.TextEditorSelectionChangeKind||(t.TextEditorSelectionChangeKind={})),function(e){e[e.OpenOpen=0]="OpenOpen",e[e.ClosedClosed=1]="ClosedClosed",e[e.OpenClosed=2]="OpenClosed",e[e.ClosedOpen=3]="ClosedOpen"}(t.DecorationRangeBehavior||(t.DecorationRangeBehavior={})),function(e){e.fromValue=function(t){switch(t){case"keyboard":return e.Keyboard;case"mouse":return e.Mouse;case"api":return e.Command}}}(t.TextEditorSelectionChangeKind||(t.TextEditorSelectionChangeKind={}));let ae=class{
constructor(e,t){if(t&&!h.URI.isUri(t))throw i.illegalArgument("target");if(!A.isRange(e)||e.isEmpty)throw i.illegalArgument("range");this.range=e,this.target=t}};ae=s([O],ae),t.DocumentLink=ae;let ce=class{constructor(e,t,n,r){this.red=e,this.green=t,this.blue=n,this.alpha=r}};ce=s([O],ce),t.Color=ce;let le=class{constructor(e,t){if(t&&!(t instanceof ce))throw i.illegalArgument("color");if(!A.isRange(e)||e.isEmpty)throw i.illegalArgument("range");this.range=e,this.color=t}};le=s([O],le),t.ColorInformation=le;let ue=class{constructor(e){if(!e||"string"!=typeof e)throw i.illegalArgument("label");this.label=e}};ue=s([O],ue),t.ColorPresentation=ue,function(e){e[e.RGB=0]="RGB",e[e.HEX=1]="HEX",e[e.HSL=2]="HSL"}(t.ColorFormat||(t.ColorFormat={})),function(e){e[e.Error=0]="Error",e[e.Warning=1]="Warning",e[e.Information=2]="Information"}(t.SourceControlInputBoxValidationType||(t.SourceControlInputBoxValidationType={})),function(e){e[e.Always=1]="Always",e[e.Silent=2]="Silent",e[e.Never=3]="Never"
}(t.TaskRevealKind||(t.TaskRevealKind={})),function(e){e[e.Shared=1]="Shared",e[e.Dedicated=2]="Dedicated",e[e.New=3]="New"}(t.TaskPanelKind||(t.TaskPanelKind={}));let he=T=class{constructor(e,t){if("string"!=typeof e)throw i.illegalArgument("name");if("string"!=typeof t)throw i.illegalArgument("name");this._id=e}static from(e){switch(e){case"clean":return T.Clean;case"build":return T.Build;case"rebuild":return T.Rebuild;case"test":return T.Test;default:return}}get id(){return this._id}};function de(e){let t="";for(let n=0;n<e.length;n++)t+=e[n].replace(/,/g,",,")+",";return t}he.Clean=new T("clean","Clean"),he.Build=new T("build","Build"),he.Rebuild=new T("rebuild","Rebuild"),he.Test=new T("test","Test"),he=T=s([O],he),t.TaskGroup=he;let fe=class{constructor(e,t,n){if("string"!=typeof e)throw i.illegalArgument("process");this._args=[],this._process=e,void 0!==t&&(Array.isArray(t)?(this._args=t,this._options=n):this._options=t)}get process(){return this._process}set process(e){
if("string"!=typeof e)throw i.illegalArgument("process");this._process=e}get args(){return this._args}set args(e){Array.isArray(e)||(e=[]),this._args=e}get options(){return this._options}set options(e){this._options=e}computeId(){const e=[];if(e.push("process"),void 0!==this._process&&e.push(this._process),this._args&&this._args.length>0)for(let t of this._args)e.push(t);return de(e)}};fe=s([O],fe),t.ProcessExecution=fe;let pe=class{constructor(e,t,n){if(this._args=[],Array.isArray(t)){if(!e)throw i.illegalArgument("command can't be undefined or null");if("string"!=typeof e&&"string"!=typeof e.value)throw i.illegalArgument("command");this._command=e,this._args=t,this._options=n}else{if("string"!=typeof e)throw i.illegalArgument("commandLine");this._commandLine=e,this._options=t}}get commandLine(){return this._commandLine}set commandLine(e){if("string"!=typeof e)throw i.illegalArgument("commandLine");this._commandLine=e}get command(){return this._command?this._command:""}set command(e){
if("string"!=typeof e&&"string"!=typeof e.value)throw i.illegalArgument("command");this._command=e}get args(){return this._args}set args(e){this._args=e||[]}get options(){return this._options}set options(e){this._options=e}computeId(){const e=[];if(e.push("shell"),void 0!==this._commandLine&&e.push(this._commandLine),void 0!==this._command&&e.push("string"==typeof this._command?this._command:this._command.value),this._args&&this._args.length>0)for(let t of this._args)e.push("string"==typeof t?t:t.value);return de(e)}};var me;pe=s([O],pe),t.ShellExecution=pe,function(e){e[e.Escape=1]="Escape",e[e.Strong=2]="Strong",e[e.Weak=3]="Weak"}(t.ShellQuoting||(t.ShellQuoting={})),function(e){e[e.Global=1]="Global",e[e.Workspace=2]="Workspace"}(me=t.TaskScope||(t.TaskScope={}));class ge{constructor(e){this._callback=e}computeId(){return"customExecution"+d.generateUuid()}set callback(e){this._callback=e}get callback(){return this._callback}}t.CustomExecution=ge;let ve=P=class{constructor(e,t,n,r,i,s){let o
;this.__deprecated=!1,this._definition=this.definition=e,"string"==typeof t?(this._name=this.name=t,this._source=this.source=n,this.execution=r,o=i,this.__deprecated=!0):(t===me.Global||me.Workspace,this.target=t,this._name=this.name=n,this._source=this.source=r,this.execution=i,o=s),"string"==typeof o?(this._problemMatchers=[o],this._hasDefinedMatchers=!0):Array.isArray(o)?(this._problemMatchers=o,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(e){this.__id=e}get _deprecated(){return this.__deprecated}clear(){void 0!==this.__id&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof fe?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof pe?this._definition={type:P.ShellType,id:this._execution.computeId()
}:this._execution instanceof ge?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:d.generateUuid()}}get definition(){return this._definition}set definition(e){if(null==e)throw i.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=e}get scope(){return this._scope}set target(e){this.clear(),this._scope=e}get name(){return this._name}set name(e){if("string"!=typeof e)throw i.illegalArgument("name");this.clear(),this._name=e}get execution(){return this._execution}set execution(e){null===e&&(e=void 0),this.clear(),this._execution=e;const t=this._definition.type;P.EmptyType!==t&&P.ProcessType!==t&&P.ShellType!==t&&P.ExtensionCallbackType!==t||this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(e){if(!Array.isArray(e))return this.clear(),this._problemMatchers=[],void(this._hasDefinedMatchers=!1);this.clear(),this._problemMatchers=e,this._hasDefinedMatchers=!0}
get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(e){!0!==e&&!1!==e&&(e=!1),this.clear(),this._isBackground=e}get source(){return this._source}set source(e){if("string"!=typeof e||0===e.length)throw i.illegalArgument("source must be a string of length > 0");this.clear(),this._source=e}get group(){return this._group}set group(e){null===e&&(e=void 0),this.clear(),this._group=e}get detail(){return this._detail}set detail(e){null===e&&(e=void 0),this._detail=e}get presentationOptions(){return this._presentationOptions}set presentationOptions(e){null==e&&(e=Object.create(null)),this.clear(),this._presentationOptions=e}get runOptions(){return this._runOptions}set runOptions(e){null==e&&(e=Object.create(null)),this.clear(),this._runOptions=e}};ve.ExtensionCallbackType="customExecution",ve.ProcessType="process",ve.ShellType="shell",ve.EmptyType="$empty",ve=P=s([O],ve),t.Task=ve,function(e){e[e.SourceControl=1]="SourceControl",
e[e.Window=10]="Window",e[e.Notification=15]="Notification"}(t.ProgressLocation||(t.ProgressLocation={}));let ye=class{constructor(e,t=be.None){this.collapsibleState=t,h.URI.isUri(e)?this.resourceUri=e:this.label=e}};var be;ye=s([O],ye),t.TreeItem=ye,function(e){e[e.None=0]="None",e[e.Collapsed=1]="Collapsed",e[e.Expanded=2]="Expanded"}(be=t.TreeItemCollapsibleState||(t.TreeItemCollapsibleState={}));let we=class{constructor(e,t){this.id=e,this.color=t}};we=s([O],we),t.ThemeIcon=we,we.File=new we("file"),we.Folder=new we("folder");let _e=class{constructor(e){this.id=e}};_e=s([O],_e),t.ThemeColor=_e,function(e){e[e.Global=1]="Global",e[e.Workspace=2]="Workspace",e[e.WorkspaceFolder=3]="WorkspaceFolder"}(t.ConfigurationTarget||(t.ConfigurationTarget={}));let Ee=class{constructor(e,t){if(!("string"==typeof e||e&&h.URI.isUri(e.uri)))throw i.illegalArgument("base");if("string"!=typeof t)throw i.illegalArgument("pattern");"string"==typeof e?this.base=e:(this.baseFolder=e.uri,this.base=e.uri.fsPath),this.pattern=t}}
;Ee=s([O],Ee),t.RelativePattern=Ee;let Se=class{constructor(e,t,n,r){this.enabled="boolean"!=typeof e||e,"string"==typeof t&&(this.condition=t),"string"==typeof n&&(this.hitCondition=n),"string"==typeof r&&(this.logMessage=r)}get id(){return this._id||(this._id=d.generateUuid()),this._id}};Se=s([O],Se),t.Breakpoint=Se;let Ce=class extends Se{constructor(e,t,n,r,s){if(super(t,n,r,s),null===e)throw i.illegalArgument("location");this.location=e}};Ce=s([O],Ce),t.SourceBreakpoint=Ce;let xe=class extends Se{constructor(e,t,n,r,s){if(super(t,n,r,s),!e)throw i.illegalArgument("functionName");this.functionName=e}};xe=s([O],xe),t.FunctionBreakpoint=xe;let Ie=class extends Se{constructor(e,t,n,r,s,o,a){if(super(r,s,o,a),!t)throw i.illegalArgument("dataId");this.label=e,this.dataId=t,this.canPersist=n}};Ie=s([O],Ie),t.DataBreakpoint=Ie;let ke=class{constructor(e,t,n){this.command=e,this.args=t||[],this.options=n}};ke=s([O],ke),t.DebugAdapterExecutable=ke;let Te=class{constructor(e,t){this.port=e,this.host=t}}
;Te=s([O],Te),t.DebugAdapterServer=Te;let Pe=class{constructor(e){this.path=e}};Pe=s([O],Pe),t.DebugAdapterNamedPipeServer=Pe;let Re=class{constructor(e){this.implementation=e}};Re=s([O],Re),t.DebugAdapterInlineImplementation=Re;let Oe=class{constructor(e,t){this.range=e,this.expression=t}};Oe=s([O],Oe),t.EvaluatableExpression=Oe,function(e){e[e.Trace=1]="Trace",e[e.Debug=2]="Debug",e[e.Info=3]="Info",e[e.Warning=4]="Warning",e[e.Error=5]="Error",e[e.Critical=6]="Critical",e[e.Off=7]="Off"}(t.LogLevel||(t.LogLevel={})),function(e){e[e.Changed=1]="Changed",e[e.Created=2]="Created",e[e.Deleted=3]="Deleted"}(t.FileChangeType||(t.FileChangeType={}));let Le=R=class extends Error{constructor(e,t=f.FileSystemProviderErrorCode.Unknown,n){var r;super(h.URI.isUri(e)?e.toString(!0):e),this.code=null!==(r=null==n?void 0:n.name)&&void 0!==r?r:"Unknown",f.markAsFileSystemProviderError(this,t),"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,R.prototype),
"function"==typeof Error.captureStackTrace&&"function"==typeof n&&Error.captureStackTrace(this,n)}static FileExists(e){return new R(e,f.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(e){return new R(e,f.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(e){return new R(e,f.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(e){return new R(e,f.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(e){return new R(e,f.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(e){return new R(e,f.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}};Le=R=s([O],Le),t.FileSystemError=Le;let De=class{constructor(e,t,n){this.start=e,this.end=t,this.kind=n}};De=s([O],De),t.FoldingRange=De,function(e){e[e.Comment=1]="Comment",e[e.Imports=2]="Imports",e[e.Region=3]="Region"}(t.FoldingRangeKind||(t.FoldingRangeKind={})),function(e){e[e.Collapsed=0]="Collapsed",
e[e.Expanded=1]="Expanded"}(t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={})),function(e){e[e.Editing=0]="Editing",e[e.Preview=1]="Preview"}(t.CommentMode||(t.CommentMode={}));t.SemanticTokensLegend=class{constructor(e,t=[]){this.tokenTypes=e,this.tokenModifiers=t}};class Ae{constructor(e){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,e){this._hasLegend=!0;for(let t=0,n=e.tokenTypes.length;t<n;t++)this._tokenTypeStrToInt.set(e.tokenTypes[t],t);for(let t=0,n=e.tokenModifiers.length;t<n;t++)this._tokenModifierStrToInt.set(e.tokenModifiers[t],t)}}push(e,t,n,r,s){if("number"==typeof e&&"number"==typeof t&&"number"==typeof n&&"number"==typeof r&&("number"==typeof s||void 0===s))return void 0===s&&(s=0),this._pushEncoded(e,t,n,r,s);if(A.isRange(e)&&"string"==typeof t&&(void 0===(o=n)||u.isStringArray(o)))return this._push(e,t,n);var o
;throw i.illegalArgument()}_push(e,t,n){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(e.start.line!==e.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(t))throw new Error("`tokenType` is not in the provided legend");const r=e.start.line,i=e.start.character,s=e.end.character-e.start.character,o=this._tokenTypeStrToInt.get(t);let a=0;if(n)for(const e of n){if(!this._tokenModifierStrToInt.has(e))throw new Error("`tokenModifier` is not in the provided legend");a|=1<<this._tokenModifierStrToInt.get(e)>>>0}this._pushEncoded(r,i,s,o,a)}_pushEncoded(e,t,n,r,i){if(this._dataIsSortedAndDeltaEncoded&&(e<this._prevLine||e===this._prevLine&&t<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const e=this._data.length/5|0;let t=0,n=0;for(let r=0;r<e;r++){let e=this._data[5*r],i=this._data[5*r+1];0===e?(e=t,i+=n):e+=t,this._data[5*r]=e,this._data[5*r+1]=i,t=e,n=i}}let s=e,o=t
;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&0===(s-=this._prevLine)&&(o-=this._prevChar),this._data[this._dataLen++]=s,this._data[this._dataLen++]=o,this._data[this._dataLen++]=n,this._data[this._dataLen++]=r,this._data[this._dataLen++]=i,this._prevLine=e,this._prevChar=t}static _sortAndDeltaEncode(e){let t=[];const n=e.length/5|0;for(let e=0;e<n;e++)t[e]=e;t.sort((t,n)=>{const r=e[5*t],i=e[5*n];if(r===i){return e[5*t+1]-e[5*n+1]}return r-i});const r=new Uint32Array(e.length);let i=0,s=0;for(let o=0;o<n;o++){const n=5*t[o],a=e[n+0],c=e[n+1],l=e[n+2],u=e[n+3],h=e[n+4],d=a-i,f=0===d?c-s:c,p=5*o;r[p+0]=d,r[p+1]=f,r[p+2]=l,r[p+3]=u,r[p+4]=h,i=a,s=c}return r}build(e){return this._dataIsSortedAndDeltaEncoded?new Ne(new Uint32Array(this._data),e):new Ne(Ae._sortAndDeltaEncode(this._data),e)}}t.SemanticTokensBuilder=Ae;class Ne{constructor(e,t){this.resultId=t,this.data=e}}t.SemanticTokens=Ne;t.SemanticTokensEdit=class{constructor(e,t,n){this.start=e,this.deleteCount=t,this.data=n}}
;t.SemanticTokensEdits=class{constructor(e,t){this.resultId=t,this.edits=e}},function(e){e[e.Separate=0]="Separate",e[e.MergeWithParent=1]="MergeWithParent"}(t.DebugConsoleMode||(t.DebugConsoleMode={})),function(e){e[e.Initial=1]="Initial",e[e.Dynamic=2]="Dynamic"}(t.DebugConfigurationProviderTriggerKind||(t.DebugConfigurationProviderTriggerKind={}));let Me=class{constructor(){}};Me.Back={iconPath:new we("arrow-left")},Me=s([O],Me),t.QuickInputButtons=Me,function(e){e[e.UI=1]="UI",e[e.Workspace=2]="Workspace"}(t.ExtensionKind||(t.ExtensionKind={}));t.FileDecoration=class{constructor(e,t,n){this.badge=e,this.tooltip=t,this.color=n}static validate(e){if(e.badge&&1!==e.badge.length)throw new Error("The 'badge'-property must be undefined or a single character");if(!e.color&&!e.badge&&!e.tooltip)throw new Error("The decoration is empty")}};let Fe=class{constructor(e){this.kind=e}};var Ue;Fe=s([O],Fe),t.ColorTheme=Fe,function(e){e[e.Light=1]="Light",e[e.Dark=2]="Dark",e[e.HighContrast=3]="HighContrast"
}(t.ColorThemeKind||(t.ColorThemeKind={}));class je{constructor(e,t,n){this.mime=e,this.value=t,this.metadata=n}static isNotebookCellOutputItem(e){return e instanceof je}}t.NotebookCellOutputItem=je;class ze{constructor(e,t){this.outputs=e,this.metadata=t}static isNotebookCellOutput(e){return e instanceof ze}toJSON(){let e={},t={},n=!1;for(let r of this.outputs)e[r.mime]=r.value,r.metadata&&(t[r.mime]=r.metadata,n=!0);return{outputKind:Ue.Rich,data:e,metadata:n?{custom:t}:void 0}}}t.NotebookCellOutput=ze,function(e){e[e.Markdown=1]="Markdown",e[e.Code=2]="Code"}(t.CellKind||(t.CellKind={})),function(e){e[e.Text=1]="Text",e[e.Error=2]="Error",e[e.Rich=3]="Rich"}(Ue=t.CellOutputKind||(t.CellOutputKind={})),function(e){e[e.Running=1]="Running",e[e.Idle=2]="Idle",e[e.Success=3]="Success",e[e.Error=4]="Error"}(t.NotebookCellRunState||(t.NotebookCellRunState={})),function(e){e[e.Running=1]="Running",e[e.Idle=2]="Idle"}(t.NotebookRunState||(t.NotebookRunState={})),function(e){e[e.Left=1]="Left",e[e.Right=2]="Right"
}(t.NotebookCellStatusBarAlignment||(t.NotebookCellStatusBarAlignment={})),function(e){e[e.Default=0]="Default",e[e.InCenter=1]="InCenter",e[e.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport"}(t.NotebookEditorRevealType||(t.NotebookEditorRevealType={}));let $e=class{constructor(e,t){this.label=e,this.timestamp=t}};$e=s([O],$e),t.TimelineItem=$e,function(e){e[e.Production=1]="Production",e[e.Development=2]="Development",e[e.Test=3]="Test"}(t.ExtensionMode||(t.ExtensionMode={})),function(e){e[e.Node=1]="Node",e[e.Webworker=2]="Webworker"}(t.ExtensionRuntime||(t.ExtensionRuntime={})),function(e){e[e.Other=0]="Other",e[e.Comment=1]="Comment",e[e.String=2]="String",e[e.RegEx=4]="RegEx"}(t.StandardTokenType||(t.StandardTokenType={}))})),define(t[100],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EnvironmentVariableMutatorType=t.IEnvironmentVariableService=void 0,t.IEnvironmentVariableService=n.createDecorator("environmentVariableService"),function(e){
e[e.Replace=1]="Replace",e[e.Append=2]="Append",e[e.Prepend=3]="Prepend"}(t.EnvironmentVariableMutatorType||(t.EnvironmentVariableMutatorType={}))})),define(t[199],n([0,1,100,5]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MergedEnvironmentVariableCollection=void 0;function i(e,t){if(!t)return e;const n=new Set;t.forEach(e=>n.add(e.extensionIdentifier));const r=[];return e.forEach(e=>{n.has(e.extensionIdentifier)||r.push(e)}),0===r.length?void 0:r}t.MergedEnvironmentVariableCollection=class{constructor(e){this.map=new Map,e.forEach((e,t)=>{const r=e.map.entries();let i=r.next();for(;!i.done;){const e=i.value[0];let s=this.map.get(e);if(s||(s=[],this.map.set(e,s)),s.length>0&&s[0].type===n.EnvironmentVariableMutatorType.Replace){i=r.next();continue}const o=i.value[1];s.unshift({extensionIdentifier:t,value:o.value,type:o.type}),i=r.next()}})}applyToProcessEnvironment(e){let t;r.isWindows&&(t={},Object.keys(e).forEach(e=>t[e.toLowerCase()]=e)),this.map.forEach((i,s)=>{
const o=r.isWindows&&t[s.toLowerCase()]||s;i.forEach(t=>{switch(t.type){case n.EnvironmentVariableMutatorType.Append:e[o]=(e[o]||"")+t.value;break;case n.EnvironmentVariableMutatorType.Prepend:e[o]=t.value+(e[o]||"");break;case n.EnvironmentVariableMutatorType.Replace:e[o]=t.value}})})}diff(e){const t=new Map,n=new Map,r=new Map;if(e.map.forEach((e,n)=>{const r=i(e,this.map.get(n));r&&t.set(n,r)}),this.map.forEach((t,n)=>{const s=i(t,e.map.get(n));s&&r.set(n,s)}),this.map.forEach((t,r)=>{const i=function(e,t){if(!t)return;const n=new Map;t.forEach(e=>n.set(e.extensionIdentifier,e));const r=[];return e.forEach(e=>{const t=n.get(e.extensionIdentifier);!t||e.type===t.type&&e.value===t.value||r.push(t)}),0===r.length?void 0:r}(t,e.map.get(r));i&&n.set(r,i)}),0!==t.size||0!==n.size||0!==r.size)return{added:t,changed:n,removed:r}}}})),define(t[101],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.deserializeEnvironmentVariableCollection=t.serializeEnvironmentVariableCollection=void 0,t.serializeEnvironmentVariableCollection=function(e){return[...e.entries()]},t.deserializeEnvironmentVariableCollection=function(e){return new Map(e)}})),define(t[102],n([0,1,155,51]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.terminalContributionsDescriptor=t.DEFAULT_COMMANDS_TO_SKIP_SHELL=t.TERMINAL_COMMAND_ID=t.TitleEventSource=t.LinuxDistro=t.ProcessState=t.SUGGESTIONS_FONT_WEIGHT=t.DEFAULT_BOLD_FONT_WEIGHT=t.DEFAULT_FONT_WEIGHT=t.MAXIMUM_FONT_WEIGHT=t.MINIMUM_FONT_WEIGHT=t.DEFAULT_LINE_HEIGHT=t.MINIMUM_LETTER_SPACING=t.DEFAULT_LETTER_SPACING=t.TERMINAL_ACTION_CATEGORY=t.TERMINAL_CONFIG_SECTION=t.TerminalCursorStyle=t.EXT_HOST_CREATION_DELAY=t.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=t.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=t.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=t.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=t.KEYBINDING_CONTEXT_TERMINAL_FOCUS=t.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=t.TERMINAL_VIEW_ID=void 0,
t.TERMINAL_VIEW_ID="terminal",t.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new r.RawContextKey("terminalIsOpen",!1),t.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new r.RawContextKey("terminalFocus",!1),t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new r.RawContextKey(t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0),t.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new r.RawContextKey("terminalA11yTreeFocus",!1),t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new r.RawContextKey("terminalTextSelected",!1),t.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new r.RawContextKey("terminalFindVisible",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),
t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new r.RawContextKey("terminalFindInputFocused",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new r.RawContextKey("terminalFindFocused",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_PROCESS_SUPPORTED=new r.RawContextKey("terminalProcessSupported",!1),t.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",t.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",t.EXT_HOST_CREATION_DELAY=100,t.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},t.TERMINAL_CONFIG_SECTION="terminal.integrated",t.TERMINAL_ACTION_CATEGORY=n.localize(0,null),t.DEFAULT_LETTER_SPACING=0,t.MINIMUM_LETTER_SPACING=-5,t.DEFAULT_LINE_HEIGHT=1,t.MINIMUM_FONT_WEIGHT=1,t.MAXIMUM_FONT_WEIGHT=1e3,t.DEFAULT_FONT_WEIGHT="normal",t.DEFAULT_BOLD_FONT_WEIGHT="bold",
t.SUGGESTIONS_FONT_WEIGHT=["normal","bold","100","200","300","400","500","600","700","800","900"],function(e){e[e.UNINITIALIZED=0]="UNINITIALIZED",e[e.LAUNCHING=1]="LAUNCHING",e[e.RUNNING=2]="RUNNING",e[e.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",e[e.KILLED_BY_USER=4]="KILLED_BY_USER",e[e.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"}(t.ProcessState||(t.ProcessState={})),function(e){e[e.Fedora=0]="Fedora",e[e.Ubuntu=1]="Ubuntu",e[e.Unknown=2]="Unknown"}(t.LinuxDistro||(t.LinuxDistro={})),function(e){e[e.Api=0]="Api",e[e.Process=1]="Process",e[e.Sequence=2]="Sequence"}(t.TitleEventSource||(t.TitleEventSource={})),function(e){e.FIND_NEXT="workbench.action.terminal.findNext",e.FIND_PREVIOUS="workbench.action.terminal.findPrevious",e.TOGGLE="workbench.action.terminal.toggleTerminal",e.KILL="workbench.action.terminal.kill",e.QUICK_KILL="workbench.action.terminal.quickKill",e.COPY_SELECTION="workbench.action.terminal.copySelection",e.SELECT_ALL="workbench.action.terminal.selectAll",
e.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",e.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",e.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",e.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",e.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",e.NEW="workbench.action.terminal.new",e.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",e.NEW_LOCAL="workbench.action.terminal.newLocal",e.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",e.SPLIT="workbench.action.terminal.split",e.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",e.RELAUNCH="workbench.action.terminal.relaunch",e.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",e.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",e.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",e.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",e.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",
e.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",e.FOCUS="workbench.action.terminal.focus",e.FOCUS_NEXT="workbench.action.terminal.focusNext",e.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",e.PASTE="workbench.action.terminal.paste",e.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",e.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",e.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",e.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",e.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",e.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",e.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",e.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",e.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",e.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",e.CLEAR="workbench.action.terminal.clear",e.CLEAR_SELECTION="workbench.action.terminal.clearSelection",
e.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",e.RENAME="workbench.action.terminal.rename",e.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",e.FIND_FOCUS="workbench.action.terminal.focusFind",e.FIND_HIDE="workbench.action.terminal.hideFind",e.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",e.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",e.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",e.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",e.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",e.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",e.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",e.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",e.SEND_SEQUENCE="workbench.action.terminal.sendSequence",e.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",
e.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",e.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",e.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",e.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",e.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",e.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation",e.SEARCH_WORKSPACE="workbench.action.terminal.searchWorkspace",e.ATTACH_TO_REMOTE_TERMINAL="workbench.action.terminal.attachToSession"}(t.TERMINAL_COMMAND_ID||(t.TERMINAL_COMMAND_ID={})),
t.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"],
t.terminalContributionsDescriptor={extensionPoint:"terminal",defaultExtensionKind:"workspace",jsonSchema:{description:n.localize(1,null),type:"object",properties:{types:{type:"array",description:n.localize(2,null),items:{type:"object",required:["command","title"],properties:{command:{description:n.localize(3,null),type:"string"},title:{description:n.localize(4,null),type:"string"}}}}}}}})),define(t[200],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminalDataBufferer=void 0;t.TerminalDataBufferer=class{constructor(e){this._callback=e,this._terminalBufferMap=new Map}dispose(){for(const e of this._terminalBufferMap.values())e.dispose()}startBuffering(e,t,n=5){let r;return r=t(t=>{const i="string"==typeof t?t:t.data;let s=this._terminalBufferMap.get(e);if(s)return void s.data.push(i);const o=setTimeout(()=>this._flushBuffer(e),n);s={data:[i],timeoutId:o,dispose:()=>{clearTimeout(o),this._flushBuffer(e),r.dispose()}},this._terminalBufferMap.set(e,s)})}stopBuffering(e){
const t=this._terminalBufferMap.get(e);t&&t.dispose()}_flushBuffer(e){const t=this._terminalBufferMap.get(e);t&&(this._terminalBufferMap.delete(e),this._callback(e,t.data.join("")))}}})),define(t[201],n([0,1,2,5,113]),(function(e,t,n,r,i){"use strict";function s(e,t){if(t)if(r.isWindows)for(const n in t){let r=n;for(const t in e)if(n.toLowerCase()===t.toLowerCase()){r=t;break}const i=t[n];o(e,r,i)}else Object.keys(t).forEach(n=>{const r=t[n];o(e,n,r)})}function o(e,t,n){"string"==typeof n?e[t]=n:delete e[t]}function a(e,t,n,r){e.TERM_PROGRAM="vscode",t&&(e.TERM_PROGRAM_VERSION=t),u(e,r)&&(e.LANG=h(n)),e.COLORTERM="truecolor"}function c(e,t){if(t)for(const n of Object.keys(t)){const r=t[n];r&&(e[n]=r)}}function l(e,t){return Object.keys(t).forEach(n=>{const r=t[n];if("string"==typeof r)try{t[n]=e(r)}catch(e){t[n]=r}}),t}function u(e,t){return"on"===t||"auto"===t&&(!e.LANG||-1===e.LANG.search(/\.UTF\-8$/)&&-1===e.LANG.search(/\.utf8$/))}function h(e){const t=e?e.split("-"):[],n=t.length
;if(0===n)return"en_US.UTF-8";if(1===n){const e={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in e&&t.push(e[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}function d(e,t,n){if(t)try{return t(e)}catch(e){return void(null==n||n.error("Could not resolve terminal cwd",e))}return e}function f(e){return 3===r.platform&&e&&":"===e[1]?e[0].toUpperCase()+e.substr(1):e}function p(e,t,n,i=r.platform){const s=e(`terminal.integrated.${n}.${3===i?"windows":1===i?"osx":"linux"}`);return(t?s.value:s.userValue)||s.defaultValue}Object.defineProperty(t,"__esModule",{value:!0}),
t.createTerminalEnvironment=t.getDefaultShellArgs=t.getDefaultShell=t.createVariableResolver=t.escapeNonWindowsPath=t.getCwd=t.getLangEnvVariable=t.shouldSetLangEnvVariable=t.addTerminalEnvironmentKeys=t.mergeEnvironments=void 0,t.mergeEnvironments=s,t.addTerminalEnvironmentKeys=a,t.shouldSetLangEnvVariable=u,t.getLangEnvVariable=h,t.getCwd=function(e,t,r,i,s,o){if(e.cwd){const t="object"==typeof e.cwd?e.cwd.fsPath:e.cwd;return f(d(t,r)||t)}let a;return!e.ignoreConfigurationCwd&&s&&(r&&(s=d(s,r,o)),s&&(n.isAbsolute(s)?a=s:i&&(a=n.join(i.fsPath,s)))),a||(a=i?i.fsPath:t||""),f(a)},t.escapeNonWindowsPath=function(e){let t=e;return 0!==t.indexOf("\\")&&(t=t.replace(/\\/g,"\\\\")),t||-1===t.indexOf('"')?-1!==t.indexOf(" ")&&(t=t.replace(/ /g,"\\ ")):t="'"+t+"'",t},t.createVariableResolver=function(e,t){if(t)return n=>t.resolve(e,n)},t.getDefaultShell=function(e,t,i,s,o,a,c,l,u=r.platform){let h=null;l&&(h=p(e,t,"automationShell",u)),h||(h=p(e,t,"shell",u));let d=h||i;if(3===u&&!s&&o){
const e=n.join(o,"Sysnative").replace(/\//g,"\\").toLowerCase();d&&0===d.toLowerCase().indexOf(e)&&(d=n.join(o,"System32",d.substr(e.length+1)))}if(d&&3===u&&(d=d.replace(/\//g,"\\")),a)try{d=a(d)}catch(e){c.error("Could not resolve shell",e)}return d},t.getDefaultShellArgs=function(e,t,n,i,s,o=r.platform){if(n&&p(e,t,"automationShell",o))return[];const a=3===o?"windows":1===o?"osx":"linux",c=e(`terminal.integrated.shellArgs.${a}`);let l=(t?c.value:c.userValue)||c.defaultValue;if(!l)return[];if("string"==typeof l&&3===o)return i?i(l):l;if(i){const e=[];for(const t of l)try{e.push(i(t))}catch(n){s.error(`Could not resolve terminal.integrated.shellArgs.${a}`,n),e.push(t)}l=e}return l},t.createTerminalEnvironment=function(e,t,n,o,u,h,d){let f={};if(e.strictEnv)c(f,e.env);else{c(f,d);const p=Object.assign({},o?t.value:t.userValue);n&&(p&&l(n,p),e.env&&l(n,e.env)),i.sanitizeProcessEnvironment(f,"VSCODE_IPC_HOOK_CLI"),s(f,p),s(f,e.env),a(f,u,r.locale,h)}return f}})),
define(t[103],n([0,1,25,5,82,14,102,16,2]),(function(e,t,n,r,i,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.detectAvailableShells=t.getWindowsBuildNumber=t.linuxDistro=t.getSystemShell=void 0,t.getSystemShell=function(e,t=process.env){return 3===e?r.isWindows?function(e){if(!u){const t=r.isWindows&&parseFloat(n.release())>=10,s=e.hasOwnProperty("PROCESSOR_ARCHITEW6432"),o=`${e.windir}\\${s?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;u=t?o:i.getWindowsShell(e)}return u}(t):i.getWindowsShell(t):r.isLinux&&1===e||r.isMacintosh&&2===e?"/bin/bash":function(e){if(!l){let t="sh";!r.isWindows&&e.SHELL&&"/bin/false"===(t=e.SHELL)&&(t="/bin/bash"),r.isWindows&&(t="/bin/bash"),l=t}return l}(t)};let l=null;let u=null;let h=o.LinuxDistro.Unknown;if(r.isLinux){const e="/etc/os-release";s.fileExists(e).then(async t=>{if(!t)return;const n=(await s.readFile(e)).toString();/NAME="?Fedora"?/.test(n)?h=o.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(n)&&(h=o.LinuxDistro.Ubuntu)})}
function d(){const e=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let t=0;return e&&4===e.length&&(t=parseInt(e[3])),t}async function f(t){const n=await new Promise((t,n)=>{e(["vscode-windows-registry"],t,n)});try{const e=n.GetStringRegKey("HKEY_LOCAL_MACHINE",`SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\${t}.exe`,"");return e||""}catch(e){return""}}t.linuxDistro=h,t.getWindowsBuildNumber=d,t.detectAvailableShells=function(){return r.isWindows?async function(){const e=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),t=`${process.env.windir}\\${e?"Sysnative":"System32"}`;let n=!1;d()>=16299&&(n=!0);const r={"Command Prompt":[`${t}\\cmd.exe`],"Windows PowerShell":[`${t}\\WindowsPowerShell\\v1.0\\powershell.exe`],PowerShell:[await f("pwsh")],"WSL Bash":[`${t}\\${n?"wsl.exe":"bash.exe"}`],
"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]},i=[];Object.keys(r).forEach(e=>i.push(async function e(t,n){if(0===n.length)return Promise.resolve(void 0);const r=n.shift();if(""===r)return e(t,n);try{const e=await s.stat(c.normalize(r));if(e.isFile||e.isSymbolicLink)return{label:t,path:r}}catch(e){}return e(t,n)}(e,r[e])));const o=await Promise.all(i);return a.coalesce(o)}():async function(){return(await s.readFile("/etc/shells","utf8")).split("\n").filter(e=>0!==e.trim().indexOf("#")&&e.trim().length>0).map(e=>({label:c.basename(e),path:e}))}()}})),define(t[104],n([0,1,5,14,2,11,18]),(function(e,t,n,r,i,s,o){"use strict";let a;Object.defineProperty(t,"__esModule",{value:!0}),t.findExecutable=t.getMainProcessParentEnv=void 0,
t.getMainProcessParentEnv=async function(e=process.env){if(a)return a;if(n.isLinux){const e=process.ppid,t=i.basename(process.argv[0]);let n=0,s=e,o=t;do{n=s,(await r.readFile(`/proc/${n}/status`,"utf8")).split("\n").forEach(e=>{0===e.indexOf("Name:")&&(o=e.replace(/^Name:\s+/,"")),0===e.indexOf("PPid:")&&(s=parseInt(e.replace(/^PPid:\s+/,"")))})}while(o===t);const c=await r.readFile(`/proc/${n}/environ`,"utf8"),l={};c.split("\0").forEach(e=>{const t=e.indexOf("=");l[e.substr(0,t)]=e.substr(t+1)}),a=l}if(n.isMacintosh){a={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(t=>{e[t]&&(a[t]=e[t])})}return n.isWindows&&(a=e),a},t.findExecutable=async function(e,t,a,c=process.env){if(i.isAbsolute(e))return await r.exists(e)?e:void 0;if(void 0===t&&(t=process.cwd()),"."!==i.dirname(e)){const n=i.join(t,e);return await r.exists(n)?n:void 0}const l=o.getCaseInsensitive(c,"PATH");if(void 0===a&&s.isString(l)&&(a=l.split(i.delimiter)),
void 0===a||0===a.length){const n=i.join(t,e);return await r.exists(n)?n:void 0}for(let s of a){let o;if(o=i.isAbsolute(s)?i.join(s,e):i.join(t,s,e),await r.exists(o))return o;if(n.isWindows){let e=o+".com";if(await r.exists(e))return e;if(e=o+".exe",await r.exists(e))return e}}const u=i.join(t,e);return await r.exists(u)?u:void 0}})),define(t[202],n([0,1,2,5,20,6,103,3,33,12,14,104,4,156]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminalProcess=void 0;let g=class extends l.Disposable{constructor(e,t,i,s,o,l,u,h){var d;let f;super(),this._shellLaunchConfig=e,this._executableEnv=l,this._logService=h,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._writeQueue=[],this._onProcessData=this._register(new a.Emitter),this._onProcessExit=this._register(new a.Emitter),this._onProcessReady=this._register(new a.Emitter),this._onProcessTitleChanged=this._register(new a.Emitter),
f=r.isWindows?n.basename(this._shellLaunchConfig.executable||""):"xterm-256color",this._initialCwd=t;const p=u&&"win32"===process.platform&&c.getWindowsBuildNumber()>=18309;this._ptyOptions={name:f,cwd:t,env:o,cols:i,rows:s,useConpty:p,conptyInheritCursor:p&&!!e.initialText},r.isWindows&&p&&0===i&&0===s&&(null===(d=this._shellLaunchConfig.executable)||void 0===d?void 0:d.endsWith("Git\\bin\\bash.exe"))&&(this._delayedResizer=new v,this._register(this._delayedResizer.onTrigger(e=>{var t;null===(t=this._delayedResizer)||void 0===t||t.dispose(),this._delayedResizer=void 0,e.cols&&e.rows&&this.resize(e.cols,e.rows)})))}get exitMessage(){return this._exitMessage}get onProcessData(){return this._onProcessData.event}get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}async start(){const e=(await Promise.all([this._validateCwd(),this._validateExecutable()])).find(e=>void 0!==e);if(e)return e
;try{return void await this.setupPtyProcess(this._shellLaunchConfig,this._ptyOptions)}catch(e){return this._logService.trace("IPty#spawn native exception",e),{message:`A native exception occurred during launch (${e.message})`}}}async _validateCwd(){try{if(!(await d.stat(this._initialCwd)).isDirectory())return{message:m.localize(0,null,this._initialCwd.toString())}}catch(e){if("ENOENT"===(null==e?void 0:e.code))return{message:m.localize(1,null,this._initialCwd.toString())}}}async _validateExecutable(){const e=this._shellLaunchConfig;if(!e.executable)throw new Error("IShellLaunchConfig.executable not set");try{const t=await d.stat(e.executable);if(!t.isFile()&&!t.isSymbolicLink())return{message:m.localize(2,null,e.executable)}}catch(t){if("ENOENT"===(null==t?void 0:t.code)){let t=e.cwd instanceof p.URI?e.cwd.path:e.cwd;const r=e.env&&e.env.PATH?e.env.PATH.split(n.delimiter):void 0;if(!await f.findExecutable(e.executable,t,r,this._executableEnv))return{message:m.localize(3,null,e.executable)}}}}
async setupPtyProcess(t,n){const r=t.args||[];this._logService.trace("IPty#spawn",t.executable,r,n);const i=(await new Promise((t,n)=>{e(["node-pty"],t,n)})).spawn(t.executable,r,n);this._ptyProcess=i,this._processStartupComplete=new Promise(e=>{this.onProcessReady(()=>e())}),i.onData(e=>{this._onProcessData.fire(e),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),i.onExit(e=>{this._exitCode=e.exitCode,this._queueProcessExit()}),this._setupTitlePolling(i),this._sendProcessId(i.pid)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),super.dispose()}_setupTitlePolling(e){setTimeout(()=>{this._sendProcessTitle(e)},0),r.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==e.process&&this._sendProcessTitle(e)},200))}_queueProcessExit(){
this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>this._kill(),250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(e){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(e){this._onProcessReady.fire({pid:e,cwd:this._initialCwd})}_sendProcessTitle(e){this._isDisposed||(this._currentTitle=e.process,this._onProcessTitleChanged.fire(this._currentTitle))}shutdown(e){e?this._kill():this._queueProcessExit()}input(e){if(!this._isDisposed&&this._ptyProcess){for(let t=0;t<=Math.floor(e.length/50);t++)this._writeQueue.push(e.substr(50*t,50));this._startWrite()}}_startWrite(){void 0===this._writeTimeout&&0!==this._writeQueue.length&&(this._doWrite(),0!==this._writeQueue.length?this._writeTimeout=setTimeout(()=>{this._writeTimeout=void 0,this._startWrite()},5):this._writeTimeout=void 0)}_doWrite(){const e=this._writeQueue.shift()
;this._logService.trace("IPty#write",`${e.length} characters`),this._ptyProcess.write(e)}resize(e,t){if(!this._isDisposed&&"number"==typeof e&&"number"==typeof t&&!isNaN(e)&&!isNaN(t)&&this._ptyProcess){if(e=Math.max(e,1),t=Math.max(t,1),this._delayedResizer)return this._delayedResizer.cols=e,void(this._delayedResizer.rows=t);this._logService.trace("IPty#resize",e,t);try{this._ptyProcess.resize(e,t)}catch(e){if(this._logService.trace("IPty#resize exception "+e.message),void 0!==this._exitCode&&"ioctl(2) failed, EBADF"!==e.message)throw e}}}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){return r.isMacintosh?new Promise(e=>{this._ptyProcess?(this._logService.trace("IPty#pid"),u.exec("lsof -OPl -p "+this._ptyProcess.pid+" | grep cwd",(t,n,r)=>{""!==n&&e(n.substring(n.indexOf("/"),n.length-1))})):e(this._initialCwd)}):r.isLinux?new Promise(e=>{this._ptyProcess?(this._logService.trace("IPty#pid"),i.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(t,n)=>{t&&e(this._initialCwd),e(n)
})):e(this._initialCwd)}):new Promise(e=>{e(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};g=s([o(7,h.ILogService)],g),t.TerminalProcess=g;class v extends l.Disposable{constructor(){super(),this._onTrigger=this._register(new a.Emitter),this._timeout=setTimeout(()=>{this._onTrigger.fire({rows:this.rows,cols:this.cols})},1e3),this._register({dispose:()=>{clearTimeout(this._timeout)}})}get onTrigger(){return this._onTrigger.event}dispose(){super.dispose(),clearTimeout(this._timeout)}}})),define(t[203],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IConfigurationResolverService=void 0,t.IConfigurationResolverService=n.createDecorator("configurationResolverService")})),define(t[204],n([0,1,2,44,11,18,5,47,157]),(function(e,t,n,r,i,s,o,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractVariableResolverService=void 0;class l{constructor(e,t,n,r=!1){if(this._ignoreEditorVariables=r,this._contributedVariables=new Map,this._context=e,
this._labelService=t,n)if(o.isWindows){const e=Object.create(null);this._envVariables=e,Object.keys(n).forEach(t=>{e[t.toLowerCase()]=n[t]})}else this._envVariables=n}resolve(e,t){return this.recursiveResolve(e?e.uri:void 0,t)}resolveAnyBase(e,t,n,r){const i=s.deepClone(t);return o.isWindows&&i.windows?Object.keys(i.windows).forEach(e=>i[e]=i.windows[e]):o.isMacintosh&&i.osx?Object.keys(i.osx).forEach(e=>i[e]=i.osx[e]):o.isLinux&&i.linux&&Object.keys(i.linux).forEach(e=>i[e]=i.linux[e]),delete i.windows,delete i.osx,delete i.linux,this.recursiveResolve(e?e.uri:void 0,i,n,r)}resolveAny(e,t,n){return this.resolveAnyBase(e,t,n)}resolveAnyMap(e,t,n){const r=new Map;return{newConfig:this.resolveAnyBase(e,t,n,r),resolvedVariables:r}}resolveWithInteractionReplace(e,t,n,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(e,t,n,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(e,t){
if(this._contributedVariables.has(e))throw new Error("Variable "+e+" is contributed twice.");this._contributedVariables.set(e,t)}recursiveResolve(e,t,n,r){if(i.isString(t))return this.resolveString(e,t,n,r);if(i.isArray(t))return t.map(t=>this.recursiveResolve(e,t,n,r));if(i.isObject(t)){let i=Object.create(null);return Object.keys(t).forEach(s=>{const o=this.resolveString(e,s,n,r);i[o]=this.recursiveResolve(e,t[s],n,r)}),i}return t}resolveString(e,t,n,r){return t.replace(l.VARIABLE_REGEXP,(t,i)=>{let s=this.evaluateSingleVariable(t,i,e,n);return r&&r.set(i,s),s})}fsPath(e){return this._labelService?this._labelService.getUriLabel(e,{noPrefix:!0}):e.fsPath}evaluateSingleVariable(e,t,s,l){let u;const h=t.split(":");h.length>1&&(t=h[0],u=h[1]);const d=()=>{const t=this._context.getFilePath();if(t)return t;throw new Error(c.localize(0,null,e))},f=(t=!0)=>{if(t&&u){const t=this._context.getFolderUri(u);if(t)return t;throw new Error(c.localize(1,null,e,u))}if(s)return s
;if(this._context.getWorkspaceFolderCount()>1)throw new Error(c.localize(2,null,e));throw new Error(c.localize(3,null,e))};switch(t){case"env":if(u){if(this._envVariables){const e=this._envVariables[o.isWindows?u.toLowerCase():u];if(i.isString(e))return e}return""}throw new Error(c.localize(4,null,e));case"config":if(u){const t=this._context.getConfigurationValue(f(!1),u);if(i.isUndefinedOrNull(t))throw new Error(c.localize(5,null,e,u));if(i.isObject(t))throw new Error(c.localize(6,null,e,u));return t}throw new Error(c.localize(7,null,e));case"command":return this.resolveFromMap(e,u,l,"command");case"input":return this.resolveFromMap(e,u,l,"input");default:switch(t){case"workspaceRoot":case"workspaceFolder":return a.normalizeDriveLetter(this.fsPath(f()));case"cwd":return s||u?a.normalizeDriveLetter(this.fsPath(f())):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return n.basename(this.fsPath(f()));case"lineNumber":if(this._ignoreEditorVariables)return e
;const i=this._context.getLineNumber();if(i)return i;throw new Error(c.localize(8,null,e));case"selectedText":if(this._ignoreEditorVariables)return e;const o=this._context.getSelectedText();if(o)return o;throw new Error(c.localize(9,null,e));case"file":return this._ignoreEditorVariables?e:d();case"relativeFile":return this._ignoreEditorVariables?e:s||u?n.relative(this.fsPath(f()),d()):d();case"relativeFileDirname":if(this._ignoreEditorVariables)return e;const h=n.dirname(d());if(s||u){const e=n.relative(this.fsPath(f()),h);return 0===e.length?".":e}return h;case"fileDirname":return this._ignoreEditorVariables?e:n.dirname(d());case"fileExtname":return this._ignoreEditorVariables?e:n.extname(d());case"fileBasename":return this._ignoreEditorVariables?e:n.basename(d());case"fileBasenameNoExtension":if(this._ignoreEditorVariables)return e;const p=n.basename(d());return p.slice(0,p.length-n.extname(p).length);case"execPath":const m=this._context.getExecPath();return m||e;default:try{
return this.resolveFromMap(e,t,l,void 0)}catch(t){return e}}}}resolveFromMap(e,t,n,r){if(t&&n){const i=void 0===r?n[t]:n[r+":"+t];if("string"==typeof i)return i;throw new Error(c.localize(10,null,e))}return e}}t.AbstractVariableResolverService=l,l.VARIABLE_REGEXP=/\$\{(.*?)\}/g})),define(t[105],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SIDE_GROUP=t.ACTIVE_GROUP=t.IEditorService=void 0,t.IEditorService=n.createDecorator("editorService"),t.ACTIVE_GROUP=-1,t.SIDE_GROUP=-2})),define(t[205],n([0,1,172,99,4,61,74,179,105,11,227,46,18,12,16,98]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p,m){"use strict";var g,v,y,b,w,_,E,S,C,x,I,k,T,P,R,O,L,D,A,N,M;function F(e){return 0===e.length||!!function(e){return void 0!==e.range}(e[0])}function U(e){return void 0===e?e:"string"==typeof e?i.URI.file(e):e}Object.defineProperty(t,"__esModule",{value:!0}),
t.NotebookDecorationRenderOptions=t.NotebookExclusiveDocumentPattern=t.NotebookCellOutputItem=t.NotebookCellOutput=t.LogLevel=t.LanguageSelector=t.GlobPattern=t.TextEditorOpenOptions=t.FoldingRangeKind=t.FoldingRange=t.ProgressLocation=t.EndOfLine=t.TextEditorLineNumbersStyle=t.TextDocumentSaveReason=t.SelectionRange=t.Color=t.ColorPresentation=t.DocumentLink=t.SignatureHelp=t.SignatureInformation=t.ParameterInformation=t.CompletionItem=t.CompletionItemKind=t.CompletionItemTag=t.CompletionContext=t.CompletionTriggerKind=t.DocumentHighlight=t.EvaluatableExpression=t.Hover=t.DefinitionLink=t.location=t.CallHierarchyOutgoingCall=t.CallHierarchyIncomingCall=t.CallHierarchyItem=t.DocumentSymbol=t.WorkspaceSymbol=t.SymbolTag=t.SymbolKind=t.WorkspaceEdit=t.TextEdit=t.DecorationRenderOptions=t.DecorationRangeBehavior=t.ThemableDecorationRenderOptions=t.ThemableDecorationAttachmentRenderOptions=t.pathOrURIToURI=t.fromRangeOrRangeWithMessage=t.MarkdownString=t.isDecorationOptionsArr=t.ViewColumn=t.DiagnosticSeverity=t.DiagnosticRelatedInformation=t.Diagnostic=t.DiagnosticTag=t.Position=t.TokenType=t.Range=t.Selection=void 0,
function(e){e.to=function(e){const{selectionStartLineNumber:t,selectionStartColumn:n,positionLineNumber:i,positionColumn:s}=e,o=new r.Position(t-1,n-1),a=new r.Position(i-1,s-1);return new r.Selection(o,a)},e.from=function(e){const{anchor:t,active:n}=e;return{selectionStartLineNumber:t.line+1,selectionStartColumn:t.character+1,positionLineNumber:n.line+1,positionColumn:n.character+1}}}(t.Selection||(t.Selection={})),function(e){e.from=function(e){if(!e)return;const{start:t,end:n}=e;return{startLineNumber:t.line+1,startColumn:t.character+1,endLineNumber:n.line+1,endColumn:n.character+1}},e.to=function(e){if(!e)return;const{startLineNumber:t,startColumn:n,endLineNumber:i,endColumn:s}=e;return new r.Range(t-1,n-1,i-1,s-1)}}(g=t.Range||(t.Range={})),function(e){e.to=function(e){switch(e){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 4:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}}(t.TokenType||(t.TokenType={})),function(e){e.to=function(e){
return new r.Position(e.lineNumber-1,e.column-1)},e.from=function(e){return{lineNumber:e.line+1,column:e.character+1}}}(t.Position||(t.Position={})),function(e){e.from=function(e){switch(e){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}},e.to=function(e){switch(e){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}}(v=t.DiagnosticTag||(t.DiagnosticTag={})),function(e){e.from=function(e){let t;return e.code&&(t=l.isString(e.code)||l.isNumber(e.code)?String(e.code):{value:String(e.code.value),target:e.code.target}),Object.assign(Object.assign({},g.from(e.range)),{message:e.message,source:e.source,code:t,severity:b.from(e.severity),relatedInformation:e.relatedInformation&&e.relatedInformation.map(y.from),tags:Array.isArray(e.tags)?p.coalesce(e.tags.map(v.from)):void 0})},e.to=function(e){var t;const n=new r.Diagnostic(g.to(e),e.message,b.to(e.severity));return n.source=e.source,
n.code=l.isString(e.code)?e.code:null===(t=e.code)||void 0===t?void 0:t.value,n.relatedInformation=e.relatedInformation&&e.relatedInformation.map(y.to),n.tags=e.tags&&p.coalesce(e.tags.map(v.to)),n}}(t.Diagnostic||(t.Diagnostic={})),function(e){e.from=function(e){return Object.assign(Object.assign({},g.from(e.location.range)),{message:e.message,resource:e.location.uri})},e.to=function(e){return new r.DiagnosticRelatedInformation(new r.Location(e.resource,g.to(e)),e.message)}}(y=t.DiagnosticRelatedInformation||(t.DiagnosticRelatedInformation={})),function(e){e.from=function(e){switch(e){case r.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error},e.to=function(e){switch(e){case a.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:
return r.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}}(b=t.DiagnosticSeverity||(t.DiagnosticSeverity={})),function(e){e.from=function(e){return"number"==typeof e&&e>=r.ViewColumn.One?e-1:e===r.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP},e.to=function(e){if("number"==typeof e&&e>=0)return e+1;throw new Error("invalid 'EditorViewColumn'")}}(t.ViewColumn||(t.ViewColumn={})),t.isDecorationOptionsArr=F,function(e){function t(e,t){if(!e)return e;let n;try{n=h.parse(e)}catch(e){}if(!n)return e;let r=!1;return n=d.cloneAndChange(n,e=>{if(i.URI.isUri(e)){const n=`__uri_${Math.random().toString(16).slice(2,8)}`;return t[n]=e,r=!0,n}}),r?JSON.stringify(n):e}e.fromMany=function(t){return t.map(e.from)},e.from=function(e){let n;if((r=e)&&"object"==typeof r&&"string"==typeof r.language&&"string"==typeof r.value){const{language:t,value:r}=e;n={value:"```"+t+"\n"+r+"\n```\n"}
}else n=o.isMarkdownString(e)?e:"string"==typeof e?{value:e}:{value:""};var r;const s=Object.create(null);n.uris=s;const a=e=>{try{let n=i.URI.parse(e,!0);n=n.with({query:t(n.query,s)}),s[e]=n}catch(e){}return""},c=new u.Renderer;return c.link=a,c.image=e=>a(o.parseHrefAndDimensions(e).href),u(n.value,{renderer:c}),n},e.to=function(e){const t=new r.MarkdownString(e.value,e.supportThemeIcons);return t.isTrusted=e.isTrusted,t},e.fromStrict=function(t){if(t)return"string"==typeof t?t:e.from(t)}}(w=t.MarkdownString||(t.MarkdownString={})),t.fromRangeOrRangeWithMessage=function(e){return F(e)?e.map(e=>({range:g.from(e.range),hoverMessage:Array.isArray(e.hoverMessage)?w.fromMany(e.hoverMessage):e.hoverMessage?w.from(e.hoverMessage):void 0,renderOptions:e.renderOptions})):e.map(e=>({range:g.from(e)}))},t.pathOrURIToURI=U,function(e){e.from=function(e){return void 0===e?e:{contentText:e.contentText,contentIconPath:e.contentIconPath?U(e.contentIconPath):void 0,border:e.border,borderColor:e.borderColor,
fontStyle:e.fontStyle,fontWeight:e.fontWeight,textDecoration:e.textDecoration,color:e.color,backgroundColor:e.backgroundColor,margin:e.margin,width:e.width,height:e.height}}}(_=t.ThemableDecorationAttachmentRenderOptions||(t.ThemableDecorationAttachmentRenderOptions={})),function(e){e.from=function(e){return void 0===e?e:{backgroundColor:e.backgroundColor,outline:e.outline,outlineColor:e.outlineColor,outlineStyle:e.outlineStyle,outlineWidth:e.outlineWidth,border:e.border,borderColor:e.borderColor,borderRadius:e.borderRadius,borderSpacing:e.borderSpacing,borderStyle:e.borderStyle,borderWidth:e.borderWidth,fontStyle:e.fontStyle,fontWeight:e.fontWeight,textDecoration:e.textDecoration,cursor:e.cursor,color:e.color,opacity:e.opacity,letterSpacing:e.letterSpacing,gutterIconPath:e.gutterIconPath?U(e.gutterIconPath):void 0,gutterIconSize:e.gutterIconSize,overviewRulerColor:e.overviewRulerColor,before:e.before?_.from(e.before):void 0,after:e.after?_.from(e.after):void 0}}
}(E=t.ThemableDecorationRenderOptions||(t.ThemableDecorationRenderOptions={})),function(e){e.from=function(e){if(void 0===e)return e;switch(e){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}}(S=t.DecorationRangeBehavior||(t.DecorationRangeBehavior={})),function(e){e.from=function(e){return{isWholeLine:e.isWholeLine,rangeBehavior:e.rangeBehavior?S.from(e.rangeBehavior):void 0,overviewRulerLane:e.overviewRulerLane,light:e.light?E.from(e.light):void 0,dark:e.dark?E.from(e.dark):void 0,backgroundColor:e.backgroundColor,outline:e.outline,outlineColor:e.outlineColor,outlineStyle:e.outlineStyle,outlineWidth:e.outlineWidth,border:e.border,borderColor:e.borderColor,borderRadius:e.borderRadius,borderSpacing:e.borderSpacing,borderStyle:e.borderStyle,borderWidth:e.borderWidth,fontStyle:e.fontStyle,fontWeight:e.fontWeight,textDecoration:e.textDecoration,
cursor:e.cursor,color:e.color,opacity:e.opacity,letterSpacing:e.letterSpacing,gutterIconPath:e.gutterIconPath?U(e.gutterIconPath):void 0,gutterIconSize:e.gutterIconSize,overviewRulerColor:e.overviewRulerColor,before:e.before?_.from(e.before):void 0,after:e.after?_.from(e.after):void 0}}}(t.DecorationRenderOptions||(t.DecorationRenderOptions={})),function(e){e.from=function(e){return{text:e.newText,eol:e.newEol&&A.from(e.newEol),range:g.from(e.range)}},e.to=function(e){const t=new r.TextEdit(g.to(e.range),e.text);return t.newEol=void 0===e.eol?void 0:A.to(e.eol),t}}(C=t.TextEdit||(t.TextEdit={})),function(e){e.from=function(e,t,n){var i;const s={edits:[]};if(e instanceof r.WorkspaceEdit)for(let r of e._allEntries())if(1===r._type)s.edits.push({_type:1,oldUri:r.from,newUri:r.to,options:r.options,metadata:r.metadata});else if(2===r._type){const e=null==t?void 0:t.getDocument(r.uri);s.edits.push({_type:2,resource:r.uri,edit:C.from(r.edit),modelVersionId:null==e?void 0:e.version,metadata:r.metadata})
}else 3===r._type&&s.edits.push({_type:3,metadata:r.metadata,resource:r.uri,edit:r.edit,notebookMetadata:r.notebookMetadata,notebookVersionId:null===(i=null==n?void 0:n.lookupNotebookDocument(r.uri))||void 0===i?void 0:i.notebookDocument.version});return s},e.to=function(e){const t=new r.WorkspaceEdit;for(const n of e.edits)n.edit?t.replace(i.URI.revive(n.resource),g.to(n.edit.range),n.edit.text):t.renameFile(i.URI.revive(n.oldUri),i.URI.revive(n.newUri),n.options);return t}}(t.WorkspaceEdit||(t.WorkspaceEdit={})),function(e){const t=Object.create(null);t[r.SymbolKind.File]=0,t[r.SymbolKind.Module]=1,t[r.SymbolKind.Namespace]=2,t[r.SymbolKind.Package]=3,t[r.SymbolKind.Class]=4,t[r.SymbolKind.Method]=5,t[r.SymbolKind.Property]=6,t[r.SymbolKind.Field]=7,t[r.SymbolKind.Constructor]=8,t[r.SymbolKind.Enum]=9,t[r.SymbolKind.Interface]=10,t[r.SymbolKind.Function]=11,t[r.SymbolKind.Variable]=12,t[r.SymbolKind.Constant]=13,t[r.SymbolKind.String]=14,t[r.SymbolKind.Number]=15,t[r.SymbolKind.Boolean]=16,
t[r.SymbolKind.Array]=17,t[r.SymbolKind.Object]=18,t[r.SymbolKind.Key]=19,t[r.SymbolKind.Null]=20,t[r.SymbolKind.EnumMember]=21,t[r.SymbolKind.Struct]=22,t[r.SymbolKind.Event]=23,t[r.SymbolKind.Operator]=24,t[r.SymbolKind.TypeParameter]=25,e.from=function(e){return"number"==typeof t[e]?t[e]:6},e.to=function(e){for(const n in t)if(t[n]===e)return Number(n);return r.SymbolKind.Property}}(x=t.SymbolKind||(t.SymbolKind={})),function(e){e.from=function(e){switch(e){case r.SymbolTag.Deprecated:return 1}},e.to=function(e){switch(e){case 1:return r.SymbolTag.Deprecated}}}(I=t.SymbolTag||(t.SymbolTag={})),function(e){e.from=function(e){return{name:e.name,kind:x.from(e.kind),tags:e.tags&&e.tags.map(I.from),containerName:e.containerName,location:T.from(e.location)}},e.to=function(e){const t=new r.SymbolInformation(e.name,x.to(e.kind),e.containerName,T.to(e.location));return t.tags=e.tags&&e.tags.map(I.to),t}}(t.WorkspaceSymbol||(t.WorkspaceSymbol={})),function(e){e.from=function e(t){var n,r;const i={
name:t.name||"!!MISSING: name!!",detail:t.detail,range:g.from(t.range),selectionRange:g.from(t.selectionRange),kind:x.from(t.kind),tags:null!==(r=null===(n=t.tags)||void 0===n?void 0:n.map(I.from))&&void 0!==r?r:[]};return t.children&&(i.children=t.children.map(e)),i},e.to=function e(t){const n=new r.DocumentSymbol(t.name,t.detail,x.to(t.kind),g.to(t.range),g.to(t.selectionRange));return p.isNonEmptyArray(t.tags)&&(n.tags=t.tags.map(I.to)),t.children&&(n.children=t.children.map(e)),n}}(t.DocumentSymbol||(t.DocumentSymbol={})),function(e){e.to=function(e){const t=new r.CallHierarchyItem(x.to(e.kind),e.name,e.detail||"",i.URI.revive(e.uri),g.to(e.range),g.to(e.selectionRange));return t._sessionId=e._sessionId,t._itemId=e._itemId,t}}(k=t.CallHierarchyItem||(t.CallHierarchyItem={})),function(e){e.to=function(e){return new r.CallHierarchyIncomingCall(k.to(e.from),e.fromRanges.map(e=>g.to(e)))}}(t.CallHierarchyIncomingCall||(t.CallHierarchyIncomingCall={})),function(e){e.to=function(e){
return new r.CallHierarchyOutgoingCall(k.to(e.to),e.fromRanges.map(e=>g.to(e)))}}(t.CallHierarchyOutgoingCall||(t.CallHierarchyOutgoingCall={})),function(e){e.from=function(e){return{range:e.range&&g.from(e.range),uri:e.uri}},e.to=function(e){return new r.Location(e.uri,g.to(e.range))}}(T=t.location||(t.location={})),function(e){e.from=function(e){const t=e,n=e;return{originSelectionRange:t.originSelectionRange?g.from(t.originSelectionRange):void 0,uri:t.targetUri?t.targetUri:n.uri,range:g.from(t.targetRange?t.targetRange:n.range),targetSelectionRange:t.targetSelectionRange?g.from(t.targetSelectionRange):void 0}},e.to=function(e){return{targetUri:e.uri,targetRange:g.to(e.range),targetSelectionRange:e.targetSelectionRange?g.to(e.targetSelectionRange):void 0,originSelectionRange:e.originSelectionRange?g.to(e.originSelectionRange):void 0}}}(t.DefinitionLink||(t.DefinitionLink={})),function(e){e.from=function(e){return{range:g.from(e.range),contents:w.fromMany(e.contents)}},e.to=function(e){
return new r.Hover(e.contents.map(w.to),g.to(e.range))}}(t.Hover||(t.Hover={})),function(e){e.from=function(e){return{range:g.from(e.range),expression:e.expression}},e.to=function(e){return new r.EvaluatableExpression(g.to(e.range),e.expression)}}(t.EvaluatableExpression||(t.EvaluatableExpression={})),function(e){e.from=function(e){return{range:g.from(e.range),kind:e.kind}},e.to=function(e){return new r.DocumentHighlight(g.to(e.range),e.kind)}}(t.DocumentHighlight||(t.DocumentHighlight={})),function(e){e.to=function(e){switch(e){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}}(P=t.CompletionTriggerKind||(t.CompletionTriggerKind={})),function(e){e.to=function(e){return{triggerKind:P.to(e.triggerKind),triggerCharacter:e.triggerCharacter}}}(t.CompletionContext||(t.CompletionContext={})),function(e){e.from=function(e){switch(e){case r.CompletionItemTag.Deprecated:return 1}},
e.to=function(e){switch(e){case 1:return r.CompletionItemTag.Deprecated}}}(R=t.CompletionItemTag||(t.CompletionItemTag={})),function(e){
const t=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);e.from=function(e){var n;return null!==(n=t.get(e))&&void 0!==n?n:9}
;const n=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);e.to=function(e){var t;return null!==(t=n.get(e))&&void 0!==t?t:r.CompletionItemKind.Property}
}(O=t.CompletionItemKind||(t.CompletionItemKind={})),function(e){e.to=function(e,t){var n;const i=new r.CompletionItem("string"==typeof e.label?e.label:e.label.name);return"string"!=typeof e.label&&(i.label2=e.label),i.insertText=e.insertText,i.kind=O.to(e.kind),i.tags=null===(n=e.tags)||void 0===n?void 0:n.map(R.to),i.detail=e.detail,i.documentation=o.isMarkdownString(e.documentation)?w.to(e.documentation):e.documentation,i.sortText=e.sortText,i.filterText=e.filterText,i.preselect=e.preselect,i.commitCharacters=e.commitCharacters,s.Range.isIRange(e.range)?i.range=g.to(e.range):"object"==typeof e.range&&(i.range={inserting:g.to(e.range.insert),replacing:g.to(e.range.replace)}),i.keepWhitespace=void 0!==e.insertTextRules&&Boolean(1&e.insertTextRules),void 0!==e.insertTextRules&&4&e.insertTextRules?i.insertText=new r.SnippetString(e.insertText):(i.insertText=e.insertText,i.textEdit=i.range instanceof r.Range?new r.TextEdit(i.range,i.insertText):void 0),
e.additionalTextEdits&&e.additionalTextEdits.length>0&&(i.additionalTextEdits=e.additionalTextEdits.map(e=>C.to(e))),i.command=t&&e.command?t.fromInternal(e.command):void 0,i}}(t.CompletionItem||(t.CompletionItem={})),function(e){e.from=function(e){return{label:e.label,documentation:e.documentation?w.fromStrict(e.documentation):void 0}},e.to=function(e){return{label:e.label,documentation:o.isMarkdownString(e.documentation)?w.to(e.documentation):e.documentation}}}(L=t.ParameterInformation||(t.ParameterInformation={})),function(e){e.from=function(e){return{label:e.label,documentation:e.documentation?w.fromStrict(e.documentation):void 0,parameters:Array.isArray(e.parameters)?e.parameters.map(L.from):[],activeParameter:e.activeParameter}},e.to=function(e){return{label:e.label,documentation:o.isMarkdownString(e.documentation)?w.to(e.documentation):e.documentation,parameters:Array.isArray(e.parameters)?e.parameters.map(L.to):[],activeParameter:e.activeParameter}}
}(D=t.SignatureInformation||(t.SignatureInformation={})),function(e){e.from=function(e){return{activeSignature:e.activeSignature,activeParameter:e.activeParameter,signatures:Array.isArray(e.signatures)?e.signatures.map(D.from):[]}},e.to=function(e){return{activeSignature:e.activeSignature,activeParameter:e.activeParameter,signatures:Array.isArray(e.signatures)?e.signatures.map(D.to):[]}}}(t.SignatureHelp||(t.SignatureHelp={})),function(e){e.from=function(e){return{range:g.from(e.range),url:e.target,tooltip:e.tooltip}},e.to=function(e){let t=void 0;if(e.url)try{t="string"==typeof e.url?i.URI.parse(e.url,!0):i.URI.revive(e.url)}catch(e){}return new r.DocumentLink(g.to(e.range),t)}}(t.DocumentLink||(t.DocumentLink={})),function(e){e.to=function(e){const t=new r.ColorPresentation(e.label);return e.textEdit&&(t.textEdit=C.to(e.textEdit)),e.additionalTextEdits&&(t.additionalTextEdits=e.additionalTextEdits.map(e=>C.to(e))),t},e.from=function(e){return{label:e.label,textEdit:e.textEdit?C.from(e.textEdit):void 0,
additionalTextEdits:e.additionalTextEdits?e.additionalTextEdits.map(e=>C.from(e)):void 0}}}(t.ColorPresentation||(t.ColorPresentation={})),function(e){e.to=function(e){return new r.Color(e[0],e[1],e[2],e[3])},e.from=function(e){return[e.red,e.green,e.blue,e.alpha]}}(t.Color||(t.Color={})),function(e){e.from=function(e){return{range:g.from(e.range)}},e.to=function(e){return new r.SelectionRange(g.to(e.range))}}(t.SelectionRange||(t.SelectionRange={})),function(e){e.to=function(e){switch(e){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}}(t.TextDocumentSaveReason||(t.TextDocumentSaveReason={})),function(e){e.from=function(e){switch(e){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}},e.to=function(e){switch(e){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:
return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}}(t.TextEditorLineNumbersStyle||(t.TextEditorLineNumbersStyle={})),function(e){e.from=function(e){return e===r.EndOfLine.CRLF?1:e===r.EndOfLine.LF?0:void 0},e.to=function(e){return 1===e?r.EndOfLine.CRLF:0===e?r.EndOfLine.LF:void 0}}(A=t.EndOfLine||(t.EndOfLine={})),function(e){e.from=function(e){if("object"==typeof e)return e.viewId;switch(e){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}}(t.ProgressLocation||(t.ProgressLocation={})),function(e){e.from=function(e){const t={start:e.start+1,end:e.end+1};return e.kind&&(t.kind=N.from(e.kind)),t}}(t.FoldingRange||(t.FoldingRange={})),function(e){e.from=function(e){if(e)switch(e){case r.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports
;case r.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}}(N=t.FoldingRangeKind||(t.FoldingRangeKind={})),function(e){e.from=function(e){if(e)return{pinned:"boolean"==typeof e.preview?!e.preview:void 0,inactive:e.background,preserveFocus:e.preserveFocus,selection:"object"==typeof e.selection?g.from(e.selection):void 0}}}(t.TextEditorOpenOptions||(t.TextEditorOpenOptions={})),function(e){e.from=function(e){return e instanceof r.RelativePattern?e:"string"==typeof e?e:function(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}(e)?new r.RelativePattern(e.base,e.pattern):e}}(M=t.GlobPattern||(t.GlobPattern={})),function(e){e.from=function e(t){return t?Array.isArray(t)?t.map(e):"string"==typeof t?t:{language:t.language,scheme:t.scheme,pattern:void 0===t.pattern?void 0:M.from(t.pattern),exclusive:t.exclusive}:void 0}}(t.LanguageSelector||(t.LanguageSelector={})),function(e){e.from=function(e){switch(e){case r.LogLevel.Trace:return f.LogLevel.Trace;case r.LogLevel.Debug:
return f.LogLevel.Debug;case r.LogLevel.Info:return f.LogLevel.Info;case r.LogLevel.Warning:return f.LogLevel.Warning;case r.LogLevel.Error:return f.LogLevel.Error;case r.LogLevel.Critical:return f.LogLevel.Critical;case r.LogLevel.Off:return f.LogLevel.Off;default:return f.LogLevel.Info}},e.to=function(e){switch(e){case f.LogLevel.Trace:return r.LogLevel.Trace;case f.LogLevel.Debug:return r.LogLevel.Debug;case f.LogLevel.Info:return r.LogLevel.Info;case f.LogLevel.Warning:return r.LogLevel.Warning;case f.LogLevel.Error:return r.LogLevel.Error;case f.LogLevel.Critical:return r.LogLevel.Critical;case f.LogLevel.Off:return r.LogLevel.Off;default:return r.LogLevel.Info}}}(t.LogLevel||(t.LogLevel={})),function(e){e.from=function(e){return e.toJSON()}}(t.NotebookCellOutput||(t.NotebookCellOutput={})),function(e){e.from=function(e){return{outputKind:m.CellOutputKind.Rich,data:{[e.mime]:e.value},metadata:e.metadata&&{custom:e.metadata}}}}(t.NotebookCellOutputItem||(t.NotebookCellOutputItem={})),function(e){
function t(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}e.from=function(e){if(null!=e)return e instanceof r.RelativePattern?e:"string"==typeof e?e:t(e)?new r.RelativePattern(e.base,e.pattern):function(e){const t=e,n=M.from(t.include);if(!(n&&n instanceof r.RelativePattern||"string"==typeof n))return!1;const i=M.from(t.exclude);if(!(i&&i instanceof r.RelativePattern||"string"==typeof i))return!1;return!0}(e)?{include:M.from(e.include)||void 0,exclude:M.from(e.exclude)||void 0}:void 0},e.to=function(e){return"string"==typeof e?e:t(e)?{base:e.base,pattern:e.pattern}:{include:e.include,exclude:e.exclude}}}(t.NotebookExclusiveDocumentPattern||(t.NotebookExclusiveDocumentPattern={})),function(e){e.from=function(e){return{backgroundColor:e.backgroundColor,borderColor:e.borderColor,top:e.top?_.from(e.top):void 0}}}(t.NotebookDecorationRenderOptions||(t.NotebookDecorationRenderOptions={}))})),
define(t[206],n([0,1,11,29,12,91,194,100,101,102,203,198,105,8,175]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteTerminalChannelClient=t.REMOTE_TERMINAL_CHANNEL_NAME=void 0,t.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let v=class{constructor(e,t,n,r,i,s,o,a,c,l){this._remoteAuthority=e,this._channel=t,this._configurationService=n,this._workspaceContextService=r,this._resolverService=i,this._environmentVariableService=s,this._remoteAuthorityResolverService=o,this._logService=a,this._editorService=c,this._labelService=l}_readSingleTerminalConfiguration(e){const t=this._configurationService.inspect(e);return{userValue:t.userValue,value:t.value,defaultValue:t.defaultValue}}async createTerminalProcess(e,t,r,i,s,o){const a=this._configurationService.getValue(h.TERMINAL_CONFIG_SECTION),c={"terminal.integrated.automationShell.windows":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.windows"),
"terminal.integrated.automationShell.osx":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.osx"),"terminal.integrated.automationShell.linux":this._readSingleTerminalConfiguration("terminal.integrated.automationShell.linux"),"terminal.integrated.shell.windows":this._readSingleTerminalConfiguration("terminal.integrated.shell.windows"),"terminal.integrated.shell.osx":this._readSingleTerminalConfiguration("terminal.integrated.shell.osx"),"terminal.integrated.shell.linux":this._readSingleTerminalConfiguration("terminal.integrated.shell.linux"),"terminal.integrated.shellArgs.windows":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.windows"),"terminal.integrated.shellArgs.osx":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.osx"),"terminal.integrated.shellArgs.linux":this._readSingleTerminalConfiguration("terminal.integrated.shellArgs.linux"),"terminal.integrated.env.windows":this._readSingleTerminalConfiguration("terminal.integrated.env.windows"),
"terminal.integrated.env.osx":this._readSingleTerminalConfiguration("terminal.integrated.env.osx"),"terminal.integrated.env.linux":this._readSingleTerminalConfiguration("terminal.integrated.env.linux"),"terminal.integrated.inheritEnv":a.inheritEnv,"terminal.integrated.cwd":a.cwd,"terminal.integrated.detectLocale":a.detectLocale},l=Object.create(null),d=t?n.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(t)):void 0;let p=void 0;try{p=await this._resolverService.resolveWithInteraction(d,{shellLaunchConfig:e,configuration:c})}catch(e){this._logService.error(e)}if(p)for(const[e,t]of p.entries())(/^config:/.test(e)||"selectedText"===e||"lineNumber"===e)&&(l[e]=t);const g=[];for(const[e,t]of this._environmentVariableService.collections.entries())g.push([e,u.serializeEnvironmentVariableCollection(t.map)])
;const v=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),y=v.options&&v.options.extensionHostEnv,b=this._workspaceContextService.getWorkspace(),w=b.folders,_=t?this._workspaceContextService.getWorkspaceFolder(t):null,E=f.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:f.SideBySideEditor.PRIMARY,filterByScheme:[m.Schemas.file,m.Schemas.userData,m.Schemas.vscodeRemote]}),S={configuration:c,resolvedVariables:l,envVariableCollections:g,shellLaunchConfig:e,workspaceId:b.id,workspaceName:this._labelService.getWorkspaceLabel(b),workspaceFolders:w,activeWorkspaceFolder:_,activeFileResource:E,shouldPersistTerminal:r,cols:i,rows:s,isWorkspaceShellAllowed:o,resolverEnv:y};return await this._channel.call("$createTerminalProcess",S)}async startTerminalProcess(e){const t={id:e};return this._channel.call("$startTerminalProcess",t)}onTerminalProcessEvent(e){const t={id:e};return this._channel.listen("$onTerminalProcessEvent",t)}
sendInputToTerminalProcess(e,t){const n={id:e,data:t};return this._channel.call("$sendInputToTerminalProcess",n)}shutdownTerminalProcess(e,t){const n={id:e,immediate:t};return this._channel.call("$shutdownTerminalProcess",n)}resizeTerminalProcess(e,t,n){const r={id:e,cols:t,rows:n};return this._channel.call("$resizeTerminalProcess",r)}getTerminalInitialCwd(e){const t={id:e};return this._channel.call("$getTerminalInitialCwd",t)}getTerminalCwd(e){const t={id:e};return this._channel.call("$getTerminalCwd",t)}sendCommandResultToTerminalProcess(e,t,n,r){const i={id:e,reqId:t,isError:n,payload:r};return this._channel.call("$sendCommandResultToTerminalProcess",i)}orphanQuestionReply(e){const t={id:e};return this._channel.call("$orphanQuestionReply",t)}listTerminals(e){const t={isInitialization:e};return this._channel.call("$listTerminals",t)}}
;v=s([o(2,r.IConfigurationService),o(3,c.IWorkspaceContextService),o(4,d.IConfigurationResolverService),o(5,l.IEnvironmentVariableService),o(6,a.IRemoteAuthorityResolverService),o(7,i.ILogService),o(8,p.IEditorService),o(9,g.ILabelService)],v),t.RemoteTerminalChannelClient=v})),define(t[207],n([0,1,180]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Logger=t.Translations=void 0,function(e){e.equals=function(e,t){if(e===t)return!0;let n=Object.keys(e),r=new Set;for(let e of Object.keys(t))r.add(e);if(n.length!==r.size)return!1;for(let i of n){if(e[i]!==t[i])return!1;r.delete(i)}return 0===r.size}}(t.Translations||(t.Translations={}));t.Logger=class{constructor(e){this._messageHandler=e}error(e,t){this._messageHandler(n.Severity.Error,e,t)}warn(e,t){this._messageHandler(n.Severity.Warning,e,t)}info(e,t){this._messageHandler(n.Severity.Info,e,t)}}})),define(t[208],n([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getStringIdentifierForProxy=t.createExtHostContextProxyIdentifier=t.createMainContextProxyIdentifier=t.ProxyIdentifier=void 0;class n{constructor(e,t){this.isMain=e,this.sid=t,this.nid=++n.count}}t.ProxyIdentifier=n,n.count=0;const r=[];t.createMainContextProxyIdentifier=function(e){const t=new n(!0,e);return r[t.nid]=t,t},t.createExtHostContextProxyIdentifier=function(e){const t=new n(!1,e);return r[t.nid]=t,t},t.getStringIdentifierForProxy=function(e){return r[e].sid}})),define(t[209],n([0,1,4,208,46]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostContext=t.MainContext=t.reviveWorkspaceEditDto=t.WorkspaceEditType=t.ISuggestResultDtoField=t.ISuggestDataDtoField=t.IdObject=t.ObjectIdentifier=t.NotebookEditorRevealType=t.CellOutputKind=t.CellKind=t.WebviewEditorCapabilities=t.TextEditorRevealType=t.UIKind=void 0,function(e){e[e.Desktop=1]="Desktop",e[e.Web=2]="Web"}(t.UIKind||(t.UIKind={})),function(e){e[e.Default=0]="Default",e[e.InCenter=1]="InCenter",
e[e.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",e[e.AtTop=3]="AtTop"}(t.TextEditorRevealType||(t.TextEditorRevealType={})),function(e){e[e.Editable=0]="Editable",e[e.SupportsHotExit=1]="SupportsHotExit"}(t.WebviewEditorCapabilities||(t.WebviewEditorCapabilities={})),function(e){e[e.Markdown=1]="Markdown",e[e.Code=2]="Code"}(t.CellKind||(t.CellKind={})),function(e){e[e.Text=1]="Text",e[e.Error=2]="Error",e[e.Rich=3]="Rich"}(t.CellOutputKind||(t.CellOutputKind={})),function(e){e[e.Default=0]="Default",e[e.InCenter=1]="InCenter",e[e.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport"}(t.NotebookEditorRevealType||(t.NotebookEditorRevealType={})),function(e){e.name="$ident",e.mixin=function(t,n){return Object.defineProperty(t,e.name,{value:n,enumerable:!0}),t},e.of=function(t){return t[e.name]}}(t.ObjectIdentifier||(t.ObjectIdentifier={}));class s{static mixin(e){return e._id=s._n++,e}}t.IdObject=s,s._n=0,function(e){e.label="a",e.kind="b",e.detail="c",e.documentation="d",e.sortText="e",
e.filterText="f",e.preselect="g",e.insertText="h",e.insertTextRules="i",e.range="j",e.commitCharacters="k",e.additionalTextEdits="l",e.command="m",e.kindModifier="n",e.label2="o"}(t.ISuggestDataDtoField||(t.ISuggestDataDtoField={})),function(e){e.defaultRanges="a",e.completions="b",e.isIncomplete="c",e.duration="d"}(t.ISuggestResultDtoField||(t.ISuggestResultDtoField={})),function(e){e[e.File=1]="File",e[e.Text=2]="Text",e[e.Cell=3]="Cell"}(t.WorkspaceEditType||(t.WorkspaceEditType={})),t.reviveWorkspaceEditDto=function(e){if(e&&e.edits)for(const t of e.edits)"object"==typeof t.resource?t.resource=n.URI.revive(t.resource):(t.newUri=n.URI.revive(t.newUri),t.oldUri=n.URI.revive(t.oldUri)),t.metadata&&t.metadata.iconPath&&(t.metadata=i.revive(t.metadata));return e},t.MainContext={MainThreadAuthentication:r.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:r.createMainContextProxyIdentifier("MainThreadBulkEdits"),
MainThreadClipboard:r.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:r.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:r.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:r.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:r.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:r.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:r.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:r.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:r.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:r.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:r.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:r.createMainContextProxyIdentifier("MainThreadTextEditors"),
MainThreadEditorInsets:r.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadErrors:r.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:r.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:r.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:r.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:r.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:r.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:r.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:r.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:r.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:r.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:r.createMainContextProxyIdentifier("MainThreadQuickOpen"),
MainThreadStatusBar:r.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadStorage:r.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:r.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:r.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:r.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:r.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:r.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:r.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:r.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadWorkspace:r.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:r.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:r.createMainContextProxyIdentifier("MainThreadExtensionService"),
MainThreadSCM:r.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:r.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:r.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:r.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:r.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:r.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadTheming:r.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:r.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:r.createMainContextProxyIdentifier("MainThreadTimeline")},t.ExtHostContext={ExtHostCommands:r.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:r.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:r.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:r.createExtHostContextProxyIdentifier("ExtHostDebugService"),
ExtHostDecorations:r.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:r.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:r.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:r.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:r.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:r.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:r.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:r.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:r.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:r.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:r.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),
ExtHostQuickOpen:r.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:r.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:r.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:r.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:r.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:r.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:r.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:r.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:r.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:r.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:r.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:r.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:r.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),
ExtHostEditorInsets:r.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostProgress:r.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:r.createMainContextProxyIdentifier("ExtHostComments"),ExtHostStorage:r.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:r.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostOutputService:r.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:r.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:r.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostTheming:r.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:r.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:r.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:r.createMainContextProxyIdentifier("ExtHostTimeline")}})),define(t[210],n([0,1,11,99,205,18,209,16,12,46,61,81,4,3,7,197]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g,v){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostCommands=t.CommandsConverter=t.ExtHostCommands=void 0;let y=class{constructor(e,t){this._commands=new Map,this._proxy=e.getProxy(c.MainContext.MainThreadCommands),this._logService=t,this._converter=new b(this,t),this._argumentProcessors=[{processArgument:e=>h.revive(e)},{processArgument:e=>a.cloneAndChange(e,(function(e){return d.Range.isIRange(e)?i.Range.to(e):f.Position.isIPosition(e)?i.Position.to(e):d.Range.isIRange(e.range)&&p.URI.isUri(e.uri)?i.location.to(e):Array.isArray(e)?void 0:e}))}]}get converter(){return this._converter}registerArgumentProcessor(e){this._argumentProcessors.push(e)}registerCommand(e,t,n,i,s){if(this._logService.trace("ExtHostCommands#registerCommand",t),!t.trim().length)throw new Error("invalid id");if(this._commands.has(t))throw new Error(`command '${t}' already exists`);return this._commands.set(t,{callback:n,thisArg:i,description:s}),e&&this._proxy.$registerCommand(t),new r.Disposable(()=>{
this._commands.delete(t)&&e&&this._proxy.$unregisterCommand(t)})}executeCommand(e,...t){return this._logService.trace("ExtHostCommands#executeCommand",e),this._doExecuteCommand(e,t,!0)}async _doExecuteCommand(e,t,n){if(this._commands.has(e))return this._executeContributedCommand(e,t);{const s=a.cloneAndChange(t,(function(e){return e instanceof r.Position?i.Position.from(e):e instanceof r.Range?i.Range.from(e):e instanceof r.Location?i.location.from(e):Array.isArray(e)?void 0:e}));try{const t=await this._proxy.$executeCommand(e,s,n);return h.revive(t)}catch(n){if(n instanceof Error&&"$executeCommand:retry"===n.message)return this._doExecuteCommand(e,t,!1);throw n}}}_executeContributedCommand(e,t){const r=this._commands.get(e);if(!r)throw new Error("Unknown command");let{callback:i,thisArg:s,description:o}=r;if(o)for(let r=0;r<o.args.length;r++)try{n.validateConstraint(t[r],o.args[r].constraint)}catch(t){
return Promise.reject(new Error(`Running the contributed command: '${e}' failed. Illegal argument '${o.args[r].name}' - ${o.args[r].description}`))}try{const e=i.apply(s,t);return Promise.resolve(e)}catch(t){return this._logService.error(t,e),Promise.reject(new Error(`Running the contributed command: '${e}' failed.`))}}$executeContributedCommand(e,...t){return this._logService.trace("ExtHostCommands#$executeContributedCommand",e),this._commands.has(e)?(t=t.map(e=>this._argumentProcessors.reduce((e,t)=>t.processArgument(e),e)),this._executeContributedCommand(e,t)):Promise.reject(new Error(`Contributed command '${e}' does not exist.`))}getCommands(e=!1){return this._logService.trace("ExtHostCommands#getCommands",e),this._proxy.$getCommands().then(t=>(e&&(t=t.filter(e=>"_"!==e[0])),t))}$getContributedCommandHandlerDescriptions(){const e=Object.create(null);for(let[t,n]of this._commands){let{description:r}=n;r&&(e[t]=r)}return Promise.resolve(e)}};y=s([o(0,v.IExtHostRpcService),o(1,u.ILogService)],y),
t.ExtHostCommands=y;class b{constructor(e,t){this._commands=e,this._logService=t,this._cache=new Map,this._cachIdPool=0,this._delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._commands.registerCommand(!0,this._delegatingCommandId,this._executeConvertedCommand,this)}toInternal(e,t){if(!e)return;const n={$ident:void 0,id:e.command,title:e.title,tooltip:e.tooltip};if(e.command&&l.isNonEmptyArray(e.arguments)){const r=++this._cachIdPool;this._cache.set(r,e),t.add(m.toDisposable(()=>{this._cache.delete(r),this._logService.trace("CommandsConverter#DISPOSE",r)})),n.$ident=r,n.id=this._delegatingCommandId,n.arguments=[r],this._logService.trace("CommandsConverter#CREATE",e.command,r)}return n}fromInternal(e){const t=c.ObjectIdentifier.of(e);return"number"==typeof t?this._cache.get(t):{command:e.id,title:e.title,arguments:e.arguments}}_executeConvertedCommand(...e){const t=this._cache.get(e[0]);return this._logService.trace("CommandsConverter#EXECUTE",e[0],t?t.command:"MISSING"),
t?this._commands.executeCommand(t.command,...t.arguments||[]):Promise.reject("actual command NOT FOUND")}}t.CommandsConverter=b,t.IExtHostCommands=g.createDecorator("IExtHostCommands")})),define(t[211],n([0,1,40,212,20,210,4,95,12]),(function(e,t,n,r,i,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CLIServer=t.CLIServerBase=void 0;class h{constructor(e,t,n){this._commands=e,this.logService=t,this._ipcHandlePath=n,this._server=r.createServer((e,t)=>this.onRequest(e,t)),this.setup().catch(e=>(t.error(e),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",e=>this.logService.error(e))}catch(e){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(e,t){const n=[];e.setEncoding("utf8"),e.on("data",e=>n.push(e)),e.on("end",()=>{const e=JSON.parse(n.join(""));switch(e.type){case"open":this.open(e,t);break;case"status":this.getStatus(e,t);break;case"command":
this.runCommand(e,t).catch(this.logService.error);break;default:t.writeHead(404),t.write(`Unknown message type: ${e.type}`,e=>{e&&this.logService.error(e)}),t.end()}})}open(e,t){let{fileURIs:n,folderURIs:r,forceNewWindow:i,diffMode:s,addMode:o,forceReuseWindow:a,gotoLineMode:u,waitMarkerFilePath:h}=e;const d=[];if(Array.isArray(r))for(const e of r)try{d.push({folderUri:c.URI.parse(e)})}catch(e){}if(Array.isArray(n))for(const e of n)try{l.hasWorkspaceFileExtension(e)?d.push({workspaceUri:c.URI.parse(e)}):d.push({fileUri:c.URI.parse(e)})}catch(e){}if(d.length){const e=h?c.URI.file(h):void 0,t={forceNewWindow:i,diffMode:s,addMode:o,gotoLineMode:u,forceReuseWindow:a,preferNewWindow:!a&&!e&&!o,waitMarkerFileURI:e};this._commands.executeCommand("_files.windowOpen",d,t)}t.writeHead(200),t.end()}async getStatus(e,t){try{const e=await this._commands.executeCommand("_issues.getSystemStatus");t.writeHead(200),t.write(e),t.end()}catch(e){t.writeHead(500),t.write(String(e),e=>{e&&this.logService.error(e)}),t.end()}}
async runCommand(e,t){try{const{command:n,args:r}=e,i=await this._commands.executeCommand(n,...r);t.writeHead(200),t.write(JSON.stringify(i),e=>{e&&this.logService.error(e)}),t.end()}catch(e){t.writeHead(500),t.write(String(e),e=>{e&&this.logService.error(e)}),t.end()}}dispose(){this._server.close(),this._ipcHandlePath&&"win32"!==process.platform&&i.existsSync(this._ipcHandlePath)&&i.unlinkSync(this._ipcHandlePath)}}t.CLIServerBase=h;let d=class extends h{constructor(e,t){super(e,t,n.createRandomIPCHandle())}};d=s([o(0,a.IExtHostCommands),o(1,u.ILogService)],d),t.CLIServer=d})),define(t[213],n([0,1,158,2,53,35,16,134,11,4,14,34,62,41,207]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionScanner=t.ExtensionScannerInput=void 0;const m="package.json";class g{constructor(e,t,n,i,s){this._ourVersion=e,this._log=t,this._absoluteFolderPath=n,this._isBuiltin=i,this._isUnderDevelopment=s,this._absoluteManifestPath=r.join(n,m)}}class v extends g{parse(){
return u.readFile(this._absoluteManifestPath).then(e=>{var t;const r=[],i=s.parse(e.toString(),r);if("object"!==s.getNodeType(i))this._log.error(this._absoluteFolderPath,n.localize(0,null,this._absoluteManifestPath));else{if(0===r.length)return i.__metadata&&(i.uuid=i.__metadata.id),i.isUserBuiltin=!!(null===(t=i.__metadata)||void 0===t?void 0:t.isBuiltin),delete i.__metadata,i;r.forEach(e=>{this._log.error(this._absoluteFolderPath,n.localize(1,null,this._absoluteManifestPath,e.offset,e.length,a.getParseErrorMessage(e.error)))})}return null},e=>"ENOENT"===e.code?null:(this._log.error(this._absoluteFolderPath,n.localize(2,null,this._absoluteManifestPath,e.message)),null))}}class y extends g{constructor(e,t,n,r,i,s){super(e,t,n,r,i),this._nlsConfig=s}replaceNLS(e){const t=(e,t)=>{t.forEach(t=>{this._log.error(this._absoluteFolderPath,n.localize(3,null,e,a.getParseErrorMessage(t.error)))})},i=e=>{this._log.error(this._absoluteFolderPath,n.localize(4,null,e))}
;let o=r.extname(this._absoluteManifestPath),c=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-o.length);const l=`${e.publisher}.${e.name}`;let h,d=this._nlsConfig.translations[l];return(h=d?u.readFile(d,"utf8").then(e=>{let n=[],r=s.parse(e,n);if(n.length>0)return t(d,n),{values:void 0,default:`${c}.nls.json`};if("object"!==s.getNodeType(r))return i(d),{values:void 0,default:`${c}.nls.json`};return{values:r.contents?r.contents.package:void 0,default:`${c}.nls.json`}},e=>({values:void 0,default:`${c}.nls.json`})):u.fileExists(c+".nls"+o).then(e=>{if(e)return y.findMessageBundles(this._nlsConfig,c).then(e=>e.localized?u.readFile(e.localized,"utf8").then(n=>{let r=[],o=s.parse(n,r);return r.length>0?(t(e.localized,r),{values:void 0,default:e.original}):"object"!==s.getNodeType(o)?(i(e.localized),{values:void 0,default:e.original}):{values:o,default:e.original}},t=>({values:void 0,default:e.original})):{values:void 0,default:e.original},e=>{})})).then(n=>{if(void 0===n)return e;let r=[]
;return y.resolveOriginalMessageBundle(n.default,r).then(o=>{if(r.length>0)return t(n.default,r),e;if("object"!==s.getNodeType(n))return i(n.default),e;const a=n.values||Object.create(null);return y._replaceNLStrings(this._nlsConfig,e,a,o,this._log,this._absoluteFolderPath),e})},t=>e)}static resolveOriginalMessageBundle(e,t){return new Promise((n,r)=>{e?u.readFile(e).then(e=>{n(s.parse(e.toString(),t))},e=>{n(null)}):n(null)})}static findMessageBundles(e,t){return new Promise((n,r)=>{if(e.devMode||e.pseudo||!e.locale)return n({localized:t+".nls.json",original:null});!function e(t,r){let i=`${t}.nls.${r}.json`;u.fileExists(i).then(s=>{s&&n({localized:i,original:`${t}.nls.json`});let o=r.lastIndexOf("-");-1===o?n({localized:`${t}.nls.json`,original:null}):(r=r.substring(0,o),e(t,r))})}(t,e.locale)})}static _replaceNLStrings(e,t,r,i,s,o){function a(t,l,u){let h=t[l];if(c.isString(h)){let a=h,c=a.length;if(c>1&&"%"===a[0]&&"%"===a[c-1]){let h=a.substr(1,c-2),d=r[h];void 0===d&&i&&(d=i[h]),
d?(e.pseudo&&(d="［"+d.replace(/[aouei]/g,"$&$&")+"］"),t[l]=u&&("title"===l||"category"===l)&&i?{value:d,original:i[h]}:d):s.warn(o,n.localize(5,null,h))}}else if(c.isObject(h))for(let e in h)h.hasOwnProperty(e)&&a(h,e,"commands"===e||u);else if(c.isArray(h))for(let e=0;e<h.length;e++)a(h,e,u)}for(let e in t)t.hasOwnProperty(e)&&a(t,e)}}class b extends g{validate(e){let t=e;t.isBuiltin=this._isBuiltin,t.isUserBuiltin=!this._isBuiltin&&!!t.isUserBuiltin,t.isUnderDevelopment=this._isUnderDevelopment;let n=[];return b.isValidExtensionDescription(this._ourVersion,this._absoluteFolderPath,t,n)?(n.forEach(e=>{this._log.warn(this._absoluteFolderPath,e)}),t.publisher||(t.publisher="undefined_publisher"),t.id=`${t.publisher}.${t.name}`,t.identifier=new f.ExtensionIdentifier(t.id),t.extensionLocation=l.URI.file(this._absoluteFolderPath),t):(n.forEach(e=>{this._log.error(this._absoluteFolderPath,e)}),null)}static isValidExtensionDescription(e,t,r,s){
return!!b.baseIsValidExtensionDescription(t,r,s)&&(i.valid(r.version)?d.isValidExtensionVersion(e,r,s):(s.push(n.localize(6,null)),!1))}static baseIsValidExtensionDescription(e,t,i){if(!t)return i.push(n.localize(7,null)),!1;if(void 0!==t.publisher&&"string"!=typeof t.publisher)return i.push(n.localize(8,null)),!1;if("string"!=typeof t.name)return i.push(n.localize(9,null,"name")),!1;if("string"!=typeof t.version)return i.push(n.localize(10,null,"version")),!1;if(!t.engines)return i.push(n.localize(11,null,"engines")),!1;if("string"!=typeof t.engines.vscode)return i.push(n.localize(12,null,"engines.vscode")),!1;if(void 0!==t.extensionDependencies&&!b._isStringArray(t.extensionDependencies))return i.push(n.localize(13,null,"extensionDependencies")),!1;if(void 0!==t.activationEvents){if(!b._isStringArray(t.activationEvents))return i.push(n.localize(14,null,"activationEvents")),!1;if(void 0===t.main&&void 0===t.browser)return i.push(n.localize(15,null,"activationEvents","main")),!1}if(void 0!==t.main){
if("string"!=typeof t.main)return i.push(n.localize(16,null,"main")),!1;{const s=r.join(e,t.main);s.startsWith(e)||i.push(n.localize(17,null,s,e))}if(void 0===t.activationEvents)return i.push(n.localize(18,null,"activationEvents","main")),!1}if(void 0!==t.browser){if("string"!=typeof t.browser)return i.push(n.localize(19,null,"browser")),!1;{const s=r.join(e,t.browser);s.startsWith(e)||i.push(n.localize(20,null,s,e))}if(void 0===t.activationEvents)return i.push(n.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(e){if(!Array.isArray(e))return!1;for(let t=0,n=e.length;t<n;t++)if("string"!=typeof e[t])return!1;return!0}}class w{constructor(e,t,n,r,i,s,o,a){this.ourVersion=e,this.commit=t,this.locale=n,this.devMode=r,this.absoluteFolderPath=i,this.isBuiltin=s,this.isUnderDevelopment=o,this.translations=a}static createNLSConfig(e){return{devMode:e.devMode,locale:e.locale,pseudo:"pseudo"===e.locale,translations:e.translations}}static equals(e,t){
return e.ourVersion===t.ourVersion&&e.commit===t.commit&&e.locale===t.locale&&e.devMode===t.devMode&&e.absoluteFolderPath===t.absoluteFolderPath&&e.isBuiltin===t.isBuiltin&&e.isUnderDevelopment===t.isUnderDevelopment&&e.mtime===t.mtime&&p.Translations.equals(e.translations,t.translations)}}t.ExtensionScannerInput=w;class _{constructor(e){this.root=e}resolveExtensions(){return u.readDirsInDir(this.root).then(e=>e.map(e=>({name:e,path:r.join(this.root,e)})))}}t.ExtensionScanner=class{static scanExtension(e,t,n,i,s,o){return n=r.normalize(n),new v(e,t,n,i,s).parse().then(r=>{if(null===r)return null;return new y(e,t,n,i,s,o).replaceNLS(r)}).then(r=>{if(null===r)return null;return new b(e,t,n,i,s).validate(r)})}static async scanExtensions(e,t,n=null){const s=e.absoluteFolderPath,a=e.isBuiltin,c=e.isUnderDevelopment;n||(n=new _(s));try{let l={};if(!a)try{const e=await u.readFile(r.join(s,".obsolete"),"utf8");l=JSON.parse(e)}catch(e){}let d=await n.resolveExtensions();d.sort((e,t)=>e.name<t.name?-1:1),
a||(d=d.filter(e=>0!==e.name.indexOf(".")));const f=w.createNLSConfig(e);let p=await Promise.all(d.map(n=>this.scanExtension(e.ourVersion,t,n.path,a,c,f))),m=o.coalesce(p);if(m=m.filter(e=>null!==e&&!l[new h.ExtensionIdentifierWithVersion({id:h.getGalleryExtensionId(e.publisher,e.name)},e.version).key()]),!a){m=h.groupByExtension(m,e=>({id:e.identifier.value,uuid:e.uuid})).map(e=>e.sort((e,t)=>i.rcompare(e.version,t.version))[0])}return m.sort((e,t)=>e.extensionLocation.fsPath<t.extensionLocation.fsPath?-1:1),m}catch(e){return t.error(s,e),[]}}static scanOneOrMultipleExtensions(e,t){const n=e.absoluteFolderPath,i=e.isBuiltin,s=e.isUnderDevelopment;return u.fileExists(r.join(n,m)).then(r=>{if(r){const r=w.createNLSConfig(e);return this.scanExtension(e.ourVersion,t,n,i,s,r).then(e=>null===e?[]:[e])}return this.scanExtensions(e,t)},e=>(t.error(n,e),[]))}static scanSingleExtension(e,t){const n=e.absoluteFolderPath,r=e.isBuiltin,i=e.isUnderDevelopment,s=w.createNLSConfig(e)
;return this.scanExtension(e.ourVersion,t,n,r,i,s)}static mergeBuiltinExtensions(e,t){return Promise.all([e,t]).then(([e,t])=>{let n=Object.create(null);for(let t=0,r=e.length;t<r;t++)n[f.ExtensionIdentifier.toKey(e[t].identifier)]=e[t];for(let e=0,r=t.length;e<r;e++)n[f.ExtensionIdentifier.toKey(t[e].identifier)]=t[e];let i=Object.keys(n).map(e=>n[e]);return i.sort((e,t)=>{const n=r.basename(e.extensionLocation.fsPath),i=r.basename(t.extensionLocation.fsPath);return n<i?-1:n>i?1:0}),i})}}})),define(t[214],n([0,1,5,4,38,153,14,8,24,213,41,59,96,51,79,191,2]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p,m,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAgentEnvironmentChannel=void 0;let v=null;let y=null;function b(){return y||(y=g.normalize(g.join(a.FileAccess.asFileUri("",e).fsPath,"..",".build","builtInExtensions"))),y}class w{constructor(e,t,n,r,i){this._connectionToken=e,this.environmentService=t,this.logService=n,this.telemetryService=r,this.telemetryAppender=i,this._logger=new class{
error(e,t){n.error(e,t)}warn(e,t){n.warn(e,t)}info(e,t){n.info(e,t)}}}async call(e,t,n){switch(t){case"disableTelemetry":return void this.telemetryService.setEnabled(!1);case"getEnvironmentData":{const e=n,t=i.createRemoteURITransformer(e.remoteAuthority);let r=await this._getEnvironmentData();return r=h.transformOutgoingURIs(r,t)}case"scanExtensions":{const e=n,t=e.language;this.logService.trace(`Scanning extensions using UI language: ${t}`);const s=i.createRemoteURITransformer(e.remoteAuthority),o=e.extensionDevelopmentPath&&e.extensionDevelopmentPath.map(e=>r.URI.revive(s.transformIncoming(e))),c=o?o.filter(e=>e.scheme===a.Schemas.file).map(e=>e.fsPath):void 0;let l=await this._scanExtensions(t,c);return l=h.transformOutgoingURIs(l,s),w._massageWhenConditions(l),l}case"scanSingleExtension":{const e=n,t=e.language,s=e.isBuiltin,o=i.createRemoteURITransformer(e.remoteAuthority),c=r.URI.revive(o.transformIncoming(e.extensionLocation)),l=c.scheme===a.Schemas.file?c.fsPath:null;if(!l)return null
;const u=await this._getTranslations(t);let d=await this._scanSingleExtension(l,s,t,u);return d?(d=h.transformOutgoingURIs(d,o),w._massageWhenConditions([d]),d):null}case"getDiagnosticInfo":{const e=n,t={machineInfo:m.getMachineInfo()},s=e.includeProcesses?p.listProcesses(process.pid):Promise.resolve();let o=[];const a={};if(e.folders){const t=i.createRemoteURITransformer("");o=e.folders.map(e=>r.URI.revive(t.transformIncoming(e))).filter(e=>"file"===e.scheme).map(e=>m.collectWorkspaceStats(e.fsPath,["node_modules",".git"]).then(t=>{a[g.basename(e.fsPath)]=t}))}return Promise.all([s,...o]).then(([n,r])=>(t.processes=n||void 0,t.workspaceMetadata=e.folders?a:void 0,t))}case"logTelemetry":{const{eventName:e,data:t}=n;return this.telemetryAppender?this.telemetryAppender.log(e,t):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${t} not found`)}listen(e,t,n){throw new Error("Not supported")}
static _massageWhenConditions(e){const t=(e,t)=>e.replace(/file/g,"vscode-remote"),n=new class{mapDefined(e){return f.ContextKeyDefinedExpr.create(e)}mapNot(e){return f.ContextKeyNotExpr.create(e)}mapEquals(e,n){return"resourceScheme"===e&&"string"==typeof n?f.ContextKeyEqualsExpr.create(e,t(n)):f.ContextKeyEqualsExpr.create(e,n)}mapNotEquals(e,n){return"resourceScheme"===e&&"string"==typeof n?f.ContextKeyNotEqualsExpr.create(e,t(n)):f.ContextKeyNotEqualsExpr.create(e,n)}mapRegex(e,n){return"resourceScheme"===e&&n?f.ContextKeyRegexExpr.create(e,(e=>{let n="";return n+=e.global?"g":"",n+=e.ignoreCase?"i":"",n+=e.multiline?"m":"",new RegExp(t(e.source),n)})(n)):f.ContextKeyRegexExpr.create(e,n)}mapIn(e,t){return f.ContextKeyInExpr.create(e,t)}},r=e=>{if(!e||!e.when||!/resourceScheme/.test(e.when))return;const t=f.ContextKeyExpr.deserialize(e.when);if(!t)return;const r=t.map(n);e.when=r.serialize()},i=e=>{if(Array.isArray(e))for(let t of e)r(t);else r(e)},s=e=>{for(let t in e)i(e[t])};e.forEach(e=>{
e.contributes&&(e.contributes.menus&&s(e.contributes.menus),e.contributes.keybindings&&i(e.contributes.keybindings),e.contributes.views&&s(e.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:r.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:r.URI.file(this.environmentService.logsPath),extensionsPath:r.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:r.URI.file(g.join(this.environmentService.logsPath,`exthost${w._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:n.OS}}async _getTranslations(e){const t=await d.getNLSConfiguration(e,this.environmentService.userDataPath);if(!d.InternalNLSConfiguration.is(t))return Object.create(null);try{const e=await o.readFile(t._translationsConfigFile,"utf8");return JSON.parse(e)}catch(e){
return Object.create(null)}}async _scanExtensions(e,t){const n=await this._getTranslations(e),[r,i,o]=await Promise.all([this._scanBuiltinExtensions(e,n),this._scanInstalledExtensions(e,n),this._scanDevelopedExtensions(e,n,t)]);let a=new Map;r.forEach(e=>{e&&a.set(u.ExtensionIdentifier.toKey(e.identifier),e)}),i.forEach(e=>{e&&(a.has(u.ExtensionIdentifier.toKey(e.identifier))&&console.warn(s.localize(0,null,a.get(u.ExtensionIdentifier.toKey(e.identifier)).extensionLocation.fsPath,e.extensionLocation.fsPath)),a.set(u.ExtensionIdentifier.toKey(e.identifier),e))}),o.forEach(e=>{e&&a.set(u.ExtensionIdentifier.toKey(e.identifier),e)});const c=[];return a.forEach(e=>c.push(e)),c}_scanDevelopedExtensions(e,t,n){if(n){const r=n.map(n=>l.ExtensionScanner.scanOneOrMultipleExtensions(new l.ExtensionScannerInput(c.default.version,c.default.commit,e,!0,n,!1,!0,t),this._logger));return Promise.all(r).then(e=>{let t=[];for(let n of e)t=t.concat(n);return t})}return Promise.resolve([])}_scanBuiltinExtensions(t,n){
const r=c.default.version,i=c.default.commit,s=!!process.env.VSCODE_DEV,o=new l.ExtensionScannerInput(r,i,t,s,(v||(v=g.normalize(g.join(a.FileAccess.asFileUri("",e).fsPath,"..","extensions"))),v),!0,!1,n),u=l.ExtensionScanner.scanExtensions(o,this._logger);let h=u;if(s){class e{constructor(e){this.builtInExtensions=e}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(e=>({name:e.name,path:g.join(b(),e.name)})))}}const n=Promise.resolve(c.default.builtInExtensions||[]),o=new l.ExtensionScannerInput(r,i,t,s,b(),!0,!1,{}),a=n.then(t=>new e(t)).then(e=>l.ExtensionScanner.scanExtensions(o,this._logger,e));h=l.ExtensionScanner.mergeBuiltinExtensions(u,a)}return h}_scanInstalledExtensions(e,t){const n=!!process.env.VSCODE_DEV,r=new l.ExtensionScannerInput(c.default.version,c.default.commit,e,n,this.environmentService.extensionsPath,!1,!1,t);return l.ExtensionScanner.scanExtensions(r,this._logger)}_scanSingleExtension(e,t,n,r){
const i=!!process.env.VSCODE_DEV,s=new l.ExtensionScannerInput(c.default.version,c.default.commit,n,i,e,t,!1,r);return l.ExtensionScanner.scanSingleExtension(s,this._logger)}}t.RemoteAgentEnvironmentChannel=w,w._namePool=1})),define(t[215],n([0,1,6,3,4,21,19,45,15,49]),(function(e,t,n,r,i,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteFileSystemProvider=t.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,t.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class u extends r.Disposable{constructor(e){super(),this.session=s.generateUuid(),this._onDidChange=this._register(new n.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new n.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new n.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event;const r=e.getConnection();this.channel=r.getChannel(t.REMOTE_FILE_SYSTEM_CHANNEL_NAME),this.setCaseSensitive(!0),(async()=>{
const t=await e.getEnvironment();this.setCaseSensitive(3===(null==t?void 0:t.os))})(),this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(e=>{if(Array.isArray(e)){const t=e;this._onDidChange.fire(t.map(e=>({resource:i.URI.revive(e.resource),type:e.type})))}else{const t=e;this._onDidWatchErrorOccur.fire(t)}}))}setCaseSensitive(e){let t=30;e&&(t|=1024),this._capabilities=t,this._onDidChangeCapabilities.fire(void 0)}stat(e){return this.channel.call("stat",[e])}open(e,t){return this.channel.call("open",[e,t])}close(e){return this.channel.call("close",[e])}async read(e,t,n,r,i){const[s,o]=await this.channel.call("read",[e,t,i]);return n.set(s.buffer.slice(0,o),r),o}async readFile(e){return(await this.channel.call("readFile",[e])).buffer}readFileStream(e,t,n){const r=a.newWriteableStream(e=>o.VSBuffer.concat(e.map(e=>o.VSBuffer.wrap(e))).buffer),i=this.channel.listen("readFileStream",[e,t])(e=>{
if(e instanceof o.VSBuffer)r.write(e.buffer);else{if("end"===e)r.end();else{let t=e;t instanceof Error||(t=new Error(l.toErrorMessage(t))),r.end(t)}i.dispose()}});return n.onCancellationRequested(()=>{r.end(c.canceled()),i.dispose()}),r}write(e,t,n,r,i){return this.channel.call("write",[e,t,o.VSBuffer.wrap(n),r,i])}writeFile(e,t,n){return this.channel.call("writeFile",[e,o.VSBuffer.wrap(t),n])}delete(e,t){return this.channel.call("delete",[e,t])}mkdir(e){return this.channel.call("mkdir",[e])}readdir(e){return this.channel.call("readdir",[e])}rename(e,t,n){return this.channel.call("rename",[e,t,n])}copy(e,t,n){return this.channel.call("copy",[e,t,n])}watch(e,t){const n=Math.random();return this.channel.call("watch",[this.session,n,e,t]),r.toDisposable(()=>this.channel.call("unwatch",[this.session,n]))}}t.RemoteFileSystemProvider=u})),define(t[216],n([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IRemoteAgentService=t.RemoteExtensionLogFileName=void 0,
t.RemoteExtensionLogFileName="remoteagent",t.IRemoteAgentService=n.createDecorator("remoteAgentService")})),define(t[68],n([0,1,136,2,20,17,14,228,229,11]),(function(e,t,n,r,i,s,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class u extends Error{constructor(e,t){let n=t.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`}super(n),this.type=e,this.cause=t}}function h(e){if(e instanceof u)return e;let t=void 0;return/end of central directory record signature not found/.test(e.message)&&(t="CorruptZip"),new u(t,e)}function d(e,t,a,c){let l=s.createCancelablePromise(()=>Promise.resolve()),h=0;return c.onCancellationRequested(()=>{l.cancel(),e.close()}),new Promise((d,f)=>{const m=new s.Sequencer,g=t=>{t.isCancellationRequested||(h++,e.readEntry())};e.once("error",f),e.once("close",()=>l.then(()=>{c.isCancellationRequested||e.entryCount===h?d():f(new u("Incomplete",new Error(n.localize(1,null,h,e.entryCount))))},f)),e.readEntry(),
e.on("entry",u=>{if(c.isCancellationRequested)return;if(!a.sourcePathRegex.test(u.fileName))return void g(c);const h=u.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(h)){const e=r.join(t,h);return void(l=s.createCancelablePromise(t=>o.mkdirp(e).then(()=>g(t)).then(void 0,f)))}const d=p(e,u),v=function(e){const t=e.externalFileAttributes>>16||33188;return[448,56,7].map(e=>t&e).reduce((e,t)=>e+t,61440&t)}(u);l=s.createCancelablePromise(e=>m.queue(()=>d.then(s=>(function(e,t,s,a,c,l){const u=r.dirname(t),h=r.join(a,u);if(!h.startsWith(a))return Promise.reject(new Error(n.localize(0,null,t)));const d=r.join(a,t);let f;return l.onCancellationRequested(()=>{f&&f.destroy()}),Promise.resolve(o.mkdirp(h)).then(()=>new Promise((t,n)=>{if(!l.isCancellationRequested)try{(f=i.createWriteStream(d,{mode:s})).once("close",()=>t()),f.once("error",n),e.once("error",n),e.pipe(f)}catch(e){n(e)}}))})(s,h,v,t,0,e).then(()=>g(e)))).then(null,f))})})}function f(e,t=!1){return new Promise((n,r)=>{a.open(e,t?{lazyEntries:!0
}:void 0,(e,t)=>{e?r(h(e)):n(l.assertIsDefined(t))})})}function p(e,t){return new Promise((n,r)=>{e.openReadStream(t,(e,t)=>{e?r(h(e)):n(l.assertIsDefined(t))})})}t.ExtractError=u,t.zip=function(e,t){return new Promise((n,r)=>{const s=new c.ZipFile;t.forEach(e=>{e.contents?s.addBuffer("string"==typeof e.contents?Buffer.from(e.contents,"utf8"):e.contents,e.path):e.localPath&&s.addFile(e.localPath,e.path)}),s.end();const o=i.createWriteStream(e);s.outputStream.pipe(o),s.outputStream.once("error",r),o.once("error",r),o.once("finish",()=>n(e))})},t.extract=function(e,t,n={},r){const i=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let s=f(e,!0);return n.overwrite&&(s=s.then(e=>o.rimraf(t).then(()=>e))),s.then(e=>d(e,t,{sourcePathRegex:i},r))},t.buffer=function(e,t){return function(e,t){return f(e).then(e=>new Promise((r,i)=>{e.on("entry",n=>{n.fileName===t&&p(e,n).then(e=>r(e),e=>i(e))}),e.once("close",()=>i(new Error(n.localize(2,null,t))))}))}(e,t).then(e=>new Promise((t,n)=>{const r=[];e.once("error",n),
e.on("data",e=>r.push(e)),e.on("end",()=>t(Buffer.concat(r)))}))}})),define(t[106],n([0,1,68,142]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0,t.getManifest=function(e){return n.buffer(e,"extension/package.json").then(e=>{try{return JSON.parse(e.toString("utf8"))}catch(e){throw new Error(r.localize(0,null))}})}})),define(t[217],n([0,1,53,3,14,2,12,31,34,17,4,26,164,143,42,68,5,16,8]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g,v,y,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;let _=class extends r.Disposable{constructor(e,t,n,r){super(),this.beforeRemovingExtension=e,this.logService=t,this.environmentService=n,this.productService=r,this._devSystemExtensionsPath=null,this.systemExtensionsPath=n.builtinExtensionsPath,this.extensionsPath=n.extensionsPath,this.uninstalledPath=a.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new h.Queue}async cleanUp(){await this.removeUninstalledExtensions(),
await this.removeOutdatedExtensions()}async scanExtensions(e){const t=[];null!==e&&0!==e||t.push(this.scanSystemExtensions().then(null,e=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(e).message,"scanningSystem")))),null!==e&&1!==e||t.push(this.scanUserExtensions(!0).then(null,e=>Promise.reject(new l.ExtensionManagementError(this.joinErrors(e).message,"scanningUser"))));try{const e=await Promise.all(t);return b.flatten(e)}catch(e){throw this.joinErrors(e)}}async scanUserExtensions(e){this.logService.trace("Started scanning user extensions");let[t,r]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);if(r=r.filter(e=>!t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()]),e){r=u.groupByExtension(r,e=>e.identifier).map(e=>e.sort((e,t)=>n.rcompare(e.manifest.version,t.manifest.version))[0])}return this.logService.trace("Scanned user extensions:",r.length),r}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}
async extractUserExtension(e,t,n){const r=e.key(),s=a.join(this.extensionsPath,`.${r}`),o=a.join(this.extensionsPath,r);try{await i.rimraf(o)}catch(t){try{await i.rimraf(o)}catch(e){}throw new l.ExtensionManagementError(m.localize(0,null,o,e.id),"deleting")}await this.extractAtLocation(e,t,s,n);try{await this.rename(e,s,o,Date.now()+12e4),this.logService.info("Renamed to",o)}catch(e){this.logService.info("Rename failed. Deleting from extracted location",s);try{i.rimraf(s)}catch(e){}throw e}let c=null;try{c=await this.scanExtension(r,this.extensionsPath,1)}catch(e){}if(c)return c;throw new Error(m.localize(1,null,this.extensionsPath))}async saveMetadataForLocalExtension(e,t){this.setMetadata(e,t),t.isMachineScoped=t.isMachineScoped||void 0,t.isBuiltin=t.isBuiltin||void 0;const n=a.join(e.location.fsPath,"package.json"),r=await i.readFile(n,"utf8"),{manifest:s}=await this.parseManifest(r);return s.__metadata=t,await i.writeFile(n,JSON.stringify(s,null,"\t")),e}getUninstalledExtensions(){
return this.withUninstalledExtensions(e=>e)}async withUninstalledExtensions(e){return this.uninstalledFileLimiter.queue(async()=>{let t;try{t=await i.readFile(this.uninstalledPath,"utf8")}catch(e){if("ENOENT"!==e.code)throw e}let n={};if(t)try{n=JSON.parse(t)}catch(e){}const r=e(n);return Object.keys(n).length?await i.writeFile(this.uninstalledPath,JSON.stringify(n)):await i.rimraf(this.uninstalledPath),r})}async removeExtension(e,t){this.logService.trace(`Deleting ${t} extension from disk`,e.identifier.id,e.location.fsPath),await i.rimraf(e.location.fsPath),this.logService.info("Deleted from disk",e.identifier.id,e.location.fsPath)}async removeUninstalledExtension(e){await this.removeExtension(e,"uninstalled"),await this.withUninstalledExtensions(t=>delete t[new u.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version).key()])}async extractAtLocation(e,t,n,r){this.logService.trace(`Started extracting the extension from ${t} to ${n}`);try{await i.rimraf(n)}catch(e){
throw new l.ExtensionManagementError(this.joinErrors(e).message,"deleting")}try{await v.extract(t,n,{sourcePath:"extension",overwrite:!0},r),this.logService.info(`Extracted extension to ${n}:`,e.id)}catch(e){try{await i.rimraf(n)}catch(e){}throw new l.ExtensionManagementError(e.message,e instanceof v.ExtractError&&e.type?e.type:"extracting")}}async rename(e,t,n,r){try{await i.rename(t,n)}catch(i){if(y.isWindows&&i&&"EPERM"===i.code&&Date.now()<r)return this.logService.info(`Failed renaming ${t} to ${n} with 'EPERM' error. Trying again...`,e.id),this.rename(e,t,n,r);throw new l.ExtensionManagementError(i.message||m.localize(2,null,t,n),i.code||"renaming")}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const e=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return e;const t=this.scanDevSystemExtensions(),[n,r]=await Promise.all([e,t]);return[...n,...r]}async scanExtensionsInDir(e,t){const n=new h.Limiter(10),r=await i.readdir(e)
;return(await Promise.all(r.map(r=>n.queue(()=>this.scanExtension(r,e,t))))).filter(e=>e&&e.identifier)}async scanExtension(e,t,n){if(1===n&&0===e.indexOf("."))return null;const r=a.join(t,e);try{const e=await i.readdir(r),{manifest:t,metadata:s}=await this.readManifest(r),o=e.filter(e=>/^readme(\.txt|\.md|)$/i.test(e))[0],c=o?d.URI.file(a.join(r,o)):void 0,l=e.filter(e=>/^changelog(\.txt|\.md|)$/i.test(e))[0],h=l?d.URI.file(a.join(r,l)):void 0,f={type:n,identifier:{id:u.getGalleryExtensionId(t.publisher,t.name)},manifest:t,location:d.URI.file(r),readmeUrl:c,changelogUrl:h,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:0===n};return s&&this.setMetadata(f,s),f}catch(e){return this.logService.trace(e),null}}async scanDefaultSystemExtensions(){const e=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",e.length),e}async scanDevSystemExtensions(){const e=this.getDevSystemExtensionsList();if(e.length){
const t=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",t.length),t.filter(t=>e.some(e=>u.areSameExtensions(t.identifier,{id:e})))}return[]}setMetadata(e,t){e.publisherDisplayName=t.publisherDisplayName||null,e.publisherId=t.publisherId||null,e.identifier.uuid=t.id,e.isMachineScoped=!!t.isMachineScoped,e.isBuiltin=0===e.type||!!t.isBuiltin}async removeUninstalledExtensions(){const e=await this.getUninstalledExtensions(),t=await this.scanAllUserExtensions(),r=new Set;for(const n of t)e[new u.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()]||r.add(n.identifier.id.toLowerCase());const i=u.groupByExtension(t,e=>e.identifier);await Promise.all(i.map(async e=>{const t=e.sort((e,t)=>n.rcompare(e.manifest.version,t.manifest.version))[0];r.has(t.identifier.id.toLowerCase())||await this.beforeRemovingExtension(t)}));const s=t.filter(t=>e[new u.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])
;await Promise.all(s.map(e=>this.removeUninstalledExtension(e)))}async removeOutdatedExtensions(){const e=await this.scanAllUserExtensions(),t=[],r=u.groupByExtension(e,e=>e.identifier);t.push(...b.flatten(r.map(e=>e.sort((e,t)=>n.rcompare(e.manifest.version,t.manifest.version)).slice(1)))),await Promise.all(t.map(e=>this.removeExtension(e,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(e=>e.name)}joinErrors(e){const t=Array.isArray(e)?e:[e];return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=a.normalize(a.join(w.FileAccess.asFileUri("",e).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(e){
const t=[i.readFile(a.join(e,"package.json"),"utf8").then(e=>this.parseManifest(e)),i.readFile(a.join(e,"package.nls.json"),"utf8").then(void 0,e=>"ENOENT"!==e.code?Promise.reject(e):"{}").then(e=>JSON.parse(e))],[{manifest:n,metadata:r},s]=await Promise.all(t);return{manifest:p.localizeManifest(n,s),metadata:r}}parseManifest(e){return new Promise((t,n)=>{try{const n=JSON.parse(e);t({manifest:n,metadata:n.__metadata||null})}catch(e){n(new Error(m.localize(3,null)))}})}};_=s([o(1,c.ILogService),o(2,f.INativeEnvironmentService),o(3,g.IProductService)],_),t.ExtensionsScanner=_})),define(t[69],n([0,1,141,2,14,3,16,68,31,34,26,17,6,53,4,24,5,12,173,49,37,62,22,21,84,7,8,28,106,176,217,177]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g,v,y,b,w,_,E,S,C,x,I,k,T,P,R,O,L,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;let A=class extends a.Disposable{constructor(e,t,n,r,i,s){super(),this.environmentService=e,this.galleryService=t,this.logService=n,this.downloadService=r,
this.telemetryService=i,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const o=this._register(s.createInstance(D.ExtensionsLifecycle));this.extensionsScanner=this._register(s.createInstance(L.ExtensionsScanner,e=>o.postUninstall(e))),this.manifestCache=this._register(new w.ExtensionsManifestCache(e,this)),this.extensionsDownloader=this._register(s.createInstance(O.ExtensionsDownloader)),this._register(a.toDisposable(()=>{this.installingExtensions.forEach(e=>e.cancel()),
this.uninstallingExtensions.forEach(e=>e.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(e){this.logService.trace("ExtensionManagementService#zip",e.identifier.id);const t=await this.collectFiles(e),n=await l.zip(C.joinPath(this.environmentService.tmpDir,x.generateUuid()).fsPath,t);return g.URI.file(n)}async unzip(e){return this.logService.trace("ExtensionManagementService#unzip",e.toString()),(await this.install(e)).identifier}async getManifest(e){const t=await this.downloadVsix(e),n=r.resolve(t.fsPath);return R.getManifest(n)}async collectFiles(e){const t=async e=>{let n=await i.readdir(e);n=n.map(t=>r.join(e,t));const s=await Promise.all(n.map(e=>i.stat(e)));let o=Promise.resolve([]);return s.forEach((e,r)=>{const i=n[r];e.isFile()&&(o=o.then(e=>[...e,i])),e.isDirectory()&&(o=o.then(e=>t(i).then(t=>[...e,...t])))}),o};return(await t(e.location.fsPath)).map(t=>({path:`extension/${r.relative(e.location.fsPath,t)}`,localPath:t}))}async install(e,t={}){
return this.logService.trace("ExtensionManagementService#install",e.toString()),f.createCancelablePromise(async i=>{const s=await this.downloadVsix(e),o=r.resolve(s.fsPath),a=await R.getManifest(o),c={id:h.getGalleryExtensionId(a.publisher,a.name)};let l=1;if(a.engines&&a.engines.vscode&&!S.isEngineValid(a.engines.vscode,v.default.version))throw new Error(n.localize(0,null,c.id,v.default.version));const u=new h.ExtensionIdentifierWithVersion(c,a.version),d=(await this.getInstalled(1)).find(e=>h.areSameExtensions(c,e.identifier));if(d)if(t.isMachineScoped=t.isMachineScoped||d.isMachineScoped,t.isBuiltin=t.isBuiltin||d.isBuiltin,l=2,u.equals(new h.ExtensionIdentifierWithVersion(d.identifier,d.manifest.version)))try{await this.extensionsScanner.removeExtension(d,"existing")}catch(e){throw new Error(n.localize(1,null,a.displayName||a.name))}else m.gt(d.manifest.version,a.version)&&await this.uninstallExtension(d);else{const e=await this.unsetUninstalledAndGetLocal(u);if(e)try{
await this.extensionsScanner.removeExtension(e,"existing")}catch(e){throw new Error(n.localize(2,null,a.displayName||a.name))}}let f;this.logService.info("Installing the extension:",c.id),this._onInstallExtension.fire({identifier:c,zipPath:o});try{f=await this.getGalleryMetadata(h.getGalleryExtensionId(a.publisher,a.name))}catch(e){}try{const e=await this.installFromZipPath(u,o,Object.assign(Object.assign({},f||{}),t),t,l,i);return this.logService.info("Successfully installed the extension:",c.id),e}catch(e){throw this.logService.error("Failed to install the extension:",c.id,e.message),e}})}async downloadVsix(e){if(e.scheme===T.Schemas.file)return e;if(!this.downloadService)throw new Error("Download service is not available");const t=C.joinPath(this.environmentService.tmpDir,x.generateUuid());return await this.downloadService.download(e,t),t}async installFromZipPath(e,t,n,r,i,s){try{const o=await this.installExtension({zipPath:t,identifierWithVersion:e,metadata:n},s);try{
await this.installDependenciesAndPackExtensions(o,void 0,r)}catch(e){c.isNonEmptyArray(o.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",o.identifier.id,e.message),c.isNonEmptyArray(o.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",o.identifier.id,e.message)}return this._onDidInstallExtension.fire({identifier:e,zipPath:t,local:o,operation:i}),o}catch(n){throw this._onDidInstallExtension.fire({identifier:e,zipPath:t,operation:i,error:n}),n}}async canInstall(e){return!0}async installFromGallery(e,t={}){if(!this.galleryService.isEnabled())throw new Error(n.localize(3,null));try{e=await this.checkAndGetCompatibleVersion(e)}catch(t){const n=t&&t.code?t.code:"unknown";throw this.logService.error("Failed to install extension:",e.identifier.id,t?t.message:n),this.reportTelemetry(this.getTelemetryEvent(1),h.getGalleryExtensionTelemetryData(e),void 0,t),t instanceof Error&&(t.name=n),t}
const r=new h.ExtensionIdentifierWithVersion(e.identifier,e.version).key();let i=this.installingExtensions.get(r);return i||(i=f.createCancelablePromise(n=>this.doInstallFromGallery(e,t,n)),this.installingExtensions.set(r,i),i.finally(()=>this.installingExtensions.delete(r))),i}async doInstallFromGallery(e,t,n){const r=(new Date).getTime();let i=1;this.logService.info("Installing extension:",e.identifier.id),this._onInstallExtension.fire({identifier:e.identifier,gallery:e});try{const s=(await this.getInstalled(1)).find(t=>h.areSameExtensions(t.identifier,e.identifier));s&&(i=2);const o=await this.downloadInstallableExtension(e,i);o.metadata.isMachineScoped=t.isMachineScoped||(null==s?void 0:s.isMachineScoped),o.metadata.isBuiltin=t.isBuiltin||(null==s?void 0:s.isBuiltin);const a=await this.installExtension(o,n);try{await this.extensionsDownloader.delete(g.URI.file(o.zipPath))}catch(e){}try{await this.installDependenciesAndPackExtensions(a,s,t)}catch(e){try{await this.uninstall(a)}catch(e){}throw e}
return s&&m.neq(s.manifest.version,e.version)&&await this.setUninstalled(s),this.logService.info("Extensions installed successfully:",e.identifier.id),this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,local:a,operation:i}),this.reportTelemetry(this.getTelemetryEvent(i),h.getGalleryExtensionTelemetryData(e),(new Date).getTime()-r,void 0),a}catch(t){const n=t&&t.code?t.code:"unknown";throw this.logService.error("Failed to install extension:",e.identifier.id,t?t.message:n),this._onDidInstallExtension.fire({identifier:e.identifier,gallery:e,operation:i,error:n}),this.reportTelemetry(this.getTelemetryEvent(i),h.getGalleryExtensionTelemetryData(e),(new Date).getTime()-r,t),t instanceof Error&&(t.name=n),t}}async checkAndGetCompatibleVersion(e){if(await this.isMalicious(e))throw new u.ExtensionManagementError(n.localize(4,null),u.INSTALL_ERROR_MALICIOUS);const t=await this.galleryService.getCompatibleExtension(e)
;if(!t)throw new u.ExtensionManagementError(n.localize(5,null,e.identifier.id,v.default.version),u.INSTALL_ERROR_INCOMPATIBLE);return t}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(n.localize(6,null));const t=await this.findGalleryExtension(e);if(!t)throw new Error(n.localize(7,null));await this.setUninstalled(e);try{await this.extensionsScanner.removeUninstalledExtension(e)}catch(e){throw new Error(n.localize(8,null,_.toErrorMessage(e)))}await this.installFromGallery(t)}getTelemetryEvent(e){return 2===e?"extensionGallery:update":"extensionGallery:install"}async isMalicious(e){const t=await this.getExtensionsReport();return h.getMaliciousExtensionsSet(t).has(e.identifier.id)}async downloadInstallableExtension(e,t){const n={id:e.identifier.uuid,publisherId:e.publisherId,publisherDisplayName:e.publisherDisplayName};let r;try{
this.logService.trace("Started downloading extension:",e.identifier.id);const n=await this.extensionsDownloader.downloadExtension(e,t);this.logService.info("Downloaded extension:",e.identifier.id,r),r=n.fsPath}catch(e){throw new u.ExtensionManagementError(this.joinErrors(e).message,"downloading")}try{const t=await R.getManifest(r);return{zipPath:r,identifierWithVersion:new h.ExtensionIdentifierWithVersion(e.identifier,t.version),metadata:n}}catch(e){throw new u.ExtensionManagementError(this.joinErrors(e).message,"validating")}}async installExtension(e,t){try{const t=await this.unsetUninstalledAndGetLocal(e.identifierWithVersion);if(t)return e.metadata?this.extensionsScanner.saveMetadataForLocalExtension(t,e.metadata):t}catch(e){throw y.isMacintosh?new u.ExtensionManagementError(n.localize(9,null),"unsetUninstalled"):new u.ExtensionManagementError(n.localize(10,null),"unsetUninstalled")}return this.extractAndInstall(e,t)}async unsetUninstalledAndGetLocal(e){
return await this.isUninstalled(e)?(this.logService.trace("Removing the extension from uninstalled list:",e.id),await this.unsetUninstalled(e),this.logService.info("Removed the extension from uninstalled list:",e.id),(await this.getInstalled(1)).find(t=>new h.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(e))||null):null}async extractAndInstall({zipPath:e,identifierWithVersion:t,metadata:n},r){let i=await this.extensionsScanner.extractUserExtension(t,e,r);return this.logService.info("Installation completed.",t.id),n&&(i=await this.extensionsScanner.saveMetadataForLocalExtension(i,n)),i}async installDependenciesAndPackExtensions(e,t,n){if(!this.galleryService.isEnabled())return;const r=e.manifest.extensionDependencies||[];if(e.manifest.extensionPack)for(const n of e.manifest.extensionPack)t&&t.manifest.extensionPack&&t.manifest.extensionPack.some(e=>h.areSameExtensions({id:e},{id:n}))||r.every(e=>!h.areSameExtensions({id:e},{id:n}))&&r.push(n);if(r.length){
const e=await this.getInstalled(),t=r.filter(t=>e.every(({identifier:e})=>!h.areSameExtensions(e,{id:t})));if(t.length){const e=(await this.galleryService.query({names:t,pageSize:r.length},P.CancellationToken.None)).firstPage;try{await Promise.all(e.map(e=>this.installFromGallery(e,n)))}catch(t){try{await this.rollback(e)}catch(e){}throw t}}}}async rollback(e){const t=(await this.getInstalled(1)).filter(t=>e.some(e=>new h.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).equals(new h.ExtensionIdentifierWithVersion(e.identifier,e.version))));await Promise.all(t.map(e=>this.uninstall(e)))}async uninstall(e){this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id);const t=await this.getInstalled(1),r=t.find(t=>h.areSameExtensions(t.identifier,e.identifier));if(!r)throw new Error(n.localize(11,null,e.manifest.displayName||e.manifest.name));try{await this.checkForDependenciesAndUninstall(r,t)}catch(e){throw this.joinErrors(e)}}async updateMetadata(e,t){
return this.logService.trace("ExtensionManagementService#updateMetadata",e.identifier.id),e=await this.extensionsScanner.saveMetadataForLocalExtension(e,Object.assign(Object.assign({},e.manifest.__metadata||{}),t)),this.manifestCache.invalidate(),e}async updateExtensionScope(e,t){return this.logService.trace("ExtensionManagementService#updateExtensionScope",e.identifier.id),e=await this.extensionsScanner.saveMetadataForLocalExtension(e,Object.assign(Object.assign({},e.manifest.__metadata||{}),{isMachineScoped:t})),this.manifestCache.invalidate(),e}async getGalleryMetadata(e){const t=await this.findGalleryExtensionByName(e);return t?{id:t.identifier.uuid,publisherDisplayName:t.publisherDisplayName,publisherId:t.publisherId}:void 0}async findGalleryExtension(e){if(e.identifier.uuid){const t=await this.findGalleryExtensionById(e.identifier.uuid);return t||this.findGalleryExtensionByName(e.identifier.id)}return this.findGalleryExtensionByName(e.identifier.id)}async findGalleryExtensionById(e){
return(await this.galleryService.query({ids:[e],pageSize:1},P.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(e){return(await this.galleryService.query({names:[e],pageSize:1},P.CancellationToken.None)).firstPage[0]}joinErrors(e){const t=Array.isArray(e)?e:[e];return 1===t.length?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((e,t)=>new Error(`${e.message}${e.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}async checkForDependenciesAndUninstall(e,t){try{await this.preUninstallExtension(e);const n=this.getAllPackExtensionsToUninstall(e,t);n.length?await this.uninstallExtensions(e,n,t):await this.uninstallExtensions(e,[],t)}catch(t){throw await this.postUninstallExtension(e,new u.ExtensionManagementError(t instanceof Error?t.message:t,"local")),t}await this.postUninstallExtension(e)}async uninstallExtensions(e,t,n){const r=[e,...t];for(const t of r)this.checkForDependents(t,r,n,e);await Promise.all([this.uninstallExtension(e),...t.map(e=>this.doUninstall(e))])}
checkForDependents(e,t,n,r){const i=this.getDependents(e,n);if(i.length){const n=i.filter(e=>-1===t.indexOf(e));if(n.length)throw new Error(this.getDependentsErrorMessage(e,n,r))}}getDependentsErrorMessage(e,t,r){
return r===e?1===t.length?n.localize(12,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?n.localize(13,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(14,null,r.manifest.displayName||r.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):1===t.length?n.localize(15,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name):2===t.length?n.localize(16,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name):n.localize(17,null,r.manifest.displayName||r.manifest.name,e.manifest.displayName||e.manifest.name,t[0].manifest.displayName||t[0].manifest.name,t[1].manifest.displayName||t[1].manifest.name)}
getAllPackExtensionsToUninstall(e,t,n=[]){if(-1!==n.indexOf(e))return[];n.push(e);const r=e.manifest.extensionPack?e.manifest.extensionPack:[];if(r.length){const e=t.filter(e=>!e.isBuiltin&&r.some(t=>h.areSameExtensions({id:t},e.identifier))),i=[];for(const r of e)i.push(...this.getAllPackExtensionsToUninstall(r,t,n));return[...e,...i]}return[]}getDependents(e,t){return t.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(t=>h.areSameExtensions({id:t},e.identifier)))}async doUninstall(e){try{await this.preUninstallExtension(e),await this.uninstallExtension(e)}catch(t){throw await this.postUninstallExtension(e,new u.ExtensionManagementError(t instanceof Error?t.message:t,"local")),t}await this.postUninstallExtension(e)}async preUninstallExtension(e){if(!await i.exists(e.location.fsPath))throw new Error(n.localize(18,null));this.logService.info("Uninstalling extension:",e.identifier.id),this._onUninstallExtension.fire(e.identifier)}async uninstallExtension(e){
let t=this.uninstallingExtensions.get(e.identifier.id);return t||(t=f.createCancelablePromise(async()=>{const t=await this.extensionsScanner.scanUserExtensions(!1);await this.setUninstalled(...t.filter(t=>h.areSameExtensions(t.identifier,e.identifier)))}),this.uninstallingExtensions.set(e.identifier.id,t),t.finally(()=>this.uninstallingExtensions.delete(e.identifier.id))),t}async postUninstallExtension(e,t){if(t)this.logService.error("Failed to uninstall extension:",e.identifier.id,t.message);else if(this.logService.info("Successfully uninstalled extension:",e.identifier.id),e.identifier.uuid)try{await this.galleryService.reportStatistic(e.manifest.publisher,e.manifest.name,e.manifest.version,"uninstall")}catch(t){}this.reportTelemetry("extensionGallery:uninstall",h.getLocalExtensionTelemetryData(e),void 0,t);const n=t?t instanceof u.ExtensionManagementError?t.code:"unknown":void 0;this._onDidUninstallExtension.fire({identifier:e.identifier,error:n})}getInstalled(e=null){
return this.extensionsScanner.scanExtensions(e)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(e){return 1===(await this.filterUninstalled(e)).length}filterUninstalled(...e){return this.extensionsScanner.withUninstalledExtensions(t=>{const n=[];for(const r of e)t[r.key()]&&n.push(r.key());return n})}setUninstalled(...e){const t=e.map(e=>new h.ExtensionIdentifierWithVersion(e.identifier,e.manifest.version));return this.extensionsScanner.withUninstalledExtensions(e=>(t.forEach(t=>e[t.key()]=!0),e))}unsetUninstalled(e){return this.extensionsScanner.withUninstalledExtensions(t=>delete t[e.key()])}getExtensionsReport(){const e=(new Date).getTime();return(!this.reportedExtensions||e-this.lastReportTimestamp>3e5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=e),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsReport()
;return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${e.length} reported extensions from service`),e}catch(e){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(e,t,n,r){const i=r?r instanceof u.ExtensionManagementError?r.code:"unknown":void 0;this.telemetryService.publicLogError(e,Object.assign(Object.assign({},t),{success:!r,duration:n,errorcode:i}))}};A=s([o(0,d.INativeEnvironmentService),o(1,u.IExtensionGalleryService),o(2,b.ILogService),o(3,k.optional(I.IDownloadService)),o(4,E.ITelemetryService),o(5,k.IInstantiationService)],A),t.ExtensionManagementService=A})),define(t[70],n([0,1,230,66,3,11,15,185,29,12,19]),(function(e,t,n,r,i,a,c,l,u,h,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let f=class extends i.Disposable{constructor(e,t){super(),this.logService=t,this.configure(e.getValue()),
this._register(e.onDidChangeConfiguration(()=>this.configure(e.getValue()),this))}configure(e){this.proxyUrl=e.http&&e.http.proxy,this.strictSSL=!(!e.http||!e.http.proxyStrictSSL),this.authorization=e.http&&e.http.proxyAuthorization}async request(e,t){this.logService.trace("RequestService#request",e.url);const{proxyUrl:n,strictSSL:r}=this,i=e.agent?e.agent:await l.getProxyAgent(e.url||"",{proxyUrl:n,strictSSL:r});return e.agent=i,e.strictSSL=r,this.authorization&&(e.headers=Object.assign(Object.assign({},e.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(e,t)}async getNodeRequest(t){return("https:"===r.parse(t.url).protocol?await new Promise((t,n)=>{e(["https"],t,n)}):await new Promise((t,n)=>{e(["http"],t,n)})).request}_request(e,t){return new Promise(async(i,s)=>{let o;const l=r.parse(e.url),u=e.getRawRequest?e.getRawRequest(e):await this.getNodeRequest(e),h={hostname:l.hostname,port:l.port?parseInt(l.port):"https:"===l.protocol?443:80,protocol:l.protocol,path:l.path,
method:e.type||"GET",headers:e.headers,agent:e.agent,rejectUnauthorized:!a.isBoolean(e.strictSSL)||e.strictSSL};e.user&&e.password&&(h.auth=e.user+":"+e.password),(o=u(h,r=>{const o=a.isNumber(e.followRedirects)?e.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&o>0&&r.headers.location)this._request(Object.assign(Object.assign({},e),{url:r.headers.location,followRedirects:o-1}),t).then(i,s);else{let e=r;"gzip"===r.headers["content-encoding"]&&(e=r.pipe(n.createGunzip())),i({res:r,stream:d.streamToBufferReadableStream(e)})}})).on("error",s),e.timeout&&o.setTimeout(e.timeout),e.data&&"string"==typeof e.data&&o.write(e.data),o.end(),t.onCancellationRequested(()=>{o.abort(),s(c.canceled())})})}async resolveProxy(e){}};f=s([o(0,u.IConfigurationService),o(1,h.ILogService)],f),t.RequestService=f})),
define(t[218],n([0,1,137,17,53,24,2,52,50,7,63,26,90,31,69,67,37,56,92,94,55,70,29,65,93,14,47,187,188,12,15,34,4,106,41,28,88,8,89,193,64,27,54,3,42]),(function(e,t,n,r,i,a,c,l,u,h,d,f,p,m,g,v,y,b,w,_,E,S,C,x,I,k,T,P,R,O,L,D,A,N,M,F,U,j,z,$,B,W,V,H,K){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=t.Main=t.getIdAndVersion=void 0;const q=e=>n.localize(1,null,e),G=n.localize(2,null,"ms-dotnettools.csharp");function X(e,t){return t?`${e.publisher}.${e.name}@${e.version}`:`${e.publisher}.${e.name}`}const Y=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function Q(e){const t=Y.exec(e);return t&&t[1]?[D.adoptToGalleryExtensionId(t[1]),t[2]]:[D.adoptToGalleryExtensionId(e),void 0]}t.getIdAndVersion=Q;let J=class{constructor(e,t,n,r){this.instantiationService=e,this.environmentService=t,this.extensionManagementService=n,this.extensionGalleryService=r}async run(e){
e["install-source"]?await this.setInstallSource(e["install-source"]):e["list-extensions"]?await this.listExtensions(!!e["show-versions"],e.category):e["install-extension"]||e["install-builtin-extension"]?await this.installExtensions(e["install-extension"]||[],e["install-builtin-extension"]||[],!!e["do-not-sync"],!!e.force):e["uninstall-extension"]?await this.uninstallExtension(e["uninstall-extension"],!!e.force):e["locate-extension"]?await this.locateExtension(e["locate-extension"]):e.telemetry&&console.log($.buildTelemetryMessage(this.environmentService.appRoot,this.environmentService.extensionsPath?this.environmentService.extensionsPath:void 0))}setInstallSource(e){return k.writeFile(this.environmentService.installSourcePath,e.slice(0,30))}async listExtensions(e,t){let n=await this.extensionManagementService.getInstalled(1);const r=M.EXTENSION_CATEGORIES.map(e=>e.toLowerCase());if(t&&""!==t){
if(r.indexOf(t.toLowerCase())<0)return void console.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");n=n.filter(e=>{if(e.manifest.categories){return e.manifest.categories.map(e=>e.toLowerCase()).indexOf(t.toLowerCase())>-1}return!1})}else if(""===t)return console.log("Possible Categories: "),void r.forEach(e=>{console.log(e)});n.forEach(t=>console.log(X(t.manifest,e)))}async installExtensions(e,t,r,i){const s=[],o=[];e.length&&console.log(n.localize(3,null));const a=[],c=[];for(const t of e)if(/\.vsix$/i.test(t))a.push(t);else{const[e,n]=Q(t);c.push({id:e,version:n,installOptions:{isBuiltin:!1,isMachineScoped:r}})}for(const e of t){const[t,n]=Q(e);c.push({id:t,version:n,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}a.length&&await Promise.all(a.map(async e=>{try{const t=await this.installVSIX(e,i);t&&o.push(t)}catch(t){console.error(t.message||t.stack||t),s.push(e)}}))
;const[l,u]=await Promise.all([this.getGalleryExtensions(c),this.extensionManagementService.getInstalled(1)]);if(await Promise.all(c.map(async e=>{const t=l.get(e.id.toLowerCase());if(t)try{const n=await this.installFromGallery(e,t,u,i);n&&o.push(n)}catch(t){console.error(t.message||t.stack||t),s.push(e.id)}else console.error(`${(e=>n.localize(0,null,e))(e.version?`${e.id}@${e.version}`:e.id)}\n${G}`),s.push(e.id)})),o.some(e=>M.isLanguagePackExtension(e))&&await this.updateLocalizationsCache(),s.length)throw new Error(n.localize(4,null,s.join(", ")))}async installVSIX(e,t){e=c.isAbsolute(e)?e:c.join(process.cwd(),e);const r=await N.getManifest(e);if(await this.validate(r,t))try{return await this.extensionManagementService.install(A.URI.file(e)),console.log(n.localize(5,null,T.getBaseLabel(e))),r}catch(t){if(L.isPromiseCanceledError(t))return console.log(n.localize(6,null,T.getBaseLabel(e))),null;throw t}return null}async getGalleryExtensions(e){
const t=e.filter(({version:e})=>void 0===e).map(({id:e})=>e),n=e.filter(({version:e})=>void 0!==e),r=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(t,F.CancellationToken.None)).forEach(e=>r.set(e.identifier.id.toLowerCase(),e))})(),Promise.all(n.map(async({id:e,version:t})=>{const n=await this.extensionGalleryService.getCompatibleExtension({id:e},t);n&&r.set(n.identifier.id.toLowerCase(),n)}))]),r}async installFromGallery({id:e,version:t,installOptions:r},i,s,o){const a=await this.extensionGalleryService.getManifest(i,F.CancellationToken.None),c=s.find(e=>D.areSameExtensions(e.identifier,i.identifier));if(c){if(i.version===c.manifest.version)return console.log(n.localize(7,null,t?`${e}@${t}`:e)),null;if(!t&&!o)return console.log(n.localize(8,null,e,c.manifest.version,i.version)),null;console.log(n.localize(9,null,e,i.version))}try{return r.isBuiltin?console.log(n.localize(10,null,e,i.version)):console.log(n.localize(11,null,e,i.version)),
await this.extensionManagementService.installFromGallery(i,r),console.log(n.localize(12,null,e,i.version)),a}catch(t){if(L.isPromiseCanceledError(t))return console.log(n.localize(13,null,e)),null;throw t}}async validate(e,t){if(!e)throw new Error("Invalid vsix");const r={id:D.getGalleryExtensionId(e.publisher,e.name)},s=(await this.extensionManagementService.getInstalled(1)).find(t=>D.areSameExtensions(r,t.identifier)&&i.gt(t.manifest.version,e.version));return!(s&&!t)||(console.log(n.localize(14,null,s.identifier.id,s.manifest.version,e.version)),!1)}async uninstallExtension(e,t){async function r(e){if(!/\.vsix$/i.test(e))return e;const t=c.isAbsolute(e)?e:c.join(process.cwd(),e);return X(await N.getManifest(t))}const i=[];for(const s of e){const e=await r(s),o=(await this.extensionManagementService.getInstalled()).find(t=>D.areSameExtensions(t.identifier,{id:e}));if(!o)throw new Error(`${q(e)}\n${G}`);if(0===o.type)return void console.log(n.localize(15,null,e))
;if(o.isBuiltin&&!t)return void console.log(n.localize(16,null,e));console.log(n.localize(17,null,e)),await this.extensionManagementService.uninstall(o,!0),i.push(o),console.log(n.localize(18,null,e))}i.some(e=>M.isLanguagePackExtension(e.manifest))&&await this.updateLocalizationsCache()}async locateExtension(e){const t=await this.extensionManagementService.getInstalled();e.forEach(e=>{t.forEach(t=>{t.identifier.id!==e||t.location.scheme!==j.Schemas.file||console.log(t.location.fsPath)})})}async updateLocalizationsCache(){const e=this.instantiationService.createInstance(U.LocalizationsService);await e.update(),e.dispose()}};J=s([o(0,h.IInstantiationService),o(1,f.INativeEnvironmentService),o(2,m.IExtensionManagementService),o(3,m.IExtensionGalleryService)],J),t.Main=J;const Z="monacoworkbench";t.main=async function(e){const t=new l.ServiceCollection,n=new H.DisposableStore,i=new p.NativeEnvironmentService(e),s=new z.SpdLogService("cli",i.logsPath,O.getLogLevel(i));process.once("exit",()=>s.dispose()),
s.info("main",e),await Promise.all([i.appSettingsHome.fsPath,i.extensionsPath].map(e=>e?k.mkdirp(e):void 0));const o=new B.FileService(s);n.add(o),t.set(W.IFileService,o);const c=new V.DiskFileSystemProvider(s);n.add(c),o.registerProvider(j.Schemas.file,c);const h=new x.ConfigurationService(i.settingsResource,o);n.add(h),await h.initialize(),t.set(f.IEnvironmentService,i),t.set(f.INativeEnvironmentService,i),t.set(O.ILogService,s),t.set(C.IConfigurationService,h),t.set(P.IStateService,new u.SyncDescriptor(R.StateService)),t.set(K.IProductService,Object.assign({_serviceBrand:void 0},a.default));const T=new d.InstantiationService(t);return T.invokeFunction(async t=>{const s=t.get(P.IStateService),{appRoot:o,extensionsPath:c,extensionDevelopmentLocationURI:h,isBuilt:d,installSourcePath:f}=i,p=new l.ServiceCollection;p.set(E.IRequestService,new u.SyncDescriptor(S.RequestService)),p.set(m.IExtensionManagementService,new u.SyncDescriptor(g.ExtensionManagementService)),
p.set(m.IExtensionGalleryService,new u.SyncDescriptor(v.ExtensionGalleryService));const C=[];if(d&&!h&&!i.disableTelemetry&&a.default.enableTelemetry){a.default.aiConfig&&a.default.aiConfig.asimovKey&&C.push(new I.AppInsightsAppender(Z,null,a.default.aiConfig.asimovKey));const e={appender:b.combinedAppender(...C),sendErrorTelemetry:!1,commonProperties:_.resolveCommonProperties(a.default.commit,a.default.version,s.getItem("telemetry.machineId"),a.default.msftInternalDomains,f),piiPaths:c?[o,c]:[o]};p.set(y.ITelemetryService,new u.SyncDescriptor(w.TelemetryService,[e]))}else p.set(y.ITelemetryService,b.NullTelemetryService);const x=T.createChild(p).createInstance(J);try{await x.run(e),await r.raceTimeout(b.combinedAppender(...C).flush(),1e3)}finally{n.dispose()}})}})),define(t[71],n([0,1,26,52,12,50,65,29,55,70,56,37,31,67,69,63,6,218,24,3,64,54,8,27,42,17]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p,m,g,v,y,b,w,_,E,S,C,x){"use strict";function I(e){let t=0,n=0,r=0;return e>=1e3&&(e-=1e3*(r=Math.floor(e/1e3))),
r>=60&&(r-=60*(n=Math.floor(r/60))),n>=60&&(n-=60*(t=Math.floor(n/60))),`${t?`${t}h`:""}${n?`${n}m`:""}${r?`${r}s`:""}${e?`${e}ms`:""}`}Object.defineProperty(t,"__esModule",{value:!0}),t.run=t.shouldSpawnCli=t.ManagementConnection=t.printTime=void 0,t.printTime=I;function k(e){return!!(e["list-extensions"]||e["install-extension"]||e["install-builtin-extension"]||e["uninstall-extension"]||e["locate-extension"])}t.ManagementConnection=class{constructor(e,t,n,r){this._logService=e,this._reconnectionToken=t,this._onClose=new g.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=n,this.protocol=r,this._disposed=!1,this._disconnectRunner1=new x.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${I(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new x.RunOnceScheduler(()=>{
this._log(`The reconnection short grace time of ${I(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onClose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${I(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(e){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${e}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${I(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){
if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end(),this._onClose.fire(void 0)}acceptReconnection(e,t,n){this._remoteAddress=e,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(t,n),this.protocol.endAcceptReconnection()}},t.shouldSpawnCli=k,t.run=async function(e,t,g){if(!k(e))return!1;const x=new b.DisposableStore,I=new r.ServiceCollection;I.set(n.IEnvironmentService,t),I.set(n.INativeEnvironmentService,t),I.set(i.ILogService,g),I.set(C.IProductService,Object.assign({_serviceBrand:void 0},y.default));const T=new w.FileService(g);x.add(T),I.set(S.IFileService,T);const P=new _.DiskFileSystemProvider(g);x.add(P),T.registerProvider(E.Schemas.file,P);const R=new o.ConfigurationService(t.settingsResource,T);x.add(R),await R.initialize(),
I.set(a.IConfigurationService,R);const O=new m.InstantiationService(I);I.set(c.IRequestService,new s.SyncDescriptor(l.RequestService)),I.set(h.ITelemetryService,u.NullTelemetryService),I.set(d.IExtensionGalleryService,new s.SyncDescriptor(f.ExtensionGalleryService)),I.set(d.IExtensionManagementService,new s.SyncDescriptor(p.ExtensionManagementService));try{await O.createInstance(v.Main).run(e)}finally{x.dispose()}return!0}})),define(t[219],n([0,1,6,4,25,2,24,5,201,202,3,200,104,103,204,38,101,199,211,40,18,97,17,71]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p,m,g,v,y,b,w,_,E,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteTerminalChannel=void 0;const C=1048576;class x extends p.AbstractVariableResolverService{constructor(e,t,n,r){super({getFolderUri:e=>{const n=t.filter(t=>t.name===e);if(n&&n.length>0)return n[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(e,t)=>r[`config:${t}`],getExecPath:()=>e.VSCODE_EXEC_PATH,getFilePath:()=>{if(n)return s.normalize(n.fsPath)},
getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber},void 0,e)}}class I{constructor(e,t){this._logService=e,this._environmentService=t,this._terminals=new Map,this._terminals=new Map}async call(e,t,n){switch(t){case"$createTerminalProcess":{const t=m.createRemoteURITransformer(e.remoteAuthority),r=n;return this._createTerminalProcess(t,r)}case"$startTerminalProcess":{const e=n;return this._startTerminalProcess(e)}case"$sendInputToTerminalProcess":{const e=n;return this._sendInputToTerminalProcess(e)}case"$shutdownTerminalProcess":{const e=n;return this._shutdownTerminalProcess(e)}case"$resizeTerminalProcess":{const e=n;return this._resizeTerminalProcess(e)}case"$getTerminalInitialCwd":{const e=n;return this._getTerminalInitialCwd(e)}case"$getTerminalCwd":{const e=n;return this._getTerminalCwd(e)}case"$sendCommandResultToTerminalProcess":{const e=n;return this._sendCommandResultToTerminalProcess(e)}case"$orphanQuestionReply":{const e=n;return this._orphanQuestionReply(e)}case"$listTerminals":{
const e=n;return this._listTerminals(e)}}throw new Error(`IPC Command ${t} not found`)}async _createTerminalProcess(e,t){const n={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:"string"==typeof t.shellLaunchConfig.cwd||void 0===t.shellLaunchConfig.cwd?t.shellLaunchConfig.cwd:r.URI.revive(e.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env},s=await _.buildUserEnvironment(t.resolverEnv,a.language,this._environmentService,this._logService),u=t=>({uri:r.URI.revive(e.transformIncoming(t.uri)),name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),h=t.workspaceFolders.map(u),d=t.activeWorkspaceFolder?u(t.activeWorkspaceFolder):void 0,f=t.activeFileResource?r.URI.revive(e.transformIncoming(t.activeFileResource)):void 0,p=new x(s,h,f,t.resolvedVariables),m=c.createVariableResolver(d,p),y=a.isWindows?"terminal.integrated.env.windows":a.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux"
;if(n.executable){if(m&&(n.executable=m(n.executable),n.args))if(Array.isArray(n.args)){const e=[];for(const t of n.args)e.push(m(t));n.args=e}else n.args=m(n.args)}else n.executable=this._getDefaultShell(!1,t.configuration,m,t.isWorkspaceShellAllowed,s),n.args=this._getDefaultShellArgs(!1,t.configuration,m,t.isWorkspaceShellAllowed);const w=c.getCwd(n,i.homedir(),m,null==d?void 0:d.uri,t.configuration["terminal.integrated.cwd"],this._logService);n.cwd=w;const E=t.configuration[y],S=t.configuration["terminal.integrated.inheritEnv"]?s:await this._getNonInheritedEnv(s),C=c.createTerminalEnvironment(n,E,m,t.isWorkspaceShellAllowed,o.default.version,t.configuration["terminal.integrated.detectLocale"],S);if(!n.strictEnv){const e=[];for(const[n,r]of t.envVariableCollections)e.push([n,{map:g.deserializeEnvironmentVariableCollection(r)}]);const n=new Map(e);new v.MergedEnvironmentVariableCollection(n).applyToProcessEnvironment(C)}this._logService.debug("Terminal process launching on ext host",{shellLaunchConfig:n,
initialCwd:w,cols:t.cols,rows:t.rows,env:C});const k=b.createRandomIPCHandle();C.VSCODE_IPC_HOOK_CLI=k,C.USES_VSCODE_SERVER_SPAWN="true";const P=I._nextTerminalId++,R=new l.TerminalProcess(n,w,t.cols,t.rows,C,s,!1,this._logService),O=new T(P,R,t.workspaceId,t.workspaceName,t.shouldPersistTerminal,t.cols,t.rows,e,k,this._logService,()=>{O.dispose(),this._terminals.delete(P)});return this._terminals.set(P,O),{terminalId:P,resolvedShellLaunchConfig:n}}async _startTerminalProcess(e){const t=this._terminals.get(e.id);if(!t)return{message:"Missing terminal"};const n=await t.start();return n||void 0}_getDefaultShell(e,t,n,r,i){return c.getDefaultShell(e=>t[e],r,f.getSystemShell(a.platform),i.hasOwnProperty("PROCESSOR_ARCHITEW6432"),i.windir,n,this._logService,e)}_getDefaultShellArgs(e,t,n,r){return c.getDefaultShellArgs(e=>t[e],r,e,n,this._logService)}_getNonInheritedEnv(e){return d.getMainProcessParentEnv(e)}_getTerminalOrThrow(e){const t=this._terminals.get(e);if(!t)throw new Error("Missing terminal");return t}
_sendInputToTerminalProcess(e){this._getTerminalOrThrow(e.id).input(e.data)}_shutdownTerminalProcess(e){this._getTerminalOrThrow(e.id).shutdown(e.immediate)}_resizeTerminalProcess(e){this._getTerminalOrThrow(e.id).resize(e.cols,e.rows)}_getTerminalInitialCwd(e){return this._getTerminalOrThrow(e.id).getInitialCwd()}_getTerminalCwd(e){return this._getTerminalOrThrow(e.id).getCwd()}_sendCommandResultToTerminalProcess(e){this._getTerminalOrThrow(e.id).sendCommandResult(e.reqId,e.isError,e.payload)}_orphanQuestionReply(e){this._getTerminalOrThrow(e.id).orphanQuestionReply()}async _listTerminals(e){if(e.isInitialization)for(const[,e]of this._terminals)e.reduceGraceTime();const t=Array.from(this._terminals.entries()).filter(([e,t])=>t.shouldPersistTerminal);this._logService.info(`Listing ${t.length} persistent terminals, ${this._terminals.size} total terminals`);const n=t.map(async([e,t])=>{const[n,r]=await Promise.all([t.getCwd(),t.isOrphaned()]);return{id:e,title:t.title,pid:t.pid,workspaceId:t.workspaceId,
workspaceName:t.workspaceName,cwd:n,isOrphan:r}});return(await Promise.all(n)).filter(e=>e.isOrphan)}listen(e,t,n){switch(t){case"$onTerminalProcessEvent":{const e=n;return this._onTerminalProcessEvent(e)}}throw new Error("Not supported")}_onTerminalProcessEvent(e){const t=this._terminals.get(e.id);if(!t)throw new Error("Missing terminal");return t.events}}t.RemoteTerminalChannel=I,I._nextTerminalId=1;class k{constructor(e,t){this._entries=[{cols:e,rows:t,data:[]}],this._totalDataLength=0}recordResize(e,t){if(this._entries.length>0){0===this._entries[this._entries.length-1].data.length&&this._entries.pop()}if(this._entries.length>0){const n=this._entries[this._entries.length-1];if(n.cols===e&&n.rows===t)return;if(0===n.cols&&0===n.rows)return n.cols=e,void(n.rows=t)}this._entries.push({cols:e,rows:t,data:[]})}recordData(e){for(this._entries[this._entries.length-1].data.push(e),this._totalDataLength+=e.length;this._totalDataLength>C;){const e=this._entries[0],t=this._totalDataLength-C
;t>=e.data[0].length?(this._totalDataLength-=e.data[0].length,e.data.shift(),0===e.data.length&&this._entries.shift()):(e.data[0]=e.data[0].substr(t),this._totalDataLength-=t)}}generateReplayEvent(){return this._entries.forEach(e=>{e.data.length>0&&(e.data=[e.data.join("")])}),{type:"replay",events:this._entries.map(e=>{var t;return{cols:e.cols,rows:e.rows,data:null!==(t=e.data[0])&&void 0!==t?t:""}})}}}class T extends u.Disposable{constructor(e,t,r,i,s,o,a,c,l,u,d){super(),this._id=e,this._terminalProcess=t,this.workspaceId=r,this.workspaceName=i,this.shouldPersistTerminal=s,this._uriTransformer=c,this._logService=u,this._onExit=d,this._lastReqId=0,this._pendingCommands=new Map,this._orphanRequestQueue=new E.Queue,this._title="",this._pid=-1,this._recorder=new k(o,a),this._seenFirstListener=!1,this._orphanQuestionBarrier=null,this._orphanQuestionReplyTime=0,this._disconnectRunner1=this._register(new E.RunOnceScheduler(()=>{
this._logService.info(`The reconnection grace time of ${S.printTime(108e5)} has expired, so the terminal process with pid ${this._pid} will be shutdown.`),this.shutdown(!0)},108e5)),this._disconnectRunner2=this._register(new E.RunOnceScheduler(()=>{this._logService.info(`The short reconnection grace time of ${S.printTime(3e5)} has expired, so the terminal process with pid ${this._pid} will be shutdown.`),this.shutdown(!0)},3e5)),this._events=this._register(new n.Emitter({onListenerDidAdd:()=>{this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this._seenFirstListener&&this._triggerReplay(),this._seenFirstListener=!0},onLastListenerRemove:()=>{this.shouldPersistTerminal?this._disconnectRunner1.schedule():this.shutdown(!0)}})),this.events=this._events.event,this._bufferer=new h.TerminalDataBufferer((e,t)=>{const n={type:"data",data:t};this._events.fire(n)}),this._register(this._terminalProcess.onProcessReady(e=>{this._pid=e.pid;const t={type:"ready",pid:e.pid,cwd:e.cwd};this._events.fire(t)})),
this._register(this._terminalProcess.onProcessTitleChanged(e=>{this._title=e;const t={type:"titleChanged",title:e};this._events.fire(t)})),this._register(this._bufferer.startBuffering(this._id,this._terminalProcess.onProcessData)),this._register(this._terminalProcess.onProcessData(e=>{this._recorder.recordData(e)})),this._register(this._terminalProcess.onProcessExit(e=>{this._bufferer.stopBuffering(this._id);const t={type:"exit",exitCode:e};this._events.fire(t),this._onExit()}));const f={executeCommand:(e,...t)=>this._executeCommand(e,t)};this._register(new y.CLIServerBase(f,this._logService,l))}get pid(){return this._pid}get title(){return this._title}start(){return this._terminalProcess.start()}shutdown(e){return this._terminalProcess.shutdown(e)}input(e){return this._terminalProcess.input(e)}resize(e,t){return this._recorder.recordResize(e,t),this._terminalProcess.resize(e,t)}getInitialCwd(){return this._terminalProcess.getInitialCwd()}getCwd(){return this._terminalProcess.getCwd()}_triggerReplay(){
const e=this._recorder.generateReplayEvent();let t=0;for(const n of e.events)t+=n.data.length;this._logService.info(`Replaying ${t} chars and ${e.events.length} size events.`),this._events.fire(e)}_executeCommand(e,t){let n,i;const s=new Promise((e,t)=>{n=e,i=t}),o=++this._lastReqId;this._pendingCommands.set(o,{resolve:n,reject:i});const a={type:"execCommand",reqId:o,commandId:e,commandArgs:w.cloneAndChange(t,e=>e&&1===e.$mid?this._uriTransformer.transformOutgoing(e):e&&e instanceof r.URI?this._uriTransformer.transformOutgoingURI(e):void 0)};return this._events.fire(a),s}sendCommandResult(e,t,n){const r=this._pendingCommands.get(e);if(!r)return;this._pendingCommands.delete(e);const i=w.cloneAndChange(n,e=>{if(e&&1===e.$mid)return this._uriTransformer.transformIncoming(e)});t?r.reject(i):r.resolve(i)}async orphanQuestionReply(){if(this._orphanQuestionReplyTime=Date.now(),this._orphanQuestionBarrier){const e=this._orphanQuestionBarrier;this._orphanQuestionBarrier=null,e.open()}}reduceGraceTime(){
this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&this._disconnectRunner2.schedule()}async isOrphaned(){return await this._orphanRequestQueue.queue(async()=>this._isOrphaned())}async _isOrphaned(){if(this._disconnectRunner1.isScheduled()||this._disconnectRunner2.isScheduled())return!0;if(!this._orphanQuestionBarrier){this._orphanQuestionBarrier=new P(4e3),this._orphanQuestionReplyTime=0;const e={type:"orphan?"};this._events.fire(e)}return await this._orphanQuestionBarrier.wait(),Date.now()-this._orphanQuestionReplyTime>500}}class P extends E.Barrier{constructor(e){super(),this._timeout=setTimeout(()=>this.open(),e)}open(){clearTimeout(this._timeout),super.open()}}})),
define(t[220],n([0,1,60,20,212,78,25,66,19,3,21,14,123,5,80,40,97,71,38,12,8,24,26,52,50,65,29,55,70,56,37,31,67,69,63,84,161,87,88,93,92,94,77,64,54,27,42,36,6,214,195,215,184,163,192,159,178,196,4,30,2,11,206,219]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p,m,g,v,y,b,w,_,E,S,C,x,I,k,T,P,R,O,L,D,A,N,M,F,U,j,z,$,B,W,V,H,K,q,G,X,Y,Q,J,Z,ee,te,ne,re,ie,se,oe,ae,ce,le){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteExtensionHostAgentServer=void 0;const ue=3e5,he="monacoworkbench";class de extends q.IPCServer{constructor(){const e=new G.Emitter;super(e.event),this._onDidConnectEmitter=e}acceptConnection(e,t){this._onDidConnectEmitter.fire({protocol:e,onDidClientDisconnect:t})}}function fe(e){return e<10?`0${e}`:String(e)}function pe(){const e=new Date;return`${fe(e.getHours())}:${fe(e.getMinutes())}:${fe(e.getSeconds())}`}class me extends b.AbstractLogService{constructor(e=b.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),this.useColors=Boolean(process.stdout.isTTY)}trace(e,...t){
this.getLevel()<=b.LogLevel.Trace&&(this.useColors?console.log(`[90m[${pe()}][0m`,e,...t):console.log(`[${pe()}]`,e,...t))}debug(e,...t){this.getLevel()<=b.LogLevel.Debug&&(this.useColors?console.log(`[90m[${pe()}][0m`,e,...t):console.log(`[${pe()}]`,e,...t))}info(e,...t){this.getLevel()<=b.LogLevel.Info&&(this.useColors?console.log(`[90m[${pe()}][0m`,e,...t):console.log(`[${pe()}]`,e,...t))}warn(e,...t){this.getLevel()<=b.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${pe()}][0m`,e,...t):console.warn(`[${pe()}]`,e,...t))}error(e,...t){this.getLevel()<=b.LogLevel.Error&&(this.useColors?console.error(`[91m[${pe()}][0m`,e,...t):console.error(`[${pe()}]`,e,...t))}critical(e,...t){this.getLevel()<=b.LogLevel.Critical&&(this.useColors?console.error(`[90m[${pe()}][0m`,e,...t):console.error(`[${pe()}]`,e,...t))}dispose(){}flush(){}}class ge extends l.Disposable{constructor(t,n,i,s){super(),this._connectionToken=t,this._connectionTokenIsMandatory=n,this._environmentService=i,
this._logService=new b.MultiplexLogService([new me(b.getLogLevel(this._environmentService)),s]),this._socketServer=new de,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null);const o=w.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",e).fsPath;r.existsSync(o)?this._webClientServer=new re.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null}async start(e){return await this._createServices(),this._start(e)}async _createServices(){const e=new S.ServiceCollection;this._socketServer.registerChannel(te.ExtensionHostDebugBroadcastChannel.ChannelName,new te.ExtensionHostDebugBroadcastChannel);const t=new q.StaticRouter(e=>"renderer"===e.clientId);this._socketServer.registerChannel("logger",new ne.LoggerChannel(this._logService)),e.set(E.IEnvironmentService,this._environmentService),e.set(E.INativeEnvironmentService,this._environmentService),
e.set(b.ILogService,this._logService),e.set(K.IProductService,Object.assign({_serviceBrand:void 0},_.default));const n=this._register(new W.FileService(this._logService));e.set(H.IFileService,n),n.registerProvider(w.Schemas.file,this._register(new V.DiskFileSystemProvider(this._logService))),e.set(I.IConfigurationService,new C.SyncDescriptor(x.ConfigurationService,[this._environmentService.machineSettingsResource,n])),e.set(k.IRequestService,new C.SyncDescriptor(T.RequestService));let r=P.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&_.default.enableTelemetry){_.default.aiConfig&&_.default.aiConfig.asimovKey&&(r=new j.AppInsightsAppender(he,null,_.default.aiConfig.asimovKey),this._register(l.toDisposable(()=>r.flush())));const t=await B.getMachineId(),n={appender:r,commonProperties:$.resolveCommonProperties(_.default.commit,_.default.version+"-remote",t,_.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]}
;e.set(R.ITelemetryService,new C.SyncDescriptor(z.TelemetryService,[n]))}else e.set(R.ITelemetryService,P.NullTelemetryService);e.set(O.IExtensionGalleryService,new C.SyncDescriptor(L.ExtensionGalleryService));const i=this._socketServer.getChannel("download",t);e.set(N.IDownloadService,new M.DownloadServiceChannelClient(i,()=>this._getUriTransformer("renderer"))),e.set(O.IExtensionManagementService,new C.SyncDescriptor(D.ExtensionManagementService));const s=new A.InstantiationService(e);e.set(F.ILocalizationsService,s.createInstance(U.LocalizationsService)),s.invokeFunction(e=>{const t=new X.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,this._logService,e.get(R.ITelemetryService),r);this._socketServer.registerChannel("remoteextensionsenvironment",t),this._socketServer.registerChannel(ce.REMOTE_TERMINAL_CHANNEL_NAME,new le.RemoteTerminalChannel(this._logService,this._environmentService));const n=new Y.RemoteAgentFileSystemChannel(this._logService,this._environmentService)
;this._socketServer.registerChannel(Q.REMOTE_FILE_SYSTEM_CHANNEL_NAME,n),this._socketServer.registerChannel("request",new J.RequestChannel(e.get(k.IRequestService)));const i=e.get(O.IExtensionManagementService),s=new Z.ExtensionManagementChannel(i,e=>this._getUriTransformer(e.remoteAuthority));this._socketServer.registerChannel("extensions",s),i.removeDeprecatedExtensions(),this._register(new ee.default(e.get(R.ITelemetryService)))})}_getUriTransformer(e){return this._uriTransformerCache[e]||(this._uriTransformerCache[e]=y.createRemoteURITransformer(e)),this._uriTransformerCache[e]}async _start(e){if("number"==typeof e.port){const e=o.networkInterfaces(),t=this._logService;Object.keys(e).forEach((function(n){e[n].forEach((function(e){e.internal||"IPv4"!==e.family||(console.log(`IP Address: ${e.address}`),t.trace(`IP Address: ${e.address}`))}))}))}setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,e=>this._logService.error(e)),1e4);const t=i.createServer(async(e,t)=>{
if("GET"!==e.method)return re.serveError(e,t,405,`Unsupported method ${e.method}`);if(!e.url)return re.serveError(e,t,400,"Bad request.");const n=a.parse(e.url,!0),r=n.pathname;if(!r)return re.serveError(e,t,400,"Bad request.");if("/version"===r)return t.writeHead(200,{"Content-Type":"text/plain"}),t.end(_.default.commit||"");if("/delay-shutdown"===r)return this._delayShutdown(),t.writeHead(200),t.end("OK");if("/vscode-remote-resource"===r){if(n.query.tkn!==this._connectionToken)return re.serveError(e,t,403,"Forbidden.");const r=n.query.path;if("string"!=typeof r)return re.serveError(e,t,400,"Bad request.");let i;try{i=ie.URI.from({scheme:w.Schemas.file,path:r}).fsPath}catch(n){return re.serveError(e,t,400,"Bad request.")}const s=Object.create(null);return this._environmentService.isBuilt&&(se.isEqualOrParent(i,this._environmentService.builtinExtensionsPath,!f.isLinux)||se.isEqualOrParent(i,this._environmentService.extensionsPath,!f.isLinux))&&(s["Cache-Control"]="public, max-age=31536000"),
re.serveFile(this._logService,e,t,i,s)}if(!this._webClientServer)return t.writeHead(404,{"Content-Type":"text/plain"}),t.end("Not found");this._webClientServer.handle(e,t,n)});t.on("upgrade",(e,t)=>{if("websocket"!==e.headers.upgrade)return void t.end("HTTP/1.1 400 Bad Request");const r=e.headers["sec-websocket-key"],i=n.createHash("sha1");i.update(r+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const s=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${i.digest("base64")}`];t.write(s.join("\r\n")+"\r\n\r\n"),t.setTimeout(0);let o=u.generateUuid(),c=!1,l=!1;if(e.url){const t=a.parse(e.url,!0).query;"string"==typeof t.reconnectionToken&&(o=t.reconnectionToken),"true"===t.reconnection&&(c=!0),"true"===t.skipWebSocketFrames&&(l=!0)}l?this._handleWebSocketConnection(new m.NodeSocket(t),c,o):this._handleWebSocketConnection(new m.WebSocketNodeSocket(new m.NodeSocket(t)),c,o)}),t.on("error",e=>{this._logService.error("Error occurred in server"),this._logService.error(e)
});const r=e.socketPath?{path:e.socketPath}:{host:e.host,port:e.port};t.listen(r,()=>{const e=ae.assertIsDefined(t.address());console.log(`Extension host agent listening on ${"string"==typeof e?e:e.port}`),this._webClientServer&&"string"!=typeof e&&console.log(`Web UI available at http://localhost${80===e.port?"":`:${e.port}`}/?tkn=${this._connectionToken}`),console.log(),console.log(),this._logService.info("Extension host agent started.")}),this._register({dispose:()=>t.close()})}async _cleanupOlderLogs(e){const t=oe.basename(e),n=oe.dirname(e),r=(await h.readdir(n)).filter(e=>/^\d{8}T\d{6}$/.test(e)).sort().filter(e=>e!==t),i=r.slice(0,Math.max(0,r.length-9));await Promise.all(i.map(e=>h.rimraf(oe.join(n,e))))}_getRemoteAddress(e){let t;return(t=e instanceof m.NodeSocket?e.socket:e.socket.socket).remoteAddress||"<unknown>"}_handleWebSocketConnection(t,n,r){const i=this._getRemoteAddress(t),s=`[${i}][${r.substr(0,8)}]`,o=new p.PersistentProtocol(t);let a;try{const t=e.__$__nodeRequire("vsda")
;a=new t.validator}catch(e){}const l=o.onControlMessage(e=>{const u=JSON.parse(e.toString());if("auth"===u.type){if(this._connectionTokenIsMandatory&&u.auth!==this._connectionToken)return this._logService.error(`${s} Unauthorized client refused, missing auth.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unauthorized client refused, missing auth."}))),o.dispose(),void t.dispose();let e="VS Code Headless is cool";if(a)try{e=a.createNewMessage(e)}catch(e){}const n={type:"sign",data:e};o.sendControl(c.VSBuffer.fromString(JSON.stringify(n)))}else if("connectionType"===u.type){l.dispose();const e=u.commit,h=_.default.commit;if(e&&h&&e!==h)return this._logService.error(`${s} Version mismatch, client refused.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Version mismatch, client refused."}))),o.dispose(),void t.dispose();let d=!1;if(u.signedData===this._connectionToken&&(d=!0),!d&&a&&"string"==typeof u.signedData)try{d="ok"===a.validate(u.signedData)
}catch(e){}if(d)this._environmentService.isBuilt||this._logService.trace(`${s} Client handshake succeded.`);else{if(this._environmentService.isBuilt)return this._logService.error(`${s} Unauthorized client refused.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unauthorized client refused."}))),o.dispose(),void t.dispose();this._logService.error(`${s} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let e in this._managementConnections){this._managementConnections[e].shortenReconnectionGraceTimeIfNecessary()}for(let e in this._extHostConnections){this._extHostConnections[e].shortenReconnectionGraceTimeIfNecessary()}switch(u.desiredConnectionType){case 1:if(n)if(this._managementConnections[r]){o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"ok"})));const e=o.readEntireBuffer();o.dispose(),this._managementConnections[r].acceptReconnection(i,t,e)}else this._logService.error(`${s}[ManagementConnection] Unknown reconnection token.`),
o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unknown reconnection token."}))),o.dispose(),t.dispose();else if(this._managementConnections[r])this._logService.error(`${s}[ManagementConnection] Duplicate reconnection token.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Duplicate reconnection token."}))),o.dispose(),t.dispose();else{o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"ok"})));const e=new v.ManagementConnection(this._logService,r,i,o);this._socketServer.acceptConnection(e.protocol,e.onClose),this._managementConnections[r]=e,e.onClose(()=>{delete this._managementConnections[r]})}break;case 2:const e=u.args||{language:"en"};this._updateWithFreeDebugPort(e).then(e=>{if(e.port&&this._logService.trace(`${s}[ExtensionHostConnection] - startParams debug port ${e.port}`),u.args?(this._logService.trace(`${s}[ExtensionHostConnection] - startParams language: ${e.language}`),
this._logService.trace(`${s}[ExtensionHostConnection] - startParams env: ${JSON.stringify(e.env)}`)):this._logService.trace(`${s}[ExtensionHostConnection] - no UI language provided by renderer. Falling back to English`),n)if(this._extHostConnections[r]){o.sendControl(c.VSBuffer.fromString(JSON.stringify(e.port?{debugPort:e.port}:{})));const n=o.readEntireBuffer();o.dispose(),this._extHostConnections[r].acceptReconnection(i,t,n)}else this._logService.error(`${s}[ExtensionHostConnection] Unknown reconnection token.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unknown reconnection token."}))),o.dispose(),t.dispose();else if(this._extHostConnections[r])this._logService.error(`${s}[ExtensionHostConnection] Duplicate reconnection token.`),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Duplicate reconnection token."}))),o.dispose(),t.dispose();else{o.sendControl(c.VSBuffer.fromString(JSON.stringify(e.port?{debugPort:e.port}:{})));const n=o.readEntireBuffer()
;o.dispose();const s=new g.ExtensionHostConnection(this._environmentService,this._logService,r,i,t,n);this._extHostConnections[r]=s,s.onClose(()=>{delete this._extHostConnections[r],this._onDidCloseExtHostConnection()}),s.start(e)}});break;case 3:const a=u.args;this._createTunnel(o,a);break;default:console.error("Unknown initial data received."),this._logService.error("Unknown initial data received."),o.sendControl(c.VSBuffer.fromString(JSON.stringify({type:"error",reason:"Unknown initial data received."}))),o.dispose(),t.dispose()}}})}async _createTunnel(e,t){const n=e.getSocket().socket,r=e.readEntireBuffer();e.dispose(),n.pause();const i=await this._connectTunnelSocket(t.port);r.byteLength>0&&i.write(r.buffer),i.on("end",()=>n.end()),i.on("close",()=>n.end()),i.on("error",()=>n.destroy()),n.on("end",()=>i.end()),n.on("close",()=>i.end()),n.on("error",()=>i.destroy()),i.pipe(n),n.pipe(i)}_connectTunnelSocket(e){return new Promise((t,n)=>{const r=s.createConnection({port:e},()=>{r.removeListener("error",n),
r.pause(),t(r)});r.once("error",n)})}_updateWithFreeDebugPort(e){return"number"==typeof e.port?d.findFreePort(e.port,10,5e3).then(t=>(e.port=t,e)):(e.debugId=void 0,e.port=void 0,e.break=void 0,Promise.resolve(e))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){this._environmentService.args["enable-remote-auto-shutdown"]&&(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},ue))}_shutdown(){if(!!Object.keys(this._extHostConnections).length)return console.log("New EH opened, aborting shutdown"),void this._logService.info("New EH opened, aborting shutdown")
;console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}t.RemoteExtensionHostAgentServer=ge})),define(t[231],n([0,1,25,20,9,8,71,90,220,12,216,89,21,162,2]),(function(e,t,n,r,i,s,o,a,c,l,u,h,d,f,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServerEnvironmentService=void 0;const m={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:i.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},
driver:{type:"string"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"disable-telemetry":f.OPTIONS["disable-telemetry"],"extensions-dir":f.OPTIONS["extensions-dir"],"extensions-download-dir":f.OPTIONS["extensions-download-dir"],"install-extension":f.OPTIONS["install-extension"],"install-builtin-extension":f.OPTIONS["install-builtin-extension"],"uninstall-extension":f.OPTIONS["uninstall-extension"],"locate-extension":f.OPTIONS["locate-extension"],"list-extensions":f.OPTIONS["list-extensions"],force:f.OPTIONS.force,"do-not-sync":f.OPTIONS["do-not-sync"],"disable-user-env-probe":f.OPTIONS["disable-user-env-probe"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},_:f.OPTIONS._};class g extends a.NativeEnvironmentService{get args(){return super.args}}t.ServerEnvironmentService=g;const v={onMultipleValues:(e,t)=>{
console.error(`Option ${e} can only be defined once. Using value ${t}.`)},onUnknownOption:e=>{console.error(`Ignoring option ${e}: not supported for server.`)}},y=f.parseArgs(process.argv.slice(2),m,v),b=process.env.VSCODE_AGENT_FOLDER||p.join(n.homedir(),".vscode-remote"),w=p.join(b,"data"),_=p.join(w,"User"),E=p.join(_,"globalStorage"),S=p.join(w,"Machine");y["user-data-dir"]=w;const C=p.dirname(s.FileAccess.asFileUri("",e).fsPath),x=p.join(C,"extensions");y["builtin-extensions-dir"]=x;const I=y.host;let k=8e3;try{y.port&&(k=parseInt(y.port))}catch(e){console.log("Port is not a number, using 8000 instead.")}const T=y["socket-path"];let P,R;if(y["connection-secret"]){y.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let e=r.readFileSync(y["connection-secret"]).toString();e=e.replace(/\r?\n$/,""),
/^[0-9A-Za-z\-]+$/.test(e)||(console.warn(`The secret defined in ${y["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),P=e,R=!0}else P=y.connectionToken||d.generateUuid(),R=!1;y["extensions-dir"]=y["extensions-dir"]||p.join(b,"extensions"),[b,y["extensions-dir"],w,_,S,E].forEach(e=>{try{r.existsSync(e)||r.mkdirSync(e)}catch(e){console.error(e)}});const O=new g(y),L=new h.SpdLogService(u.RemoteExtensionLogFileName,O.logsPath,l.getLogLevel(O));function D(e){setTimeout(()=>process.exit(e),0)}if(L.trace(`Remote configuration data at ${b}`),L.trace("process arguments:",y),o.shouldSpawnCli(y))o.run(y,O,L).then(()=>D(0)).then(null,e=>{L.error(e.message||e.stack||e),D(1)});else{const e="\n\n*\n* Visual Studio Code Server\n*\n* Reminder: You may only use this software with Visual Studio family products,\n* as described in the license https://aka.ms/vscode-remote/license\n*\n\n";if(L.info(e),console.log(e),
"win32"===process.platform&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const e=p.join(process.env.HOMEDRIVE,"node_modules"),t=p.dirname(p.join(process.env.HOMEDRIVE,process.env.HOMEPATH)),n=p.join(t,"node_modules");if(r.existsSync(e)||r.existsSync(n)){const t=`\n\n*\n* !!!! Server terminated due to presence of CVE-2020-1416 !!!!\n*\n* Please remove the following directories and re-try\n* ${e}\n* ${n}\n*\n* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416\n*\n\n`;L.warn(t),console.warn(t),process.exit(0)}}const t=new c.RemoteExtensionHostAgentServer(P,R,O,L);T?t.start({socketPath:T}):t.start({host:I,port:k}),process.on("exit",()=>{t.dispose()})}}))}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/e5a624b788d92b8d34d1392e4c4d9789406efe8f/core/vs/server/remoteExtensionHostAgent.js.map
